import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css, space } from './styled.js';
import { a as Button, b as buttonPropTypes } from './chunk-0ba092a8.js';
import { Text as _Text } from './Text.js';
import { Heading } from './Heading.js';
import VisuallyHidden from './VisuallyHidden.js';
import _omit from 'lodash/omit';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import Flex from 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import './types.js';
import { a as Icon } from './chunk-51b7d577.js';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'airbnb-prop-types';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-c400d1e8.js';
import './chunk-e8f72546.js';
import 'reakit/Heading';
import 'classnames';

var AlertTitle = styled(Heading).withConfig({
  displayName: "styled__AlertTitle",
  componentId: "sc-14yopcx-0"
})(["font-weight:", ";&&{margin-bottom:", "em;}&{", ";}"], theme('fannypack.fontWeights.semibold'), space(2), theme('fannypack.Alert.Title.base'));
var AlertClose = styled(Button).withConfig({
  displayName: "styled__AlertClose",
  componentId: "sc-14yopcx-1"
})(["width:24px;height:24px;padding:0;text-align:right;", ";&:hover{background-color:", ";&{", ";}}", ";"], function (props) {
  return props.isAbsolute ? css(["position:absolute;right:", "rem;top:", "rem;"], space(2), space(2)) : css(["margin:0 ", "rem;"], space(2));
}, palette('white700'), theme('fannypack.Alert.Close.hover'), theme('fannypack.Alert.Close.base'));
var tintAttributes = css(["background-color:", ";border-top-width:0;border-right-width:0;border-bottom-width:0;color:", ";fill:", ";", ";"], function (props) {
  return props.type && palette(props.type + "Tint")(props);
}, function (props) {
  return props.type && palette(props.type + "TintInverted")(props);
}, function (props) {
  return props.type && palette(props.type + "TintInverted")(props);
}, theme('fannypack.Alert.tint'));
var _Alert = styled(Box).withConfig({
  displayName: "styled",
  componentId: "sc-14yopcx-2"
})(["background-color:white;border:1px solid ", ";border-left:4px solid ", ";border-radius:4px;position:relative;&{", ";}&{", ";}"], palette('white800'), function (props) {
  return props.type && palette(props.type)(props);
}, function (props) {
  return props.hasTint && tintAttributes;
}, theme('fannypack.Alert.base'));

var AlertClose$1 = function AlertClose$$1(_ref) {
  var onClickClose = _ref.onClickClose,
      props = _objectWithoutPropertiesLoose(_ref, ["onClickClose"]);

  return createElement(AlertClose, _extends({
    kind: "link",
    onClick: onClickClose
  }, props), createElement(VisuallyHidden, null, "Close"), createElement(Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
AlertClose$1.defaultProps = {
  isAbsolute: false,
  onClickClose: undefined
};
var C = AlertClose$1;

var AlertTitle$1 = function AlertTitle$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(AlertTitle, _extends({
    use: "h6"
  }, props), children);
};

AlertTitle$1.propTypes = {
  children: node.isRequired
};

var ContentWrapper = styled(Box).withConfig({
  displayName: "Alert__ContentWrapper",
  componentId: "sc-1e5x83i-0"
})(["padding:", "rem;", ";"], space(4), function (props) {
  return props.hasIcon && css(["padding-left:0;"]);
});
var IconWrapper = styled(Flex).withConfig({
  displayName: "Alert__IconWrapper",
  componentId: "sc-1e5x83i-1"
})(["padding:0 ", "rem;"], space(4));
var defaultProps = {
  className: undefined,
  closeButtonProps: {},
  children: undefined,
  hasIcon: false,
  hasTint: false,
  onClickClose: undefined,
  showCloseButton: false,
  title: undefined,
  type: 'info'
};
var Alert = function Alert(_ref) {
  var className = _ref.className,
      closeButtonProps = _ref.closeButtonProps,
      children = _ref.children,
      hasIcon = _ref.hasIcon,
      onClickClose = _ref.onClickClose,
      showCloseButton = _ref.showCloseButton,
      title = _ref.title,
      type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, ["className", "closeButtonProps", "children", "hasIcon", "onClickClose", "showCloseButton", "title", "type"]);

  return createElement(_Alert, _extends({
    role: "alert",
    className: className,
    type: type
  }, props), createElement(Flex, {
    alignItems: "center"
  }, hasIcon && type && createElement(IconWrapper, null, createElement(Icon, {
    a11yLabel: type,
    color: type,
    icon: type,
    size: children ? '400' : undefined
  })), createElement(ContentWrapper, {
    hasIcon: hasIcon
  }, title && createElement(AlertTitle$1, null, title), typeof children === 'string' ? createElement(_Text, null, children) : children), showCloseButton && createElement(C, _extends({
    isAbsolute: Boolean(children),
    onClickClose: onClickClose
  }, closeButtonProps))));
};
Alert.propTypes = {
  className: string,
  closeButtonProps: shape(_omit(buttonPropTypes, 'children')),
  children: node,
  hasIcon: bool,
  hasTint: bool,
  onClickClose: func,
  showCloseButton: bool,
  title: string,
  type: string
};
Alert.defaultProps = defaultProps;

export default Alert;
export { Alert };
