import styled, { space } from './styled.js';
import { List } from './List.js';
import { a as Navigation } from './Navigation-848d4222.js';
import { Link } from './Link.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme, palette } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/Box';
import 'reakit/Block';
import Inline from 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import './chunk-cd704477.js';
import 'reakit/List';
import 'reakit/Navigation';
import './chunk-d1ea7076.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Link';

var Breadcrumb = styled(Navigation).withConfig({
  displayName: "styled__Breadcrumb",
  componentId: "zajvqz-0"
})(["& li + li::before{border-right-color:", ";border-right-style:solid;border-right-width:", "rem;content:'';display:inline-block;height:0.8rem;margin:0 ", "rem;msrgin-right:0;transform:rotate(15deg);}& [aria-current='page']{font-weight:", ";text-decoration:none;}&{", ";}"], function (props) {
  return palette(props.separationColor || 'text100', props.separationColor);
}, space(0.5), space(4), theme('fannypack.fontWeights.semibold'), theme('fannypack.Breadcrumb.base'));
var BreadcrumbList = styled(List).withConfig({
  displayName: "styled__BreadcrumbList",
  componentId: "zajvqz-1"
})(["& li{margin-right:0;}&{", ";}"], theme('fannypack.Breadcrumb.List.base'));
var BreadcrumbStep = styled(List.Item).withConfig({
  displayName: "styled__BreadcrumbStep",
  componentId: "zajvqz-2"
})(["&{", ";}"], theme('fannypack.Breadcrumb.Step.base'));
var BreadcrumbSpan = styled(Inline).withConfig({
  displayName: "styled__BreadcrumbSpan",
  componentId: "zajvqz-3"
})(["&{", ";}"], theme('fannypack.Breadcrumb.Span.base'));
var BreadcrumbLink = styled(Link).withConfig({
  displayName: "styled__BreadcrumbLink",
  componentId: "zajvqz-4"
})(["&{", ";}"], theme('fannypack.Breadcrumb.Link.base'));

/* eslint react/prop-types: 0 */

var BreadcrumbStep$1 = function BreadcrumbStep$$1(_ref) {
  var children = _ref.children,
      color = _ref.color,
      href = _ref.href,
      isCurrent = _ref.isCurrent;
  return createElement(BreadcrumbStep, null, href ? createElement(BreadcrumbLink, {
    "aria-current": isCurrent ? 'page' : undefined,
    color: color,
    href: href
  }, children) : createElement(BreadcrumbSpan, {
    "aria-current": isCurrent ? 'page' : undefined,
    color: color
  }, children));
};

BreadcrumbStep$1.propTypes = {
  children: node.isRequired,
  color: string,
  href: string,
  isCurrent: bool
};
BreadcrumbStep$1.defaultProps = {
  color: undefined,
  href: undefined,
  isCurrent: undefined
}; // @ts-ignore

var C = BreadcrumbStep$1;

/* eslint react/prop-types: 0 */
var Breadcrumb$1 = function Breadcrumb$$1(_ref) {
  var children = _ref.children,
      separationColor = _ref.separationColor;
  return createElement(Breadcrumb, {
    a11yTitle: "Breadcrumb",
    separationColor: separationColor
  }, createElement(BreadcrumbList, {
    isOrdered: true,
    isHorizontal: true
  }, children));
};
Breadcrumb$1.Step = C;
Breadcrumb$1.propTypes = {
  children: node.isRequired,
  separationColor: string
};
Breadcrumb$1.defaultProps = {
  separationColor: ''
}; // @ts-ignore

var C$1 = Breadcrumb$1;

export default C$1;
export { C$1 as Breadcrumb };
