import { a as _objectSpread, b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import { a as CardCard, f as cardCardPropTypes, g as cardCardDefaultProps, c as CardContent, b as CardHeader, e as CardFooter, d as CardTitle } from './chunk-36b1c440.js';
import { getUniqueId } from './uniqueId.js';
import ConditionalWrap from 'conditional-wrap';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import './styled.js';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import './Heading.js';
import './chunk-d1ea7076.js';
import 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/Heading';
import 'classnames';
import './chunk-a1e5c7d9.js';
import 'lodash/uniqueId';

var Card = function Card(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      footer = _ref.footer,
      headerActions = _ref.headerActions,
      title = _ref.title,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "children", "footer", "headerActions", "title"]);

  return createElement(CardCard, _extends({
    a11yDescriptionId: title || footer ? a11yDescriptionId : undefined,
    a11yTitleId: title ? a11yTitleId : undefined
  }, props), title && createElement(CardHeader, null, typeof title === 'string' ? createElement(CardTitle, {
    id: a11yTitleId
  }, title) : title, headerActions && createElement("div", null, headerActions)), createElement(ConditionalWrap, {
    condition: title || footer,
    wrap: function wrap(children) {
      return createElement(CardContent, {
        id: a11yDescriptionId
      }, children);
    }
  }, children), footer && createElement(CardFooter, null, footer));
};
Card.Card = CardCard;
Card.Header = CardHeader;
Card.Content = CardContent;
Card.Footer = CardFooter;
Card.Title = CardTitle;
Card.propTypes = _objectSpread({
  a11yDescriptionId: string,
  a11yTitleId: string,
  children: node.isRequired,
  className: string,
  footer: oneOfType([string, element]),
  headerActions: element,
  isFullWidth: bool,
  title: oneOfType([string, element])
}, cardCardPropTypes);
Card.defaultProps = _objectSpread({}, cardCardDefaultProps, {
  a11yDescriptionId: getUniqueId('Card'),
  a11yTitleId: getUniqueId('Card'),
  children: undefined,
  className: undefined,
  footer: undefined,
  headerActions: undefined,
  isFullWidth: false,
  title: undefined
}); // @ts-ignore

var C = Card;

export default C;
export { C as Card, CardCard, CardContent, CardFooter, CardHeader, CardTitle };
