import { b as _extends, c as _objectWithoutPropertiesLoose, a as _objectSpread } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import { Text as _Text } from './Text.js';
import { a as HiddenInput } from './chunk-acbb1544.js';
import { a as FieldWrapper, b as fieldWrapperDefaultProps, c as fieldWrapperPropTypes } from './chunk-b8380805.js';
import Label from 'reakit/Label';
import _omit from 'lodash/omit';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import './chunk-d1ea7076.js';
import 'reakit/Input';
import './Label.js';
import 'reakit/Field';

var CheckboxIcon = styled(Box).withConfig({
  displayName: "styled__CheckboxIcon",
  componentId: "sc-1cw8kp1-0"
})(["border:1px solid #bdbdbd;box-shadow:inset 0px 1px 2px #e5e5e5;border-radius:0.2em;height:1em;position:relative;width:1em;&{", ";}&{", ";}"], function (props) {
  return props.state && css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
    return palette("" + props.state)(props);
  }, function (props) {
    return palette("" + props.state)(props);
  });
}, theme('fannypack.Checkbox.base'));
var HiddenCheckbox = HiddenInput({
  Icon: CheckboxIcon,
  checkedIconCss: css(["background-clip:padding-box;content:'';left:calc(50% - 0.1875em);top:calc(50% - 0.375em);position:absolute;&{", ";}"], function (props) {
    return props.indeterminate ? css(["background-color:", ";height:0.125em;width:0.625em;top:calc(50% - 0.0625em);left:calc(50% - 0.3125em);"], palette('primary')) : css(["border:0.1em solid ", ";border-left-width:0;border-top-width:0;height:0.625em;transform:rotate(45deg);width:0.375em;"], palette('primary'));
  }),
  disabledCheckedIconCss: css(["border-color:", ";"], palette('gray300')),
  themePrefix: 'Checkbox'
});
var _Checkbox = styled(Label).withConfig({
  displayName: "styled",
  componentId: "sc-1cw8kp1-1"
})(["display:flex;align-items:center;&{", ";}"], theme('fannypack.Checkbox.label'));

var Checkbox = function Checkbox(_ref) {
  var autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      id = _ref.id,
      indeterminate = _ref.indeterminate,
      isRequired = _ref.isRequired,
      label = _ref.label,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, ["autoFocus", "checked", "className", "defaultChecked", "disabled", "id", "indeterminate", "isRequired", "label", "onBlur", "onChange", "onFocus", "name", "state", "value"]);

  return createElement(_Checkbox, _extends({
    "aria-describedby": "label",
    "aria-invalid": state === 'danger',
    "aria-label": label,
    "aria-required": isRequired
  }, props), createElement(HiddenCheckbox, {
    autoFocus: autoFocus,
    checked: checked,
    defaultChecked: defaultChecked,
    disabled: disabled,
    id: id,
    indeterminate: indeterminate,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    name: name,
    state: state,
    type: "checkbox" // @ts-ignore
    ,
    value: value
  }), createElement(CheckboxIcon, {
    state: state
  }), label && createElement(_Text, {
    id: "label",
    htmlFor: id,
    marginLeft: "minor-2"
  }, label));
};
var checkboxPropTypes = {
  autoFocus: bool,
  checked: bool,
  className: string,
  defaultChecked: bool,
  disabled: bool,
  id: string,
  indeterminate: bool,
  isRequired: bool,
  label: string,
  name: string,
  state: string,
  value: oneOfType([bool, string]),
  onBlur: func,
  onChange: func,
  onFocus: func
};
Checkbox.propTypes = checkboxPropTypes;
var checkboxDefaultProps = {
  autoFocus: false,
  checked: undefined,
  className: undefined,
  defaultChecked: undefined,
  disabled: false,
  id: undefined,
  indeterminate: false,
  isRequired: false,
  label: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  name: undefined,
  state: undefined,
  value: undefined
};
Checkbox.defaultProps = checkboxDefaultProps; // @ts-ignore

var C = Checkbox;

var CheckboxField = function CheckboxField(_ref) {
  var a11yId = _ref.a11yId,
      autoFocus = _ref.autoFocus,
      checkboxLabel = _ref.checkboxLabel,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      description = _ref.description,
      disabled = _ref.disabled,
      hint = _ref.hint,
      label = _ref.label,
      indeterminate = _ref.indeterminate,
      id = _ref.id,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      state = _ref.state,
      validationText = _ref.validationText,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yId", "autoFocus", "checkboxLabel", "checked", "className", "defaultChecked", "description", "disabled", "hint", "label", "indeterminate", "id", "isOptional", "isRequired", "onBlur", "onChange", "onFocus", "name", "state", "validationText", "value"]);

  return createElement(FieldWrapper, _extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return createElement(C, _extends({
      autoFocus: autoFocus,
      checked: checked,
      className: className,
      defaultChecked: defaultChecked,
      disabled: disabled,
      id: id,
      indeterminate: indeterminate,
      isRequired: isRequired,
      label: checkboxLabel,
      name: name,
      state: state // @ts-ignore
      ,
      value: value,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus
    }, elementProps));
  });
};
CheckboxField.propTypes = _objectSpread({
  checkboxLabel: string
}, checkboxPropTypes, _omit(fieldWrapperPropTypes, 'children'));
CheckboxField.defaultProps = _objectSpread({}, checkboxDefaultProps, fieldWrapperDefaultProps); // @ts-ignore

var C$1 = CheckboxField;

export default C;
export { C as Checkbox, C$1 as CheckboxField };
