import { b as _extends, c as _objectWithoutPropertiesLoose, d as _inheritsLoose, e as _assertThisInitialized, f as _defineProperty } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import Code from 'reakit/Code';
import SyntaxHighlighter, { registerLanguage } from 'react-syntax-highlighter/prism-light';
import defaultTheme from 'react-syntax-highlighter/styles/prism/coy';
import javascript from 'react-syntax-highlighter/languages/prism/javascript';
import jsx from 'react-syntax-highlighter/languages/prism/jsx';
import json from 'react-syntax-highlighter/languages/prism/json';
import { darken } from 'polished';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';

var _Code = styled(Code).withConfig({
  displayName: "styled",
  componentId: "sc-1otm95n-0"
})(["background-color:", ";border-radius:0.1rem;color:", ";font-family:'SF Mono','Segoe UI Mono','Roboto Mono',Menlo,Courier,monospace;code&{padding:0.1rem 0.2rem;", ";}pre&{padding:1rem;", ";}&{", ";}"], darken(0.05, 'white'), palette('text'), theme('fannypack.Code.inline'), theme('fannypack.Code.block'), theme('fannypack.Code.base'));

var Code$1 = function Code$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      codeClassName = _ref.codeClassName,
      isBlock = _ref.isBlock,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "className", "codeClassName", "isBlock"]);

  return createElement(_Code, _extends({
    block: isBlock
  }, props), children);
};
Code$1.propTypes = {
  children: node.isRequired,
  className: string,
  codeClassName: string,
  isBlock: bool
};
Code$1.defaultProps = {
  className: undefined,
  codeClassName: undefined,
  isBlock: false
};
var C = Code$1;

var Wrapper = styled(Box).withConfig({
  displayName: "HighlightedCode__Wrapper",
  componentId: "kn73h9-0"
})(["", ";"], function (props) {
  return props.showLabel && css(["position:relative;&:before{color:", ";content:'", "';font-family:'SF Mono','Segoe UI Mono','Roboto Mono',Menlo,Courier,monospace;font-size:0.8rem;font-weight:bold;position:absolute;right:0.5rem;top:0.2rem;text-transform:uppercase;}"], palette('text'), function (props) {
    return props.lang;
  });
});
var HighlightedCode =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(HighlightedCode, _React$PureComponent);

  function HighlightedCode() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentDidMount", function () {
      registerLanguage('javascript', javascript);
      registerLanguage('jsx', jsx);
      registerLanguage('json', json);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          codeClassName = _this$props.codeClassName,
          isBlock = _this$props.isBlock,
          lang = _this$props.lang,
          showLineNumbers = _this$props.showLineNumbers,
          props = _objectWithoutPropertiesLoose(_this$props, ["children", "className", "codeClassName", "isBlock", "lang", "showLineNumbers"]);

      return createElement(Wrapper, _extends({
        lang: lang
      }, props), createElement(SyntaxHighlighter, {
        className: className,
        codeClassName: codeClassName,
        block: isBlock,
        language: lang,
        showLineNumbers: showLineNumbers,
        style: defaultTheme,
        PreTag: C
      }, children));
    });

    return _this;
  }

  return HighlightedCode;
}(PureComponent); // @ts-ignore

_defineProperty(HighlightedCode, "propTypes", {
  children: node.isRequired,
  className: string,
  codeClassName: string,
  isBlock: bool,
  lang: string.isRequired,
  showLabel: bool,
  showLineNumbers: bool
});

_defineProperty(HighlightedCode, "defaultProps", {
  className: undefined,
  codeClassName: undefined,
  isBlock: false,
  showLabel: false,
  showLineNumbers: false
});

var C$1 = HighlightedCode;

export default C;
export { C as Code, C$1 as HighlightedCode };
