import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import { a as ColumnsContext } from './chunk-2e24b33b.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';

var getWrapProperties = function getWrapProperties(props) {
  var isOneLine = props.isOneLine,
      minBreakpoint = props.minBreakpoint;

  if (isOneLine) {
    if (minBreakpoint !== 'tablet' && minBreakpoint !== 'mobile') {
      return css(["@media (max-width:", "px){flex-wrap:wrap;}"], theme('fannypack.layout.tabletBreakpoint'));
    }

    if (minBreakpoint !== 'mobile') {
      return css(["@media (max-width:", "px){flex-wrap:wrap;}"], theme('fannypack.layout.mobileBreakpoint'));
    }

    return null;
  } else {
    return css(["flex-wrap:wrap;"]);
  }
};

var _Columns = styled(Box).withConfig({
  displayName: "styled",
  componentId: "otaduv-0"
})(["display:flex;", ";", ";&{", ";}"], function (props) {
  return !props.isGapless && css(["margin-left:-", "rem;margin-right:-", "rem;margin-top:-", "rem;&:last-child{margin-bottom:-", "rem;}"], theme('fannypack.layout.gapFactor'), theme('fannypack.layout.gapFactor'), theme('fannypack.layout.gapFactor'), theme('fannypack.layout.gapFactor'));
}, getWrapProperties, theme('fannypack.Columns.base'));

var Columns = function Columns(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isGapless = _ref.isGapless,
      isOneLine = _ref.isOneLine,
      minBreakpoint = _ref.minBreakpoint,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "className", "isGapless", "isOneLine", "minBreakpoint"]);

  return createElement(ColumnsContext.Provider, {
    value: {
      isGapless: isGapless,
      minBreakpoint: minBreakpoint
    }
  }, createElement(_Columns, _extends({
    className: className,
    isGapless: isGapless,
    isOneLine: isOneLine,
    minBreakpoint: minBreakpoint
  }, props), children));
};
Columns.propTypes = {
  children: node.isRequired,
  className: string,
  isGapless: bool,
  isOneLine: bool,
  minBreakpoint: oneOf(['tablet', 'mobile'])
};
Columns.defaultProps = {
  className: undefined,
  isGapless: false,
  isOneLine: false,
  minBreakpoint: undefined
};
var C = Columns;

export default C;
export { C as Columns };
