import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import { breakpointPropType } from './types.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';

var alignProperties = {
  left: css(["margin-right:auto;"]),
  center: css(["margin-left:auto;margin-right:auto;"]),
  right: css(["margin-left:auto;"])
};

var getResponsiveProperties = function getResponsiveProperties(props) {
  var breakpoint = props.breakpoint,
      isFluid = props.isFluid;
  if (isFluid) return;

  if (breakpoint) {
    return css(["&{max-width:", "px;}"], theme("fannypack.layout." + breakpoint + "Breakpoint"));
  }

  return css(["@media (max-width:", "px){max-width:", "px;}@media (max-width:", "px){max-width:", "px;}@media (max-width:", "px){max-width:", "px;}"], function (props) {
    return theme('fannypack.layout.fullHDBreakpoint')(props) + 128;
  }, theme('fannypack.layout.widescreenBreakpoint'), function (props) {
    return theme('fannypack.layout.widescreenBreakpoint')(props) + 128;
  }, theme('fannypack.layout.desktopBreakpoint'), function (props) {
    return theme('fannypack.layout.desktopBreakpoint')(props) + 128;
  }, theme('fannypack.layout.tabletBreakpoint'));
};

var _Container = styled(Box).withConfig({
  displayName: "styled",
  componentId: "sc-144wh3b-0"
})(["width:100%;", ";", ";", ";", ";", ";", ";"], function (props) {
  return !props.isFluid && css(["max-width:", "px;"], theme('fannypack.layout.fullHDBreakpoint'));
}, function (props) {
  return props.isFluid && css(["margin:", ";"], theme('fannypack.Container.fluidMargin'));
}, function (props) {
  return props.isLayout && css(["@media (max-width:", "px){margin:", ";}"], theme('fannypack.layout.tabletBreakpoint'), theme('fannypack.Container.tabletMargin'));
}, getResponsiveProperties, function (props) {
  return props.align && !props.isFluid ? alignProperties[props.align] : null;
}, theme('fannypack.Container.base'));

var Container = function Container(_ref) {
  var align = _ref.align,
      children = _ref.children,
      className = _ref.className,
      props = _objectWithoutPropertiesLoose(_ref, ["align", "children", "className"]);

  return createElement(_Container, _extends({
    className: className,
    align: align
  }, props), children);
};
Container.propTypes = {
  align: oneOf(['left', 'right', 'center']),
  breakpoint: breakpointPropType,
  children: node.isRequired,
  className: string,
  isFluid: bool,
  isLayout: bool
};
Container.defaultProps = {
  align: 'center',
  breakpoint: undefined,
  className: undefined,
  isFluid: false,
  isLayout: false
};
var C = Container;

export default C;
export { C as Container };
