import { a as _objectSpread, b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { space } from './styled.js';
import { a as Icon } from './chunk-51b7d577.js';
import { a as Button, b as buttonPropTypes } from './chunk-0ba092a8.js';
import { a as ActionButtons, b as actionButtonsPropTypes } from './chunk-c400d1e8.js';
import { Heading } from './Heading.js';
import VisuallyHidden from './VisuallyHidden.js';
import { a as Pane, b as panePropTypes, c as paneDefaultProps } from './chunk-a1e5c7d9.js';
import { getUniqueId } from './uniqueId.js';
import _omit from 'lodash/omit';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'airbnb-prop-types';
import './types.js';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-e8f72546.js';
import 'reakit/Heading';
import 'classnames';
import 'lodash/uniqueId';

var DialogContent = styled(Box).withConfig({
  displayName: "styled__DialogContent",
  componentId: "sc-1loaala-0"
})(["padding:", "rem;max-height:50vh;overflow-y:scroll;width:100%;&{", ";}"], space(5), theme('fannypack.Dialog.Content.base'));
var DialogHeader = styled(Box).withConfig({
  displayName: "styled__DialogHeader",
  componentId: "sc-1loaala-1"
})(["align-items:center;background-color:", ";display:flex;justify-content:space-between;padding:", "rem;width:100%;&{", ";}"], palette('white700'), space(5), theme('fannypack.Dialog.Header.base'));
var DialogFooter = styled(Box).withConfig({
  displayName: "styled__DialogFooter",
  componentId: "sc-1loaala-2"
})(["display:flex;align-items:center;background-color:", ";padding:", "rem ", "rem;width:100%;&{", ";}"], palette('white700'), space(4), space(4), theme('fannypack.Dialog.Footer.base'));
var DialogTitle = styled(Heading).withConfig({
  displayName: "styled__DialogTitle",
  componentId: "sc-1loaala-3"
})(["margin-bottom:0px;&{", ";}"], theme('fannypack.Dialog.Title.base'));
var DialogClose = styled(Button).withConfig({
  displayName: "styled__DialogClose",
  componentId: "sc-1loaala-4"
})(["height:2em;width:2em;padding:0px;&:hover{background-color:", ";&{", ";}}&{", ";}"], palette('white700'), theme('fannypack.Dialog.Close.hover'), theme('fannypack.Dialog.Close.base'));
var DialogIcon = styled(Icon).withConfig({
  displayName: "styled__DialogIcon",
  componentId: "sc-1loaala-5"
})(["margin-right:", "rem;&{", ";}"], space(2), theme('fannypack.Dialog.Icon.base'));
var Dialog = styled(Pane).withConfig({
  displayName: "styled",
  componentId: "sc-1loaala-6"
})(["border-radius:5px;&:focus{outline:unset;}&{", ";}"], theme('fannypack.Dialog.base'));

var DialogDialog = function DialogDialog(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      kind = _ref.kind,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "children", "kind"]);

  return createElement(Dialog, _extends({
    "aria-describedby": a11yDescriptionId,
    "aria-labelledby": a11yTitleId,
    role: kind === 'alert' ? 'alertdialog' : 'dialog'
  }, props), children);
};
var dialogDialogPropTypes = _objectSpread({
  a11yDescriptionId: string,
  a11yTitleId: string,
  className: string,
  kind: oneOf(['alert'])
}, panePropTypes, {
  children: node.isRequired
});
DialogDialog.propTypes = dialogDialogPropTypes;
var dialogDialogDefaultProps = _objectSpread({}, paneDefaultProps, {
  a11yDescriptionId: undefined,
  a11yTitleId: undefined,
  border: true,
  className: undefined,
  kind: undefined
});
DialogDialog.defaultProps = dialogDialogDefaultProps;
var C = DialogDialog;

var DialogContent$1 = function DialogContent$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(DialogContent, props, children);
};
DialogContent$1.propTypes = {
  children: node.isRequired,
  className: string
};
DialogContent$1.defaultProps = {
  className: undefined
};
var C$1 = DialogContent$1;

var DialogHeader$1 = function DialogHeader$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(DialogHeader, props, children);
};
DialogHeader$1.propTypes = {
  children: node.isRequired,
  className: string
};
DialogHeader$1.defaultProps = {
  className: undefined
};
var C$2 = DialogHeader$1;

var DialogFooter$1 = function DialogFooter$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(DialogFooter, props, children);
};
DialogFooter$1.propTypes = {
  children: node.isRequired,
  className: string
};
DialogFooter$1.defaultProps = {
  className: undefined
};
var C$3 = DialogFooter$1;

var DialogTitle$1 = function DialogTitle$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(DialogTitle, _extends({
    use: "h5",
    isSubHeading: true
  }, props), children);
};
DialogTitle$1.propTypes = {
  children: node.isRequired,
  className: string
};
DialogTitle$1.defaultProps = {
  className: undefined
};
var C$4 = DialogTitle$1;

var DialogClose$1 = function DialogClose$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(DialogClose, _extends({
    kind: "link"
  }, props), createElement(VisuallyHidden, null, "Close"), createElement(Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
DialogClose$1.propTypes = {
  className: string
};
DialogClose$1.defaultProps = {
  className: undefined
};
var C$5 = DialogClose$1;

// @ts-ignore
var DialogIcon$1 = function DialogIcon$$1(props) {
  return createElement(DialogIcon, props);
};
DialogIcon$1.propTypes = {
  className: string,
  icon: string.isRequired
};
DialogIcon$1.defaultProps = {
  className: undefined
}; // @ts-ignore

var C$6 = DialogIcon$1;

var Dialog$1 = function Dialog(_ref) {
  var actionButtonsProps = _ref.actionButtonsProps,
      a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      closeButtonProps = _ref.closeButtonProps,
      footer = _ref.footer,
      onClickClose = _ref.onClickClose,
      showActionButtons = _ref.showActionButtons,
      showCloseButton = _ref.showCloseButton,
      title = _ref.title,
      type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, ["actionButtonsProps", "a11yDescriptionId", "a11yTitleId", "children", "closeButtonProps", "footer", "onClickClose", "showActionButtons", "showCloseButton", "title", "type"]);

  return createElement(C, _extends({
    a11yDescriptionId: a11yDescriptionId,
    a11yTitleId: a11yTitleId
  }, props), title && createElement(C$2, null, typeof title === 'string' ? createElement(C$4, {
    id: a11yTitleId
  }, type && createElement(C$6, {
    a11yHidden: true,
    color: type,
    icon: type
  }), title) : title, showCloseButton && createElement(C$5, _extends({
    onClick: onClickClose
  }, closeButtonProps))), createElement(C$1, {
    id: a11yDescriptionId
  }, children), (footer || showActionButtons) && createElement(C$3, {
    justifyContent: footer ? 'space-between' : 'flex-end'
  }, footer && createElement(Box, null, footer), showActionButtons && createElement(Box, null, createElement(ActionButtons, actionButtonsProps))));
};
Dialog$1.Dialog = C;
Dialog$1.Header = C$2;
Dialog$1.Content = C$1;
Dialog$1.Footer = C$3;
Dialog$1.Title = C$4;
Dialog$1.Close = C$5;
Dialog$1.Icon = C$6;
Dialog$1.propTypes = _objectSpread({
  actionButtonsProps: shape(actionButtonsPropTypes),
  a11yDescriptionId: string,
  a11yTitleId: string,
  children: node.isRequired,
  className: string,
  closeButtonProps: shape(_omit(buttonPropTypes, 'children')),
  footer: oneOfType([string, element]),
  onClickClose: func,
  showActionButtons: bool,
  showCloseButton: bool,
  title: oneOfType([string, element]),
  type: string
}, dialogDialogPropTypes);
Dialog$1.defaultProps = _objectSpread({}, dialogDialogDefaultProps, {
  actionButtonsProps: {},
  a11yDescriptionId: getUniqueId('Dialog'),
  a11yTitleId: getUniqueId('Dialog'),
  className: undefined,
  closeButtonProps: {},
  footer: undefined,
  onClickClose: undefined,
  showActionButtons: false,
  showCloseButton: false,
  title: undefined,
  type: undefined
}); // @ts-ignore

var C$7 = Dialog$1;

export default C$7;
export { C$7 as Dialog, C$1 as DialogContent, C$5 as DialogClose, C as DialogDialog, C$3 as DialogFooter, C$2 as DialogHeader, C$4 as DialogTitle, C$6 as DialogIcon };
