import { b as _extends, a as _objectSpread, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import { animateDefaultProps, animatePropTypes, restrictDefaultProps, restrictHidePropTypes } from './types.js';
import { b as actionButtonsPropTypes } from './chunk-c400d1e8.js';
import { getUniqueId } from './uniqueId.js';
import Dialog from './Dialog.js';
import { a as Modal } from './chunk-787112f7.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import './chunk-0ba092a8.js';
import './styled.js';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import './chunk-51b7d577.js';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'airbnb-prop-types';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-e8f72546.js';
import 'lodash/omit';
import 'lodash/uniqueId';
import './Heading.js';
import 'reakit/Heading';
import 'classnames';
import './VisuallyHidden.js';
import './chunk-a1e5c7d9.js';
import './Backdrop.js';
import 'reakit/Backdrop';
import './Overlay-4abbaad8.js';
import 'reakit/Overlay';
import './chunk-dc5258d0.js';
import 'focus-trap';
import './Portal.js';
import 'reakit/Portal';

var DialogModal = function DialogModal(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      actionButtonsProps = _ref.actionButtonsProps,
      children = _ref.children,
      footer = _ref.footer,
      hide = _ref.hide,
      kind = _ref.kind,
      showActionButtons = _ref.showActionButtons,
      showCloseButton = _ref.showCloseButton,
      title = _ref.title,
      type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "actionButtonsProps", "children", "footer", "hide", "kind", "showActionButtons", "showCloseButton", "title", "type"]);

  return createElement(Modal, _extends({
    hide: hide,
    kind: kind
  }, props), function (_ref2) {
    var fallbackFocusRef = _ref2.fallbackFocusRef,
        initialFocusRef = _ref2.initialFocusRef;
    return createElement(Dialog, {
      a11yDescriptionId: a11yDescriptionId,
      a11yTitleId: a11yTitleId,
      actionButtonsProps: _objectSpread({
        cancelProps: _objectSpread({
          elementRef: initialFocusRef,
          use: Modal.Hide,
          // @ts-ignore
          hide: hide
        }, (actionButtonsProps || {}).cancelProps),
        palette: type
      }, actionButtonsProps),
      closeButtonProps: {
        elementRef: initialFocusRef
      },
      elementRef: fallbackFocusRef // @ts-ignore
      ,
      footer: typeof footer === 'function' ? footer({
        initialFocusRef: initialFocusRef
      }) : footer,
      onClickClose: hide,
      role: kind === 'alert' ? 'alertdialog' : 'dialog',
      showActionButtons: showActionButtons || kind === 'alert',
      showCloseButton: showCloseButton && kind !== 'alert',
      tabIndex: -1 // @ts-ignore
      ,
      title: title,
      type: type,
      width: "100%"
    }, typeof children === 'function' ? children({
      initialFocusRef: initialFocusRef
    }) : children);
  });
};
DialogModal.propTypes = _objectSpread({
  a11yDescriptionId: string,
  a11yTitleId: string,
  actionButtonsProps: shape(actionButtonsPropTypes),
  children: oneOfType([node, func]).isRequired,
  className: string,
  footer: oneOfType([func, string, element]),
  hide: func,
  isVisible: bool,
  kind: oneOf(['alert']),
  showActionButtons: bool,
  showCloseButton: bool,
  title: oneOfType([string, element]),
  type: string
}, animatePropTypes, restrictHidePropTypes);
DialogModal.defaultProps = _objectSpread({
  actionButtonsProps: {},
  a11yDescriptionId: getUniqueId('Modal'),
  a11yTitleId: getUniqueId('Modal'),
  className: undefined,
  footer: undefined,
  isVisible: false,
  kind: undefined,
  showActionButtons: false,
  showCloseButton: false,
  title: undefined,
  type: undefined
}, animateDefaultProps, restrictDefaultProps, {
  hideOnEsc: true,
  hideOnClickOutside: true
}); // @ts-ignore

var C = DialogModal;

export default C;
export { C as DialogModal };
