import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import Divider from 'reakit/Divider';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/styled';
import 'lodash/get';

var contentProperties = css(["display:flex;align-items:center;justify-content:center;&::before{background:white;color:#c3c3c3;content:'", "';text-transform:uppercase;font-size:0.7em;font-weight:", ";padding:0.2rem 0.5rem;&{", "}}"], function (props) {
  return props.content;
}, theme('fannypack.fontWeights.bold'), theme('fannypack.Divider.content'));
var verticalProperties = css(["height:auto;&{", ";}"], theme('fannypack.Divider.vertical'));
var _Divider = styled(Divider).withConfig({
  displayName: "styled",
  componentId: "sc-1rdxdja-0"
})(["opacity:1;border-color:#e7e9ed;&{", ";", ";}&{", ";}"], function (props) {
  return props.content && contentProperties;
}, function (props) {
  return props.vertical && verticalProperties;
}, theme('fannypack.Divider.base'));

var Divider$1 = function Divider$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      content = _ref.content,
      isVertical = _ref.isVertical,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "className", "content", "isVertical"]);

  return createElement(_Divider, _extends({
    className: className,
    content: content,
    vertical: isVertical
  }, props), children);
};
Divider$1.propTypes = {
  children: node,
  className: string,
  content: string,
  isVertical: bool
};
Divider$1.defaultProps = {
  children: null,
  className: undefined,
  content: undefined,
  isVertical: false
};
var C = Divider$1;

export default C;
export { C as Divider };
