import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css, withTheme } from './styled.js';
import { breakpointPropType } from './types.js';
import Group from 'reakit/Group';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import _get from 'lodash/get';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/styled';

var _Group = styled(Group).withConfig({
  displayName: "styled",
  componentId: "sc-1cm5zaa-0"
})(["& > *{border-radius:4px;}& input:focus,& select:focus{z-index:1;position:relative;}& > *:first-child{& input,& select{", ";}}& > *:last-child{& input,& select{", ";}}& > *:not(:first-child):not(:last-child) > input,& > *:not(:first-child):not(:last-child) > select{border-radius:0;}&{", ";}"], function (props) {
  return props.vertical ? css(["border-bottom-right-radius:0;border-bottom-left-radius:0;"]) : css(["border-bottom-right-radius:0;border-top-right-radius:0;"]);
}, function (props) {
  return props.vertical ? css(["border-top-left-radius:0;border-top-right-radius:0;"]) : css(["border-top-left-radius:0;border-bottom-left-radius:0;"]);
}, theme('fannypack.Group.base'));

var getVerticalBreakpoint = function getVerticalBreakpoint(_ref) {
  var breakpoint = _ref.breakpoint,
      theme$$1 = _ref.theme;
  return typeof breakpoint === 'number' ? breakpoint : _get(theme$$1, "fannypack.layout[" + breakpoint + "Breakpoint]");
};

var Group$1 = function Group$$1(_ref2) {
  var children = _ref2.children,
      className = _ref2.className,
      isVertical = _ref2.isVertical,
      theme$$1 = _ref2.theme,
      _verticalAt = _ref2.verticalAt,
      props = _objectWithoutPropertiesLoose(_ref2, ["children", "className", "isVertical", "theme", "verticalAt"]);

  var verticalAt = getVerticalBreakpoint({
    breakpoint: _verticalAt,
    theme: theme$$1
  });
  return createElement(_Group, _extends({
    className: className,
    vertical: isVertical,
    verticalAt: verticalAt
  }, props), children);
};
Group$1.propTypes = {
  children: node.isRequired,
  className: string,
  isVertical: bool,
  theme: object,
  verticalAt: oneOfType([breakpointPropType, number])
};
Group$1.defaultProps = {
  className: undefined,
  isVertical: false,
  theme: {},
  verticalAt: undefined
}; // @ts-ignore

var C = withTheme(Group$1);

export default C;
export { C as Group };
