import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css, space, theme } from './styled.js';
import { a as Icon } from './chunk-d1ea7076.js';
import Heading from 'reakit/Heading';
import classNames from 'classnames';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';

var subHeadingProperties = css(["font-weight:", ";&{", ";}"], theme('fannypack.fontWeights.semibold'), theme('fannypack.Heading.subHeading'));
var _Heading = styled(Heading).withConfig({
  displayName: "styled",
  componentId: "cya4kb-0"
})(["font-weight:", ";line-height:1.2;&:not(:last-child){margin-bottom:", "rem;}.heading& + .sub-heading{margin-top:-1rem;}h1&{font-size:", "rem;&{", ";}}h2&{font-size:", "rem;&{", ";}}h3&{font-size:", "rem;&{", ";}}h4&{font-size:", "rem;&{", ";}}h5&{font-size:", "rem;&{", ";}}h6&{font-size:", "rem;&{", ";}}& ", "{top:0.15em;}&{", ";}", ";"], theme('fannypack.fontWeights.bold'), space(4), theme('fannypack.fontSizes.700'), theme('fannypack.Heading.h1'), theme('fannypack.fontSizes.600'), theme('fannypack.Heading.h2'), theme('fannypack.fontSizes.500'), theme('fannypack.Heading.h3'), theme('fannypack.fontSizes.400'), theme('fannypack.Heading.h4'), theme('fannypack.fontSizes.300'), theme('fannypack.Heading.h5'), theme('fannypack.fontSizes.200'), theme('fannypack.Heading.h6'), Icon, function (props) {
  return props.isSubHeading && subHeadingProperties;
}, theme('fannypack.Heading.base'));

var Heading$1 = function Heading$$1(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      isSubHeading = _ref.isSubHeading,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "className", "isSubHeading"]);

  return createElement(_Heading, _extends({
    className: classNames((_classNames = {}, _classNames[className || ''] = Boolean(className), _classNames.heading = !isSubHeading, _classNames['sub-heading'] = isSubHeading, _classNames)),
    isSubHeading: isSubHeading
  }, props), children);
};
Heading$1.propTypes = {
  children: node.isRequired,
  className: string,
  isSubHeading: bool
};
Heading$1.defaultProps = {
  className: undefined,
  isSubHeading: false
}; // @ts-ignore

var C = Heading$1;

export default C;
export { C as Heading };
