import { b as _extends, a as _objectSpread, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { theme } from './styled.js';
import { animateDefaultProps, animatePropTypes, restrictDefaultProps, restrictHidePropTypes } from './types.js';
import Hidden from 'reakit/Hidden';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';

var HiddenContainer = function HiddenContainer(_ref) {
  var children = _ref.children,
      defaultVisible = _ref.defaultVisible,
      initialState = _ref.initialState,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "defaultVisible", "initialState"]);

  return createElement(Hidden.Container, _extends({
    initialState: _objectSpread({
      visible: defaultVisible
    }, initialState)
  }, props), function (_ref2) {
    var visible = _ref2.visible,
        rest = _objectWithoutPropertiesLoose(_ref2, ["visible"]);

    return children(_objectSpread({
      isVisible: visible
    }, rest));
  });
};
HiddenContainer.propTypes = {
  children: func.isRequired,
  defaultVisible: bool,
  initialState: object
};
HiddenContainer.defaultProps = {
  defaultVisible: false,
  initialState: {}
};

var HiddenHide = styled(Hidden.Hide).withConfig({
  displayName: "styled__HiddenHide",
  componentId: "sc-1iaaa8w-0"
})(["", ";"], theme('fannypack.Hidden.Hide.base'));
var HiddenShow = styled(Hidden.Show).withConfig({
  displayName: "styled__HiddenShow",
  componentId: "sc-1iaaa8w-1"
})(["", ";"], theme('fannypack.Hidden.Show.base'));
var HiddenToggle = styled(Hidden.Toggle).withConfig({
  displayName: "styled__HiddenToggle",
  componentId: "sc-1iaaa8w-2"
})(["", ";"], theme('fannypack.Hidden.Toggle.base'));
var _Hidden = styled(Hidden).withConfig({
  displayName: "styled",
  componentId: "sc-1iaaa8w-3"
})(["&{", ";}"], theme('fannypack.Hidden.base'));

var HiddenShow$1 = function HiddenShow$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(HiddenShow, props, children);
};
HiddenShow$1.propTypes = {
  children: node,
  onClick: func,
  show: func.isRequired
};
HiddenShow$1.defaultProps = {
  children: null,
  onClick: undefined
}; // @ts-ignore

var C = HiddenShow$1;

var HiddenHide$1 = forwardRef(function (_ref, ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return (// @ts-ignore
    createElement(HiddenHide, _extends({}, props, {
      ref: ref
    }), children)
  );
});
HiddenHide$1.propTypes = {
  children: node,
  hide: func.isRequired,
  onClick: func
};
HiddenHide$1.defaultProps = {
  children: null,
  onClick: undefined
}; // @ts-ignore

var C$1 = HiddenHide$1;

var HiddenToggle$1 = function HiddenToggle$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(HiddenToggle, props, children);
};
HiddenToggle$1.propTypes = {
  children: node,
  onClick: func,
  toggle: func.isRequired
};
HiddenToggle$1.defaultProps = {
  children: null,
  onClick: undefined
};
var C$2 = HiddenToggle$1;

var Hidden$1 = function Hidden$$1(_ref) {
  var children = _ref.children,
      isVisible = _ref.isVisible,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "isVisible"]);

  return createElement(_Hidden, _extends({
    visible: isVisible
  }, props), children);
};
Hidden$1.Container = HiddenContainer;
Hidden$1.Show = C;
Hidden$1.Hide = C$1;
Hidden$1.Toggle = C$2;
Hidden$1.propTypes = _objectSpread({}, animatePropTypes, restrictHidePropTypes, {
  children: node.isRequired,
  className: string,
  isVisible: bool
});
Hidden$1.defaultProps = _objectSpread({}, animateDefaultProps, restrictDefaultProps, {
  className: undefined,
  isVisible: undefined
}); // @ts-ignore

var C$3 = Hidden$1;

export default C$3;
export { C$3 as Hidden, HiddenContainer, C$1 as HiddenHide, C as HiddenShow, C$2 as HiddenToggle };
