import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import Image from 'reakit/Image';
import classNames from 'classnames';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/styled';
import 'lodash/get';

var fitProperties = function fitProperties(props) {
  if (!props.fit) return;

  if (props.fit === 'contain') {
    return css(["object-fit:contain;", ";", ";", ";"], function (props) {
      return props.fitPosition ? css(["object-position:", ";"], props.fitPosition) : '';
    }, theme('fannypack.Image.fit.base'), theme('fannypack.Image.fit.contain'));
  }

  if (props.fit === 'cover') {
    return css(["object-fit:cover;", ";", ";", ";"], function (props) {
      return props.fitPosition ? css(["object-position:", ";"], props.fitPosition) : '';
    }, theme('fannypack.Image.fit.base'), theme('fannypack.Image.fit.cover'));
  }

  return null;
};

var fixedProperties = function fixedProperties(props) {
  if (!props.isFixed) return;
  return css(["max-width:unset;", ";"], theme('fannypack.Image.fixed'));
};

var _Image = styled(Image).withConfig({
  displayName: "styled",
  componentId: "sc-19nzt74-0"
})(["max-width:100%;&{", ";}&{", ";}", ";"], fitProperties, fixedProperties, theme('fannypack.Image.base'));

var Image$1 = function Image$$1(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      isFixed = _ref.isFixed,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "className", "isFixed"]);

  return createElement(_Image, _extends({
    className: classNames((_classNames = {}, _classNames[className || ''] = Boolean(className), _classNames)),
    isFixed: isFixed
  }, props), children);
};
Image$1.propTypes = {
  children: node,
  className: string,
  fit: oneOf(['cover', 'contain']),
  fitPosition: string,
  isFixed: bool
};
Image$1.defaultProps = {
  className: undefined,
  fit: undefined,
  fitPosition: undefined,
  isFixed: false
};
var C = Image$1;

export default C;
export { C as Image };
