import { a as _objectSpread, b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import { a as FieldWrapper, b as fieldWrapperDefaultProps, c as fieldWrapperPropTypes } from './chunk-b8380805.js';
import { Group } from './Group.js';
import { a as Input, b as inputDefaultProps, c as inputPropTypes } from './chunk-4cd67ec0.js';
import ConditionalWrap from 'conditional-wrap';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import './styled.js';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import './Text.js';
import './chunk-d1ea7076.js';
import 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import './Label.js';
import 'reakit/Label';
import 'reakit/Field';
import './types.js';
import 'reakit/Group';
import './chunk-51b7d577.js';
import './parseIcons.js';
import 'airbnb-prop-types';
import './Spinner.js';
import 'reakit/Input';

var InputField = function InputField(_ref) {
  var addonBefore = _ref.addonBefore,
      addonAfter = _ref.addonAfter,
      a11yId = _ref.a11yId,
      description = _ref.description,
      hint = _ref.hint,
      isOptional = _ref.isOptional,
      isVertical = _ref.isVertical,
      label = _ref.label,
      validationText = _ref.validationText,
      after = _ref.after,
      a11yLabel = _ref.a11yLabel,
      autoComplete = _ref.autoComplete,
      autoFocus = _ref.autoFocus,
      before = _ref.before,
      children = _ref.children,
      className = _ref.className,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      isLoading = _ref.isLoading,
      isRequired = _ref.isRequired,
      name = _ref.name,
      size = _ref.size,
      max = _ref.max,
      maxLength = _ref.maxLength,
      min = _ref.min,
      minLength = _ref.minLength,
      multiple = _ref.multiple,
      pattern = _ref.pattern,
      placeholder = _ref.placeholder,
      readOnly = _ref.readOnly,
      spellCheck = _ref.spellCheck,
      step = _ref.step,
      state = _ref.state,
      type = _ref.type,
      value = _ref.value,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      props = _objectWithoutPropertiesLoose(_ref, ["addonBefore", "addonAfter", "a11yId", "description", "hint", "isOptional", "isVertical", "label", "validationText", "after", "a11yLabel", "autoComplete", "autoFocus", "before", "children", "className", "defaultValue", "disabled", "isLoading", "isRequired", "name", "size", "max", "maxLength", "min", "minLength", "multiple", "pattern", "placeholder", "readOnly", "spellCheck", "step", "state", "type", "value", "onBlur", "onChange", "onFocus"]);

  return createElement(FieldWrapper, _extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return createElement(ConditionalWrap, {
      condition: addonBefore || addonAfter,
      wrap: function wrap(children) {
        return createElement(Group, {
          isVertical: isVertical
        }, children);
      }
    }, addonBefore, createElement(Input, _extends({
      after: after,
      a11yId: a11yId,
      a11yLabel: a11yLabel,
      autoComplete: autoComplete,
      autoFocus: autoFocus,
      before: before,
      className: className,
      defaultValue: defaultValue,
      disabled: disabled,
      isLoading: isLoading,
      isRequired: isRequired,
      name: name,
      size: size,
      max: max,
      maxLength: maxLength,
      min: min,
      minLength: minLength,
      multiple: multiple,
      pattern: pattern,
      placeholder: placeholder,
      readOnly: readOnly,
      spellCheck: spellCheck,
      step: step,
      state: state,
      type: type,
      value: value,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus
    }, elementProps), children), addonAfter);
  });
};
var inputFieldPropTypes = _objectSpread({
  addonBefore: element,
  addonAfter: element,
  isVertical: bool
}, fieldWrapperPropTypes, inputPropTypes);
InputField.propTypes = inputFieldPropTypes;
var inputFieldDefaultProps = _objectSpread({
  addonBefore: undefined,
  addonAfter: undefined,
  isVertical: false
}, fieldWrapperDefaultProps, inputDefaultProps);
InputField.defaultProps = inputFieldDefaultProps; // @ts-ignore

var C = InputField;

export default Input;
export { Input, C as InputField };
