import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css, space } from './styled.js';
import List from 'reakit/List';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';

var orderedProperties = css(["list-style-type:decimal;& &{list-style-type:lower-alpha;}& & &{list-style-type:lower-roman;}&{", ";}"], theme('fannypack.List.ordered'));
var horizontalProperties = css(["& li{display:inline-block;margin-right:1rem;margin-bottom:unset;}&{", ";}"], theme('fannypack.List.horizontal'));
var ListItem = styled(Box).withConfig({
  displayName: "styled__ListItem",
  componentId: "wo6si3-0"
})(["margin-bottom:0.2rem;&{", ";}"], theme('fannypack.List.item.base'));
var _List = styled(List).withConfig({
  displayName: "styled",
  componentId: "wo6si3-1"
})(["list-style:unset;list-style-type:none;&:not(:last-child){margin-bottom:", "rem;}& &{margin-left:", "rem;}&{", ";}&{", ";}&{", ";}"], space(4), space(4), function (props) {
  return props.isOrdered && orderedProperties;
}, function (props) {
  return props.isHorizontal && horizontalProperties;
}, theme('fannypack.List.base'));

var ListItem$1 = function ListItem$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "className"]);

  return createElement(ListItem, _extends({
    use: "li",
    className: className
  }, props), children);
};
ListItem$1.propTypes = {
  children: node.isRequired,
  className: string
};
ListItem$1.defaultProps = {
  className: undefined
};
var C = ListItem$1;

var List$1 = function List$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isOrdered = _ref.isOrdered,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "className", "isOrdered"]);

  return createElement(_List, _extends({
    use: isOrdered ? 'ol' : undefined,
    className: className,
    isOrdered: isOrdered
  }, props), children);
};
List$1.Item = C;
List$1.propTypes = {
  children: node.isRequired,
  className: string,
  isOrdered: bool,
  isHorizontal: bool
};
List$1.defaultProps = {
  className: undefined,
  isOrdered: false,
  isHorizontal: false
};
var C$1 = List$1;

export default C$1;
export { C$1 as List, C as ListItem };
