import { c as _objectWithoutPropertiesLoose, b as _extends, d as _inheritsLoose, e as _assertThisInitialized, f as _defineProperty, a as _objectSpread } from './chunk-cd704477.js';
import { Text as _Text } from './Text.js';
import { Heading } from './Heading.js';
import { Blockquote } from './Blockquote.js';
import { List } from './List.js';
import { Link } from './Link.js';
import { Divider } from './Divider.js';
import { Image } from './Image.js';
import MarkdownRenderer from 'markdown-react-js';
import { Paragraph } from './Paragraph.js';
import Table from './Table.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import _get from 'lodash/get';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import './styled.js';
import 'reakit/styled';
import 'styled-tools';
import './chunk-d1ea7076.js';
import 'reakit/Heading';
import 'classnames';
import 'reakit/Blockquote';
import 'polished';
import 'reakit/List';
import './chunk-b58fa33f.js';
import 'reakit/Link';
import 'reakit/Divider';
import 'reakit/Image';
import 'reakit/Paragraph';
import 'conditional-wrap';

var tags = function tags(props) {
  return {
    p: {
      Component: Paragraph,
      props: _get(props, 'elementProps.p', {})
    },
    strong: {
      Component: _Text,
      props: _objectSpread({
        fontWeight: 'bold'
      }, _get(props, 'elementProps.strong', {}))
    },
    em: {
      Component: _Text,
      props: _objectSpread({
        use: 'em'
      }, _get(props, 'elementProps.em', {}))
    },
    a: {
      Component: Link,
      props: _get(props, 'elementProps.a', {})
    },
    blockquote: {
      Component: Blockquote,
      props: _get(props, 'elementProps.blockquote', {})
    },
    h1: {
      Component: Heading,
      props: _objectSpread({
        use: 'h1'
      }, _get(props, 'elementProps.h1', {}))
    },
    h2: {
      Component: Heading,
      props: _objectSpread({
        use: 'h2'
      }, _get(props, 'elementProps.h2', {}))
    },
    h3: {
      Component: Heading,
      props: _objectSpread({
        use: 'h3'
      }, _get(props, 'elementProps.h3', {}))
    },
    h4: {
      Component: Heading,
      props: _objectSpread({
        use: 'h4'
      }, _get(props, 'elementProps.h4', {}))
    },
    h5: {
      Component: Heading,
      props: _objectSpread({
        use: 'h5'
      }, _get(props, 'elementProps.h5', {}))
    },
    h6: {
      Component: Heading,
      props: _objectSpread({
        use: 'h6'
      }, _get(props, 'elementProps.h6', {}))
    },
    hr: _objectSpread({
      Component: Divider
    }, _get(props, 'elementProps.hr', {})),
    ul: {
      Component: List,
      props: _objectSpread({
        listStyleType: 'disc',
        listStylePosition: 'inside'
      }, _get(props, 'elementProps.ul', {}))
    },
    ol: {
      Component: List,
      props: _objectSpread({
        isOrdered: true,
        listStylePosition: 'inside'
      }, _get(props, 'elementProps.ol', {}))
    },
    li: {
      Component: List.Item,
      props: _get(props, 'elementProps.li', {})
    },
    table: {
      Component: Table,
      props: _get(props, 'elementProps.table', {})
    },
    tbody: {
      Component: Table.Body,
      props: _get(props, 'elementProps.tbody', {})
    },
    thead: {
      Component: Table.Head,
      props: _get(props, 'elementProps.thead', {})
    },
    tfoot: {
      Component: Table.Foot,
      props: _get(props, 'elementProps.tfoot', {})
    },
    tr: {
      Component: Table.Row,
      props: _get(props, 'elementProps.tr', {})
    },
    td: {
      Component: Table.Cell,
      props: _get(props, 'elementProps.td', {})
    },
    th: {
      Component: Table.HeadCell,
      props: _get(props, 'elementProps.th', {})
    },
    img: {
      Component: Image,
      props: _get(props, 'elementProps.img', {})
    }
  };
};

var Markdown =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Markdown, _React$Component);

  function Markdown() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleIterate", function (Tag, props, children) {
      var _ref = tags(_this.props)[Tag] || {
        Component: Tag
      },
          Component$$1 = _ref.Component,
          _ref$props = _ref.props,
          overrideProps = _ref$props === void 0 ? {} : _ref$props;

      return (// @ts-ignore
        createElement(Component$$1, _extends({}, props, overrideProps || {}), children)
      );
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var _this$props = _this.props,
          content = _this$props.content,
          props = _objectWithoutPropertiesLoose(_this$props, ["content"]);

      return createElement(Box, props, createElement(MarkdownRenderer, {
        onIterate: _this.handleIterate,
        text: content
      }));
    });

    return _this;
  }

  return Markdown;
}(Component);

_defineProperty(Markdown, "propTypes", {
  content: string.isRequired,
  elementProps: object
});

_defineProperty(Markdown, "defaultProps", {
  elementProps: {}
});

var C = Markdown;

export default C;
export { C as Markdown };
