import { a as _objectSpread, b as _extends, c as _objectWithoutPropertiesLoose, d as _inheritsLoose, e as _assertThisInitialized, f as _defineProperty } from './chunk-cd704477.js';
import { b as buttonPropTypes, c as buttonDefaultProps } from './chunk-0ba092a8.js';
import { b as navigationPropTypes, c as navigationDefaultProps } from './Navigation-848d4222.js';
import { b as popoverPropTypes, c as popoverDefaultProps } from './Popover-0ad4ce49.js';
import { a as MenuButton, b as withMenuContext, c as MenuDivider, d as MenuGroup, e as MenuGroupTitle, f as MenuContext, g as MenuPopover, h as _Menu, i as MenuItem } from './chunk-07496600.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import './styled.js';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import './types.js';
import './chunk-51b7d577.js';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'airbnb-prop-types';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import 'reakit/Navigation';
import './VisuallyHidden.js';
import './chunk-dc5258d0.js';
import 'focus-trap';
import 'reakit/Popover';
import './chunk-a1e5c7d9.js';
import './chunk-c400d1e8.js';
import './chunk-e8f72546.js';
import 'lodash/omit';
import './Divider.js';
import 'reakit/Divider';

var KEYS = {
  UP: 38,
  DOWN: 40,
  TAB: 9,
  SPACE: 32
};
var MenuButton$1 =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(MenuButton$$1, _React$Component);

  function MenuButton$$1() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleKeyDown", function (e) {
      var _this$props = _this.props,
          context = _this$props.context,
          isVisible = _this$props.isVisible;

      if (!isVisible) {
        if (e.keyCode === KEYS.DOWN || e.keyCode === KEYS.TAB || e.keyCode === KEYS.SPACE || e.keyCode === KEYS.UP) {
          e.preventDefault();
          context && context.handleMenuOpenViaKeyboard({
            startAt: e.keyCode === KEYS.UP ? 'last' : 'first'
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var _this$props2 = _this.props,
          context = _this$props2.context,
          props = _objectWithoutPropertiesLoose(_this$props2, ["context"]);

      return createElement(MenuButton, _extends({
        "aria-haspopup": "menu",
        "aria-expanded": props.isVisible,
        onKeyDown: _this.handleKeyDown
      }, context, props, {
        type: "button"
      }));
    });

    return _this;
  }

  return MenuButton$$1;
}(Component); // @ts-ignore

_defineProperty(MenuButton$1, "propTypes", _objectSpread({}, buttonPropTypes, {
  onClick: func
}));

_defineProperty(MenuButton$1, "defaultProps", _objectSpread({}, buttonDefaultProps));

var C = withMenuContext(MenuButton$1);

var MenuDivider$1 = function MenuDivider$$1(_ref) {
  var props = _extends({}, _ref);

  return createElement(MenuDivider, _extends({
    role: "separator"
  }, props));
};
MenuDivider$1.propTypes = {};
MenuDivider$1.defaultProps = {};
var C$1 = MenuDivider$1;

var MenuGroup$1 = function MenuGroup$$1(_ref) {
  var children = _ref.children,
      title = _ref.title,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "title"]);

  return createElement(MenuGroup, props, title && createElement(MenuGroupTitle, null, title), children);
};
MenuGroup$1.propTypes = {
  children: node.isRequired,
  title: string
};
MenuGroup$1.defaultProps = {};
var C$2 = MenuGroup$1;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component$1 = function (_React$Component) {
  _inherits(Component$$1, _React$Component);

  function Component$$1() {
    var _temp, _this, _ret;

    _classCallCheck(this, Component$$1);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  Component$$1.prototype.getArgs = function getArgs() {
    var state = this.state,
        props = this.props,
        setState = this._setState,
        forceUpdate = this._forceUpdate;

    return {
      state: state,
      props: props,
      setState: setState,
      forceUpdate: forceUpdate
    };
  };

  Component$$1.prototype.componentDidMount = function componentDidMount() {
    if (this.props.didMount) this.props.didMount(this.getArgs());
  };

  Component$$1.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    if (this.props.shouldUpdate) return this.props.shouldUpdate({
      props: this.props,
      state: this.state,
      nextProps: nextProps,
      nextState: nextState
    });else return true;
  };

  Component$$1.prototype.componentWillUnmount = function componentWillUnmount() {
    if (this.props.willUnmount) this.props.willUnmount({
      state: this.state,
      props: this.props
    });
  };

  Component$$1.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (this.props.didUpdate) this.props.didUpdate(Object.assign(this.getArgs(), {
      prevProps: prevProps,
      prevState: prevState
    }));
  };

  Component$$1.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        render = _props.render;

    return children ? typeof children === 'function' ? children(this.getArgs()) : children : render ? render(this.getArgs()) : null;
  };

  return Component$$1;
}(React__default.Component);

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.state = this.props.initialState;

  this._setState = function () {
    return _this2.setState.apply(_this2, arguments);
  };

  this._forceUpdate = function () {
    return _this2.forceUpdate.apply(_this2, arguments);
  };
};

var MenuPopover$1 =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(MenuPopover$$1, _React$Component);

  function MenuPopover$$1() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var _this$props = _this.props,
          children = _this$props.children,
          props = _objectWithoutPropertiesLoose(_this$props, ["children"]);

      return createElement(MenuContext.Provider, null, createElement(MenuPopover, _extends({}, props, {
        gutter: 6,
        placement: "bottom-start"
      }), function (popover) {
        return createElement(MenuContext.Consumer, null, function (_ref) {
          var setPopoverProps = _ref.setPopoverProps;
          return createElement(Component$1, {
            initialState: {
              isVisible: popover.isVisible
            } // @ts-ignore
            ,
            didMount: function didMount(_ref2) {
              var setState = _ref2.setState;
              setState({
                isVisible: popover.isVisible
              });
              setPopoverProps && setPopoverProps(popover);
            } // @ts-ignore
            ,
            didUpdate: function didUpdate(_ref3) {
              var isVisible = _ref3.state.isVisible,
                  setState = _ref3.setState;

              if (popover.isVisible !== isVisible) {
                setState({
                  isVisible: popover.isVisible
                });
                setPopoverProps && setPopoverProps(popover);
              }
            }
          }, function () {
            return children;
          });
        });
      }));
    });

    return _this;
  }

  return MenuPopover$$1;
}(Component); // @ts-ignore

_defineProperty(MenuPopover$1, "propTypes", _objectSpread({}, popoverPropTypes, {
  children: node.isRequired
}));

_defineProperty(MenuPopover$1, "defaultProps", _objectSpread({}, popoverDefaultProps));

var C$3 = MenuPopover$1;

var KEYS$1 = {
  UP: 38,
  DOWN: 40,
  LEFT: 37,
  RIGHT: 39,
  HOME: 36,
  END: 35,
  FNUP: 33,
  FNDOWN: 34
};
var Menu =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Menu, _React$Component);

  function Menu() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "menu", createRef());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      activeItemIndex: -1
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentDidUpdate", function (prevProps) {
      var _this$props = _this.props,
          context = _this$props.context,
          setInitialFocus = _this$props.setInitialFocus;
      var prevContext = prevProps.context;

      if (setInitialFocus && context && prevContext && context.isVisible !== prevContext.isVisible) {
        var menuItems = _this.menu.current && _this.menu.current.querySelectorAll('[role=menuitem]:not(:disabled)') || [];
        var startAtFirst = !context.startAt || context.startAt === 'first';
        requestAnimationFrame(function () {
          var focusedItem = menuItems[startAtFirst ? 0 : menuItems.length - 1];

          if (focusedItem) {
            // @ts-ignore
            focusedItem.focus();
          }
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleKeyDown", function (e) {
      var prevActiveItemIndex = _this.state.activeItemIndex;
      var menuItems = _this.menu.current && _this.menu.current.querySelectorAll('[role=menuitem]:not(:disabled)') || [];

      if (Object.values(KEYS$1).some(function (key) {
        return e.keyCode === key;
      })) {
        var _activeItemIndex = prevActiveItemIndex;
        e.preventDefault();

        if (e.keyCode === KEYS$1.DOWN || e.keyCode === KEYS$1.RIGHT) {
          _activeItemIndex = prevActiveItemIndex + 1;

          if (_activeItemIndex >= menuItems.length) {
            _activeItemIndex = 0;
          }
        } else if (e.keyCode === KEYS$1.UP || e.keyCode === KEYS$1.LEFT) {
          _activeItemIndex = prevActiveItemIndex - 1;

          if (_activeItemIndex < 0) {
            _activeItemIndex = menuItems.length - 1;
          }
        } else if (e.keyCode === KEYS$1.HOME || e.keyCode === KEYS$1.FNUP) {
          _activeItemIndex = 0;
        } else if (e.keyCode === KEYS$1.END || e.keyCode === KEYS$1.FNDOWN) {
          _activeItemIndex = menuItems.length - 1;
        }

        if (_activeItemIndex > -1 && menuItems[_activeItemIndex]) {
          // @ts-ignore
          menuItems[_activeItemIndex].focus();

          _this.setState({
            activeItemIndex: _activeItemIndex
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleFocus", function () {
      var setInitialFocus = _this.props.setInitialFocus;
      var menuItems = _this.menu.current && _this.menu.current.querySelectorAll('[role=menuitem]') || [];
      var activeItemIndex = setInitialFocus ? 0 : -1; // @ts-ignore

      menuItems.forEach(function (item, i) {
        if (document.activeElement && document.activeElement.isEqualNode(item)) {
          activeItemIndex = i;
        }
      });

      _this.setState({
        activeItemIndex: activeItemIndex
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          isHorizontal = _this$props2.isHorizontal,
          props = _objectWithoutPropertiesLoose(_this$props2, ["children", "isHorizontal"]);

      return createElement(_Menu, _extends({
        elementRef: _this.menu,
        role: "menu",
        "aria-orientation": isHorizontal ? 'horizontal' : 'vertical',
        isHorizontal: isHorizontal,
        onKeyDown: _this.handleKeyDown,
        onFocus: _this.handleFocus
      }, props), children);
    });

    return _this;
  }

  return Menu;
}(Component); // @ts-ignore

_defineProperty(Menu, "propTypes", _objectSpread({}, navigationPropTypes, {
  children: node.isRequired,
  isHorizontal: bool
}));

_defineProperty(Menu, "defaultProps", _objectSpread({}, navigationDefaultProps, {
  isHorizontal: false,
  setInitialFocus: true
}));

var C$4 = withMenuContext(Menu);
C$4.Button = C;
C$4.Divider = C$1;
C$4.Group = C$2;
C$4.Item = MenuItem;
C$4.Popover = C$3;

export default C$4;
export { C$4 as Menu, C$1 as MenuDivider, C$2 as MenuGroup, MenuItem, C as MenuButton, C$3 as MenuPopover };
