import { b as _extends, a as _objectSpread, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { space, theme } from './styled.js';
import { animateDefaultProps, placementPropType, restrictDefaultProps, animatePropTypes, restrictHidePropTypes } from './types.js';
import VisuallyHidden from './VisuallyHidden.js';
import { a as isFunction, b as TrapFocus } from './chunk-dc5258d0.js';
import Popover from 'reakit/Popover';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import { a as Button } from './chunk-0ba092a8.js';
import { a as Icon } from './chunk-51b7d577.js';
import Box from 'reakit/Box';
import InlineBlock from 'reakit/InlineBlock';
import { a as Pane } from './chunk-a1e5c7d9.js';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'airbnb-prop-types';
import './chunk-c400d1e8.js';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-e8f72546.js';
import 'lodash/omit';

var PopoverContainer = function PopoverContainer(_ref) {
  var children = _ref.children,
      defaultVisible = _ref.defaultVisible,
      initialState = _ref.initialState,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "defaultVisible", "initialState"]);

  return createElement(Popover.Container, _extends({
    initialState: _objectSpread({
      visible: defaultVisible
    }, initialState)
  }, props), function (_ref2) {
    var visible = _ref2.visible,
        rest = _objectWithoutPropertiesLoose(_ref2, ["visible"]);

    return children(_objectSpread({
      isVisible: visible
    }, rest));
  });
};
PopoverContainer.propTypes = {
  children: func.isRequired,
  defaultVisible: bool,
  initialState: object
};
PopoverContainer.defaultProps = {
  defaultVisible: false,
  initialState: {}
};

var PopoverHide = styled(Popover.Hide).withConfig({
  displayName: "styled__PopoverHide",
  componentId: "sc-12khuk0-0"
})(["", ";"], theme('fannypack.Popover.Hide.base'));
var PopoverShow = styled(Popover.Show).withConfig({
  displayName: "styled__PopoverShow",
  componentId: "sc-12khuk0-1"
})(["", ";"], theme('fannypack.Popover.Show.base'));
var PopoverToggle = styled(Popover.Toggle).withConfig({
  displayName: "styled__PopoverToggle",
  componentId: "sc-12khuk0-2"
})(["", ";"], theme('fannypack.Popover.Toggle.base'));
var PopoverClose = styled(Button).withConfig({
  displayName: "styled__PopoverClose",
  componentId: "sc-12khuk0-3"
})(["position:absolute;width:24px;height:24px;right:0;top:0;padding:0px;text-align:right;", ";"], theme('fannypack.Popover.Close.base'));
var _Popover = styled(Popover).withConfig({
  displayName: "styled",
  componentId: "sc-12khuk0-4"
})(["display:block;padding:", "rem;", ";"], space(5), theme('fannypack.Popover.base'));

var PopoverHide$1 = forwardRef(function (_ref, ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return (// @ts-ignore
    createElement(PopoverHide, _extends({}, props, {
      ref: ref
    }), children)
  );
});
PopoverHide$1.propTypes = {
  children: node.isRequired,
  hide: func.isRequired,
  onClick: func
};
PopoverHide$1.defaultProps = {
  onClick: undefined
};
var C = PopoverHide$1;

var PopoverClose$1 = function PopoverClose$$1(props) {
  return createElement(PopoverClose, _extends({
    use: C,
    size: "small",
    kind: "link"
  }, props), createElement(VisuallyHidden, null, "Close"), createElement(Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
PopoverClose$1.propTypes = {
  hide: func.isRequired
};
PopoverClose$1.defaultProps = {}; // @ts-ignore

var C$1 = PopoverClose$1;

var PopoverPopover = function PopoverPopover(_ref) {
  var children = _ref.children,
      isVisible = _ref.isVisible,
      trapFocus = _ref.trapFocus,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "isVisible", "trapFocus"]);

  return createElement(_Popover, _extends({
    visible: isVisible
  }, props), trapFocus ? createElement(TrapFocus, {
    isActive: isVisible
  }, function (_ref2) {
    var fallbackFocusRef = _ref2.fallbackFocusRef,
        initialFocusRef = _ref2.initialFocusRef;
    return createElement(Box, {
      elementRef: fallbackFocusRef
    }, isFunction(children) ? children({
      initialFocusRef: initialFocusRef
    }) : children);
  }) : isFunction(children) ? children({}) : children);
};
var popoverPopoverPropTypes = _objectSpread({
  children: oneOfType([node, func]).isRequired,
  className: string,
  isVisible: bool,
  flip: bool,
  gutter: oneOfType([number, string]),
  placement: placementPropType,
  shift: bool,
  trapFocus: bool
}, animatePropTypes, restrictHidePropTypes);
PopoverPopover.propTypes = popoverPopoverPropTypes;
var popoverPopoverDefaultProps = _objectSpread({
  className: undefined,
  flip: true,
  gutter: 12,
  isVisible: false,
  placement: 'bottom',
  shift: true,
  trapFocus: false
}, animateDefaultProps, restrictDefaultProps, {
  hideOnEsc: true,
  hideOnClickOutside: true
});
PopoverPopover.defaultProps = popoverPopoverDefaultProps;
var C$2 = PopoverPopover;

var PopoverShow$1 = function PopoverShow$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(PopoverShow, props, children);
};
PopoverShow$1.propTypes = {
  children: node.isRequired,
  onClick: func,
  show: func.isRequired
};
PopoverShow$1.defaultProps = {
  onClick: undefined
};
var C$3 = PopoverShow$1;

var PopoverToggle$1 = function PopoverToggle$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(PopoverToggle, props, children);
};
PopoverToggle$1.propTypes = {
  children: node.isRequired,
  onClick: func,
  toggle: func.isRequired
};
PopoverToggle$1.defaultProps = {
  onClick: undefined
};
var C$4 = PopoverToggle$1;

var Popover$1 = function Popover$$1(_ref) {
  var children = _ref.children,
      content = _ref.content,
      showCloseButton = _ref.showCloseButton,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "content", "showCloseButton"]);

  return createElement(PopoverContainer, null, function (popover) {
    return createElement(InlineBlock, {
      relative: true
    }, isFunction(children) ?
    /*
    // @ts-ignore */
    children(_objectSpread({
      use: C$4
    }, popover)) : children ? cloneElement(children, _objectSpread({
      use: C$4
    }, popover)) : null, createElement(C$2, _extends({
      elevation: "200"
    }, props, popover, {
      use: Pane
    }), function (_ref2) {
      var initialFocusRef = _ref2.initialFocusRef;
      return createElement(Fragment, null, showCloseButton && createElement(C$1, _extends({
        elementRef: initialFocusRef
      }, popover)), typeof content === 'function' ? content(_objectSpread({
        initialFocusRef: initialFocusRef
      }, popover)) : content);
    }));
  });
};
Popover$1.Popover = C$2;
Popover$1.Container = PopoverContainer;
Popover$1.Close = C$1;
Popover$1.Hide = C;
Popover$1.Show = C$3;
Popover$1.Toggle = C$4;
var popoverPropTypes = _objectSpread({}, popoverPopoverPropTypes, {
  className: string,
  content: oneOfType([string, element, func]),
  showCloseButton: bool,
  children: oneOfType([element, func]).isRequired
});
Popover$1.propTypes = popoverPropTypes;
var popoverDefaultProps = _objectSpread({}, popoverPopoverDefaultProps, {
  className: undefined,
  showCloseButton: false,
  children: undefined
});
Popover$1.defaultProps = popoverDefaultProps; // @ts-ignore

var C$5 = Popover$1;

export { C$5 as a, popoverPropTypes as b, popoverDefaultProps as c, PopoverContainer as d, C$2 as e, C$3 as f, C as g, C$4 as h, C$1 as i };
