import { b as _extends, c as _objectWithoutPropertiesLoose, a as _objectSpread } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import { Text as _Text } from './Text.js';
import { a as HiddenInput } from './chunk-acbb1544.js';
import { a as FieldWrapper, b as fieldWrapperDefaultProps, c as fieldWrapperPropTypes } from './chunk-b8380805.js';
import Label from 'reakit/Label';
import _omit from 'lodash/omit';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import './chunk-d1ea7076.js';
import 'reakit/Input';
import './Label.js';
import 'reakit/Field';

var RadioIcon = styled(Box).withConfig({
  displayName: "styled__RadioIcon",
  componentId: "sc-1viz9if-0"
})(["border:1px solid #bdbdbd;box-shadow:inset 0px 1px 2px #e5e5e5;border-radius:100%;height:1em;position:relative;width:1em;&{", ";}&{", ";}"], function (props) {
  return props.state && css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
    return palette("" + props.state)(props);
  }, function (props) {
    return palette("" + props.state)(props);
  });
}, theme('fannypack.Radio.base'));
var HiddenRadio = HiddenInput({
  Icon: RadioIcon,
  checkedIconCss: css(["background:", ";border-radius:50%;content:'';height:0.5em;left:50%;position:absolute;top:50%;transform:translate(-50%,-50%);width:0.5em;"], palette('primary')),
  disabledCheckedIconCss: css(["background:", ";"], palette('gray300')),
  themePrefix: 'Radio'
});
var Radio = styled(Label).withConfig({
  displayName: "styled__Radio",
  componentId: "sc-1viz9if-1"
})(["display:flex;align-items:center;&{", ";}"], theme('fannypack.Radio.label'));
var horizontalProperties = css(["display:flex;& ", ":not(:last-child){margin-right:1rem;margin-bottom:unset;}&{", ";}"], Radio, theme('fannypack.RadioGroup.horizontal'));
var RadioGroup = styled(Box).withConfig({
  displayName: "styled__RadioGroup",
  componentId: "sc-1viz9if-2"
})(["& ", ":not(:last-child){margin-bottom:0.5rem;}&{", ";}"], Radio, function (props) {
  return props.isHorizontal && horizontalProperties;
});

var Radio$1 = function Radio$$1(_ref) {
  var a11yId = _ref.a11yId,
      autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      isRequired = _ref.isRequired,
      label = _ref.label,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yId", "autoFocus", "checked", "className", "defaultChecked", "disabled", "isRequired", "label", "onBlur", "onChange", "onFocus", "name", "state", "value"]);

  return createElement(Radio, _extends({
    "aria-describedby": "label",
    "aria-invalid": state === 'danger',
    "aria-label": label,
    "aria-required": isRequired
  }, props), createElement(HiddenRadio, {
    autoFocus: autoFocus,
    checked: checked,
    defaultChecked: defaultChecked,
    disabled: disabled,
    id: a11yId,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    name: name,
    state: state,
    type: "radio",
    value: value
  }), createElement(RadioIcon, {
    state: state
  }), createElement(_Text, {
    id: "label",
    htmlFor: a11yId,
    marginLeft: "minor-2"
  }, label));
};
Radio$1.propTypes = {
  a11yId: string,
  autoFocus: bool,
  checked: oneOfType([bool, string]),
  className: string,
  defaultChecked: bool,
  disabled: bool,
  isRequired: bool,
  label: string.isRequired,
  onBlur: func,
  onChange: func,
  onFocus: func,
  name: string,
  state: string,
  value: string
};
Radio$1.defaultProps = {
  a11yId: undefined,
  autoFocus: false,
  checked: undefined,
  className: undefined,
  defaultChecked: undefined,
  disabled: false,
  isRequired: false,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  name: undefined,
  state: undefined,
  value: undefined
}; // @ts-ignore

var C = Radio$1;

var RadioGroup$1 = function RadioGroup$$1(_ref) {
  var a11yId = _ref.a11yId,
      a11yLabel = _ref.a11yLabel,
      className = _ref.className,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      onChange = _ref.onChange,
      options = _ref.options,
      name = _ref.name,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yId", "a11yLabel", "className", "defaultValue", "disabled", "onChange", "options", "name", "state", "value"]);

  return createElement(RadioGroup, _extends({
    "aria-describedby": "label",
    "aria-invalid": state === 'danger',
    "aria-label": a11yLabel,
    role: "group"
  }, props), options.map(function (option, i) {
    return createElement(C, {
      key: i // eslint-disable-line
      ,
      a11yId: a11yId,
      checked: typeof value === 'undefined' ? undefined : option.value === value,
      defaultChecked: typeof defaultValue === 'undefined' ? undefined : option.value === defaultValue,
      disabled: disabled || option.disabled,
      name: name,
      label: option.label,
      onChange: onChange,
      state: state,
      value: option.value
    });
  }));
};
var radioGroupPropTypes = {
  a11yId: string,
  a11yLabel: string,
  className: string,
  defaultValue: string,
  disabled: bool,
  isHorizontal: bool,
  name: string.isRequired,
  options: array.isRequired,
  state: string,
  value: string,
  onChange: func
};
RadioGroup$1.propTypes = radioGroupPropTypes;
var radioGroupDefaultProps = {
  a11yId: undefined,
  a11yLabel: undefined,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  isHorizontal: false,
  onChange: undefined,
  state: undefined,
  value: undefined
};
RadioGroup$1.defaultProps = radioGroupDefaultProps; // @ts-ignore

var C$1 = RadioGroup$1;

var RadioGroupField = function RadioGroupField(_ref) {
  var a11yId = _ref.a11yId,
      a11yLabel = _ref.a11yLabel,
      className = _ref.className,
      defaultValue = _ref.defaultValue,
      description = _ref.description,
      disabled = _ref.disabled,
      hint = _ref.hint,
      isHorizontal = _ref.isHorizontal,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      label = _ref.label,
      name = _ref.name,
      onChange = _ref.onChange,
      options = _ref.options,
      state = _ref.state,
      validationText = _ref.validationText,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yId", "a11yLabel", "className", "defaultValue", "description", "disabled", "hint", "isHorizontal", "isOptional", "isRequired", "label", "name", "onChange", "options", "state", "validationText", "value"]);

  return createElement(FieldWrapper, _extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return createElement(C$1, _extends({
      a11yId: a11yId,
      a11yLabel: a11yLabel,
      className: className,
      defaultValue: defaultValue,
      disabled: disabled,
      isHorizontal: isHorizontal,
      name: name,
      options: options,
      state: state,
      value: value,
      onChange: onChange
    }, elementProps));
  });
};
RadioGroupField.propTypes = _objectSpread({}, _omit(fieldWrapperPropTypes, 'children'), radioGroupPropTypes);
RadioGroupField.defaultProps = _objectSpread({}, fieldWrapperDefaultProps, radioGroupDefaultProps); // @ts-ignore

var C$2 = RadioGroupField;

export default C;
export { C as Radio, C$1 as RadioGroup, C$2 as RadioGroupField };
