import { b as _extends, c as _objectWithoutPropertiesLoose, d as _inheritsLoose, e as _assertThisInitialized, f as _defineProperty } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import times from 'lodash/times';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme, palette } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';

var Rating = styled(Box).withConfig({
  displayName: "styled__Rating",
  componentId: "sc-1kw6xuh-0"
})(["&{", ";}"], theme('fannypack.Rating.base'));
var starSizes = {
  small: css(["&{width:1rem;height:1rem;}&{", ";}"], theme('fannypack.Rating.Star.sizes.small')),
  medium: css(["&{width:2rem;height:2rem;}&{", ";}"], theme('fannypack.Rating.Star.sizes.medium')),
  large: css(["&{width:3rem;height:3rem;}&{", ";}"], theme('fannypack.Rating.Star.sizes.large'))
};
var RatingStar = styled(Box).withConfig({
  displayName: "styled__RatingStar",
  componentId: "sc-1kw6xuh-1"
})(["width:1.5rem;height:1.5rem;&{", ";}", ";& path{fill:", ";}"], theme('fannypack.Rating.Star.base'), function (props) {
  return props.size ? starSizes[props.size || ''] : null;
}, function (props) {
  return props.active ? theme('fannypack.Rating.Star.color')(props) || 'gold' : palette('white800');
});

var RatingStar$1 = function RatingStar$$1(_ref) {
  var size = _ref.size,
      active = _ref.active,
      props = _objectWithoutPropertiesLoose(_ref, ["size", "active"]);

  return (// @ts-ignore
    createElement(RatingStar, _extends({
      use: "svg",
      size: size,
      active: active,
      viewBox: "0 0 24 24"
    }, props), createElement("path", {
      d: "M12 17.27L18.18 21l-1.64-7.03L22 9.24l-7.19-.61L12 2 9.19 8.63 2 9.24l5.46 4.73L5.82 21z"
    }))
  );
};
RatingStar$1.propTypes = {
  active: bool,
  size: string
};
RatingStar$1.defaultProps = {
  size: 'default',
  active: false
}; // @ts-ignore

var C = RatingStar$1;

var Rating$1 =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Rating$$1, _React$Component);

  function Rating$$1() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      rating: _this.props.defaultRating || 0,
      isSelecting: false,
      selectedIndex: 0
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleStarClick", function (index) {
      var _this$props = _this.props,
          onRate = _this$props.onRate,
          disabled = _this$props.disabled,
          maxRating = _this$props.maxRating;
      var rating = index + 1;

      if (!disabled) {
        _this.setState({
          rating: rating
        });

        onRate && onRate({
          rating: rating,
          maxRating: maxRating
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleStarMouseOver", function (index) {
      var disabled = _this.props.disabled;
      !disabled && _this.setState({
        isSelecting: true,
        selectedIndex: index
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleMouseLeave", function () {
      _this.setState({
        isSelecting: false
      });
    });

    return _this;
  }

  var _proto = Rating$$1.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props2 = this.props,
        className = _this$props2.className,
        size = _this$props2.size,
        maxRating = _this$props2.maxRating;
    var _this$state = this.state,
        rating = _this$state.rating,
        selectedIndex = _this$state.selectedIndex,
        isSelecting = _this$state.isSelecting;
    return createElement(Rating, {
      className: className,
      onMouseLeave: this.handleMouseLeave
    }, times(maxRating, function (index) {
      return createElement(C, {
        key: index,
        active: isSelecting ? selectedIndex >= index : rating >= index + 1,
        "aria-label": "" + (index + 1),
        onClick: function onClick() {
          return _this2.handleStarClick(index);
        },
        onMouseEnter: function onMouseEnter() {
          return _this2.handleStarMouseOver(index);
        },
        size: size
      });
    }));
  };

  return Rating$$1;
}(Component); // @ts-ignore

_defineProperty(Rating$1, "defaultProps", {
  className: undefined,
  size: 'default',
  defaultRating: 0,
  maxRating: 5,
  onRate: undefined,
  disabled: false
});

var C$1 = Rating$1;

export default C$1;
export { C$1 as Rating, C as RatingStar };
