import { b as _extends, c as _objectWithoutPropertiesLoose, d as _inheritsLoose, e as _assertThisInitialized, f as _defineProperty, a as _objectSpread } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import { Spinner } from './Spinner.js';
import { a as _defaultPalette } from './chunk-b58fa33f.js';
import { a as FieldWrapper, c as fieldWrapperPropTypes, b as fieldWrapperDefaultProps } from './chunk-b8380805.js';
import { Group } from './Group.js';
import ConditionalWrap from 'conditional-wrap';
import Input from 'reakit/Input';
import _omit from 'lodash/omit';
import { tint } from 'polished';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import InlineBlock from 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import './Text.js';
import './chunk-d1ea7076.js';
import './Label.js';
import 'reakit/Label';
import 'reakit/Field';
import './types.js';
import 'reakit/Group';

var defaultPalette = _defaultPalette({});

var Icon = styled.svg.withConfig({
  displayName: "styled__Icon",
  componentId: "sc-1acvgnh-0"
})(["position:absolute;width:20px;height:20px;right:2px;z-index:1;fill:", ";transform:translateY(50%);"], palette('text'));
var LoadingSpinner = styled(Spinner).withConfig({
  displayName: "styled__LoadingSpinner",
  componentId: "sc-1acvgnh-1"
})(["position:absolute;width:15px;height:15px;top:12px;right:7px;z-index:1;"]);
var sizeProperties = {
  small: css(["font-size:0.8rem;& + ", "{width:15px;height:15px;}& + ", "{width:10px;height:10px;top:10px;}&{", ";}"], Icon, LoadingSpinner, theme('fannypack.Select.sizes.small')),
  medium: css(["font-size:1.25rem;& + ", "{width:25px;height:25px;}& + ", "{width:20px;height:20px;top:15px;right:10px;}&{", ";}"], Icon, LoadingSpinner, theme('fannypack.Select.sizes.medium')),
  large: css(["font-size:1.5rem;& + ", "{width:30px;height:30px;}& + ", "{width:25px;height:25px;top:16px;right:12px;}&{", ";}"], Icon, LoadingSpinner, theme('fannypack.Select.sizes.large'))
};
var stateProperties = css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
  return palette("" + props.state)(props);
}, function (props) {
  return palette("" + props.state)(props);
});
var _Select = styled(Input).withConfig({
  displayName: "styled",
  componentId: "sc-1acvgnh-2"
})(["appearance:none;background:linear-gradient(rgb(255,255,255),rgb(249,250,251));border:1px solid #bdbdbd;border-radius:0.2em;color:", ";height:2.5em;padding:0.4em 1.4em 0.4em 0.6em;line-height:1.5;width:100%;&[disabled]{background:", ";box-shadow:unset;color:", ";&{", ";}}&[disabled] + ", "{fill:", ";}&:focus{outline:unset;z-index:2;border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;&{", ";}}&{", ";}&{", ";}", ";"], function (props) {
  return props.isPlaceholderSelected ? tint(0.4, palette('text', 0, defaultPalette.text)(props)) : palette('text')(props);
}, palette('white700'), palette('gray400'), theme('fannypack.Select.disabled'), Icon, palette('gray400'), palette('primary'), palette('primary'), theme('fannypack.Select.focus'), function (props) {
  return props.styledSize && sizeProperties[props.styledSize];
}, function (props) {
  return props.state && stateProperties;
}, theme('fannypack.Select.base'));

var Icon$1 = (function () {
  return createElement(Icon, {
    viewBox: "0 0 20 20",
    focusable: "false",
    "aria-hidden": "true"
  }, createElement("path", {
    d: "M13 8l-3-3-3 3h6zm-.1 4L10 14.9 7.1 12h5.8z",
    fillRule: "evenodd"
  }));
});

var selectDefaultProps = {
  a11yId: undefined,
  a11yLabel: undefined,
  autoComplete: undefined,
  autoFocus: false,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  isFullWidth: false,
  isLoading: false,
  isRequired: false,
  name: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  placeholder: undefined,
  size: 'default',
  state: undefined,
  value: undefined
};
var selectPropTypes = {
  a11yId: string,
  a11yLabel: string,
  autoComplete: string,
  autoFocus: bool,
  className: string,
  defaultValue: string,
  disabled: bool,
  isFullWidth: bool,
  isLoading: bool,
  isRequired: bool,
  name: string,
  options: array.isRequired,
  placeholder: string,
  size: string,
  state: string,
  value: string,
  onBlur: func,
  onChange: func,
  onFocus: func
};
var Select =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Select, _React$PureComponent);

  function Select() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      isPlaceholderSelected: Boolean(_this.props.placeholder)
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChange", function (e) {
      var onChange = _this.props.onChange;

      _this.setState({
        isPlaceholderSelected: false
      });

      onChange && onChange(e);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var _this$props = _this.props,
          a11yId = _this$props.a11yId,
          a11yLabel = _this$props.a11yLabel,
          autoComplete = _this$props.autoComplete,
          className = _this$props.className,
          autoFocus = _this$props.autoFocus,
          defaultValue = _this$props.defaultValue,
          disabled = _this$props.disabled,
          isFullWidth = _this$props.isFullWidth,
          isLoading = _this$props.isLoading,
          isRequired = _this$props.isRequired,
          name = _this$props.name,
          onBlur = _this$props.onBlur,
          onChange = _this$props.onChange,
          onFocus = _this$props.onFocus,
          options = _this$props.options,
          placeholder = _this$props.placeholder,
          size = _this$props.size,
          state = _this$props.state,
          value = _this$props.value,
          props = _objectWithoutPropertiesLoose(_this$props, ["a11yId", "a11yLabel", "autoComplete", "className", "autoFocus", "defaultValue", "disabled", "isFullWidth", "isLoading", "isRequired", "name", "onBlur", "onChange", "onFocus", "options", "placeholder", "size", "state", "value"]);

      var isPlaceholderSelected = _this.state.isPlaceholderSelected;
      return createElement(InlineBlock, _extends({
        relative: true,
        minWidth: "50px",
        width: isFullWidth ? '100%' : undefined
      }, props), createElement(_Select, {
        "aria-invalid": state === 'danger',
        "aria-label": a11yLabel,
        "aria-required": isRequired,
        use: "select",
        autoComplete: autoComplete,
        autoFocus: autoFocus,
        defaultValue: defaultValue || placeholder,
        disabled: disabled,
        id: a11yId,
        isFullWidth: isFullWidth,
        isPlaceholderSelected: isPlaceholderSelected,
        name: name,
        onBlur: onBlur,
        onChange: _this.handleChange,
        onFocus: onFocus,
        styledSize: size,
        state: state,
        value: value
      }, placeholder && createElement("option", {
        disabled: true
      }, placeholder), options.map(function (option, i) {
        return createElement("option", {
          key: i // eslint-disable-line
          ,
          disabled: disabled || option.disabled,
          value: option.value
        }, option.label);
      })), isLoading ? createElement(LoadingSpinner, {
        color: "text"
      }) : createElement(Icon$1, null));
    });

    return _this;
  }

  return Select;
}(PureComponent); // @ts-ignore

_defineProperty(Select, "defaultProps", selectDefaultProps);

_defineProperty(Select, "propTypes", selectPropTypes);

var C = Select;

var SelectField = function SelectField(_ref) {
  var a11yLabel = _ref.a11yLabel,
      a11yId = _ref.a11yId,
      addonBefore = _ref.addonBefore,
      addonAfter = _ref.addonAfter,
      autoComplete = _ref.autoComplete,
      autoFocus = _ref.autoFocus,
      className = _ref.className,
      description = _ref.description,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      hint = _ref.hint,
      isLoading = _ref.isLoading,
      isFullWidth = _ref.isFullWidth,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      isVertical = _ref.isVertical,
      label = _ref.label,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      options = _ref.options,
      placeholder = _ref.placeholder,
      size = _ref.size,
      state = _ref.state,
      validationText = _ref.validationText,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yLabel", "a11yId", "addonBefore", "addonAfter", "autoComplete", "autoFocus", "className", "description", "defaultValue", "disabled", "hint", "isLoading", "isFullWidth", "isOptional", "isRequired", "isVertical", "label", "name", "onBlur", "onChange", "onFocus", "options", "placeholder", "size", "state", "validationText", "value"]);

  return createElement(FieldWrapper, _extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return createElement(ConditionalWrap, {
      condition: addonBefore || addonAfter,
      wrap: function wrap(children) {
        return createElement(Group, {
          isVertical: isVertical
        }, children);
      }
    }, addonBefore, createElement(C, _extends({
      a11yId: a11yId,
      a11yLabel: a11yLabel,
      autoComplete: autoComplete,
      autoFocus: autoFocus,
      className: className,
      defaultValue: defaultValue,
      disabled: disabled,
      isFullWidth: isFullWidth,
      isLoading: isLoading,
      isRequired: isRequired,
      name: name,
      options: options,
      placeholder: placeholder,
      size: size,
      state: state,
      value: value,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus
    }, elementProps)), addonAfter);
  });
};
SelectField.propTypes = _objectSpread({
  addonBefore: element,
  addonAfter: element,
  isVertical: bool
}, _omit(fieldWrapperPropTypes, 'children'), selectPropTypes);
SelectField.defaultProps = _objectSpread({
  addonBefore: undefined,
  addonAfter: undefined,
  isVertical: false
}, fieldWrapperDefaultProps, selectDefaultProps); // @ts-ignore

var C$1 = SelectField;

export default C;
export { C as Select, C$1 as SelectField };
