import { b as _extends, d as _inheritsLoose, e as _assertThisInitialized, f as _defineProperty, a as _objectSpread, c as _objectWithoutPropertiesLoose, g as _asyncToGenerator } from './chunk-cd704477.js';
import styled, { css, palette, space, theme } from './styled.js';
import { Spinner } from './Spinner.js';
import { getUniqueId } from './uniqueId.js';
import { a as FieldWrapper, c as fieldWrapperPropTypes, b as fieldWrapperDefaultProps } from './chunk-b8380805.js';
import { Group } from './Group.js';
import { c as inputPropTypes, b as inputDefaultProps } from './chunk-4cd67ec0.js';
import Input from './Input.js';
import { a as Popover } from './Popover-0ad4ce49.js';
import { e as MenuGroupTitle, j as menuItemPropTypes } from './chunk-07496600.js';
import Menu from './Menu.js';
import _debounce from 'lodash/debounce';
import { Tag } from './Tag.js';
import ConditionalWrap from 'conditional-wrap';
import Loads from 'react-loads';
import _omit from 'lodash/omit';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import _get from 'lodash/get';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import Flex from 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'styled-tools';
import { a as Icon } from './chunk-51b7d577.js';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'airbnb-prop-types';
import { a as Button } from './chunk-0ba092a8.js';
import './types.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-c400d1e8.js';
import { a as Set } from './chunk-e8f72546.js';
import 'lodash/uniqueId';
import './Text.js';
import './Label.js';
import 'reakit/Label';
import 'reakit/Field';
import 'reakit/Group';
import 'reakit/Input';
import './VisuallyHidden.js';
import './chunk-dc5258d0.js';
import 'focus-trap';
import 'reakit/Popover';
import './chunk-a1e5c7d9.js';
import './Navigation-848d4222.js';
import 'reakit/Navigation';
import './Divider.js';
import 'reakit/Divider';

var SelectMenuItem = styled(Menu.Item).withConfig({
  displayName: "styled__SelectMenuItem",
  componentId: "sc-1mfdpmr-0"
})(["font-weight:", ";&[disabled]{", ";}&:not(:disabled):focus{", ";}&:not(:disabled):hover{", ";}", ";", ";"], theme('fannypack.fontWeights.normal'), theme('fannypack.SelectMenu.Item.disabled'), theme('fannypack.SelectMenu.Item.focus'), theme('fannypack.SelectMenu.Item.hover'), function (props) {
  return props.isActive && css(["background-color:", ";color:", ";&&:hover,&&:focus{background-color:", ";}&&:hover:active{background-color:", ";}&{", ";}"], palette('primary'), palette('white'), palette('primary600'), palette('primary700'), theme('fannypack.SelectMenu.Item.active'));
}, theme('fannypack.SelectMenu.Item.base'));
var SelectMenuIcon = styled.svg.withConfig({
  displayName: "styled__SelectMenuIcon",
  componentId: "sc-1mfdpmr-1"
})(["position:absolute;width:20px;height:20px;right:2px;z-index:1;fill:", ";", ";"], palette('text'), theme('fannypack.SelectMenu.Icon.base'));
var SelectMenuLoadingSpinner = styled(Spinner).withConfig({
  displayName: "styled__SelectMenuLoadingSpinner",
  componentId: "sc-1mfdpmr-2"
})(["position:absolute;width:15px;height:15px;top:12px;right:7px;z-index:1;", ";"], theme('fannypack.SelectMenu.LoadingSpinner.base'));
var SelectMenuStaticItem = styled(Flex).withConfig({
  displayName: "styled__SelectMenuStaticItem",
  componentId: "sc-1mfdpmr-3"
})(["justify-content:center;padding:0.5rem 0;", ";"], theme('fannypack.SelectMenu.StaticItem.base'));
var SelectMenuLoadingItemSpinner = styled(Spinner).withConfig({
  displayName: "styled__SelectMenuLoadingItemSpinner",
  componentId: "sc-1mfdpmr-4"
})(["width:15px;height:15px;", ";"], theme('fannypack.SelectMenu.LoadingItemSpinner.base'));
var SelectMenuButton = styled(Menu.Button).withConfig({
  displayName: "styled__SelectMenuButton",
  componentId: "sc-1mfdpmr-5"
})(["background:linear-gradient(rgb(255,255,255),rgb(249,250,251));padding-right:", "rem;font-weight:", ";", ";"], space(8), theme('fannypack.fontWeights.normal'), theme('fannypack.SelectMenu.Button.base'));
var SelectMenuDivider = styled(Menu.Divider).withConfig({
  displayName: "styled__SelectMenuDivider",
  componentId: "sc-1mfdpmr-6"
})(["", ";"], theme('fannypack.SelectMenu.Divider.base'));
var SelectMenuGroup = styled(Menu.Group).withConfig({
  displayName: "styled__SelectMenuGroup",
  componentId: "sc-1mfdpmr-7"
})(["margin:0;overflow-y:scroll;max-height:300px;", ";", ";"], function (props) {
  return props.isDropdown && css(["&{max-height:230px;}"]);
}, theme('fannypack.SelectMenu.Group.base'));
var SelectMenuGroupTitle = styled(MenuGroupTitle).withConfig({
  displayName: "styled__SelectMenuGroupTitle",
  componentId: "sc-1mfdpmr-8"
})(["", ";"], theme('fannypack.SelectMenu.Group.title'));
var SelectMenuItemIcon = styled(Icon).withConfig({
  displayName: "styled__SelectMenuItemIcon",
  componentId: "sc-1mfdpmr-9"
})(["", ";"], theme('fannypack.SelectMenu.Item.icon'));
var SelectMenuPopover = styled(Menu.Popover).withConfig({
  displayName: "styled__SelectMenuPopover",
  componentId: "sc-1mfdpmr-10"
})(["width:250px;", ";"], theme('fannypack.SelectMenu.Popover.base'));
var SelectMenuSearchInput = styled(Input).withConfig({
  displayName: "styled__SelectMenuSearchInput",
  componentId: "sc-1mfdpmr-11"
})(["& input{border:none;border-bottom:1px solid ", ";border-bottom-left-radius:0px;border-bottom-right-radius:0px;box-shadow:none;width:100%;&:focus{border-bottom:none;box-shadow:", " inset 0px 0px 0px 2px !important;}}", ";"], palette('white900'), function (props) {
  return palette('primary')(props);
}, theme('fannypack.SelectMenu.SearchInput.base'));
var SelectMenuSection = styled(Box).withConfig({
  displayName: "styled__SelectMenuSection",
  componentId: "sc-1mfdpmr-12"
})(["background:", ";width:100%;"], palette('white600'));
var SelectMenuBottomSection = styled(SelectMenuSection).withConfig({
  displayName: "styled__SelectMenuBottomSection",
  componentId: "sc-1mfdpmr-13"
})(["border-top:1px solid ", ";display:flex;justify-content:space-between;padding:", "rem ", "rem;", ";"], palette('white900'), space(1), space(2), theme('fannypack.SelectMenu.BottomSection.base'));
var SelectMenuTopSection = styled(SelectMenuSection).withConfig({
  displayName: "styled__SelectMenuTopSection",
  componentId: "sc-1mfdpmr-14"
})(["border-bottom:1px solid ", ";padding:", "rem;", ";"], palette('white900'), space(2), theme('fannypack.SelectMenu.TopSection.base'));
var SelectMenuActionButton = styled(Button).withConfig({
  displayName: "styled__SelectMenuActionButton",
  componentId: "sc-1mfdpmr-15"
})(["font-size:", "rem;padding:0 ", "rem;", ";"], theme('fannypack.fontSizes.100'), space(2), theme('fannypack.SelectMenu.ActionButton.base'));
var SelectMenuTag = styled(Tag).withConfig({
  displayName: "styled__SelectMenuTag",
  componentId: "sc-1mfdpmr-16"
})(["", ";"], theme('fannypack.SelectMenu.Tag.base'));
var _SelectMenu = styled(Menu).withConfig({
  displayName: "styled",
  componentId: "sc-1mfdpmr-17"
})(["", ";"], theme('fannypack.SelectMenu.base'));

var SelectIcon = (function () {
  return createElement(SelectMenuIcon, {
    viewBox: "0 0 20 20",
    focusable: "false",
    "aria-hidden": "true"
  }, createElement("path", {
    d: "M13 8l-3-3-3 3h6zm-.1 4L10 14.9 7.1 12h5.8z",
    fillRule: "evenodd"
  }));
});

var selectMenuSearchInputPropTypes = _objectSpread({}, inputPropTypes);
var selectMenuSearchInputDefaultProps = _objectSpread({}, inputDefaultProps, {
  autoComplete: 'off',
  // @ts-ignore
  before: createElement(Input.Icon, {
    icon: "solid-search"
  }),
  isDropdownActive: false,
  isFullWidth: true,
  placeholder: 'Type to search...'
});
var SelectMenuSearchInput$1 =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(SelectMenuSearchInput$$1, _React$Component);

  function SelectMenuSearchInput$$1() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "search", createRef());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentDidUpdate", function (prevProps) {
      var isDropdownActive = _this.props.isDropdownActive;
      var prevIsDropdownActive = prevProps.isDropdownActive;

      if (isDropdownActive && !prevIsDropdownActive) {
        requestAnimationFrame(function () {
          return _this.search.current && _this.search.current.focus();
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var props = _extends({}, _this.props);

      return createElement(SelectMenuSearchInput, _extends({}, props, {
        inputRef: _this.search
      }));
    });

    return _this;
  }

  return SelectMenuSearchInput$$1;
}(Component);

_defineProperty(SelectMenuSearchInput$1, "propTypes", selectMenuSearchInputPropTypes);

_defineProperty(SelectMenuSearchInput$1, "defaultProps", selectMenuSearchInputDefaultProps);

var selectMenuItemObjectPropType = shape({
  icon: menuItemPropTypes['icon'],
  isActive: menuItemPropTypes['isActive'],
  isDisabled: menuItemPropTypes['isDisabled'],
  label: string,
  value: oneOfType([string, number, bool, object])
});
var selectMenuItemPropType = oneOfType([string, selectMenuItemObjectPropType]);
var selectMenuItemsPropType = arrayOf(selectMenuItemPropType);

var getSelectedOptionsFromValue = function getSelectedOptionsFromValue(value) {
  if (typeof value === 'string') {
    var _ref;

    return _ref = {}, _ref[value] = value, _ref;
  }

  if (Array.isArray(value)) {
    return value.reduce(function (currentSelectedOptions, defaultOption) {
      var _objectSpread2;

      var key = _get(defaultOption, 'key', defaultOption);

      return _objectSpread({}, currentSelectedOptions, (_objectSpread2 = {}, _objectSpread2[key] = defaultOption, _objectSpread2));
    }, {});
  }

  if (typeof value === 'object') {
    var _ref2;

    var _key = _get(value, 'key', value);

    return _ref2 = {}, _ref2[_key] = value, _ref2;
  }

  return {};
};

var getDefaultSelectedOptionsFromProps = function getDefaultSelectedOptionsFromProps(props) {
  var defaultKey = props.defaultKey,
      defaultKeys = props.defaultKeys,
      defaultOption = props.defaultOption,
      defaultOptions = props.defaultOptions,
      options = props.options,
      value = props.value;

  if (value) {
    return getSelectedOptionsFromValue(value);
  }

  if (defaultOption) {
    var _ref3;

    var _key2 = _get(defaultOption, 'key', defaultOption);

    return _ref3 = {}, _ref3[_key2] = defaultOption, _ref3;
  }

  if (defaultOptions) {
    return defaultOptions.reduce(function (currentSelectedOptions, defaultOption) {
      var _objectSpread3;

      var key = _get(defaultOption, 'key', defaultOption);

      return _objectSpread({}, currentSelectedOptions, (_objectSpread3 = {}, _objectSpread3[key] = defaultOption, _objectSpread3));
    }, {});
  }

  if (options) {
    return options.reduce(function (currentSelectedOptions, option) {
      var key = _get(option, 'key', option);

      if (key === defaultKey || defaultKeys && defaultKeys.some(function (defaultKey) {
        return defaultKey === key;
      }) || _get(option, 'isDefault')) {
        var _objectSpread4;

        return _objectSpread({}, currentSelectedOptions, (_objectSpread4 = {}, _objectSpread4[key] = option, _objectSpread4));
      }

      return currentSelectedOptions;
    }, {});
  }

  return {};
};

var getAttribute = function getAttribute(options, attr) {
  return _get(Object.values(options), "[0]." + attr) || _get(Object.values(options), '[0]');
};

var getAttributes = function getAttributes(options, attr) {
  return Object.values(options).map(function (option) {
    return _get(option, attr, option);
  });
};

var getButtonValue = function getButtonValue(options) {
  var labels = getAttributes(options, 'label');

  if (labels.length === 1) {
    return labels[0];
  }

  return labels.length + " selected";
};

var optionsFilter = function optionsFilter(_ref4) {
  var options = _ref4.options,
      searchText = _ref4.searchText;
  return options.filter(function (option) {
    return _get(option, 'label', option).toLowerCase().includes(searchText.toLowerCase());
  });
};

var bottomActionsRenderer = function bottomActionsRenderer(_ref5) {
  var isDropdown = _ref5.isDropdown,
      isMultiSelect = _ref5.isMultiSelect,
      onClear = _ref5.onClear,
      popover = _ref5.popover,
      selectedOptions = _ref5.selectedOptions;
  return createElement(Fragment, null, isMultiSelect && Object.keys(selectedOptions).length > 0 ? createElement(SelectMenuActionButton, {
    kind: "ghost",
    onClick: onClear
  }, "Clear") : createElement("div", null), isDropdown && createElement(SelectMenuActionButton, _extends({
    use: Popover.Hide,
    kind: "ghost"
  }, popover), "Close"));
};

var emptyRenderer = function emptyRenderer(_ref6) {
  var emptyText = _ref6.emptyText;
  return createElement(SelectMenuStaticItem, null, emptyText);
};

var errorRenderer = function errorRenderer() {
  return createElement(SelectMenuStaticItem, null, "An error occurred. Please try again.");
};

var optionRenderer = function optionRenderer(option) {
  return _get(option, 'label', option);
}; // @ts-ignore


var valueRenderer = function valueRenderer(value, values, selectedOptions) {
  return getButtonValue(selectedOptions);
};

var selectMenuPropTypes = {
  defaultKey: string,
  defaultKeys: arrayOf(string),
  defaultOption: selectMenuItemPropType,
  defaultOptions: selectMenuItemsPropType,
  emptyText: string,
  filterOptions: func,
  isDropdown: bool,
  isLoading: bool,
  isMultiSelect: bool,
  isSearchable: bool,
  loadQuery: object,
  loadOptions: func,
  onChange: func,
  options: selectMenuItemsPropType,
  placeholder: string,
  renderBottomActions: func,
  renderEmpty: func,
  renderError: func,
  renderOption: func,
  renderValue: func,
  searchInputProps: shape(selectMenuSearchInputPropTypes),
  useTags: bool,
  value: oneOfType([string, object, array])
};
var selectMenuDefaultProps = {
  defaultKey: undefined,
  defaultKeys: undefined,
  defaultOption: undefined,
  defaultOptions: undefined,
  emptyText: 'No results found',
  filterOptions: optionsFilter,
  isDropdown: false,
  isLoading: false,
  isMultiSelect: false,
  isSearchable: false,
  loadQuery: undefined,
  loadOptions: undefined,
  onChange: undefined,
  options: [],
  placeholder: 'Select...',
  renderBottomActions: bottomActionsRenderer,
  renderEmpty: emptyRenderer,
  renderError: errorRenderer,
  renderOption: optionRenderer,
  renderValue: valueRenderer,
  searchInputProps: {},
  useTags: false,
  value: undefined
};
var SelectMenu =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(SelectMenu, _React$Component);

  function SelectMenu() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key3 = 0; _key3 < _len; _key3++) {
      args[_key3] = arguments[_key3];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "optionsGroup", createRef());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      blockLoad: false,
      contextKey: _this.props.loadQuery ? Object.values(_this.props.loadQuery).join('.') : undefined,
      options: _this.props.options || [],
      page: 1,
      selectedOptions: getDefaultSelectedOptionsFromProps(_this.props),
      searchText: ''
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentDidUpdate", function (prevProps) {
      var _this$props = _this.props,
          loadQuery = _this$props.loadQuery,
          options = _this$props.options,
          value = _this$props.value;
      var prevLoadQuery = prevProps.loadQuery,
          prevOptions = prevProps.options,
          prevValue = prevProps.value;

      if (value && value !== prevValue) {
        _this.setState({
          selectedOptions: getSelectedOptionsFromValue(value)
        });
      }

      if (options && _get(options, 'length') !== _get(prevOptions, 'length')) {
        _this.filterOptions();
      }

      if (loadQuery && loadQuery !== prevLoadQuery) {
        _this.setState({
          contextKey: Object.values(loadQuery).join('.'),
          page: 1,
          searchText: ''
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "loadOptions",
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var _this$props2, loadQuery, loadOptions, initialOptions, _this$state, blockLoad, currentOptions, page, searchText, _ref8, options, newOptions;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$props2 = _this.props, loadQuery = _this$props2.loadQuery, loadOptions = _this$props2.loadOptions, initialOptions = _this$props2.options;
              _this$state = _this.state, blockLoad = _this$state.blockLoad, currentOptions = _this$state.options, page = _this$state.page, searchText = _this$state.searchText;

              if (loadOptions) {
                _context.next = 4;
                break;
              }

              return _context.abrupt("return", null);

            case 4:
              if (!blockLoad) {
                _context.next = 6;
                break;
              }

              return _context.abrupt("return", null);

            case 6:
              _context.next = 8;
              return loadOptions({
                data: loadQuery,
                page: page,
                searchText: searchText
              });

            case 8:
              _ref8 = _context.sent;
              options = _ref8.options;

              if (options.length === 0) {
                _this.setState({
                  blockLoad: true
                });
              }

              newOptions = [].concat(currentOptions, options);

              if (page === 1) {
                newOptions = [].concat(options);

                if (initialOptions) {
                  newOptions = [].concat(initialOptions, newOptions);
                }
              }

              _this.setState({
                options: newOptions
              });

              return _context.abrupt("return");

            case 15:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    })));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClearSelected", function () {
      var onChange = _this.props.onChange;
      onChange && onChange(null, null, null);

      _this.setState({
        selectedOptions: {}
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClickOption", function (option) {
      return function () {
        var _this$props3 = _this.props,
            isMultiSelect = _this$props3.isMultiSelect,
            onChange = _this$props3.onChange;
        var selectedOptions = _this.state.selectedOptions;

        var key = _get(option, 'key', option); // @ts-ignore


        var isOptionSelected = Boolean(selectedOptions[key]);
        var newSelectedOptions = isMultiSelect ? selectedOptions : {};

        if (isOptionSelected) {
          // @ts-ignore
          delete newSelectedOptions[key];
        } else {
          // @ts-ignore
          newSelectedOptions[key] = option;
        }

        _this.setState({
          selectedOptions: newSelectedOptions
        });

        var newValues = Object.values(newSelectedOptions);

        if (newValues.length === 0) {
          newValues = null;
        } else if (!isMultiSelect) {
          newValues = newValues[0];
        }

        var value = _get(option, 'value', option);

        onChange && onChange(value, option, newValues);
      };
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleRemoveOption", function (option) {
      return function () {
        var selectedOptions = _this.state.selectedOptions;

        var newSelectedOptions = _objectSpread({}, selectedOptions); // @ts-ignore


        delete newSelectedOptions[_get(option, 'key', option)];

        _this.setState({
          selectedOptions: newSelectedOptions
        });
      };
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleScrollOptions", function (_ref9) {
      var event = _ref9.event,
          isLoading = _ref9.isLoading,
          load = _ref9.load;
      var page = _this.state.page;
      var target = event.currentTarget;

      if (!isLoading && target.scrollHeight > target.offsetHeight && target.scrollHeight - target.offsetHeight - target.scrollTop <= 200) {
        var nextPage = page + 1;

        _this.setState({
          page: nextPage
        }, load);
      }

      return;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleSearch", _debounce(function (_ref10) {
      var event = _ref10.event,
          load = _ref10.load;
      var searchText = event.target.value;
      var loadOptions = _this.props.loadOptions;

      _this.setState({
        blockLoad: false,
        searchText: searchText,
        page: 1
      },
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!loadOptions) {
                  _context2.next = 5;
                  break;
                }

                _context2.next = 3;
                return load();

              case 3:
                _context2.next = 6;
                break;

              case 5:
                _this.filterOptions();

              case 6:
                _this.optionsGroup && _this.optionsGroup.current && _this.optionsGroup.current.scrollTo({
                  top: 0
                });

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      })));
    }, 500));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "filterOptions", function () {
      var _this$props4 = _this.props,
          filterOptions = _this$props4.filterOptions,
          options = _this$props4.options;
      var searchText = _this.state.searchText;
      if (!options) return;
      var filteredOptions = searchText.trim() === '' ? options : filterOptions({
        options: options,
        searchText: searchText
      });

      _this.setState({
        options: filteredOptions
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var _this$props5 = _this.props,
          isDropdown = _this$props5.isDropdown,
          isLoading = _this$props5.isLoading,
          placeholder = _this$props5.placeholder,
          renderValue = _this$props5.renderValue,
          props = _objectWithoutPropertiesLoose(_this$props5, ["isDropdown", "isLoading", "placeholder", "renderValue"]);

      var selectedOptions = _this.state.selectedOptions;
      return isDropdown ? createElement(SelectMenuPopover, {
        content: _this.renderMenu
      }, createElement(SelectMenuButton, props, Object.keys(selectedOptions).length > 0 && renderValue ? renderValue(getAttribute(selectedOptions, 'value'), getAttributes(selectedOptions, 'value'), selectedOptions) : placeholder, isLoading ? createElement(SelectMenuLoadingSpinner, {
        color: "text"
      }) : createElement(SelectIcon, null))) : _this.renderMenu();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderMenu", function (popover) {
      var _this$props6 = _this.props,
          renderBottomActions = _this$props6.renderBottomActions,
          isDropdown = _this$props6.isDropdown,
          isMultiSelect = _this$props6.isMultiSelect,
          isSearchable = _this$props6.isSearchable,
          loadOptions = _this$props6.loadOptions,
          renderOption = _this$props6.renderOption,
          searchInputProps = _this$props6.searchInputProps,
          useTags = _this$props6.useTags,
          props = _objectWithoutPropertiesLoose(_this$props6, ["renderBottomActions", "isDropdown", "isMultiSelect", "isSearchable", "loadOptions", "renderOption", "searchInputProps", "useTags"]);

      var _this$state2 = _this.state,
          contextKey = _this$state2.contextKey,
          selectedOptions = _this$state2.selectedOptions;
      var selectedOptionsValues = Object.values(selectedOptions);
      return createElement(Loads, {
        contextKey: contextKey,
        delay: 0,
        load: _this.loadOptions,
        loadOnMount: Boolean(_this.loadOptions)
      }, function (_ref12) {
        var load = _ref12.load,
            isLoading = _ref12.isLoading;
        return createElement(_SelectMenu, _extends({
          setInitialFocus: !isSearchable
        }, isDropdown ? {} : props), isSearchable && createElement(SelectMenuSearchInput$1, _extends({
          isDropdownActive: popover && popover.isVisible,
          isLoading: isLoading,
          onChange: function onChange(event) {
            event.persist();

            _this.handleSearch({
              event: event,
              load: load
            });
          }
        }, searchInputProps)), useTags && selectedOptionsValues.length > 0 && _this.renderTopSection({
          selectedOptionsValues: selectedOptionsValues
        }), _this.renderOptions({
          isLoading: isLoading,
          load: load
        }), (isMultiSelect || isDropdown) && _this.renderBottomSection({
          popover: popover,
          selectedOptionsValues: selectedOptionsValues
        }));
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderTopSection", function (_ref13) {
      var selectedOptionsValues = _ref13.selectedOptionsValues;
      return createElement(SelectMenuTopSection, null, createElement(Set, {
        spacing: "minor-1"
      }, selectedOptionsValues.map(function (option) {
        return createElement(SelectMenuTag, {
          key: _get(option, 'key', option),
          onRemove: _this.handleRemoveOption(option),
          palette: "primary"
        }, _get(option, 'label', option));
      })));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderOptions", function (_ref14) {
      var isLoading = _ref14.isLoading,
          load = _ref14.load;
      var _this$props7 = _this.props,
          emptyText = _this$props7.emptyText,
          isDropdown = _this$props7.isDropdown,
          isMultiSelect = _this$props7.isMultiSelect,
          renderEmpty = _this$props7.renderEmpty,
          renderError = _this$props7.renderError,
          renderOption = _this$props7.renderOption,
          useTags = _this$props7.useTags;
      var _this$state3 = _this.state,
          options = _this$state3.options,
          selectedOptions = _this$state3.selectedOptions;
      return (// @ts-ignore
        createElement(SelectMenuGroup // @ts-ignore
        , {
          elementRef: _this.optionsGroup,
          isDropdown: isDropdown,
          isMultiSelect: isMultiSelect,
          onScroll: function onScroll(event) {
            return _this.handleScrollOptions({
              event: event,
              isLoading: isLoading,
              load: load
            });
          }
        }, options.map(function (option) {
          // @ts-ignore
          var isSelected = Boolean(selectedOptions[_get(option, 'key', option)]);
          if (useTags && isSelected) return null;
          return createElement(SelectMenuItem, {
            key: _get(option, 'key', option),
            hideOnClick: !isMultiSelect,
            icon: _get(option, 'icon'),
            isActive: isSelected || _get(option, 'isActive'),
            isDisabled: _get(option, 'isDisabled'),
            onClick: _this.handleClickOption(option)
          }, renderOption && renderOption(option));
        }), createElement(Loads.Loading, null, createElement(SelectMenuStaticItem, null, createElement(SelectMenuLoadingItemSpinner, {
          color: "text"
        }))), createElement(Loads.Success, null, options.length === 0 && renderEmpty && renderEmpty({
          emptyText: emptyText
        })), createElement(Loads.Error, null, function (_ref15) {
          var error = _ref15.error;
          return renderError && renderError({
            error: error
          });
        }))
      );
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderBottomSection", function (_ref16) {
      var popover = _ref16.popover,
          selectedOptionsValues = _ref16.selectedOptionsValues;
      var _this$props8 = _this.props,
          isDropdown = _this$props8.isDropdown,
          isMultiSelect = _this$props8.isMultiSelect,
          renderBottomActions = _this$props8.renderBottomActions;
      return createElement(SelectMenuBottomSection, null, renderBottomActions && renderBottomActions({
        isDropdown: isDropdown,
        isMultiSelect: isMultiSelect,
        onClear: _this.handleClearSelected,
        popover: popover,
        selectedOptions: selectedOptionsValues
      }));
    });

    return _this;
  }

  return SelectMenu;
}(Component);

_defineProperty(SelectMenu, "ActionButton", SelectMenuActionButton);

_defineProperty(SelectMenu, "BottomSection", SelectMenuBottomSection);

_defineProperty(SelectMenu, "Button", SelectMenuButton);

_defineProperty(SelectMenu, "LoadingSpinner", SelectMenuLoadingSpinner);

_defineProperty(SelectMenu, "LoadingItemSpinner", SelectMenuLoadingItemSpinner);

_defineProperty(SelectMenu, "Group", SelectMenuGroup);

_defineProperty(SelectMenu, "Item", SelectMenuItem);

_defineProperty(SelectMenu, "StaticItem", SelectMenuStaticItem);

_defineProperty(SelectMenu, "Popover", SelectMenuPopover);

_defineProperty(SelectMenu, "Tag", SelectMenuTag);

_defineProperty(SelectMenu, "TopSection", SelectMenuTopSection);

_defineProperty(SelectMenu, "propTypes", selectMenuPropTypes);

_defineProperty(SelectMenu, "defaultProps", selectMenuDefaultProps);

var SelectMenuField = function SelectMenuField(_ref) {
  var a11yId = _ref.a11yId,
      addonBefore = _ref.addonBefore,
      addonAfter = _ref.addonAfter,
      className = _ref.className,
      defaultKey = _ref.defaultKey,
      defaultKeys = _ref.defaultKeys,
      defaultOption = _ref.defaultOption,
      defaultOptions = _ref.defaultOptions,
      description = _ref.description,
      emptyText = _ref.emptyText,
      filterOptions = _ref.filterOptions,
      hint = _ref.hint,
      isDropdown = _ref.isDropdown,
      isLoading = _ref.isLoading,
      isMultiSelect = _ref.isMultiSelect,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      isSearchable = _ref.isSearchable,
      isVertical = _ref.isVertical,
      label = _ref.label,
      loadQuery = _ref.loadQuery,
      loadOptions = _ref.loadOptions,
      onChange = _ref.onChange,
      options = _ref.options,
      placeholder = _ref.placeholder,
      renderBottomActions = _ref.renderBottomActions,
      renderEmpty = _ref.renderEmpty,
      renderError = _ref.renderError,
      renderOption = _ref.renderOption,
      renderValue = _ref.renderValue,
      searchInputProps = _ref.searchInputProps,
      state = _ref.state,
      validationText = _ref.validationText,
      value = _ref.value,
      useTags = _ref.useTags,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yId", "addonBefore", "addonAfter", "className", "defaultKey", "defaultKeys", "defaultOption", "defaultOptions", "description", "emptyText", "filterOptions", "hint", "isDropdown", "isLoading", "isMultiSelect", "isOptional", "isRequired", "isSearchable", "isVertical", "label", "loadQuery", "loadOptions", "onChange", "options", "placeholder", "renderBottomActions", "renderEmpty", "renderError", "renderOption", "renderValue", "searchInputProps", "state", "validationText", "value", "useTags"]);

  return createElement(FieldWrapper, _extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return createElement(ConditionalWrap, {
      condition: addonBefore || addonAfter,
      wrap: function wrap(children) {
        return createElement(Group, {
          isVertical: isVertical
        }, children);
      }
    }, addonBefore, createElement(SelectMenu, _extends({
      id: a11yId,
      className: className,
      defaultKey: defaultKey,
      defaultKeys: defaultKeys,
      defaultOption: defaultOption,
      defaultOptions: defaultOptions,
      emptyText: emptyText,
      filterOptions: filterOptions,
      isDropdown: isDropdown,
      isLoading: isLoading,
      isMultiSelect: isMultiSelect,
      isRequired: isRequired,
      isSearchable: isSearchable,
      loadQuery: loadQuery,
      loadOptions: loadOptions // @ts-ignore
      ,
      onChange: onChange,
      options: options,
      placeholder: placeholder,
      renderBottomActions: renderBottomActions,
      renderEmpty: renderEmpty,
      renderError: renderError,
      renderOption: renderOption,
      renderValue: renderValue,
      searchInputProps: searchInputProps,
      state: state // @ts-ignore
      ,
      value: value,
      useTags: useTags
    }, elementProps)), addonAfter);
  });
};
SelectMenuField.propTypes = _objectSpread({
  addonBefore: element,
  addonAfter: element,
  isVertical: bool
}, _omit(fieldWrapperPropTypes, 'children'), selectMenuPropTypes);
SelectMenuField.defaultProps = _objectSpread({}, fieldWrapperDefaultProps, selectMenuDefaultProps, {
  addonBefore: undefined,
  addonAfter: undefined,
  a11yId: getUniqueId('SelectMenuField'),
  isVertical: false
}); // @ts-ignore

var C = SelectMenuField;

export default SelectMenu;
export { SelectMenu, C as SelectMenuField };
