import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css, keyframes } from './styled.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';

var sizes = {
  small: css(["&{font-size:14px;border-width:2px;}&{", ";}"], theme('fannypack.Spinner.sizes.small')),
  medium: css(["&{font-size:28px;}&{", ";}"], theme('fannypack.Spinner.sizes.medium')),
  large: css(["&{font-size:36px;}&{", ";}"], theme('fannypack.Spinner.sizes.large'))
};
var rotate = keyframes(["from{transform:rotate(0deg);}to{transform:rotate(360deg);}"]);
var spinnerProperties = css(["animation:", " 0.6s infinite linear;border:0.1em solid ", ";border-radius:100%;border-right-color:transparent;border-top-color:transparent;display:inline-block;height:1em;width:1em;position:relative;"], rotate, function (props) {
  return props.color ? palette(props.color)(props) : null;
});
var _Spinner = styled(Box).withConfig({
  displayName: "styled",
  componentId: "v4xo8u-0"
})(["font-size:20px;", ";&{", ";}", ";"], spinnerProperties, theme('fannypack.Spinner.base'), function (props) {
  return props.styledSize && sizes[props.styledSize];
});

var Spinner = function Spinner(_ref) {
  var className = _ref.className,
      color = _ref.color,
      size = _ref.size,
      props = _objectWithoutPropertiesLoose(_ref, ["className", "color", "size"]);

  return createElement(_Spinner, _extends({
    className: className,
    color: color,
    styledSize: size
  }, props));
};
Spinner.propTypes = {
  className: string,
  color: string,
  size: string
};
Spinner.defaultProps = {
  className: undefined,
  color: 'primary',
  size: 'default'
}; // @ts-ignore

var C = Spinner;

export default C;
export { C as Spinner };
