import { b as _extends, c as _objectWithoutPropertiesLoose, a as _objectSpread } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import { a as _defaultPalette } from './chunk-b58fa33f.js';
import { Text as _Text } from './Text.js';
import { a as HiddenInput } from './chunk-acbb1544.js';
import { a as FieldWrapper, c as fieldWrapperPropTypes, b as fieldWrapperDefaultProps } from './chunk-b8380805.js';
import Label from 'reakit/Label';
import _omit from 'lodash/omit';
import { tint } from 'polished';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import './chunk-d1ea7076.js';
import 'reakit/Input';
import './Label.js';
import 'reakit/Field';

var defaultPalette = _defaultPalette({});

var SwitchIcon = styled(Box).withConfig({
  displayName: "styled__SwitchIcon",
  componentId: "ohpvlq-0"
})(["background-color:", ";border:1px solid #bdbdbd;border-radius:1em;height:1.5em;position:relative;width:3em;&{", ";}&{", ";}"], palette('white700'), function (props) {
  return props.state && css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
    return palette("" + props.state);
  }, function (props) {
    return palette("" + props.state);
  });
}, theme('fannypack.Switch.base'));
var HiddenSwitch = HiddenInput({
  Icon: SwitchIcon,
  checkedCss: css(["background-color:", ";transition:all ease 0.2s;"], function (props) {
    return palette(props.palette || 'primary');
  }),
  disabledCheckedCss: css(["background-color:", ";border-color:", ";"], function (props) {
    return tint(0.5, palette(props.palette || 'primary', 0, defaultPalette.primary)(props));
  }, function (props) {
    return tint(0.5, palette(props.palette || 'primary', 0, defaultPalette.primary)(props));
  }),
  disabledUncheckedIconCss: css(["background:", ";"], palette('white700')),
  checkedIconCss: css(["border-color:", ";left:1.7em;"], function (props) {
    return palette(props.palette || 'primary', 0, defaultPalette.primary);
  }),
  disabledCheckedIconCss: css(["border-color:", ";"], function (props) {
    return tint(0.5, palette(props.palette || 'primary', 0, defaultPalette.primary)(props));
  }),
  uncheckedIconCss: css(["background:white;content:'';border-radius:100%;border:1px solid #bdbdbd;height:1em;width:1em;top:0.2em;left:0.2em;transition:all ease 0.2s;position:absolute;"]),
  themePrefix: 'Switch'
});
var _Switch = styled(Label).withConfig({
  displayName: "styled",
  componentId: "ohpvlq-1"
})(["align-items:center;cursor:", ";display:flex;&{", ";}"], function (props) {
  return props.disabled ? 'not-allowed' : 'pointer';
}, theme('fannypack.Switch.label'));

var Switch = function Switch(_ref) {
  var autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      id = _ref.id,
      isRequired = _ref.isRequired,
      label = _ref.label,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      palette$$1 = _ref.palette,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, ["autoFocus", "checked", "className", "defaultChecked", "disabled", "id", "isRequired", "label", "onBlur", "onChange", "onFocus", "name", "palette", "state", "value"]);

  return createElement(_Switch, _extends({
    "aria-describedby": "label",
    "aria-invalid": state === 'danger',
    "aria-label": label,
    "aria-required": isRequired,
    disabled: disabled
  }, props), createElement(HiddenSwitch, {
    autoFocus: autoFocus,
    checked: checked,
    defaultChecked: defaultChecked,
    disabled: disabled,
    id: id,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    name: name,
    palette: palette$$1,
    state: state,
    type: "checkbox",
    value: value
  }), createElement(SwitchIcon, {
    state: state
  }), label && createElement(_Text, {
    id: "label",
    htmlFor: id,
    marginLeft: "major-1"
  }, label));
};
var switchPropTypes = {
  autoFocus: bool,
  checked: bool,
  className: string,
  defaultChecked: bool,
  disabled: bool,
  id: string,
  isRequired: bool,
  label: string,
  name: string,
  palette: string,
  state: string,
  value: string,
  onBlur: func,
  onChange: func,
  onFocus: func
};
Switch.propTypes = switchPropTypes;
var switchDefaultProps = {
  autoFocus: false,
  checked: undefined,
  className: undefined,
  defaultChecked: undefined,
  disabled: false,
  id: undefined,
  isRequired: false,
  label: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  palette: undefined,
  name: undefined,
  state: undefined,
  value: undefined
};
Switch.defaultProps = switchDefaultProps;
var C = Switch;

var SwitchField = function SwitchField(_ref) {
  var a11yId = _ref.a11yId,
      description = _ref.description,
      hint = _ref.hint,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      label = _ref.label,
      switchLabel = _ref.switchLabel,
      state = _ref.state,
      validationText = _ref.validationText,
      autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      id = _ref.id,
      name = _ref.name,
      palette$$1 = _ref.palette,
      value = _ref.value,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yId", "description", "hint", "isOptional", "isRequired", "label", "switchLabel", "state", "validationText", "autoFocus", "checked", "className", "defaultChecked", "disabled", "id", "name", "palette", "value", "onBlur", "onChange", "onFocus"]);

  return createElement(FieldWrapper, _extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return createElement(C, _extends({
      label: switchLabel,
      autoFocus: autoFocus,
      checked: checked,
      className: className,
      defaultChecked: defaultChecked,
      disabled: disabled,
      id: id,
      isRequired: isRequired,
      name: name,
      palette: palette$$1,
      state: state,
      value: value,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus
    }, elementProps));
  });
};
SwitchField.propTypes = _objectSpread({
  a11yId: string,
  switchLabel: string
}, _omit(fieldWrapperPropTypes, 'children'), switchPropTypes);
SwitchField.defaultProps = _objectSpread({
  a11yId: undefined,
  switchLabel: undefined
}, fieldWrapperDefaultProps, switchDefaultProps); // @ts-ignore

var C$1 = SwitchField;

export default C;
export { C as Switch, C$1 as SwitchField };
