import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css, space } from './styled.js';
import ConditionalWrap from 'conditional-wrap';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import InlineBlock from 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';

var Caption = styled(Box).withConfig({
  displayName: "styled__Caption",
  componentId: "y1jyri-0"
})(["caption-side:", ";&{", ";}"], function (props) {
  return props.position;
}, theme('fannypack.Table.Caption.base'));
var TableCell = styled(Box).withConfig({
  displayName: "styled__TableCell",
  componentId: "y1jyri-1"
})(["padding:", "rem;&{", ";}"], theme('fannypack.Table.spacing'), theme('fannypack.Table.Cell.base'));
var TableFoot = styled(Box).withConfig({
  displayName: "styled__TableFoot",
  componentId: "y1jyri-2"
})(["font-weight:bold;&{", ";}&{", ";}"], function (props) {
  return props.hasBorder && css(["border-top:2px solid ", ";"], theme('fannypack.Table.borderColor'));
}, theme('fannypack.Table.Foot.base'));
var TableHead = styled(Box).withConfig({
  displayName: "styled__TableHead",
  componentId: "y1jyri-3"
})(["border:unset;&{", ";}&{", ";}"], function (props) {
  return props.hasBorder && css(["border-bottom:2px solid ", ";"], theme('fannypack.Table.borderColor'));
}, theme('fannypack.Table.Head.base'));
var TableHeadCell = styled(Box).withConfig({
  displayName: "styled__TableHeadCell",
  componentId: "y1jyri-4"
})(["font-weight:bold;padding:", "rem;&{", ";}"], theme('fannypack.Table.spacing'), theme('fannypack.Table.HeadCell.base'));
var TableRow = styled(Box).withConfig({
  displayName: "styled__TableRow",
  componentId: "y1jyri-5"
})(["&{", ";}"], theme('fannypack.Table.Row.base'));
var TableBody = styled(Box).withConfig({
  displayName: "styled__TableBody",
  componentId: "y1jyri-6"
})(["", ";&{", ";}"], function (props) {
  return props.hasBorders && css(["& ", "{border-bottom:1px solid ", ";}"], TableRow, theme('fannypack.Table.borderColor'));
}, theme('fannypack.Table.Body.base'));
var fullWidthProperties = css(["width:100%;"]);
var hoverableProperties = css(["& ", " ", ":hover{background-color:", " !important;}"], TableBody, TableRow, theme('fannypack.Table.hover.backgroundColor'));
var stripedProperties = css(["& ", " ", ":nth-child(even){background-color:", ";}"], TableBody, TableRow, theme('fannypack.Table.striped.backgroundColor'));
var _Table = styled(Box).withConfig({
  displayName: "styled",
  componentId: "y1jyri-7"
})(["border-collapse:collapse;border-spacing:0;text-align:left;&:not(:last-child){margin-bottom:", "rem;}&{", ";}&{", ";}&{", ";}&{", ";}"], space(4), function (props) {
  return props.isFullWidth && fullWidthProperties;
}, function (props) {
  return props.isHoverable && hoverableProperties;
}, function (props) {
  return props.isStriped && stripedProperties;
}, theme('fannypack.Table.base'));

var TableBody$1 = function TableBody$$1(_ref) {
  var children = _ref.children,
      hasBorders = _ref.hasBorders,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "hasBorders"]);

  return createElement(TableBody, _extends({
    use: "tbody",
    hasBorders: hasBorders
  }, props), children);
};
TableBody$1.propTypes = {
  children: node.isRequired,
  hasBorders: bool
};
TableBody$1.defaultProps = {
  hasBorders: false
};
var C = TableBody$1;

var TableCaption = function TableCaption(_ref) {
  var children = _ref.children,
      position = _ref.position,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "position"]);

  return createElement(Caption, _extends({
    use: "caption",
    position: position
  }, props), children);
};
TableCaption.propTypes = {
  children: node.isRequired,
  position: oneOf(['top', 'bottom'])
};
TableCaption.defaultProps = {
  position: 'top'
};
var C$1 = TableCaption;

var TableCell$1 = function TableCell$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(TableCell, _extends({
    use: "td"
  }, props), children);
};
TableCell$1.propTypes = {
  children: node
};
TableCell$1.defaultProps = {};
var C$2 = TableCell$1;

var TableFoot$1 = function TableFoot$$1(_ref) {
  var children = _ref.children,
      hasBorder = _ref.hasBorder,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "hasBorder"]);

  return createElement(TableFoot, _extends({
    use: "tfoot",
    hasBorder: hasBorder
  }, props), children);
};
TableFoot$1.propTypes = {
  children: node.isRequired,
  hasBorder: bool
};
TableFoot$1.defaultProps = {
  hasBorder: true
};
var C$3 = TableFoot$1;

var TableHead$1 = function TableHead$$1(_ref) {
  var children = _ref.children,
      hasBorder = _ref.hasBorder,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "hasBorder"]);

  return createElement(TableHead, _extends({
    use: "thead",
    hasBorder: hasBorder
  }, props), children);
};
TableHead$1.propTypes = {
  children: node.isRequired,
  hasBorder: bool
};
TableHead$1.defaultProps = {
  hasBorder: true
};
var C$4 = TableHead$1;

var TableHeadCell$1 = function TableHeadCell$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(TableHeadCell, _extends({
    use: "th"
  }, props), children);
};
TableHeadCell$1.propTypes = {
  children: node
};
TableHeadCell$1.defaultProps = {};
var C$5 = TableHeadCell$1;

var TableRow$1 = function TableRow$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(TableRow, _extends({
    use: "tr"
  }, props), children);
};
TableRow$1.propTypes = {
  children: node.isRequired
};
TableRow$1.defaultProps = {};
var C$6 = TableRow$1;

var OuterBorder = styled(InlineBlock).withConfig({
  displayName: "Table__OuterBorder",
  componentId: "sc-1as57q1-0"
})(["border:1px solid ", ";border-radius:5px;padding:0.25rem 0.5rem;", ";"], theme('fannypack.Table.borderColor'), function (props) {
  return props.isFullWidth && css(["width:100%;"]);
});
var Table = function Table(_ref) {
  var a11yTitle = _ref.a11yTitle,
      children = _ref.children,
      hasBorder = _ref.hasBorder,
      isFullWidth = _ref.isFullWidth,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yTitle", "children", "hasBorder", "isFullWidth"]);

  return createElement(ConditionalWrap, {
    condition: hasBorder,
    wrap: function wrap(children) {
      return createElement(OuterBorder, {
        isFullWidth: isFullWidth
      }, children);
    }
  }, createElement(_Table, _extends({
    use: "table",
    "aria-label": a11yTitle,
    isFullWidth: isFullWidth
  }, props), children));
};
Table.Body = C;
Table.Caption = C$1;
Table.Cell = C$2;
Table.Foot = C$3;
Table.Head = C$4;
Table.HeadCell = C$5;
Table.Row = C$6;
Table.propTypes = {
  a11yTitle: string,
  children: node.isRequired,
  hasBorder: bool,
  isFullWidth: bool,
  isHoverable: bool,
  isStriped: bool
};
Table.defaultProps = {
  a11yTitle: undefined,
  hasBorder: false,
  isFullWidth: false,
  isHoverable: false,
  isStriped: false
};
var C$7 = Table;

export default C$7;
export { C$7 as Table, C as TableBody, C$1 as TableCaption, C$2 as TableCell, C$3 as TableFoot, C$4 as TableHead, C$5 as TableHeadCell, C$6 as TableRow };
