import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import Tabs from 'reakit/Tabs';
import classNames from 'classnames';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/styled';
import 'lodash/get';

var TabPanel = styled(Tabs.Panel).withConfig({
  displayName: "styled__TabPanel",
  componentId: "sc-1783spc-0"
})(["&{", ";}"], theme('fannypack.Tabs.Panel.base'));
var Tab = styled(Tabs.Tab).withConfig({
  displayName: "styled__Tab",
  componentId: "sc-1783spc-1"
})(["align-items:center;border-top-left-radius:4px;border-top-right-radius:4px;cursor:pointer;display:flex;height:2.5em;justify-content:center;margin-bottom:-1px;padding:0.5rem;&.active{background-color:white;color:", ";fill:", ";", ";}&:focus{outline:none;", ";}&:not(.active):hover{background-color:", ";border-bottom:1px solid ", ";", ";}&:not(:last-child){margin-right:0.5rem;}&{", ";}"], palette('primary'), palette('primary'), theme('fannypack.Tabs.Tab.active'), theme('fannypack.Tabs.Tab.focus'), palette('white700'), palette('textTint'), theme('fannypack.Tabs.Tab.hover'), theme('fannypack.Tabs.Tab.base'));
var alignPropeties = {
  center: css(["justify-content:center;"]),
  right: css(["justify-content:flex-end;"])
};
var _Tabs = styled(Tabs).withConfig({
  displayName: "styled",
  componentId: "sc-1783spc-2"
})(["align-items:center;border-bottom:1px solid ", ";display:flex;font-weight:", ";list-style:none;", ";& ", "{", ";", ";}& ", ".active{", ";", ";}&{", ";}&{", ";}"], palette('textTint'), theme('fannypack.fontWeights.semibold'), function (props) {
  return props.isFitted && css(["& ", "{flex:1;}"], Tab);
}, Tab, function (props) {
  return props.type === 'default' && css(["&{", ";}"], theme('fannypack.Tabs.Tab.default.base'));
}, function (props) {
  return props.type === 'boxed' && css(["border:1px solid transparent;&{", ";}"], theme('fannypack.Tabs.Tab.boxed.base'));
}, Tab, function (props) {
  return props.type === 'default' && css(["box-shadow:inset 0 -2px 0 0 ", ";&{", ";}"], palette('primary'), theme('fannypack.Tabs.Tab.default.active'));
}, function (props) {
  return props.type === 'boxed' && css(["border:1px solid ", ";border-bottom-color:transparent;&{", ";}"], palette('textTint'), theme('fannypack.Tabs.Tab.boxed.active'));
}, function (props) {
  return props.align && alignPropeties[props.align || ''];
}, theme('fannypack.Tabs.base'));

var noop = function noop() {};

var Tab$1 = function Tab$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isActive = _ref.isActive,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "className", "isActive"]);

  return createElement(Tab, _extends({}, props, {
    className: classNames(className, {
      active: isActive
    })
  }), children);
};
Tab$1.propTypes = {
  children: node.isRequired,
  className: string,
  isActive: bool,
  tab: string.isRequired,
  current: number.isRequired,
  register: func.isRequired,
  update: func.isRequired,
  unregister: func.isRequired,
  isCurrent: func.isRequired,
  show: func.isRequired,
  next: func.isRequired,
  previous: func.isRequired
};
Tab$1.defaultProps = {
  className: undefined,
  isActive: false,
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: function isCurrent() {
    return false;
  },
  show: noop,
  next: noop,
  previous: noop
}; // @ts-ignore

var C = Tab$1;

var TabPanel$1 = function TabPanel$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(TabPanel, props, children);
};
TabPanel$1.propTypes = {
  children: node.isRequired,
  className: string,
  tab: string.isRequired,
  isCurrent: func.isRequired
};
TabPanel$1.defaultProps = {
  className: undefined
}; // @ts-ignore

var C$1 = TabPanel$1;

var Tabs$1 = function Tabs$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(_Tabs, _extends({
    use: Tabs
  }, props), children);
};
Tabs$1.Tab = C;
Tabs$1.Panel = C$1;
Tabs$1.Container = Tabs.Container;
Tabs$1.propTypes = {
  align: oneOf(['left', 'center', 'right']),
  children: node.isRequired,
  className: string,
  isFitted: bool,
  type: oneOf(['default', 'boxed'])
};
Tabs$1.defaultProps = {
  align: undefined,
  className: undefined,
  isFitted: false,
  type: 'default'
};
var C$2 = Tabs$1;

export default C$2;
export { C$2 as Tabs };
