import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css, space } from './styled.js';
import InlineFlex from 'reakit/InlineFlex';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import { a as Icon } from './chunk-51b7d577.js';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'airbnb-prop-types';
import { a as Button } from './chunk-0ba092a8.js';
import './types.js';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-c400d1e8.js';
import './chunk-e8f72546.js';
import 'lodash/omit';

var sizeAttributes = {
  medium: css(["font-size:1em;height:2rem;&{", ";}"], theme('fannypack.Tag.sizes.medium')),
  large: css(["font-size:1.25em;height:2.5rem;&{", ";}"], theme('fannypack.Tag.sizes.large'))
};
var outlinedProperties = css(["&{background-color:unset;border:1px solid ", ";color:", ";fill:", ";}&{", ";}"], palette(), palette(), palette(), theme('fannypack.Tag.outlined'));
var RemoveButton = styled(Button).withConfig({
  displayName: "styled__RemoveButton",
  componentId: "sc-1g01kou-0"
})(["background:none;padding:0 ", "rem;height:100%;", ";&:focus{box-shadow:inset ", " 0px 0px 0px 2px;}&{", ";}"], space(1), function (props) {
  return props.kind !== 'ghost' && css(["color:", ";"], function (props) {
    return palette(props.palette + "Inverted");
  });
}, function (props) {
  return palette(props.palette === 'default' ? 'primary' : props.palette + "300")(props);
}, theme('fannypack.Tag.RemoveButton.base'));
var TagContent = styled(Box).withConfig({
  displayName: "styled__TagContent",
  componentId: "sc-1g01kou-1"
})(["padding:0 ", "em;", ";&{", ";}"], space(2), function (props) {
  return props.isRemovable && css(["padding-right:0rem;"]);
}, theme('fannypack.Tag.TagContent.base'));
var Tag = styled(InlineFlex).withConfig({
  displayName: "styled__Tag",
  componentId: "sc-1g01kou-2"
})(["align-items:center;background-color:", ";border-radius:4px;color:", ";fill:", ";font-size:", "rem;font-weight:", ";height:1.5rem;justify-content:center;&{", ";", ";}&{", ";}"], palette(), function (props) {
  return palette(props.palette + "Inverted");
}, function (props) {
  return palette(props.palette + "Inverted");
}, theme('fannypack.fontSizes.100'), theme('fannypack.fontWeights.semibold'), function (props) {
  return props.styledSize && sizeAttributes[props.styledSize];
}, function (props) {
  return props.kind === 'outlined' && outlinedProperties;
}, theme('fannypack.Tag.base'));

var Tag$1 = function Tag$$1(_ref) {
  var children = _ref.children,
      onRemove = _ref.onRemove,
      size = _ref.size,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "onRemove", "size"]);

  return createElement(Tag, _extends({
    styledSize: size
  }, props), createElement(TagContent, {
    isRemovable: Boolean(onRemove)
  }, children), Boolean(onRemove) && createElement(RemoveButton, {
    onClick: onRemove,
    kind: props.kind === 'outlined' ? 'ghost' : undefined,
    palette: props.palette
  }, createElement(Icon, {
    a11yLabel: "Close",
    icon: "times"
  })));
};
Tag$1.propTypes = {
  className: string,
  children: node.isRequired,
  kind: oneOf(['outlined']),
  onRemove: func,
  palette: string,
  size: string
};
Tag$1.defaultProps = {
  className: undefined,
  kind: undefined,
  onRemove: undefined,
  palette: 'text',
  size: undefined
}; // @ts-ignore

var C = Tag$1;

export default C;
export { C as Tag };
