import { h as _taggedTemplateLiteralLoose, c as _objectWithoutPropertiesLoose, b as _extends, d as _inheritsLoose, e as _assertThisInitialized, f as _defineProperty, a as _objectSpread } from './chunk-cd704477.js';
import { createGlobalStyle, css, space, withTheme } from './styled.js';
import Portal from './Portal.js';
import ThemeProvider from 'reakit/Provider';
import { LoadsProvider } from 'react-loads';
import _camelCase from 'lodash/camelCase';
import { a as Toasts, b as ToastContainer, c as Toast } from './chunk-1e09c8aa.js';
import { a as defaultTheme } from './chunk-e370c1b3.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import _get from 'lodash/get';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/styled';
import 'reakit/Portal';
import 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import './types.js';
import './chunk-51b7d577.js';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'airbnb-prop-types';
import './chunk-0ba092a8.js';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-c400d1e8.js';
import './chunk-e8f72546.js';
import 'lodash/omit';
import './Heading.js';
import 'reakit/Heading';
import 'classnames';
import './VisuallyHidden.js';
import './chunk-a1e5c7d9.js';
import 'reakit';
import 'lodash/uniqueId';
import '@fortawesome/free-solid-svg-icons/faInfoCircle';
import '@fortawesome/free-solid-svg-icons/faExclamationTriangle';
import '@fortawesome/free-solid-svg-icons/faCheckCircle';
import '@fortawesome/free-solid-svg-icons/faExclamationCircle';
import '@fortawesome/free-solid-svg-icons/faTimes';

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  html, body {\n    box-sizing: border-box;\n    font-family: ", ";\n    font-size: ", "px;\n    font-weight: ", ";\n    line-height: 1.5;\n    margin: 0;\n    padding: 0;\n    overflow-x: hidden;\n    -webkit-font-smoothing: antialiased;\n    text-rendering: optimizeLegibility;\n    color: ", ";\n    fill: ", ";\n  }\n\n  html.wf-active, body {\n    font-family: ", ";\n  }\n\n  *,\n  *::before,\n  *::after {\n    box-sizing: inherit;\n  }\n\n  *:focus {\n    outline: 2px solid ", ";\n    outline-offset: 2px;\n  }\n\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Global = createGlobalStyle(_templateObject(), function (props) {
  return theme('fannypack.global.fallbackFontFamily')(props) || theme('fannypack.global.fontFamily')(props);
}, theme('fannypack.global.fontSize'), theme('fannypack.fontWeights.normal'), palette('text'), palette('text'), theme('fannypack.global.fontFamily'), palette('primary'), theme('fannypack.global.base'));

var buildColorFromPalette = function buildColorFromPalette(property, _ref) {
  var theme$$1 = _ref.theme,
      props = _objectWithoutPropertiesLoose(_ref, ["theme"]);

  // @ts-ignore
  var color = theme$$1.palette[props[_camelCase(property)]];

  if (typeof color === 'function') {
    color = color(props);
  }

  if (!color) return;
  return property + ": " + color + " !important;";
};

var buildSpacingFromTheme = function buildSpacingFromTheme(property, props) {
  // @ts-ignore
  var spacing = space(props[_camelCase(property)])(props);
  if (!spacing) return;
  return property + ": " + spacing + "rem !important;";
};

var buildFontSizeFromTheme = function buildFontSizeFromTheme(property, _ref2) {
  var theme$$1 = _ref2.theme,
      props = _objectWithoutPropertiesLoose(_ref2, ["theme"]);

  // @ts-ignore
  var size = theme$$1.fannypack.fontSizes[props[_camelCase(property)]];

  if (!size) return;
  return property + ": " + size + "rem !important;";
};

var buildFontWeightFromTheme = function buildFontWeightFromTheme(property, _ref3) {
  var theme$$1 = _ref3.theme,
      props = _objectWithoutPropertiesLoose(_ref3, ["theme"]);

  // @ts-ignore
  var weight = theme$$1.fannypack.fontWeights[props[_camelCase(property)]];

  if (!weight) return;
  return property + ": " + weight + " !important;";
};

var reakitTheme = {
  Box: css(["", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";"], function (props) {
    return buildColorFromPalette('color', props);
  }, function (props) {
    return buildColorFromPalette('background-color', props);
  }, function (props) {
    return buildColorFromPalette('border-block-end-color', props);
  }, function (props) {
    return buildColorFromPalette('border-block-start-color', props);
  }, function (props) {
    return buildColorFromPalette('border-bottom-color', props);
  }, function (props) {
    return buildColorFromPalette('border-color', props);
  }, function (props) {
    return buildColorFromPalette('border-inline-end-color', props);
  }, function (props) {
    return buildColorFromPalette('border-inline-start-color', props);
  }, function (props) {
    return buildColorFromPalette('border-left-color', props);
  }, function (props) {
    return buildColorFromPalette('border-right-color', props);
  }, function (props) {
    return buildColorFromPalette('border-top-color', props);
  }, function (props) {
    return buildColorFromPalette('border-bottom-color', props);
  }, function (props) {
    return buildColorFromPalette('caret-color', props);
  }, function (props) {
    return buildColorFromPalette('column-rule-color', props);
  }, function (props) {
    return buildColorFromPalette('outline-color', props);
  }, function (props) {
    return buildColorFromPalette('text-decoration-color', props);
  }, function (props) {
    return buildColorFromPalette('text-emphasis-color', props);
  }, function (props) {
    return buildSpacingFromTheme('margin', props);
  }, function (props) {
    return buildSpacingFromTheme('margin-left', props);
  }, function (props) {
    return buildSpacingFromTheme('margin-right', props);
  }, function (props) {
    return buildSpacingFromTheme('margin-top', props);
  }, function (props) {
    return buildSpacingFromTheme('margin-bottom', props);
  }, function (props) {
    return buildSpacingFromTheme('padding', props);
  }, function (props) {
    return buildSpacingFromTheme('padding-left', props);
  }, function (props) {
    return buildSpacingFromTheme('padding-right', props);
  }, function (props) {
    return buildSpacingFromTheme('padding-top', props);
  }, function (props) {
    return buildSpacingFromTheme('padding-bottom', props);
  }, function (props) {
    return buildFontSizeFromTheme('font-size', props);
  }, function (props) {
    return buildFontWeightFromTheme('font-weight', props);
  })
};

var ToastManager = function ToastManager(_ref) {
  var theme$$1 = _ref.theme;

  var ToastComponent = _get(theme$$1, 'fannypack.Toast.component', Toast);

  var defaultProps = _get(theme$$1, 'fannypack.Toast.defaultProps', {});

  var placement = _get(theme$$1, 'fannypack.Toast.placement', 'top-end');

  var isStacked = _get(theme$$1, 'fannypack.Toast.isStacked', true);

  return createElement(Portal, null, createElement(Toasts, {
    placement: placement
  }, createElement(ToastContainer, {
    placement: placement
  }, function (state) {
    return [].concat(isStacked ? state.toasts : [state.toasts[0]]).filter(Boolean).map(function (toast) {
      return createElement(ToastComponent, _extends({
        key: toast.key,
        onClickClose: function onClickClose() {
          return state.remove({
            key: toast.key
          });
        }
      }, defaultProps, toast), toast.message);
    });
  })));
};
ToastManager.propTypes = {
  theme: object
};
ToastManager.defaultProps = {
  theme: {
    fannypack: {}
  }
};
var ToastManager$1 = withTheme(ToastManager);

var loadTheme = function loadTheme(_ref) {
  var _theme = _ref.theme,
      isStandalone = _ref.isStandalone;
  var theme$$1 = defaultTheme(_theme);

  if (isStandalone && _theme) {
    theme$$1 = _theme;
  }

  if (typeof window !== 'undefined') {
    var webFontLoaderConfig = theme$$1.webFontLoader;

    if (webFontLoaderConfig) {
      // @ts-ignore
      import('webfontloader').then(function (webFontLoader) {
        return webFontLoader.load(webFontLoaderConfig);
      });
    }
  }

  var derivedTheme = _objectSpread({
    fannypack: theme$$1
  }, reakitTheme, theme$$1 && theme$$1.reakit ? theme$$1.reakit : {}, {
    palette: theme$$1 && theme$$1.palette ? theme$$1.palette : {}
  });

  return derivedTheme;
};

var Provider =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Provider, _React$Component);

  function Provider() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      theme: loadTheme({
        theme: _this.props.theme,
        isStandalone: _this.props.isStandalone
      })
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var children = _this.props.children;
      var theme$$1 = _this.state.theme;
      return createElement(ThemeProvider, {
        theme: theme$$1
      }, createElement(LoadsProvider, null, createElement(Fragment, null, createElement(Global, null), !_get(theme$$1, 'fannypack.Toast.disabled') && createElement(ToastManager$1, null), children)));
    });

    return _this;
  }

  return Provider;
}(Component);

_defineProperty(Provider, "propTypes", {
  children: node.isRequired,
  isStandalone: bool,
  theme: object
});

_defineProperty(Provider, "defaultProps", {
  isStandalone: false,
  theme: {}
});

export default Provider;
export { Provider as ThemeProvider };
