import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { space } from './styled.js';
import { Paragraph } from './Paragraph.js';
import _isArrayLikeObject from 'lodash/isArrayLikeObject';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme, palette } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import './chunk-d1ea7076.js';
import 'reakit/Paragraph';

var Timeline = styled(Box).withConfig({
  displayName: "styled__Timeline",
  componentId: "yjvza4-0"
})(["&{", ";}"], theme('fannypack.Timeline.base'));
var TimelineRow = styled(Box).withConfig({
  displayName: "styled__TimelineRow",
  componentId: "yjvza4-1"
})(["display:flex;position:relative;&:last-child{margin-bottom:0;}&::before{content:'';border:1px solid ", ";position:absolute;height:100%;left:", "rem;margin-top:", "rem;}&:last-child::before{border:0;}"], function (props) {
  return palette(props.lineColor || 'textTint', props.lineColor);
}, space(1), space(5));
var TimelineStep = styled(Box).withConfig({
  displayName: "styled__TimelineStep",
  componentId: "yjvza4-2"
})(["&{", ";}"], theme('fannypack.Timeline.Step.base'));
var TimelineBullet = styled(Box).withConfig({
  displayName: "styled__TimelineBullet",
  componentId: "yjvza4-3"
})(["border-radius:50%;display:inline-flex;height:0.625rem;width:0.625rem;margin-top:", "rem;margin-right:", "rem;z-index:1;&{", ";}"], space(4), space(2), theme('fannypack.Timeline.Bullet.base'));
var TimelineStepHeading = styled(Paragraph).withConfig({
  displayName: "styled__TimelineStepHeading",
  componentId: "yjvza4-4"
})(["margin-top:", "rem;margin-bottom:", "rem;line-height:1.5rem;color:", ";&:not(:last-child){margin-top:", "rem;margin-bottom:", "rem;}&{", ";}"], space(2), space(1), function (props) {
  return props.color || palette('text');
}, space(2), space(1), theme('fannypack.Timeline.StepHeading.base'));
var TimelineStepDetail = styled(Box).withConfig({
  displayName: "styled__TimelineStepDetail",
  componentId: "yjvza4-5"
})(["color:", ";&{", ";}"], function (props) {
  return props.color || palette('text');
}, theme('fannypack.Timeline.StepDetail.base'));

/* eslint react/prop-types: 0 */

var TimelineStep$1 = function TimelineStep$$1(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      lineColor = _ref.lineColor,
      progressColor = _ref.progressColor;
  return createElement(TimelineRow, {
    lineColor: lineColor,
    "aria-labelledby": a11yTitleId,
    "aria-describedby": a11yDescriptionId
  }, createElement(TimelineBullet, {
    backgroundColor: progressColor
  }), createElement(TimelineStep, {
    "aria-labelledby": a11yTitleId,
    "aria-describedby": a11yDescriptionId
  }, children));
};

TimelineStep$1.propTypes = {
  a11yDescriptionId: string,
  a11yTitleId: string,
  children: node.isRequired,
  lineColor: string,
  progressColor: string
};
TimelineStep$1.defaultProps = {
  a11yDescriptionId: undefined,
  a11yTitleId: undefined,
  lineColor: undefined,
  progressColor: 'textTint'
}; // @ts-ignore

var C = TimelineStep$1;

var TimelineStepDetail$1 = function TimelineStepDetail$$1(_ref) {
  var children = _ref.children,
      color = _ref.color,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "color"]);

  return createElement(TimelineStepDetail, _extends({
    color: color
  }, props), children);
};

TimelineStepDetail$1.propTypes = {
  children: node.isRequired,
  color: string
};
TimelineStepDetail$1.defaultProps = {
  color: undefined
};
var C$1 = TimelineStepDetail$1;

var TimelineStepHeading$1 = function TimelineStepHeading$$1(_ref) {
  var children = _ref.children,
      color = _ref.color,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "color"]);

  return createElement(TimelineStepHeading, _extends({
    color: color,
    fontWeight: "semibold"
  }, props), children);
};

TimelineStepHeading$1.propTypes = {
  children: node.isRequired,
  color: string
};
TimelineStepHeading$1.defaultProps = {
  color: undefined
};
var C$2 = TimelineStepHeading$1;

/* eslint react/prop-types: 0 */
var Timeline$1 = function Timeline$$1(_ref) {
  var activeStep = _ref.activeStep,
      children = _ref.children,
      progressColor = _ref.progressColor;

  if (!_isArrayLikeObject(children)) {
    return null;
  }

  var activeIndexStep = Children.toArray(children).findIndex(function (child) {
    return child.props.a11yTitleId === activeStep;
  });
  return createElement(Timeline, null, Children.map(children, function (child, index) {
    var _child = child;
    var color = progressColor ? progressColor : _child.props.progressColor;
    return index <= activeIndexStep ? cloneElement(_child, {
      lineColor: index < activeIndexStep ? color : undefined,
      progressColor: color || undefined
    }) : child;
  }));
};
Timeline$1.Step = C;
Timeline$1.StepHeading = C$2;
Timeline$1.StepDetail = C$1;
Timeline$1.propTypes = {
  activeStep: string,
  children: node.isRequired,
  progressColor: string
};
Timeline$1.defaultProps = {
  activeStep: undefined,
  progressColor: undefined
}; // @ts-ignore

var C$3 = Timeline$1;

export default C$3;
export { C$3 as Timeline };
