import { c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { space } from './styled.js';
import { placementPropType } from './types.js';
import _Tooltip from 'reakit/Tooltip';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import 'reakit/styled';
import 'lodash/get';

var Tooltip = styled(_Tooltip).withConfig({
  displayName: "styled__Tooltip",
  componentId: "sc-8zl4l2-0"
})(["background:black;border-radius:2px;color:white;opacity:0.8;font-size:", "rem;font-weight:", ";padding:", "rem ", "rem;&{", ";}"], theme('fannypack.fontSizes.100'), theme('fannypack.fontWeights.normal'), space(1), space(2), theme('fannypack.Tooltip.base'));

var Tooltip$1 = function Tooltip$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(Tooltip, props, children);
};
Tooltip$1.propTypes = {
  className: string,
  children: node.isRequired,
  delay: string,
  duration: string,
  expand: bool,
  gutter: oneOfType([number, string]),
  fade: bool,
  placement: placementPropType,
  slide: bool,
  timing: string
};
Tooltip$1.defaultProps = {
  className: undefined,
  delay: undefined,
  duration: '100ms',
  expand: false,
  fade: false,
  gutter: 4,
  placement: 'bottom',
  slide: false,
  timing: 'ease-in-out'
}; // @ts-ignore

var C = Tooltip$1;

export default C;
export { C as Tooltip };
