import { b as _extends, a as _objectSpread, d as _inheritsLoose, e as _assertThisInitialized, f as _defineProperty, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css, palette, space, theme } from './styled.js';
import { a as Icon$1 } from './chunk-d1ea7076.js';
import { a as Icon, b as iconPropTypes } from './chunk-51b7d577.js';
import { a as Navigation } from './Navigation-848d4222.js';
import { Divider } from './Divider.js';
import { a as Popover } from './Popover-0ad4ce49.js';
import _Button from 'reakit/Button';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import { a as Button } from './chunk-0ba092a8.js';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import './chunk-c400d1e8.js';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import './types.js';
import './parseIcons.js';
import 'airbnb-prop-types';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import './chunk-e8f72546.js';
import 'lodash/omit';

var MenuItem = styled(_Button).withConfig({
  displayName: "styled__MenuItem",
  componentId: "l9b8us-0"
})(["background-color:unset;cursor:pointer;display:block;font-weight:", ";padding:", "rem ", "rem;text-align:left;width:100%;a&{color:unset;fill:unset;text-decoration:unset;&:hover{color:unset;fill:unset;}}&[disabled]{cursor:not-allowed;opacity:0.5;&{", ";}}&:not(:disabled):focus{outline:unset;background-color:", ";&{", ";}}&:not(:disabled):hover{background-color:", ";&{", ";}}&:not(:disabled):focus:active,&:not(:disabled):hover:active{background-color:", ";}", " & ", "{top:0.15em;}&{", ";}"], theme('fannypack.fontWeights.semibold'), space(1.5), space(4), theme('fannypack.Menu.Item.disabled'), palette('white600'), theme('fannypack.Menu.Item.focus'), palette('white600'), theme('fannypack.Menu.Item.hover'), palette('white700'), function (props) {
  return props.isActive && css(["background-color:", ";&&:hover,&&:focus{background-color:", ";}&{", ";}"], palette('white700'), palette('white800'), theme('fannypack.Menu.Item.active'));
}, Icon$1, theme('fannypack.Menu.Item.base'));
var MenuButton = styled(Button).withConfig({
  displayName: "styled__MenuButton",
  componentId: "l9b8us-1"
})(["&{", ";}"], theme('fannypack.Menu.Button.base'));
var MenuDivider = styled(Divider).withConfig({
  displayName: "styled__MenuDivider",
  componentId: "l9b8us-2"
})(["margin:0;width:100%;&{", ";}"], theme('fannypack.Menu.Divider.base'));
var MenuIcon = styled(Icon).withConfig({
  displayName: "styled__MenuIcon",
  componentId: "l9b8us-3"
})(["margin-right:", "rem;&{", ";}"], space(2), theme('fannypack.Menu.Item.icon'));
var MenuGroup = styled(Box).withConfig({
  displayName: "styled__MenuGroup",
  componentId: "l9b8us-4"
})(["margin:", "rem 0;width:100%;&{", ";}"], space(2), theme('fannypack.Menu.Group.base'));
var MenuGroupTitle = styled(Box).withConfig({
  displayName: "styled__MenuGroupTitle",
  componentId: "l9b8us-5"
})(["color:", ";font-size:", "rem;font-weight:", ";letter-spacing:1px;padding:", "rem ", "rem;padding-top:", "rem;text-transform:uppercase;&{", ";}"], palette('text200'), theme('fannypack.fontSizes.100'), theme('fannypack.fontWeights.semibold'), space(2), space(4), space(1), theme('fannypack.Menu.Group.title'));
var MenuPopover = styled(Popover).withConfig({
  displayName: "styled__MenuPopover",
  componentId: "l9b8us-6"
})(["padding:0px;width:200px;&{", ";}"], theme('fannypack.Menu.Popover.base'));
var _Menu = styled(Navigation).withConfig({
  displayName: "styled",
  componentId: "l9b8us-7"
})(["display:flex;align-items:flex-start;", ";&{", ";}"], function (props) {
  return props.isHorizontal ? css(["flex-direction:row;& ", "{display:flex;flex-direction:row;flex-wrap:wrap;}& ", "{width:unset;}&{", ";}"], MenuGroup, MenuItem, theme('fannypack.Menu.horizontal')) : css(["flex-direction:column;&{", ";}"], theme('fannypack.Menu.vertical'));
}, theme('fannypack.Menu.base'));

var initialState = {
  startAt: undefined,
  handleMenuOpenViaKeyboard: function handleMenuOpenViaKeyboard() {},
  setPopoverProps: function setPopoverProps() {},
  hide: function hide() {},
  show: function show() {},
  toggle: function toggle() {},
  isVisible: false
};
var Context = createContext(initialState);

var MenuProvider =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(MenuProvider, _React$Component);

  function MenuProvider() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleMenuOpenViaKeyboard", function (_temp) {
      var _ref = _temp === void 0 ? {} : _temp,
          _ref$startAt = _ref.startAt,
          startAt = _ref$startAt === void 0 ? 'first' : _ref$startAt;

      _this.setState({
        startAt: startAt
      }, _this.state.show);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "setPopoverProps", function (popover) {
      _this.setState(_objectSpread({}, popover));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", _objectSpread({}, initialState, {
      setPopoverProps: _this.setPopoverProps,
      handleMenuOpenViaKeyboard: _this.handleMenuOpenViaKeyboard
    }));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var children = _this.props.children;
      return createElement(Context.Provider, {
        value: _this.state
      }, children);
    });

    return _this;
  }

  return MenuProvider;
}(Component);

var MenuContext = _objectSpread({}, Context, {
  Provider: MenuProvider
});
var withMenuContext = function withMenuContext(C) {
  return function (props) {
    return createElement(Context.Consumer, null, function (context) {
      return createElement(C, _extends({
        context: context
      }, props));
    });
  };
};

var menuItemPropTypes = {
  children: node.isRequired,
  hideOnClick: bool,
  icon: iconPropTypes['icon'],
  isActive: bool,
  isDisabled: bool,
  onClick: func
};
var menuItemDefaultProps = {
  hideOnClick: true,
  icon: undefined,
  isActive: false,
  isDisabled: false,
  onClick: undefined
};
var MenuItem$1 =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(MenuItem$$1, _React$Component);

  function MenuItem$$1() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClick", function () {
      var _this$props = _this.props,
          context = _this$props.context,
          hideOnClick = _this$props.hideOnClick,
          onClick = _this$props.onClick;
      onClick && onClick();
      hideOnClick && context && context.hide();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "render", function () {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          icon = _this$props2.icon,
          isDisabled = _this$props2.isDisabled,
          props = _objectWithoutPropertiesLoose(_this$props2, ["children", "icon", "isDisabled"]);

      return createElement(MenuItem, _extends({
        role: "menuitem",
        disabled: isDisabled
      }, props, {
        onClick: _this.handleClick,
        type: "button"
      }), icon && // @ts-ignore
      createElement(MenuIcon, {
        a11yHidden: true,
        icon: icon
      }), children);
    });

    return _this;
  }

  return MenuItem$$1;
}(Component); // @ts-ignore

_defineProperty(MenuItem$1, "propTypes", menuItemPropTypes);

_defineProperty(MenuItem$1, "defaultProps", menuItemDefaultProps);

var C = withMenuContext(MenuItem$1);

export { MenuButton as a, withMenuContext as b, MenuDivider as c, MenuGroup as d, MenuGroupTitle as e, MenuContext as f, MenuPopover as g, _Menu as h, C as i, menuItemPropTypes as j };
