import { b as _extends, c as _objectWithoutPropertiesLoose, a as _objectSpread } from './chunk-cd704477.js';
import styled, { css, keyframes, palette, space, theme } from './styled.js';
import { placementPropType } from './types.js';
import { a as Icon } from './chunk-51b7d577.js';
import { a as Button, b as buttonPropTypes } from './chunk-0ba092a8.js';
import { Heading } from './Heading.js';
import VisuallyHidden from './VisuallyHidden.js';
import { a as Pane, b as panePropTypes, c as paneDefaultProps } from './chunk-a1e5c7d9.js';
import _omit from 'lodash/omit';
import { Container } from 'reakit';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import _uniqueId from 'lodash/uniqueId';
import Box from 'reakit/Box';
import Flex from 'reakit/Flex';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'airbnb-prop-types';
import './chunk-c400d1e8.js';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-e8f72546.js';

var ToastClose = styled(Button).withConfig({
  displayName: "styled__ToastClose",
  componentId: "cax10c-0"
})(["width:24px;height:24px;padding:0;text-align:right;", ";&:hover{background-color:", ";&{", ";}}&{", ";}"], function (props) {
  return props.isAbsolute ? css(["position:absolute;right:", "rem;top:", "rem;"], space(2), space(2)) : css(["margin:0 ", "rem;"], space(2));
}, palette('white700'), theme('fannypack.Toast.Close.hover'), theme('fannypack.Toast.Close.base'));
var ToastTitle = styled(Heading).withConfig({
  displayName: "styled__ToastTitle",
  componentId: "cax10c-1"
})(["&{", ";}"], theme('fannypack.Toast.Title.base'));
var ToastIconWrapper = styled(Flex).withConfig({
  displayName: "styled__ToastIconWrapper",
  componentId: "cax10c-2"
})(["margin-right:", "rem;margin-left:-", "rem;align-items:center;&{", ";}"], space(3), space(1), theme('fannypack.Toast.Icon.wrapper'));
var ToastIcon = styled(Icon).withConfig({
  displayName: "styled__ToastIcon",
  componentId: "cax10c-3"
})(["&{", ";}"], theme('fannypack.Toast.Icon.base'));
var Content = styled(Flex).withConfig({
  displayName: "styled__Content",
  componentId: "cax10c-4"
})(["padding:", "rem;padding-left:calc(", "rem + 5px);padding-right:", "rem;&{", ";}"], space(4), space(4), space(8), theme('fannypack.Toast.Content.base'));
var heightCountdown = keyframes(["from{height:calc(100% + 2px);}to{height:0%;}"]);
var widthCountdown = keyframes(["from{width:calc(100% + 2px);}to{width:0%;}"]);
var CountdownBar = styled(Box).withConfig({
  displayName: "styled__CountdownBar",
  componentId: "cax10c-5"
})(["position:absolute;", ";", ";", ";", ";&{", ";}"], function (props) {
  return props.isHorizontal ? css(["border-bottom-right-radius:3px;border-bottom-left-radius:3px;bottom:0;height:5px;right:-1px;width:calc(100% + 2px);"]) : css(["border-top-left-radius:3px;border-bottom-left-radius:3px;bottom:-1px;height:calc(100% + 2px);margin-left:-1px;width:5px;"]);
}, function (props) {
  return props.type && css(["background-color:", ";"], props.isBackground ? palette(props.type + "Tint") : palette(props.type));
}, function (props) {
  return props.autoDismissTimeout && css(["", ";&{", ";}"], function (props) {
    return props.isHorizontal ? css(["animation:", " ", "ms linear forwards;border-bottom-left-radius:unset;"], widthCountdown, props.autoDismissTimeout) : css(["animation:", " ", "ms linear forwards;border-top-left-radius:unset;"], heightCountdown, props.autoDismissTimeout);
  }, theme('fannypack.Toast.CountdownBar.autoDismissTimeout'));
}, function (props) {
  return props.isBackground && css(["&{", ";}"], theme('fannypack.Toast.CountdownBar.background'));
}, theme('fannypack.Toast.CountdownBar.base'));
var tintAttributes = css(["background-color:", ";color:", ";fill:", ";", ";"], function (props) {
  return props.type && palette(props.type + "Tint")(props);
}, function (props) {
  return props.type && palette(props.type + "TintInverted")(props);
}, function (props) {
  return props.type && palette(props.type + "TintInverted")(props);
}, theme('fannypack.Toast.tint'));
var Toast = styled(Pane).withConfig({
  displayName: "styled__Toast",
  componentId: "cax10c-6"
})(["align-items:center;display:flex;font-size:", "rem;justify-content:space-between;position:relative;width:350px;&:not(:last-child){margin-bottom:", "rem;}&{", ";}&{", ";}"], theme('fannypack.fontSizes.150'), space(4), function (props) {
  return props.hasTint && tintAttributes;
}, theme('fannypack.Toast.base'));
var fromLeft = keyframes(["from{transform:translateX(-120%);}to{transform:translateX(0);}"]);
var fromRight = keyframes(["from{transform:translateX(120%);}to{transform:translateX(0);}"]);
var fromTop = keyframes(["from{transform:translateY(-120%);}to{transform:translateY(0);}"]);
var fromBottom = keyframes(["from{transform:translateY(120%);}to{transform:translateY(0);}"]);
var placementAttributes = {
  'top-start': css(["top:1rem;left:1rem;& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromLeft),
  top: css(["top:1rem;left:50%;transform:translateX(-50%);& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromTop),
  'top-end': css(["top:1rem;right:1rem;& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromRight),
  left: css(["left:1rem;top:50%;transform:translateY(-50%);& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromLeft),
  right: css(["right:1rem;top:50%;transform:translateY(-50%);& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromRight),
  'bottom-start': css(["bottom:1rem;left:1rem;& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromLeft),
  bottom: css(["bottom:1rem;left:50%;transform:translateX(-50%);& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromBottom),
  'bottom-end': css(["bottom:1rem;right:1rem;& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromRight)
};
var Toasts = styled(Box).withConfig({
  displayName: "styled__Toasts",
  componentId: "cax10c-7"
})(["position:fixed;z-index:99999;", ";&{", ";}"], function (props) {
  return placementAttributes[props.placement];
}, theme('fannypack.Toasts.base'));

var initialState = {
  autoDismissTimeout: 5000,
  toasts: []
};

var add = function add(toast) {
  return function (_ref) {
    var setState = _ref.setState,
        state = _ref.state;
    var placement = state.props.placement;

    var key = _uniqueId('toast-');

    var autoDismissTimeout = typeof toast.autoDismissTimeout === 'number' ? toast.autoDismissTimeout : state.autoDismissTimeout;
    setState(function (state) {
      return {
        toasts: [].concat(placement.includes('bottom') ? state.toasts : [], [_objectSpread({
          key: key,
          autoDismissTimeout: autoDismissTimeout
        }, toast)], !placement.includes('bottom') ? state.toasts : [])
      };
    });

    if (autoDismissTimeout > 0) {
      setTimeout(function () {
        return setState(function (state) {
          return {
            toasts: state.toasts.filter(function (toast) {
              return toast.key !== key;
            })
          };
        });
      }, toast.autoDismissTimeout || state.autoDismissTimeout);
    }
  };
};

var effects = {
  add: add,
  info: function info(toast) {
    return add(_objectSpread({}, toast, {
      type: 'info'
    }));
  },
  success: function success(toast) {
    return add(_objectSpread({}, toast, {
      type: 'success'
    }));
  },
  danger: function danger(toast) {
    return add(_objectSpread({}, toast, {
      type: 'danger'
    }));
  },
  warning: function warning(toast) {
    return add(_objectSpread({}, toast, {
      type: 'warning'
    }));
  }
};
var actions = {
  remove: function remove(_ref2) {
    var key = _ref2.key;
    return function (state) {
      return {
        toasts: state.toasts.filter(function (toast) {
          return toast.key !== key;
        })
      };
    };
  }
};
var ToastContainer = function ToastContainer(_ref3) {
  var children = _ref3.children,
      props = _objectWithoutPropertiesLoose(_ref3, ["children"]);

  return createElement(Container, {
    context: "toasts",
    initialState: _objectSpread({}, initialState, {
      props: props
    }),
    actions: actions,
    effects: effects,
    pure: true
  }, children);
};
ToastContainer.propTypes = {
  children: func.isRequired,
  placement: placementPropType
};
ToastContainer.defaultProps = {
  placement: 'top-end'
};

var ToastClose$1 = function ToastClose$$1(_ref) {
  var onClickClose = _ref.onClickClose,
      props = _objectWithoutPropertiesLoose(_ref, ["onClickClose"]);

  return createElement(ToastClose, _extends({
    kind: "link",
    onClick: onClickClose
  }, props), createElement(VisuallyHidden, null, "Close"), createElement(Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
ToastClose$1.propTypes = {
  isAbsolute: bool,
  onClickClose: func
};
ToastClose$1.defaultProps = {
  isAbsolute: false,
  onClickClose: undefined
};
var C = ToastClose$1;

var ToastIcon$1 = function ToastIcon$$1(_ref) {
  var size = _ref.size,
      type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, ["size", "type"]);

  return createElement(ToastIconWrapper, props, createElement(ToastIcon, {
    a11yLabel: type,
    color: type,
    icon: type,
    size: size
  }));
};
ToastIcon$1.propTypes = {
  size: string,
  type: string.isRequired
};
ToastIcon$1.defaultProps = {
  size: undefined
}; // @ts-ignore

var C$1 = ToastIcon$1;

var ToastTitle$1 = function ToastTitle$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(ToastTitle, _extends({
    fontWeight: "semibold",
    use: "h6"
  }, props), children);
};
ToastTitle$1.propTypes = {
  children: node.isRequired
};
var C$2 = ToastTitle$1;

var Toast$1 = function Toast$$1(_ref) {
  var autoDismissTimeout = _ref.autoDismissTimeout,
      children = _ref.children,
      closeButtonProps = _ref.closeButtonProps,
      hasHorizontalBar = _ref.hasHorizontalBar,
      hasIcon = _ref.hasIcon,
      hideCloseButton = _ref.hideCloseButton,
      onClickClose = _ref.onClickClose,
      title = _ref.title,
      type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, ["autoDismissTimeout", "children", "closeButtonProps", "hasHorizontalBar", "hasIcon", "hideCloseButton", "onClickClose", "title", "type"]);

  return createElement(Toast, _extends({
    type: type
  }, props), createElement(CountdownBar, {
    isHorizontal: hasHorizontalBar,
    isBackground: true,
    type: type
  }), createElement(CountdownBar, {
    autoDismissTimeout: autoDismissTimeout,
    isHorizontal: hasHorizontalBar,
    type: type
  }), createElement(Content, null, hasIcon && type && createElement(C$1, {
    type: type,
    size: children ? '300' : undefined
  }), createElement(Box, null, title && createElement(C$2, {
    marginBottom: children ? 'minor-2' : undefined
  }, title), children)), !hideCloseButton && createElement(C, _extends({
    isAbsolute: Boolean(children),
    onClickClose: onClickClose
  }, closeButtonProps)));
};
Toast$1.Container = ToastContainer;
Toast$1.propTypes = _objectSpread({
  autoDismissTimeout: number,
  children: node,
  closeButtonProps: shape(_omit(buttonPropTypes, 'children')),
  hasHorizontalBar: bool,
  hasIcon: bool,
  hasTint: bool,
  hideCloseButton: bool,
  onClickClose: func,
  type: string,
  title: string
}, panePropTypes);
Toast$1.defaultProps = _objectSpread({}, paneDefaultProps, {
  autoDismissTimeout: undefined,
  children: undefined,
  closeButtonProps: {},
  elevation: '300',
  hasHorizontalBar: false,
  hasIcon: true,
  hasTint: false,
  hideCloseButton: false,
  onClickClose: undefined,
  title: undefined,
  type: 'info'
});
var C$3 = Toast$1;

export { Toasts as a, ToastContainer as b, C$3 as c };
