import { a as _objectSpread, b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { space } from './styled.js';
import { Heading } from './Heading.js';
import { a as Pane, b as panePropTypes, c as paneDefaultProps } from './chunk-a1e5c7d9.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';

var Card = styled(Pane).withConfig({
  displayName: "styled",
  componentId: "sc-150cbjc-0"
})(["padding:", "rem;&{", ";}"], space(6, 'minor'), theme('fannypack.Card.base'));
var CardContent = styled(Box).withConfig({
  displayName: "styled__CardContent",
  componentId: "sc-150cbjc-1"
})(["&{", ";}"], theme('fannypack.Card.Content.base'));
var CardHeader = styled(Box).withConfig({
  displayName: "styled__CardHeader",
  componentId: "sc-150cbjc-2"
})(["align-items:center;display:flex;flex-wrap:wrap;justify-content:space-between;padding-bottom:", "em;position:relative;width:100%;&{", ";}"], space(4), theme('fannypack.Card.Header.base'));
var CardFooter = styled(Box).withConfig({
  displayName: "styled__CardFooter",
  componentId: "sc-150cbjc-3"
})(["display:flex;padding-top:", "rem;width:100%;&{", ";}"], space(4), theme('fannypack.Card.Footer.base'));
var CardTitle = styled(Heading).withConfig({
  displayName: "styled__CardTitle",
  componentId: "sc-150cbjc-4"
})(["margin-bottom:0px;&{", ";}"], theme('fannypack.Card.Title.base'));

var CardCard = function CardCard(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "children"]);

  return createElement(Card, _extends({
    "aria-describedby": a11yDescriptionId,
    "aria-labelledby": a11yTitleId
  }, props), children);
};

var cardCardPropTypes = _objectSpread({
  a11yDescriptionId: string,
  a11yTitleId: string,
  children: node.isRequired,
  className: string
}, panePropTypes);
CardCard.propTypes = cardCardPropTypes;
var cardCardDefaultProps = _objectSpread({}, paneDefaultProps, {
  a11yDescriptionId: undefined,
  a11yTitleId: undefined,
  border: 'shadow',
  children: undefined,
  className: undefined
});
CardCard.defaultProps = cardCardDefaultProps;
var C = CardCard;

var CardHeader$1 = function CardHeader$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(CardHeader, props, children);
};

CardHeader$1.propTypes = {
  children: node.isRequired,
  className: string
};
CardHeader$1.defaultProps = {
  className: undefined
};
var C$1 = CardHeader$1;

var CardContent$1 = function CardContent$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(CardContent, props, children);
};

CardContent$1.propTypes = {
  children: node.isRequired,
  className: string
};
CardContent$1.defaultProps = {
  className: undefined
};
var C$2 = CardContent$1;

var CardTitle$1 = function CardTitle$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(CardTitle, _extends({
    use: "h5",
    isSubHeading: true
  }, props), children);
};

CardTitle$1.defaultProps = {
  className: undefined
};
var C$3 = CardTitle$1;

var CardFooter$1 = function CardFooter$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(CardFooter, props, children);
};

CardFooter$1.propTypes = {
  children: node.isRequired,
  className: string
};
CardFooter$1.defaultProps = {
  className: undefined
};
var C$4 = CardFooter$1;

export { C as a, C$1 as b, C$2 as c, C$3 as d, C$4 as e, cardCardPropTypes as f, cardCardDefaultProps as g };
