import { b as _extends, c as _objectWithoutPropertiesLoose, a as _objectSpread } from './chunk-cd704477.js';
import styled, { css, space, palette, theme } from './styled.js';
import { a as Icon } from './chunk-51b7d577.js';
import VisuallyHidden from './VisuallyHidden.js';
import { a as CardCard, b as CardHeader, c as CardContent, d as CardTitle, e as CardFooter, f as cardCardPropTypes, g as cardCardDefaultProps } from './chunk-36b1c440.js';
import { getUniqueId } from './uniqueId.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import { a as Button } from './chunk-0ba092a8.js';
import Box from 'reakit/Box';
import Flex from 'reakit/Flex';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/InlineFlex';
import 'reakit/Grid';
import 'reakit/styled';
import 'lodash/get';
import 'styled-tools';
import './parseIcons.js';
import './chunk-d1ea7076.js';
import 'airbnb-prop-types';
import './chunk-c400d1e8.js';
import './types.js';
import './Spinner.js';
import './chunk-b1ec3790.js';
import './chunk-b58fa33f.js';
import 'polished';
import 'reakit/Button';
import './chunk-e8f72546.js';
import 'lodash/omit';

var getTintAttributes = function getTintAttributes(props) {
  var type = props.type,
      hasTint = props.hasTint;

  if (!hasTint || !type) {
    return;
  }

  return css(["background-color:", ";box-shadow:none;color:", ";fill:", ";", ";"], type && palette(type + "Tint")(props), type && palette(type + "TintInverted")(props), type && palette(type + "TintInverted")(props), theme('fannypack.Callout.tint'));
};

var _Callout = styled(CardCard).withConfig({
  displayName: "styled",
  componentId: "sc-578c22-0"
})(["position:relative;", ";&{", ";}"], getTintAttributes, theme('fannypack.Callout.base'));
var CalloutClose = styled(Button).withConfig({
  displayName: "styled__CalloutClose",
  componentId: "sc-578c22-1"
})(["position:absolute;right:0.8rem;top:0.8rem;width:30px;height:30px;padding:0;text-align:right;&:hover{background-color:", ";&{", ";}}", ";"], palette('white700'), theme('fannypack.Callout.Close.hover'), theme('fannypack.Callout.Close.base'));
var CalloutHeader = styled(CardHeader).withConfig({
  displayName: "styled__CalloutHeader",
  componentId: "sc-578c22-2"
})(["display:flex;justify-content:flex-start;&{", ";}"], theme('fannypack.Callout.Header.base'));
var CalloutContent = styled(CardContent).withConfig({
  displayName: "styled__CalloutContent",
  componentId: "sc-578c22-3"
})(["&{", ";}"], theme('fannypack.Callout.Content.base'));
var CalloutTitle = styled(CardTitle).withConfig({
  displayName: "styled__CalloutTitle",
  componentId: "sc-578c22-4"
})(["&{", ";}"], theme('fannypack.Callout.Title.base'));
var CalloutFooter = styled(CardFooter).withConfig({
  displayName: "styled__CalloutFooter",
  componentId: "sc-578c22-5"
})(["&{", ";}"], theme('fannypack.Callout.Footer.base'));
var CalloutIcon = styled(Icon).withConfig({
  displayName: "styled__CalloutIcon",
  componentId: "sc-578c22-6"
})(["margin-right:", "rem;&{", ";}"], space(4), theme('fannypack.Callout.Icon.base'));

var CalloutClose$1 = function CalloutClose$$1(_ref) {
  var onClickClose = _ref.onClickClose,
      props = _objectWithoutPropertiesLoose(_ref, ["onClickClose"]);

  return createElement(CalloutClose, _extends({
    kind: "link",
    onClick: onClickClose
  }, props), createElement(VisuallyHidden, null, "Close"), createElement(Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
var calloutClosePropTypes = {
  onClickClose: func
};
CalloutClose$1.propTypes = calloutClosePropTypes;
CalloutClose$1.defaultProps = {
  onClickClose: undefined
}; // @ts-ignore

var C = CalloutClose$1;

var Callout = function Callout(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      closeButtonProps = _ref.closeButtonProps,
      footer = _ref.footer,
      hasTint = _ref.hasTint,
      icon = _ref.icon,
      onClickClose = _ref.onClickClose,
      showCloseButton = _ref.showCloseButton,
      title = _ref.title,
      type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "children", "closeButtonProps", "footer", "hasTint", "icon", "onClickClose", "showCloseButton", "title", "type"]);

  return createElement(_Callout, _extends({
    a11yDescriptionId: a11yDescriptionId,
    a11yTitleId: a11yTitleId,
    hasTint: hasTint,
    type: type
  }, props), createElement(Flex, null, (type || icon) && createElement(CalloutTitle, null, createElement(CalloutIcon, {
    icon: type || icon,
    color: type
  })), createElement(Box, null, title && createElement(CalloutHeader, null, typeof title === 'string' ? createElement(CalloutTitle, {
    id: a11yTitleId
  }, title) : title), createElement(CalloutContent, {
    id: a11yDescriptionId
  }, children), footer && createElement(CalloutFooter, null, footer))), showCloseButton && createElement(C, _extends({
    onClickClose: onClickClose
  }, closeButtonProps)));
};
var calloutPropTypes = _objectSpread({
  a11yDescriptionId: string,
  a11yTitleId: string,
  children: node.isRequired,
  className: string,
  closeButtonProps: shape(calloutClosePropTypes),
  footer: oneOfType([string, element]),
  hasTint: bool,
  icon: string,
  onClickClose: func,
  showCloseButton: bool,
  title: oneOfType([string, element]),
  type: string
}, cardCardPropTypes);
Callout.propTypes = calloutPropTypes;
var calloutDefaultProps = _objectSpread({}, cardCardDefaultProps, {
  a11yDescriptionId: getUniqueId('Callout'),
  a11yTitleId: getUniqueId('Callout'),
  children: undefined,
  className: undefined,
  closeButtonProps: {},
  footer: undefined,
  hasTint: false,
  icon: undefined,
  onClickClose: undefined,
  showCloseButton: false,
  title: undefined,
  type: undefined
});
Callout.defaultProps = calloutDefaultProps; // @ts-ignore

var C$1 = Callout;

export { C$1 as a, calloutPropTypes as b, calloutDefaultProps as c };
