import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import { sizePropType } from './types.js';
import { a as Icon } from './chunk-51b7d577.js';
import { Spinner } from './Spinner.js';
import Input from 'reakit/Input';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import InlineFlex from 'reakit/InlineFlex';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/Grid';

var LoadingSpinner = styled(Spinner).withConfig({
  displayName: "styled__LoadingSpinner",
  componentId: "kl4ffb-0"
})(["position:absolute;width:15px;height:15px;top:12px;right:10px;z-index:2;"]);
var sizeProperties = {
  small: css(["& + ", "{width:10px;height:10px;top:10px;}&{", ";}"], LoadingSpinner, theme('fannypack.Input.sizes.small')),
  medium: css(["& + ", "{width:20px;height:20px;top:15px;right:10px;}&{", ";}"], LoadingSpinner, theme('fannypack.Input.sizes.medium')),
  large: css(["& + ", "{width:25px;height:25px;top:16px;right:12px;}&{", ";}"], LoadingSpinner, theme('fannypack.Input.sizes.large'))
};
var wrapperSizeProperties = {
  small: css(["font-size:0.8rem;&{", ";}"], theme('fannypack.Input.Wrapper.sizes.small')),
  medium: css(["font-size:1.25rem;&{", ";}"], theme('fannypack.Input.Wrapper.sizes.medium')),
  large: css(["font-size:1.5rem;&{", ";}"], theme('fannypack.Input.Wrapper.sizes.large'))
};
var stateProperties = css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
  return palette("" + props.state)(props);
}, function (props) {
  return palette("" + props.state)(props);
}); // @ts-ignore

var Icon$1 = styled(Icon).withConfig({
  displayName: "styled__Icon",
  componentId: "kl4ffb-1"
})(["fill:", ";height:2.5em;margin:0 0.75em;top:0;", ";"], palette('text100'), theme('fannypack.Input.Icon.base'));
var InputWrapper = styled(Box).withConfig({
  displayName: "styled__InputWrapper",
  componentId: "kl4ffb-2"
})(["align-items:center;position:relative;width:100%;&{", ";}&{", ";}"], theme('fannypack.Input.Wrapper.base'), function (props) {
  return props.styledSize && wrapperSizeProperties[props.styledSize];
});
var _Input = styled(Input).withConfig({
  displayName: "styled",
  componentId: "kl4ffb-3"
})(["border:1px solid #bdbdbd;box-shadow:inset 0px 1px 2px #e5e5e5;border-radius:0.2em;height:2.5em;width:100%;padding:0.4em 0.6em;&[disabled]{background-color:", ";box-shadow:unset;color:", ";&{", ";}}&:focus{outline:unset;z-index:2;border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;&{", ";}}&::placeholder{opacity:0.6;&{", ";}}&{", ";}&{", ";}&{", ";}&{", ";}&{", ";}"], palette('white700'), palette('gray400'), theme('fannypack.Input.disabled'), function (props) {
  return palette('primary')(props);
}, function (props) {
  return palette('primary')(props);
}, theme('fannypack.Input.focus'), theme('fannypack.Input.placeholder'), function (props) {
  return props.after && css(["padding-right:2.3em;"]);
}, function (props) {
  return props.before && css(["padding-left:2.3em;"]);
}, theme('fannypack.Input.base'), function (props) {
  return props.styledSize && sizeProperties[props.styledSize];
}, function (props) {
  return props.state && stateProperties;
});

var Input$1 = function Input$$1(_ref) {
  var a11yLabel = _ref.a11yLabel,
      a11yId = _ref.a11yId,
      after = _ref.after,
      autoComplete = _ref.autoComplete,
      autoFocus = _ref.autoFocus,
      before = _ref.before,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      inputRef = _ref.inputRef,
      isLoading = _ref.isLoading,
      isRequired = _ref.isRequired,
      max = _ref.max,
      maxLength = _ref.maxLength,
      min = _ref.min,
      minLength = _ref.minLength,
      multiple = _ref.multiple,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      pattern = _ref.pattern,
      placeholder = _ref.placeholder,
      readOnly = _ref.readOnly,
      spellCheck = _ref.spellCheck,
      step = _ref.step,
      type = _ref.type,
      size = _ref.size,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yLabel", "a11yId", "after", "autoComplete", "autoFocus", "before", "defaultValue", "disabled", "inputRef", "isLoading", "isRequired", "max", "maxLength", "min", "minLength", "multiple", "name", "onBlur", "onChange", "onFocus", "pattern", "placeholder", "readOnly", "spellCheck", "step", "type", "size", "state", "value"]);

  return createElement(InputWrapper, _extends({
    styledSize: size
  }, props), before && createElement(InlineFlex, {
    absolute: true,
    zIndex: "3"
  }, before), after && createElement(InlineFlex, {
    absolute: true,
    right: "0",
    zIndex: "3"
  }, after), createElement(_Input, {
    after: after,
    "aria-invalid": state === 'danger',
    "aria-label": a11yLabel,
    "aria-required": isRequired,
    autoComplete: autoComplete,
    autoFocus: autoFocus,
    before: before,
    defaultValue: defaultValue,
    disabled: disabled,
    elementRef: inputRef,
    id: a11yId,
    max: max,
    maxLength: maxLength,
    min: min,
    minLength: minLength,
    multiple: multiple,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    pattern: pattern,
    placeholder: placeholder,
    readOnly: readOnly,
    spellCheck: spellCheck,
    state: state,
    step: step,
    styledSize: size,
    type: type,
    value: value
  }), isLoading && createElement(LoadingSpinner, {
    color: "text"
  }));
};
Input$1.Icon = Icon$1;
var inputPropTypes = {
  after: element,
  a11yId: string,
  a11yLabel: string,
  autoComplete: string,
  autoFocus: bool,
  before: element,
  children: node,
  className: string,
  defaultValue: string,
  disabled: bool,
  inputRef: object,
  isLoading: bool,
  isRequired: bool,
  name: string,
  size: sizePropType,
  max: number,
  maxLength: number,
  min: number,
  minLength: number,
  multiple: bool,
  pattern: string,
  placeholder: string,
  readOnly: bool,
  spellCheck: bool,
  step: number,
  state: string,
  type: string,
  value: string,
  onBlur: func,
  onChange: func,
  onFocus: func
};
Input$1.propTypes = inputPropTypes;
var inputDefaultProps = {
  a11yId: undefined,
  a11yLabel: undefined,
  autoComplete: undefined,
  autoFocus: false,
  children: null,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  after: undefined,
  before: undefined,
  inputRef: undefined,
  isLoading: false,
  isRequired: false,
  max: undefined,
  maxLength: undefined,
  min: undefined,
  minLength: undefined,
  multiple: false,
  name: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  pattern: undefined,
  placeholder: undefined,
  readOnly: undefined,
  spellCheck: undefined,
  size: 'default',
  state: undefined,
  step: undefined,
  type: 'text',
  value: undefined
};
Input$1.defaultProps = inputDefaultProps; // @ts-ignore

var C = Input$1;

export { C as a, inputDefaultProps as b, inputPropTypes as c };
