import { a as _objectSpread, b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled from './styled.js';
import { animatePropTypes, animateDefaultProps, restrictDefaultProps, restrictHidePropTypes } from './types.js';
import Backdrop from './Backdrop.js';
import { d as OverlayContainer, e as overlayContainerDefaultProps, f as overlayContainerPropTypes, a as Overlay, g as overlayHideDefaultProps, h as overlayHidePropTypes, i as overlayShowDefaultProps, j as overlayShowPropTypes } from './Overlay-4abbaad8.js';
import { a as isFunction, b as TrapFocus } from './chunk-dc5258d0.js';
import Portal from './Portal.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';

var ModalContainer = function ModalContainer(_ref) {
  var children = _ref.children,
      defaultVisible = _ref.defaultVisible,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "defaultVisible"]);

  return createElement(OverlayContainer, _extends({
    defaultVisible: defaultVisible
  }, props), children);
};

ModalContainer.propTypes = _objectSpread({}, overlayContainerPropTypes);
ModalContainer.defaultProps = _objectSpread({}, overlayContainerDefaultProps);

var ModalHide = styled(Overlay.Hide).withConfig({
  displayName: "styled__ModalHide",
  componentId: "sc-13yjzse-0"
})(["", ";"], theme('fannypack.Modal.Hide.base'));
var ModalShow = styled(Overlay.Show).withConfig({
  displayName: "styled__ModalShow",
  componentId: "sc-13yjzse-1"
})(["", ";"], theme('fannypack.Modal.Show.base'));
var _Modal = styled(Overlay).withConfig({
  displayName: "styled",
  componentId: "sc-13yjzse-2"
})(["padding:0 1rem;max-width:600px;width:100%;", ";"], theme('fannypack.Modal.base'));

var ModalHide$1 = forwardRef(function (_ref, ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return (// @ts-ignore
    createElement(ModalHide, _extends({}, props, {
      ref: ref
    }), children)
  );
});
ModalHide$1.propTypes = _objectSpread({}, overlayHidePropTypes);
ModalHide$1.defaultProps = _objectSpread({}, overlayHideDefaultProps); // @ts-ignore

var C = ModalHide$1;

var ModalShow$1 = function ModalShow$$1(_ref) {
  var children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["children"]);

  return createElement(ModalShow, props, children);
};

ModalShow$1.propTypes = _objectSpread({}, overlayShowPropTypes);
ModalShow$1.defaultProps = _objectSpread({}, overlayShowDefaultProps); // @ts-ignore

var C$1 = ModalShow$1;

var Modal = function Modal(_ref) {
  var children = _ref.children,
      delay = _ref.delay,
      duration = _ref.duration,
      fade = _ref.fade,
      hide = _ref.hide,
      hideOnEsc = _ref.hideOnEsc,
      hideOnClickOutside = _ref.hideOnClickOutside,
      isVisible = _ref.isVisible,
      kind = _ref.kind,
      showActionButtons = _ref.showActionButtons,
      showCloseButton = _ref.showCloseButton,
      props = _objectWithoutPropertiesLoose(_ref, ["children", "delay", "duration", "fade", "hide", "hideOnEsc", "hideOnClickOutside", "isVisible", "kind", "showActionButtons", "showCloseButton"]);

  return createElement(Portal, null, createElement(TrapFocus, {
    isActive: isVisible,
    usesPortal: true
  }, function (_ref2) {
    var fallbackFocusRef = _ref2.fallbackFocusRef,
        initialFocusRef = _ref2.initialFocusRef;
    return createElement(Fragment, null, createElement(Backdrop, {
      delay: delay,
      duration: duration,
      expand: undefined,
      hide: hideOnClickOutside && kind !== 'alert' ? hide : undefined,
      fade: fade,
      hideOnEsc: kind === 'alert' ? false : hideOnEsc,
      isVisible: isVisible,
      slide: undefined,
      use: hideOnClickOutside && kind !== 'alert' ? C : undefined
    }), createElement(_Modal, _extends({
      "aria-modal": "true",
      delay: delay,
      duration: duration,
      fade: fade,
      hideOnEsc: kind === 'alert' ? false : hideOnEsc,
      hideOnClickOutside: kind === 'alert' ? false : hideOnClickOutside,
      isVisible: isVisible
    }, props), isFunction(children) ? children({
      fallbackFocusRef: fallbackFocusRef,
      initialFocusRef: initialFocusRef
    }) : children));
  }));
};
Modal.propTypes = _objectSpread({
  children: func,
  className: string,
  isVisible: bool,
  hide: func,
  kind: oneOf(['alert']),
  showActionButtons: bool,
  showCloseButton: bool
}, animatePropTypes, restrictHidePropTypes);
Modal.defaultProps = _objectSpread({
  className: undefined,
  isVisible: false,
  kind: undefined,
  showActionButtons: false,
  showCloseButton: false
}, animateDefaultProps, restrictDefaultProps, {
  hideOnClickOutside: true,
  hideOnEsc: true
});
Modal.Container = ModalContainer;
Modal.Hide = C;
Modal.Show = C$1;
var C$2 = Modal;

export { C$2 as a, ModalContainer as b, C as c, C$1 as d };
