import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { css } from './styled.js';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/Flex';
import 'reakit/InlineFlex';
import 'reakit/Grid';

var Pane = styled(Box).withConfig({
  displayName: "styled__Pane",
  componentId: "sc-16zc95q-0"
})(["background-color:white;border-radius:3px;", ";", ";", ";", ";", ";&{", ";}"], function (props) {
  return props.styledBorder !== 'shadow' && typeof props.styledBorder !== 'boolean' ? "border: " + props.styledBorder : null;
}, function (props) {
  return props.styledBorder === 'shadow' && css(["box-shadow:0px 2px 4px 0px rgba(0,0,0,0.1),0px 0px 0px 1px rgba(0,0,0,0.1);&{", ";}"], theme('fannypack.Pane.border.shadow'));
}, function (props) {
  return props.elevation && css(["box-shadow:0px ", "px ", "px 0px rgba(0,0,0,0.1),0px 0px 0px 1px rgba(0,0,0,0.1);"], function (props // @ts-ignore
  ) {
    return theme("fannypack.Pane.elevations." + props.elevation)(props) / 2;
  }, theme("fannypack.Pane.elevations." + props.elevation));
}, function (props) {
  return props.styledBorder === true && css(["border:1px solid ", ";&{", ";}"], palette('white800'), theme('fannypack.Pane.border.default'));
}, function (props) {
  return props.isFullWidth && css(["width:100%;"]);
}, theme('fannypack.Pane.base'));

var Pane$1 = function Pane$$1(_ref) {
  var border = _ref.border,
      children = _ref.children,
      props = _objectWithoutPropertiesLoose(_ref, ["border", "children"]);

  return createElement(Pane, _extends({
    styledBorder: border
  }, props), children);
};
var panePropTypes = {
  border: oneOfType([bool, oneOf(['shadow'])]),
  className: string,
  children: node,
  isFullWidth: bool,
  elevation: string
};
Pane$1.propTypes = panePropTypes;
var paneDefaultProps = {
  border: false,
  className: undefined,
  children: undefined,
  isFullWidth: false
};
Pane$1.defaultProps = paneDefaultProps;
var C = Pane$1;

export { C as a, panePropTypes as b, paneDefaultProps as c };
