import { c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import styled, { space } from './styled.js';
import { Text as _Text } from './Text.js';
import _Label from './Label.js';
import Field from 'reakit/Field';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { palette, theme } from 'styled-tools';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';
import Box from 'reakit/Box';
import Flex from 'reakit/Flex';
import 'reakit/Block';
import 'reakit/Inline';
import 'reakit/InlineBlock';
import 'reakit/InlineFlex';
import 'reakit/Grid';

var Label = styled(_Label).withConfig({
  displayName: "styled__Label",
  componentId: "ixmo9v-0"
})(["margin-bottom:0 !important;&{", ";}"], theme('fannypack.FieldWrapper.label'));
var DescriptionText = styled(_Text).withConfig({
  displayName: "styled__DescriptionText",
  componentId: "ixmo9v-1"
})(["display:block;font-size:0.8rem;&{", ";}"], theme('fannypack.FieldWrapper.description'));
var HintText = styled(_Text).withConfig({
  displayName: "styled__HintText",
  componentId: "ixmo9v-2"
})(["display:block;font-size:0.8rem;margin-top:", "rem;&{", ";}"], space(1), theme('fannypack.FieldWrapper.hint'));
var OptionalText = styled(_Text).withConfig({
  displayName: "styled__OptionalText",
  componentId: "ixmo9v-3"
})(["font-size:0.8rem;color:", ";margin-left:", "rem;line-height:1;&{", ";}"], palette('text100'), space(2), theme('fannypack.FieldWrapper.optional'));
var ValidationText = styled(_Text).withConfig({
  displayName: "styled__ValidationText",
  componentId: "ixmo9v-4"
})(["display:block;font-size:0.8rem;margin-top:", "rem;&{", ";}"], space(1), theme('fannypack.FieldWrapper.validation'));
var _FieldWrapper = styled(Field).withConfig({
  displayName: "styled",
  componentId: "ixmo9v-5"
})(["&{", ";}"], theme('fannypack.FieldWrapper.base'));

var FieldWrapper = function FieldWrapper(_ref) {
  var a11yId = _ref.a11yId,
      children = _ref.children,
      description = _ref.description,
      hint = _ref.hint,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      label = _ref.label,
      state = _ref.state,
      validationText = _ref.validationText,
      props = _objectWithoutPropertiesLoose(_ref, ["a11yId", "children", "description", "hint", "isOptional", "isRequired", "label", "state", "validationText"]);

  var elementProps = {
    isRequired: isRequired,
    a11yId: a11yId,
    state: state
  };
  return createElement(_FieldWrapper, props, label && createElement(Box, {
    marginBottom: "minor-2"
  }, createElement(Flex, {
    alignItems: "center"
  }, typeof label === 'string' ? createElement(Label, {
    htmlFor: a11yId
  }, label) : label, isOptional && createElement(OptionalText, null, "OPTIONAL")), typeof description === 'string' ? createElement(DescriptionText, null, description) : createElement("div", null, description)), typeof children === 'function' ? children({
    elementProps: elementProps
  }) : cloneElement(children, elementProps), typeof hint === 'string' ? createElement(HintText, null, hint) : createElement("div", null, hint), validationText && createElement(ValidationText, {
    color: state
  }, validationText));
};
var fieldWrapperPropTypes = {
  a11yId: string,
  children: oneOfType([element, func]).isRequired,
  className: string,
  description: oneOfType([string, element]),
  hint: oneOfType([string, element]),
  isOptional: bool,
  isRequired: bool,
  label: oneOfType([string, element]),
  state: string,
  validationText: string
};
FieldWrapper.propTypes = fieldWrapperPropTypes;
var fieldWrapperDefaultProps = {
  a11yId: undefined,
  className: undefined,
  description: undefined,
  hint: undefined,
  isOptional: undefined,
  isRequired: undefined,
  label: undefined,
  state: undefined,
  validationText: undefined
};
FieldWrapper.defaultProps = fieldWrapperDefaultProps; // @ts-ignore

var C = FieldWrapper;

export { C as a, fieldWrapperDefaultProps as b, fieldWrapperPropTypes as c };
