import { b as _extends, c as _objectWithoutPropertiesLoose } from './chunk-cd704477.js';
import { a as Button, b as buttonPropTypes } from './chunk-0ba092a8.js';
import { a as Set } from './chunk-e8f72546.js';
import _omit from 'lodash/omit';
import React__default, { createElement, Fragment, PureComponent, cloneElement, forwardRef, Component, createRef, Children, createContext } from 'react';
import { node, oneOf, string, oneOfType, bool, shape, func, number, any, element, object, arrayOf, array } from 'prop-types';

var ActionButtons = function ActionButtons(_ref) {
  var addonButtons = _ref.addonButtons,
      cancelProps = _ref.cancelProps,
      cancelText = _ref.cancelText,
      isLoading = _ref.isLoading,
      onClickSubmit = _ref.onClickSubmit,
      onClickCancel = _ref.onClickCancel,
      palette = _ref.palette,
      submitProps = _ref.submitProps,
      submitText = _ref.submitText,
      type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, ["addonButtons", "cancelProps", "cancelText", "isLoading", "onClickSubmit", "onClickCancel", "palette", "submitProps", "submitText", "type"]);

  return createElement(Set, props, createElement(Button, _extends({
    onClick: onClickCancel
  }, cancelProps), cancelText), addonButtons, createElement(Button, _extends({
    isLoading: isLoading,
    onClick: onClickSubmit,
    palette: palette,
    type: type
  }, submitProps), submitText));
};
var actionButtonsPropTypes = {
  cancelProps: shape(_omit(buttonPropTypes, 'children')),
  cancelText: string,
  className: string,
  isLoading: bool,
  onClickSubmit: func,
  onClickCancel: func,
  palette: string,
  submitProps: shape(_omit(buttonPropTypes, 'children')),
  submitText: string,
  type: string
};
ActionButtons.propTypes = actionButtonsPropTypes;
var actionButtonsDefaultProps = {
  cancelProps: {},
  cancelText: 'Cancel',
  className: undefined,
  isLoading: false,
  onClickSubmit: undefined,
  onClickCancel: undefined,
  palette: 'primary',
  submitProps: {},
  submitText: 'Submit',
  type: 'submit'
};
ActionButtons.defaultProps = actionButtonsDefaultProps;
var C = ActionButtons;

export { C as a, actionButtonsPropTypes as b };
