import styled, { css, keyframes, createGlobalStyle, isStyledComponent, ThemeConsumer, ThemeProvider, withTheme, ServerStyleSheet, StyleSheetManager } from 'reakit/styled';
export { ThemeProvider } from 'reakit/styled';
import _get from 'lodash/get';
import { prop, theme, palette, ifProp, ifNotProp, switchProp, withProp } from 'styled-tools';

// @ts-ignore
var space = (function (_scalar, _scaleType) {
  if (_scaleType === void 0) {
    _scaleType = 'minor';
  }

  return function (props) {
    var scalar = _scalar;
    var scaleType = _scaleType;
    if (!scalar) return 0;

    if (typeof scalar === 'string' && (scalar.includes('minor') || scalar.includes('major'))) {
      // @ts-ignore
      var _scalar$split = scalar.split('-');

      scaleType = _scalar$split[0];
      scalar = _scalar$split[1];
      scalar = parseFloat(scalar);
      if (isNaN(scalar)) return 0;
    }

    var unit = _get(props, "theme.fannypack.layout." + scaleType + "Unit");

    var fontSize = _get(props, 'theme.fannypack.global.fontSize');

    return scalar * (unit / fontSize);
  };
});

export default styled;
export { css, keyframes, createGlobalStyle, isStyledComponent, ThemeConsumer, withTheme, ServerStyleSheet, StyleSheetManager, prop, theme, palette, ifProp, ifNotProp, switchProp, withProp, space };
