'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var __chunk_6 = require('./chunk-f77e63ff.js');
var Text = require('./Text.js');
var Heading = require('./Heading.js');
var VisuallyHidden = require('./VisuallyHidden.js');
var _omit = _interopDefault(require('lodash/omit'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
var Flex = _interopDefault(require('reakit/Flex'));
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./types.js');
var __chunk_3 = require('./chunk-cb567965.js');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('airbnb-prop-types');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('./chunk-fdbfe348.js');
require('./chunk-1c9fbb5b.js');
require('reakit/Heading');
require('classnames');

var AlertTitle = styled.default(Heading.Heading).withConfig({
  displayName: "styled__AlertTitle",
  componentId: "sc-14yopcx-0"
})(["font-weight:", ";&&{margin-bottom:", "em;}&{", ";}"], styledTools.theme('fannypack.fontWeights.semibold'), styled.space(2), styledTools.theme('fannypack.Alert.Title.base'));
var AlertClose = styled.default(__chunk_6.Button).withConfig({
  displayName: "styled__AlertClose",
  componentId: "sc-14yopcx-1"
})(["width:24px;height:24px;padding:0;text-align:right;", ";&:hover{background-color:", ";&{", ";}}", ";"], function (props) {
  return props.isAbsolute ? styled.css(["position:absolute;right:", "rem;top:", "rem;"], styled.space(2), styled.space(2)) : styled.css(["margin:0 ", "rem;"], styled.space(2));
}, styledTools.palette('white700'), styledTools.theme('fannypack.Alert.Close.hover'), styledTools.theme('fannypack.Alert.Close.base'));
var tintAttributes = styled.css(["background-color:", ";border-top-width:0;border-right-width:0;border-bottom-width:0;color:", ";fill:", ";", ";"], function (props) {
  return props.type && styledTools.palette(props.type + "Tint")(props);
}, function (props) {
  return props.type && styledTools.palette(props.type + "TintInverted")(props);
}, function (props) {
  return props.type && styledTools.palette(props.type + "TintInverted")(props);
}, styledTools.theme('fannypack.Alert.tint'));
var _Alert = styled.default(Box).withConfig({
  displayName: "styled",
  componentId: "sc-14yopcx-2"
})(["background-color:white;border:1px solid ", ";border-left:4px solid ", ";border-radius:4px;position:relative;&{", ";}&{", ";}"], styledTools.palette('white800'), function (props) {
  return props.type && styledTools.palette(props.type)(props);
}, function (props) {
  return props.hasTint && tintAttributes;
}, styledTools.theme('fannypack.Alert.base'));

var AlertClose$1 = function AlertClose$$1(_ref) {
  var onClickClose = _ref.onClickClose,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["onClickClose"]);

  return React.createElement(AlertClose, __chunk_1._extends({
    kind: "link",
    onClick: onClickClose
  }, props), React.createElement(VisuallyHidden.default, null, "Close"), React.createElement(__chunk_3.Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
AlertClose$1.defaultProps = {
  isAbsolute: false,
  onClickClose: undefined
};
var C = AlertClose$1;

var AlertTitle$1 = function AlertTitle$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(AlertTitle, __chunk_1._extends({
    use: "h6"
  }, props), children);
};

AlertTitle$1.propTypes = {
  children: PropTypes.node.isRequired
};

var ContentWrapper = styled.default(Box).withConfig({
  displayName: "Alert__ContentWrapper",
  componentId: "sc-1e5x83i-0"
})(["padding:", "rem;", ";"], styled.space(4), function (props) {
  return props.hasIcon && styled.css(["padding-left:0;"]);
});
var IconWrapper = styled.default(Flex).withConfig({
  displayName: "Alert__IconWrapper",
  componentId: "sc-1e5x83i-1"
})(["padding:0 ", "rem;"], styled.space(4));
var defaultProps = {
  className: undefined,
  closeButtonProps: {},
  children: undefined,
  hasIcon: false,
  hasTint: false,
  onClickClose: undefined,
  showCloseButton: false,
  title: undefined,
  type: 'info'
};
var Alert = function Alert(_ref) {
  var className = _ref.className,
      closeButtonProps = _ref.closeButtonProps,
      children = _ref.children,
      hasIcon = _ref.hasIcon,
      onClickClose = _ref.onClickClose,
      showCloseButton = _ref.showCloseButton,
      title = _ref.title,
      type = _ref.type,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["className", "closeButtonProps", "children", "hasIcon", "onClickClose", "showCloseButton", "title", "type"]);

  return React.createElement(_Alert, __chunk_1._extends({
    role: "alert",
    className: className,
    type: type
  }, props), React.createElement(Flex, {
    alignItems: "center"
  }, hasIcon && type && React.createElement(IconWrapper, null, React.createElement(__chunk_3.Icon, {
    a11yLabel: type,
    color: type,
    icon: type,
    size: children ? '400' : undefined
  })), React.createElement(ContentWrapper, {
    hasIcon: hasIcon
  }, title && React.createElement(AlertTitle$1, null, title), typeof children === 'string' ? React.createElement(Text.Text, null, children) : children), showCloseButton && React.createElement(C, __chunk_1._extends({
    isAbsolute: Boolean(children),
    onClickClose: onClickClose
  }, closeButtonProps))));
};
Alert.propTypes = {
  className: PropTypes.string,
  closeButtonProps: PropTypes.shape(_omit(__chunk_6.buttonPropTypes, 'children')),
  children: PropTypes.node,
  hasIcon: PropTypes.bool,
  hasTint: PropTypes.bool,
  onClickClose: PropTypes.func,
  showCloseButton: PropTypes.bool,
  title: PropTypes.string,
  type: PropTypes.string
};
Alert.defaultProps = defaultProps;

exports.Alert = Alert;
exports.default = Alert;
