'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var _Avatar = _interopDefault(require('reakit/Avatar'));
var classNames = _interopDefault(require('classnames'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var circleProperties = styled.css(["&{border-radius:50%;}"]);

var fitProperties = function fitProperties(props) {
  if (!props.fit) return null;

  if (props.fit === 'contain') {
    return styled.css(["object-fit:contain;", ";", ";", ";"], function (props) {
      return props.fitPosition ? styled.css(["object-position:", ";"], props.fitPosition) : '';
    }, styledTools.theme('fannypack.Avatar.fit.base'), styledTools.theme('fannypack.Avatar.fit.contain'));
  }

  if (props.fit === 'cover') {
    return styled.css(["object-fit:cover;", ";", ";", ";"], function (props) {
      return props.fitPosition ? styled.css(["object-position:", ";"], props.fitPosition) : '';
    }, styledTools.theme('fannypack.Avatar.fit.base'), styledTools.theme('fannypack.Avatar.fit.cover'));
  }

  return null;
};

var sizeProperties = {
  xsmall: styled.css(["&{font-size:8px;width:20px;height:20px;}&{", ";}"], styledTools.theme('fannypack.Avatar.sizes.xsmall')),
  small: styled.css(["&{font-size:16px;width:40px;height:40px;}&{", ";}"], styledTools.theme('fannypack.Avatar.sizes.small')),
  medium: styled.css(["&{font-size:32px;width:80px;height:80px;}&{", ";}"], styledTools.theme('fannypack.Avatar.sizes.medium')),
  large: styled.css(["&{font-size:48px;width:100px;height:100px;}&{", ";}"], styledTools.theme('fannypack.Avatar.sizes.large'))
};
var AvatarCircle = styled.default(Box).withConfig({
  displayName: "styled__AvatarCircle",
  componentId: "k1acy4-0"
})(["align-items:center;background-color:", ";color:", ";display:flex;justify-content:center;font-size:24px;height:", ";width:", ";", ";", ";", ";"], function (props) {
  return styledTools.palette(props.palette || '')(props);
}, function (props) {
  return props.color ? props.color : styledTools.palette(props.palette + "Inverted")(props);
}, function (props) {
  return typeof props.styledSize === 'number' ? props.styledSize + "px" : '60px';
}, function (props) {
  return typeof props.styledSize === 'number' ? props.styledSize + "px" : '60px';
}, function (props) {
  return props.kind === 'circle' && circleProperties;
}, function (props) {
  return typeof props.styledSize === 'string' ? sizeProperties[props.styledSize] : null;
}, styledTools.theme('fannypack.Avatar.Circle.base'));
var AvatarImage = styled.default(_Avatar).withConfig({
  displayName: "styled__AvatarImage",
  componentId: "k1acy4-1"
})(["font-size:24px;height:", ";width:", ";", ";", ";&{", ";}", ";"], function (props) {
  return typeof props.styledSize === 'number' ? props.styledSize + "px" : '60px';
}, function (props) {
  return typeof props.styledSize === 'number' ? props.styledSize + "px" : '60px';
}, function (props) {
  return props.kind === 'circle' && circleProperties;
}, function (props) {
  return typeof props.styledSize === 'string' ? sizeProperties[props.styledSize] : null;
}, fitProperties, styledTools.theme('fannypack.Avatar.Image.base'));

var defaultProps = {
  a11yLabel: undefined,
  alt: undefined,
  kind: 'square',
  className: undefined,
  color: undefined,
  fit: undefined,
  fitPosition: undefined,
  initials: undefined,
  palette: undefined,
  size: undefined,
  src: undefined
};
var Avatar = function Avatar(_ref) {
  var _classNames, _classNames2;

  var a11yLabel = _ref.a11yLabel,
      className = _ref.className,
      initials = _ref.initials,
      size = _ref.size,
      src = _ref.src,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yLabel", "className", "initials", "size", "src"]);

  return React.createElement(React.Fragment, null, src && React.createElement(AvatarImage, __chunk_1._extends({
    alt: a11yLabel,
    className: classNames((_classNames = {}, _classNames[className || ''] = Boolean(className), _classNames)),
    styledSize: size,
    src: src
  }, props)), initials && React.createElement(AvatarCircle, __chunk_1._extends({
    className: classNames((_classNames2 = {}, _classNames2[className || ''] = Boolean(className), _classNames2)),
    styledSize: size
  }, props), initials.split(' ').length === 2 ? initials.match(/\b\w/g) : initials.substring(0, 2)));
};
Avatar.propTypes = {
  a11yLabel: PropTypes.string,
  alt: PropTypes.string,
  kind: PropTypes.oneOf(['circle', 'square']),
  color: PropTypes.string,
  className: PropTypes.string,
  fit: PropTypes.oneOf(['cover', 'contain']),
  fitPosition: PropTypes.string,
  initials: PropTypes.string,
  palette: PropTypes.string,
  size: PropTypes.oneOfType([PropTypes.number, PropTypes.oneOf(['default', 'xsmall', 'small', 'medium', 'large'])]),
  src: PropTypes.string
};
Avatar.defaultProps = defaultProps;
var C = Avatar;

exports.Avatar = C;
exports.default = C;
