'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('./styled.js');
var List = require('./List.js');
var Navigation = require('./Navigation-ddd17e18.js');
var Link = require('./Link.js');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
require('reakit/Box');
require('reakit/Block');
var Inline = _interopDefault(require('reakit/Inline'));
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./chunk-3b74065f.js');
require('reakit/List');
require('reakit/Navigation');
require('./chunk-ab4246ea.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Link');

var Breadcrumb = styled.default(Navigation.Navigation).withConfig({
  displayName: "styled__Breadcrumb",
  componentId: "zajvqz-0"
})(["& li + li::before{border-right-color:", ";border-right-style:solid;border-right-width:", "rem;content:'';display:inline-block;height:0.8rem;margin:0 ", "rem;msrgin-right:0;transform:rotate(15deg);}& [aria-current='page']{font-weight:", ";text-decoration:none;}&{", ";}"], function (props) {
  return styledTools.palette(props.separationColor || 'text100', props.separationColor);
}, styled.space(0.5), styled.space(4), styledTools.theme('fannypack.fontWeights.semibold'), styledTools.theme('fannypack.Breadcrumb.base'));
var BreadcrumbList = styled.default(List.List).withConfig({
  displayName: "styled__BreadcrumbList",
  componentId: "zajvqz-1"
})(["& li{margin-right:0;}&{", ";}"], styledTools.theme('fannypack.Breadcrumb.List.base'));
var BreadcrumbStep = styled.default(List.List.Item).withConfig({
  displayName: "styled__BreadcrumbStep",
  componentId: "zajvqz-2"
})(["&{", ";}"], styledTools.theme('fannypack.Breadcrumb.Step.base'));
var BreadcrumbSpan = styled.default(Inline).withConfig({
  displayName: "styled__BreadcrumbSpan",
  componentId: "zajvqz-3"
})(["&{", ";}"], styledTools.theme('fannypack.Breadcrumb.Span.base'));
var BreadcrumbLink = styled.default(Link.Link).withConfig({
  displayName: "styled__BreadcrumbLink",
  componentId: "zajvqz-4"
})(["&{", ";}"], styledTools.theme('fannypack.Breadcrumb.Link.base'));

/* eslint react/prop-types: 0 */

var BreadcrumbStep$1 = function BreadcrumbStep$$1(_ref) {
  var children = _ref.children,
      color = _ref.color,
      href = _ref.href,
      isCurrent = _ref.isCurrent;
  return React.createElement(BreadcrumbStep, null, href ? React.createElement(BreadcrumbLink, {
    "aria-current": isCurrent ? 'page' : undefined,
    color: color,
    href: href
  }, children) : React.createElement(BreadcrumbSpan, {
    "aria-current": isCurrent ? 'page' : undefined,
    color: color
  }, children));
};

BreadcrumbStep$1.propTypes = {
  children: PropTypes.node.isRequired,
  color: PropTypes.string,
  href: PropTypes.string,
  isCurrent: PropTypes.bool
};
BreadcrumbStep$1.defaultProps = {
  color: undefined,
  href: undefined,
  isCurrent: undefined
}; // @ts-ignore

var C = BreadcrumbStep$1;

/* eslint react/prop-types: 0 */
var Breadcrumb$1 = function Breadcrumb$$1(_ref) {
  var children = _ref.children,
      separationColor = _ref.separationColor;
  return React.createElement(Breadcrumb, {
    a11yTitle: "Breadcrumb",
    separationColor: separationColor
  }, React.createElement(BreadcrumbList, {
    isOrdered: true,
    isHorizontal: true
  }, children));
};
Breadcrumb$1.Step = C;
Breadcrumb$1.propTypes = {
  children: PropTypes.node.isRequired,
  separationColor: PropTypes.string
};
Breadcrumb$1.defaultProps = {
  separationColor: ''
}; // @ts-ignore

var C$1 = Breadcrumb$1;

exports.default = C$1;
exports.Breadcrumb = C$1;
