'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var __chunk_10 = require('./chunk-36dd93f1.js');
var uniqueId = require('./uniqueId.js');
var ConditionalWrap = _interopDefault(require('conditional-wrap'));
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
require('./styled.js');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./Heading.js');
require('./chunk-ab4246ea.js');
require('reakit/Box');
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/Heading');
require('classnames');
require('./chunk-d538c3df.js');
require('lodash/uniqueId');

var Card = function Card(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      footer = _ref.footer,
      headerActions = _ref.headerActions,
      title = _ref.title,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "children", "footer", "headerActions", "title"]);

  return React.createElement(__chunk_10.CardCard, __chunk_1._extends({
    a11yDescriptionId: title || footer ? a11yDescriptionId : undefined,
    a11yTitleId: title ? a11yTitleId : undefined
  }, props), title && React.createElement(__chunk_10.CardHeader, null, typeof title === 'string' ? React.createElement(__chunk_10.CardTitle, {
    id: a11yTitleId
  }, title) : title, headerActions && React.createElement("div", null, headerActions)), React.createElement(ConditionalWrap, {
    condition: title || footer,
    wrap: function wrap(children) {
      return React.createElement(__chunk_10.CardContent, {
        id: a11yDescriptionId
      }, children);
    }
  }, children), footer && React.createElement(__chunk_10.CardFooter, null, footer));
};
Card.Card = __chunk_10.CardCard;
Card.Header = __chunk_10.CardHeader;
Card.Content = __chunk_10.CardContent;
Card.Footer = __chunk_10.CardFooter;
Card.Title = __chunk_10.CardTitle;
Card.propTypes = __chunk_1._objectSpread({
  a11yDescriptionId: PropTypes.string,
  a11yTitleId: PropTypes.string,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  footer: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  headerActions: PropTypes.element,
  isFullWidth: PropTypes.bool,
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.element])
}, __chunk_10.cardCardPropTypes);
Card.defaultProps = __chunk_1._objectSpread({}, __chunk_10.cardCardDefaultProps, {
  a11yDescriptionId: uniqueId.getUniqueId('Card'),
  a11yTitleId: uniqueId.getUniqueId('Card'),
  children: undefined,
  className: undefined,
  footer: undefined,
  headerActions: undefined,
  isFullWidth: false,
  title: undefined
}); // @ts-ignore

var C = Card;

exports.default = C;
exports.Card = C;
exports.CardCard = __chunk_10.CardCard;
exports.CardContent = __chunk_10.CardContent;
exports.CardFooter = __chunk_10.CardFooter;
exports.CardHeader = __chunk_10.CardHeader;
exports.CardTitle = __chunk_10.CardTitle;
