'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Text = require('./Text.js');
var __chunk_12 = require('./chunk-265a0d76.js');
var __chunk_13 = require('./chunk-fb522222.js');
var Label = _interopDefault(require('reakit/Label'));
var _omit = _interopDefault(require('lodash/omit'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./chunk-ab4246ea.js');
require('reakit/Input');
require('./Label.js');
require('reakit/Field');

var CheckboxIcon = styled.default(Box).withConfig({
  displayName: "styled__CheckboxIcon",
  componentId: "sc-1cw8kp1-0"
})(["border:1px solid #bdbdbd;box-shadow:inset 0px 1px 2px #e5e5e5;border-radius:0.2em;height:1em;position:relative;width:1em;&{", ";}&{", ";}"], function (props) {
  return props.state && styled.css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
    return styledTools.palette("" + props.state)(props);
  }, function (props) {
    return styledTools.palette("" + props.state)(props);
  });
}, styledTools.theme('fannypack.Checkbox.base'));
var HiddenCheckbox = __chunk_12.HiddenInput({
  Icon: CheckboxIcon,
  checkedIconCss: styled.css(["background-clip:padding-box;content:'';left:calc(50% - 0.1875em);top:calc(50% - 0.375em);position:absolute;&{", ";}"], function (props) {
    return props.indeterminate ? styled.css(["background-color:", ";height:0.125em;width:0.625em;top:calc(50% - 0.0625em);left:calc(50% - 0.3125em);"], styledTools.palette('primary')) : styled.css(["border:0.1em solid ", ";border-left-width:0;border-top-width:0;height:0.625em;transform:rotate(45deg);width:0.375em;"], styledTools.palette('primary'));
  }),
  disabledCheckedIconCss: styled.css(["border-color:", ";"], styledTools.palette('gray300')),
  themePrefix: 'Checkbox'
});
var _Checkbox = styled.default(Label).withConfig({
  displayName: "styled",
  componentId: "sc-1cw8kp1-1"
})(["display:flex;align-items:center;&{", ";}"], styledTools.theme('fannypack.Checkbox.label'));

var Checkbox = function Checkbox(_ref) {
  var autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      id = _ref.id,
      indeterminate = _ref.indeterminate,
      isRequired = _ref.isRequired,
      label = _ref.label,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      state = _ref.state,
      value = _ref.value,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["autoFocus", "checked", "className", "defaultChecked", "disabled", "id", "indeterminate", "isRequired", "label", "onBlur", "onChange", "onFocus", "name", "state", "value"]);

  return React.createElement(_Checkbox, __chunk_1._extends({
    "aria-describedby": "label",
    "aria-invalid": state === 'danger',
    "aria-label": label,
    "aria-required": isRequired
  }, props), React.createElement(HiddenCheckbox, {
    autoFocus: autoFocus,
    checked: checked,
    defaultChecked: defaultChecked,
    disabled: disabled,
    id: id,
    indeterminate: indeterminate,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    name: name,
    state: state,
    type: "checkbox" // @ts-ignore
    ,
    value: value
  }), React.createElement(CheckboxIcon, {
    state: state
  }), label && React.createElement(Text.Text, {
    id: "label",
    htmlFor: id,
    marginLeft: "minor-2"
  }, label));
};
var checkboxPropTypes = {
  autoFocus: PropTypes.bool,
  checked: PropTypes.bool,
  className: PropTypes.string,
  defaultChecked: PropTypes.bool,
  disabled: PropTypes.bool,
  id: PropTypes.string,
  indeterminate: PropTypes.bool,
  isRequired: PropTypes.bool,
  label: PropTypes.string,
  name: PropTypes.string,
  state: PropTypes.string,
  value: PropTypes.oneOfType([PropTypes.bool, PropTypes.string]),
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func
};
Checkbox.propTypes = checkboxPropTypes;
var checkboxDefaultProps = {
  autoFocus: false,
  checked: undefined,
  className: undefined,
  defaultChecked: undefined,
  disabled: false,
  id: undefined,
  indeterminate: false,
  isRequired: false,
  label: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  name: undefined,
  state: undefined,
  value: undefined
};
Checkbox.defaultProps = checkboxDefaultProps; // @ts-ignore

var C = Checkbox;

var CheckboxField = function CheckboxField(_ref) {
  var a11yId = _ref.a11yId,
      autoFocus = _ref.autoFocus,
      checkboxLabel = _ref.checkboxLabel,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      description = _ref.description,
      disabled = _ref.disabled,
      hint = _ref.hint,
      label = _ref.label,
      indeterminate = _ref.indeterminate,
      id = _ref.id,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      state = _ref.state,
      validationText = _ref.validationText,
      value = _ref.value,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yId", "autoFocus", "checkboxLabel", "checked", "className", "defaultChecked", "description", "disabled", "hint", "label", "indeterminate", "id", "isOptional", "isRequired", "onBlur", "onChange", "onFocus", "name", "state", "validationText", "value"]);

  return React.createElement(__chunk_13.FieldWrapper, __chunk_1._extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return React.createElement(C, __chunk_1._extends({
      autoFocus: autoFocus,
      checked: checked,
      className: className,
      defaultChecked: defaultChecked,
      disabled: disabled,
      id: id,
      indeterminate: indeterminate,
      isRequired: isRequired,
      label: checkboxLabel,
      name: name,
      state: state // @ts-ignore
      ,
      value: value,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus
    }, elementProps));
  });
};
CheckboxField.propTypes = __chunk_1._objectSpread({
  checkboxLabel: PropTypes.string
}, checkboxPropTypes, _omit(__chunk_13.fieldWrapperPropTypes, 'children'));
CheckboxField.defaultProps = __chunk_1._objectSpread({}, checkboxDefaultProps, __chunk_13.fieldWrapperDefaultProps); // @ts-ignore

var C$1 = CheckboxField;

exports.Checkbox = C;
exports.CheckboxField = C$1;
exports.default = C;
