'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Code = _interopDefault(require('reakit/Code'));
var SyntaxHighlighter = require('react-syntax-highlighter/prism-light');
var SyntaxHighlighter__default = _interopDefault(SyntaxHighlighter);
var defaultTheme = _interopDefault(require('react-syntax-highlighter/styles/prism/coy'));
var javascript = _interopDefault(require('react-syntax-highlighter/languages/prism/javascript'));
var jsx = _interopDefault(require('react-syntax-highlighter/languages/prism/jsx'));
var json = _interopDefault(require('react-syntax-highlighter/languages/prism/json'));
var polished = require('polished');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var _Code = styled.default(Code).withConfig({
  displayName: "styled",
  componentId: "sc-1otm95n-0"
})(["background-color:", ";border-radius:0.1rem;color:", ";font-family:'SF Mono','Segoe UI Mono','Roboto Mono',Menlo,Courier,monospace;code&{padding:0.1rem 0.2rem;", ";}pre&{padding:1rem;", ";}&{", ";}"], polished.darken(0.05, 'white'), styledTools.palette('text'), styledTools.theme('fannypack.Code.inline'), styledTools.theme('fannypack.Code.block'), styledTools.theme('fannypack.Code.base'));

var Code$1 = function Code$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      codeClassName = _ref.codeClassName,
      isBlock = _ref.isBlock,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "className", "codeClassName", "isBlock"]);

  return React.createElement(_Code, __chunk_1._extends({
    block: isBlock
  }, props), children);
};
Code$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  codeClassName: PropTypes.string,
  isBlock: PropTypes.bool
};
Code$1.defaultProps = {
  className: undefined,
  codeClassName: undefined,
  isBlock: false
};
var C = Code$1;

var Wrapper = styled.default(Box).withConfig({
  displayName: "HighlightedCode__Wrapper",
  componentId: "kn73h9-0"
})(["", ";"], function (props) {
  return props.showLabel && styled.css(["position:relative;&:before{color:", ";content:'", "';font-family:'SF Mono','Segoe UI Mono','Roboto Mono',Menlo,Courier,monospace;font-size:0.8rem;font-weight:bold;position:absolute;right:0.5rem;top:0.2rem;text-transform:uppercase;}"], styledTools.palette('text'), function (props) {
    return props.lang;
  });
});
var HighlightedCode =
/*#__PURE__*/
function (_React$PureComponent) {
  __chunk_1._inheritsLoose(HighlightedCode, _React$PureComponent);

  function HighlightedCode() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "componentDidMount", function () {
      SyntaxHighlighter.registerLanguage('javascript', javascript);
      SyntaxHighlighter.registerLanguage('jsx', jsx);
      SyntaxHighlighter.registerLanguage('json', json);
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          codeClassName = _this$props.codeClassName,
          isBlock = _this$props.isBlock,
          lang = _this$props.lang,
          showLineNumbers = _this$props.showLineNumbers,
          props = __chunk_1._objectWithoutPropertiesLoose(_this$props, ["children", "className", "codeClassName", "isBlock", "lang", "showLineNumbers"]);

      return React.createElement(Wrapper, __chunk_1._extends({
        lang: lang
      }, props), React.createElement(SyntaxHighlighter__default, {
        className: className,
        codeClassName: codeClassName,
        block: isBlock,
        language: lang,
        showLineNumbers: showLineNumbers,
        style: defaultTheme,
        PreTag: C
      }, children));
    });

    return _this;
  }

  return HighlightedCode;
}(React.PureComponent); // @ts-ignore

__chunk_1._defineProperty(HighlightedCode, "propTypes", {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  codeClassName: PropTypes.string,
  isBlock: PropTypes.bool,
  lang: PropTypes.string.isRequired,
  showLabel: PropTypes.bool,
  showLineNumbers: PropTypes.bool
});

__chunk_1._defineProperty(HighlightedCode, "defaultProps", {
  className: undefined,
  codeClassName: undefined,
  isBlock: false,
  showLabel: false,
  showLineNumbers: false
});

var C$1 = HighlightedCode;

exports.Code = C;
exports.HighlightedCode = C$1;
exports.default = C;
