'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var __chunk_14 = require('./chunk-0ef049b2.js');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var marginAutoOffsets = {
  left: styled.css(["margin-left:auto;"]),
  both: styled.css(["margin-left:auto;margin-right:auto;"]),
  right: styled.css(["margin-right:auto;"])
};

var getWidth = function getWidth(spread) {
  return spread / 12 * 100 + "%";
};

var getSpreadProperties = function getSpreadProperties(props) {
  var minBreakpoint = props.minBreakpoint,
      spread = props.spread,
      spreadMobile = props.spreadMobile,
      spreadTablet = props.spreadTablet,
      spreadDesktop = props.spreadDesktop,
      spreadWidescreen = props.spreadWidescreen,
      spreadFullHD = props.spreadFullHD;

  if (!minBreakpoint && !spread && !spreadMobile && !spreadTablet && !spreadDesktop && !spreadWidescreen && !spreadFullHD) {
    return styled.css(["@media (max-width:", "px){flex:none;width:100%;}"], styledTools.theme('fannypack.layout.tabletBreakpoint'));
  }

  var getProperties = function getProperties(_ref) {
    var breakpoint = _ref.breakpoint,
        spread = _ref.spread;
    var properties = styled.css(["flex:none;width:", ";"], getWidth(spread));
    if (!spread) return null;

    if (breakpoint) {
      return styled.css(["@media (max-width:", "px){", ";}"], styledTools.theme("fannypack.layout." + breakpoint), properties);
    }

    return properties;
  };

  return styled.css(["", ";", ";", ";", ";", ";", ";", ";", ";"], getProperties({
    spread: spread
  }), getProperties({
    spread: spreadFullHD,
    breakpoint: 'fullHDBreakpoint'
  }), getProperties({
    spread: spreadWidescreen,
    breakpoint: 'widescreenBreakpoint'
  }), getProperties({
    spread: spreadDesktop,
    breakpoint: 'desktopBreakpoint'
  }), minBreakpoint !== 'tablet' && minBreakpoint !== 'mobile' && !spreadTablet && !spreadMobile && styled.css(["@media (max-width:", "px){width:100%;}"], styledTools.theme('fannypack.layout.tabletBreakpoint')), getProperties({
    spread: spreadTablet,
    breakpoint: 'tabletBreakpoint'
  }), minBreakpoint !== 'mobile' && !spreadMobile && styled.css(["@media (max-width:", "px){width:100%;}"], styledTools.theme('fannypack.layout.mobileBreakpoint')), getProperties({
    spread: spreadMobile,
    breakpoint: 'mobileBreakpoint'
  }));
};

var getSpreadOffsetProperties = function getSpreadOffsetProperties(props) {
  var spreadOffset = props.spreadOffset,
      spreadMobileOffset = props.spreadMobileOffset,
      spreadTabletOffset = props.spreadTabletOffset,
      spreadDesktopOffset = props.spreadDesktopOffset,
      spreadWidescreenOffset = props.spreadWidescreenOffset,
      spreadFullHDOffset = props.spreadFullHDOffset;

  if (!spreadOffset && !spreadMobileOffset && !spreadTabletOffset && !spreadDesktopOffset && !spreadWidescreenOffset && !spreadFullHDOffset) {
    return null;
  }

  var getProperties = function getProperties(_ref2) {
    var breakpoint = _ref2.breakpoint,
        spreadOffset = _ref2.spreadOffset;
    var properties = styled.css(["margin-left:", ";"], getWidth(spreadOffset));
    if (!spreadOffset) return null;

    if (breakpoint) {
      return styled.css(["@media (max-width:", "px){", ";}"], styledTools.theme("fannypack.layout." + breakpoint), properties);
    }

    return properties;
  };

  if (typeof spreadOffset === 'number') {
    return styled.css(["", ";", ";", ";", ";", ";", ";", ";", ";"], getProperties({
      spreadOffset: spreadOffset
    }), getProperties({
      spreadOffset: spreadFullHDOffset,
      breakpoint: 'fullHDBreakpoint'
    }), getProperties({
      spreadOffset: spreadWidescreenOffset,
      breakpoint: 'widescreenBreakpoint'
    }), getProperties({
      spreadOffset: spreadDesktopOffset,
      breakpoint: 'desktopBreakpoint'
    }), !spreadTabletOffset && !spreadMobileOffset && styled.css(["@media (max-width:", "px){margin-left:0;}"], styledTools.theme('fannypack.layout.tabletBreakpoint')), getProperties({
      spreadOffset: spreadTabletOffset,
      breakpoint: 'tabletBreakpoint'
    }), !spreadMobileOffset && styled.css(["@media (max-width:", "px){margin-left:0;}"], styledTools.theme('fannypack.layout.mobileBreakpoint')), getProperties({
      spreadOffset: spreadMobileOffset,
      breakpoint: 'mobileBreakpoint'
    }));
  }

  return marginAutoOffsets[spreadOffset];
};

var Column = styled.default(Box).withConfig({
  displayName: "styled__Column",
  componentId: "sc-1lmgd0f-0"
})(["flex:1;max-width:100%;", ";&{", ";}&{", ";}&{", ";}"], function (props) {
  return !props.isGapless ? styled.css(["padding:", "rem;"], styledTools.theme('fannypack.layout.gapFactor')) : null;
}, getSpreadProperties, getSpreadOffsetProperties, styledTools.theme('fannypack.Column.base'));

var Column$1 = function Column$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      spread = _ref.spread,
      spreadMobile = _ref.spreadMobile,
      spreadTablet = _ref.spreadTablet,
      spreadDesktop = _ref.spreadDesktop,
      spreadWidescreen = _ref.spreadWidescreen,
      spreadFullHD = _ref.spreadFullHD,
      spreadOffset = _ref.spreadOffset,
      spreadMobileOffset = _ref.spreadMobileOffset,
      spreadTabletOffset = _ref.spreadTabletOffset,
      spreadDesktopOffset = _ref.spreadDesktopOffset,
      spreadWidescreenOffset = _ref.spreadWidescreenOffset,
      spreadFullHDOffset = _ref.spreadFullHDOffset,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "className", "spread", "spreadMobile", "spreadTablet", "spreadDesktop", "spreadWidescreen", "spreadFullHD", "spreadOffset", "spreadMobileOffset", "spreadTabletOffset", "spreadDesktopOffset", "spreadWidescreenOffset", "spreadFullHDOffset"]);

  return React.createElement(__chunk_14.ColumnsContext.Consumer, null, function (_ref2) {
    var isGapless = _ref2.isGapless,
        minBreakpoint = _ref2.minBreakpoint;
    return React.createElement(Column, __chunk_1._extends({
      className: className,
      isGapless: isGapless,
      minBreakpoint: minBreakpoint,
      spread: spread,
      spreadMobile: spreadMobile,
      spreadTablet: spreadTablet,
      spreadDesktop: spreadDesktop,
      spreadWidescreen: spreadWidescreen,
      spreadFullHD: spreadFullHD,
      spreadOffset: spreadOffset,
      spreadMobileOffset: spreadMobileOffset,
      spreadTabletOffset: spreadTabletOffset,
      spreadDesktopOffset: spreadDesktopOffset,
      spreadWidescreenOffset: spreadWidescreenOffset,
      spreadFullHDOffset: spreadFullHDOffset
    }, props), children);
  });
};
Column$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  spread: types.columnSpreadPropType,
  spreadMobile: types.columnSpreadPropType,
  spreadTablet: types.columnSpreadPropType,
  spreadDesktop: types.columnSpreadPropType,
  spreadWidescreen: types.columnSpreadPropType,
  spreadFullHD: types.columnSpreadPropType,
  spreadOffset: types.columnSpreadOffsetPropType,
  spreadMobileOffset: types.columnSpreadOffsetPropType,
  spreadTabletOffset: types.columnSpreadOffsetPropType,
  spreadDesktopOffset: types.columnSpreadOffsetPropType,
  spreadWidescreenOffset: types.columnSpreadOffsetPropType,
  spreadFullHDOffset: types.columnSpreadOffsetPropType
};
Column$1.defaultProps = {
  className: undefined,
  spread: undefined,
  spreadMobile: undefined,
  spreadTablet: undefined,
  spreadDesktop: undefined,
  spreadWidescreen: undefined,
  spreadFullHD: undefined,
  spreadOffset: undefined,
  spreadMobileOffset: undefined,
  spreadTabletOffset: undefined,
  spreadDesktopOffset: undefined,
  spreadWidescreenOffset: undefined,
  spreadFullHDOffset: undefined
};
var C = Column$1;

exports.Column = C;
exports.default = C;
