'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var __chunk_14 = require('./chunk-0ef049b2.js');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var getWrapProperties = function getWrapProperties(props) {
  var isOneLine = props.isOneLine,
      minBreakpoint = props.minBreakpoint;

  if (isOneLine) {
    if (minBreakpoint !== 'tablet' && minBreakpoint !== 'mobile') {
      return styled.css(["@media (max-width:", "px){flex-wrap:wrap;}"], styledTools.theme('fannypack.layout.tabletBreakpoint'));
    }

    if (minBreakpoint !== 'mobile') {
      return styled.css(["@media (max-width:", "px){flex-wrap:wrap;}"], styledTools.theme('fannypack.layout.mobileBreakpoint'));
    }

    return null;
  } else {
    return styled.css(["flex-wrap:wrap;"]);
  }
};

var _Columns = styled.default(Box).withConfig({
  displayName: "styled",
  componentId: "otaduv-0"
})(["display:flex;", ";", ";&{", ";}"], function (props) {
  return !props.isGapless && styled.css(["margin-left:-", "rem;margin-right:-", "rem;margin-top:-", "rem;&:last-child{margin-bottom:-", "rem;}"], styledTools.theme('fannypack.layout.gapFactor'), styledTools.theme('fannypack.layout.gapFactor'), styledTools.theme('fannypack.layout.gapFactor'), styledTools.theme('fannypack.layout.gapFactor'));
}, getWrapProperties, styledTools.theme('fannypack.Columns.base'));

var Columns = function Columns(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isGapless = _ref.isGapless,
      isOneLine = _ref.isOneLine,
      minBreakpoint = _ref.minBreakpoint,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "className", "isGapless", "isOneLine", "minBreakpoint"]);

  return React.createElement(__chunk_14.ColumnsContext.Provider, {
    value: {
      isGapless: isGapless,
      minBreakpoint: minBreakpoint
    }
  }, React.createElement(_Columns, __chunk_1._extends({
    className: className,
    isGapless: isGapless,
    isOneLine: isOneLine,
    minBreakpoint: minBreakpoint
  }, props), children));
};
Columns.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isGapless: PropTypes.bool,
  isOneLine: PropTypes.bool,
  minBreakpoint: PropTypes.oneOf(['tablet', 'mobile'])
};
Columns.defaultProps = {
  className: undefined,
  isGapless: false,
  isOneLine: false,
  minBreakpoint: undefined
};
var C = Columns;

exports.Columns = C;
exports.default = C;
