'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var alignProperties = {
  left: styled.css(["margin-right:auto;"]),
  center: styled.css(["margin-left:auto;margin-right:auto;"]),
  right: styled.css(["margin-left:auto;"])
};

var getResponsiveProperties = function getResponsiveProperties(props) {
  var breakpoint = props.breakpoint,
      isFluid = props.isFluid;
  if (isFluid) return;

  if (breakpoint) {
    return styled.css(["&{max-width:", "px;}"], styledTools.theme("fannypack.layout." + breakpoint + "Breakpoint"));
  }

  return styled.css(["@media (max-width:", "px){max-width:", "px;}@media (max-width:", "px){max-width:", "px;}@media (max-width:", "px){max-width:", "px;}"], function (props) {
    return styledTools.theme('fannypack.layout.fullHDBreakpoint')(props) + 128;
  }, styledTools.theme('fannypack.layout.widescreenBreakpoint'), function (props) {
    return styledTools.theme('fannypack.layout.widescreenBreakpoint')(props) + 128;
  }, styledTools.theme('fannypack.layout.desktopBreakpoint'), function (props) {
    return styledTools.theme('fannypack.layout.desktopBreakpoint')(props) + 128;
  }, styledTools.theme('fannypack.layout.tabletBreakpoint'));
};

var _Container = styled.default(Box).withConfig({
  displayName: "styled",
  componentId: "sc-144wh3b-0"
})(["width:100%;", ";", ";", ";", ";", ";", ";"], function (props) {
  return !props.isFluid && styled.css(["max-width:", "px;"], styledTools.theme('fannypack.layout.fullHDBreakpoint'));
}, function (props) {
  return props.isFluid && styled.css(["margin:", ";"], styledTools.theme('fannypack.Container.fluidMargin'));
}, function (props) {
  return props.isLayout && styled.css(["@media (max-width:", "px){margin:", ";}"], styledTools.theme('fannypack.layout.tabletBreakpoint'), styledTools.theme('fannypack.Container.tabletMargin'));
}, getResponsiveProperties, function (props) {
  return props.align && !props.isFluid ? alignProperties[props.align] : null;
}, styledTools.theme('fannypack.Container.base'));

var Container = function Container(_ref) {
  var align = _ref.align,
      children = _ref.children,
      className = _ref.className,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["align", "children", "className"]);

  return React.createElement(_Container, __chunk_1._extends({
    className: className,
    align: align
  }, props), children);
};
Container.propTypes = {
  align: PropTypes.oneOf(['left', 'right', 'center']),
  breakpoint: types.breakpointPropType,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isFluid: PropTypes.bool,
  isLayout: PropTypes.bool
};
Container.defaultProps = {
  align: 'center',
  breakpoint: undefined,
  className: undefined,
  isFluid: false,
  isLayout: false
};
var C = Container;

exports.Container = C;
exports.default = C;
