'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var __chunk_3 = require('./chunk-cb567965.js');
var __chunk_6 = require('./chunk-f77e63ff.js');
var __chunk_8 = require('./chunk-fdbfe348.js');
var Heading = require('./Heading.js');
var VisuallyHidden = require('./VisuallyHidden.js');
var __chunk_9 = require('./chunk-d538c3df.js');
var uniqueId = require('./uniqueId.js');
var _omit = _interopDefault(require('lodash/omit'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('airbnb-prop-types');
require('./types.js');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('./chunk-1c9fbb5b.js');
require('reakit/Heading');
require('classnames');
require('lodash/uniqueId');

var DialogContent = styled.default(Box).withConfig({
  displayName: "styled__DialogContent",
  componentId: "sc-1loaala-0"
})(["padding:", "rem;max-height:50vh;overflow-y:scroll;width:100%;&{", ";}"], styled.space(5), styledTools.theme('fannypack.Dialog.Content.base'));
var DialogHeader = styled.default(Box).withConfig({
  displayName: "styled__DialogHeader",
  componentId: "sc-1loaala-1"
})(["align-items:center;background-color:", ";display:flex;justify-content:space-between;padding:", "rem;width:100%;&{", ";}"], styledTools.palette('white700'), styled.space(5), styledTools.theme('fannypack.Dialog.Header.base'));
var DialogFooter = styled.default(Box).withConfig({
  displayName: "styled__DialogFooter",
  componentId: "sc-1loaala-2"
})(["display:flex;align-items:center;background-color:", ";padding:", "rem ", "rem;width:100%;&{", ";}"], styledTools.palette('white700'), styled.space(4), styled.space(4), styledTools.theme('fannypack.Dialog.Footer.base'));
var DialogTitle = styled.default(Heading.Heading).withConfig({
  displayName: "styled__DialogTitle",
  componentId: "sc-1loaala-3"
})(["margin-bottom:0px;&{", ";}"], styledTools.theme('fannypack.Dialog.Title.base'));
var DialogClose = styled.default(__chunk_6.Button).withConfig({
  displayName: "styled__DialogClose",
  componentId: "sc-1loaala-4"
})(["height:2em;width:2em;padding:0px;&:hover{background-color:", ";&{", ";}}&{", ";}"], styledTools.palette('white700'), styledTools.theme('fannypack.Dialog.Close.hover'), styledTools.theme('fannypack.Dialog.Close.base'));
var DialogIcon = styled.default(__chunk_3.Icon).withConfig({
  displayName: "styled__DialogIcon",
  componentId: "sc-1loaala-5"
})(["margin-right:", "rem;&{", ";}"], styled.space(2), styledTools.theme('fannypack.Dialog.Icon.base'));
var Dialog = styled.default(__chunk_9.Pane).withConfig({
  displayName: "styled",
  componentId: "sc-1loaala-6"
})(["border-radius:5px;&:focus{outline:unset;}&{", ";}"], styledTools.theme('fannypack.Dialog.base'));

var DialogDialog = function DialogDialog(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      kind = _ref.kind,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "children", "kind"]);

  return React.createElement(Dialog, __chunk_1._extends({
    "aria-describedby": a11yDescriptionId,
    "aria-labelledby": a11yTitleId,
    role: kind === 'alert' ? 'alertdialog' : 'dialog'
  }, props), children);
};
var dialogDialogPropTypes = __chunk_1._objectSpread({
  a11yDescriptionId: PropTypes.string,
  a11yTitleId: PropTypes.string,
  className: PropTypes.string,
  kind: PropTypes.oneOf(['alert'])
}, __chunk_9.panePropTypes, {
  children: PropTypes.node.isRequired
});
DialogDialog.propTypes = dialogDialogPropTypes;
var dialogDialogDefaultProps = __chunk_1._objectSpread({}, __chunk_9.paneDefaultProps, {
  a11yDescriptionId: undefined,
  a11yTitleId: undefined,
  border: true,
  className: undefined,
  kind: undefined
});
DialogDialog.defaultProps = dialogDialogDefaultProps;
var C = DialogDialog;

var DialogContent$1 = function DialogContent$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(DialogContent, props, children);
};
DialogContent$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string
};
DialogContent$1.defaultProps = {
  className: undefined
};
var C$1 = DialogContent$1;

var DialogHeader$1 = function DialogHeader$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(DialogHeader, props, children);
};
DialogHeader$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string
};
DialogHeader$1.defaultProps = {
  className: undefined
};
var C$2 = DialogHeader$1;

var DialogFooter$1 = function DialogFooter$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(DialogFooter, props, children);
};
DialogFooter$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string
};
DialogFooter$1.defaultProps = {
  className: undefined
};
var C$3 = DialogFooter$1;

var DialogTitle$1 = function DialogTitle$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(DialogTitle, __chunk_1._extends({
    use: "h5",
    isSubHeading: true
  }, props), children);
};
DialogTitle$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string
};
DialogTitle$1.defaultProps = {
  className: undefined
};
var C$4 = DialogTitle$1;

var DialogClose$1 = function DialogClose$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(DialogClose, __chunk_1._extends({
    kind: "link"
  }, props), React.createElement(VisuallyHidden.default, null, "Close"), React.createElement(__chunk_3.Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
DialogClose$1.propTypes = {
  className: PropTypes.string
};
DialogClose$1.defaultProps = {
  className: undefined
};
var C$5 = DialogClose$1;

// @ts-ignore
var DialogIcon$1 = function DialogIcon$$1(props) {
  return React.createElement(DialogIcon, props);
};
DialogIcon$1.propTypes = {
  className: PropTypes.string,
  icon: PropTypes.string.isRequired
};
DialogIcon$1.defaultProps = {
  className: undefined
}; // @ts-ignore

var C$6 = DialogIcon$1;

var Dialog$1 = function Dialog(_ref) {
  var actionButtonsProps = _ref.actionButtonsProps,
      a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      closeButtonProps = _ref.closeButtonProps,
      footer = _ref.footer,
      onClickClose = _ref.onClickClose,
      showActionButtons = _ref.showActionButtons,
      showCloseButton = _ref.showCloseButton,
      title = _ref.title,
      type = _ref.type,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["actionButtonsProps", "a11yDescriptionId", "a11yTitleId", "children", "closeButtonProps", "footer", "onClickClose", "showActionButtons", "showCloseButton", "title", "type"]);

  return React.createElement(C, __chunk_1._extends({
    a11yDescriptionId: a11yDescriptionId,
    a11yTitleId: a11yTitleId
  }, props), title && React.createElement(C$2, null, typeof title === 'string' ? React.createElement(C$4, {
    id: a11yTitleId
  }, type && React.createElement(C$6, {
    a11yHidden: true,
    color: type,
    icon: type
  }), title) : title, showCloseButton && React.createElement(C$5, __chunk_1._extends({
    onClick: onClickClose
  }, closeButtonProps))), React.createElement(C$1, {
    id: a11yDescriptionId
  }, children), (footer || showActionButtons) && React.createElement(C$3, {
    justifyContent: footer ? 'space-between' : 'flex-end'
  }, footer && React.createElement(Box, null, footer), showActionButtons && React.createElement(Box, null, React.createElement(__chunk_8.ActionButtons, actionButtonsProps))));
};
Dialog$1.Dialog = C;
Dialog$1.Header = C$2;
Dialog$1.Content = C$1;
Dialog$1.Footer = C$3;
Dialog$1.Title = C$4;
Dialog$1.Close = C$5;
Dialog$1.Icon = C$6;
Dialog$1.propTypes = __chunk_1._objectSpread({
  actionButtonsProps: PropTypes.shape(__chunk_8.actionButtonsPropTypes),
  a11yDescriptionId: PropTypes.string,
  a11yTitleId: PropTypes.string,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  closeButtonProps: PropTypes.shape(_omit(__chunk_6.buttonPropTypes, 'children')),
  footer: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  onClickClose: PropTypes.func,
  showActionButtons: PropTypes.bool,
  showCloseButton: PropTypes.bool,
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  type: PropTypes.string
}, dialogDialogPropTypes);
Dialog$1.defaultProps = __chunk_1._objectSpread({}, dialogDialogDefaultProps, {
  actionButtonsProps: {},
  a11yDescriptionId: uniqueId.getUniqueId('Dialog'),
  a11yTitleId: uniqueId.getUniqueId('Dialog'),
  className: undefined,
  closeButtonProps: {},
  footer: undefined,
  onClickClose: undefined,
  showActionButtons: false,
  showCloseButton: false,
  title: undefined,
  type: undefined
}); // @ts-ignore

var C$7 = Dialog$1;

exports.default = C$7;
exports.Dialog = C$7;
exports.DialogContent = C$1;
exports.DialogClose = C$5;
exports.DialogDialog = C;
exports.DialogFooter = C$3;
exports.DialogHeader = C$2;
exports.DialogTitle = C$4;
exports.DialogIcon = C$6;
