'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var types = require('./types.js');
var __chunk_8 = require('./chunk-fdbfe348.js');
var uniqueId = require('./uniqueId.js');
var Dialog = require('./Dialog.js');
var __chunk_16 = require('./chunk-12990c15.js');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
require('./chunk-f77e63ff.js');
require('./styled.js');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./chunk-cb567965.js');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('reakit/Box');
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('airbnb-prop-types');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('./chunk-1c9fbb5b.js');
require('lodash/omit');
require('lodash/uniqueId');
require('./Heading.js');
require('reakit/Heading');
require('classnames');
require('./VisuallyHidden.js');
require('./chunk-d538c3df.js');
require('./Backdrop.js');
require('reakit/Backdrop');
require('./Overlay-463c58ea.js');
require('reakit/Overlay');
require('./chunk-235bc185.js');
require('focus-trap');
require('./Portal.js');
require('reakit/Portal');

var DialogModal = function DialogModal(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      actionButtonsProps = _ref.actionButtonsProps,
      children = _ref.children,
      footer = _ref.footer,
      hide = _ref.hide,
      kind = _ref.kind,
      showActionButtons = _ref.showActionButtons,
      showCloseButton = _ref.showCloseButton,
      title = _ref.title,
      type = _ref.type,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "actionButtonsProps", "children", "footer", "hide", "kind", "showActionButtons", "showCloseButton", "title", "type"]);

  return React.createElement(__chunk_16.Modal, __chunk_1._extends({
    hide: hide,
    kind: kind
  }, props), function (_ref2) {
    var fallbackFocusRef = _ref2.fallbackFocusRef,
        initialFocusRef = _ref2.initialFocusRef;
    return React.createElement(Dialog.default, {
      a11yDescriptionId: a11yDescriptionId,
      a11yTitleId: a11yTitleId,
      actionButtonsProps: __chunk_1._objectSpread({
        cancelProps: __chunk_1._objectSpread({
          elementRef: initialFocusRef,
          use: __chunk_16.Modal.Hide,
          // @ts-ignore
          hide: hide
        }, (actionButtonsProps || {}).cancelProps),
        palette: type
      }, actionButtonsProps),
      closeButtonProps: {
        elementRef: initialFocusRef
      },
      elementRef: fallbackFocusRef // @ts-ignore
      ,
      footer: typeof footer === 'function' ? footer({
        initialFocusRef: initialFocusRef
      }) : footer,
      onClickClose: hide,
      role: kind === 'alert' ? 'alertdialog' : 'dialog',
      showActionButtons: showActionButtons || kind === 'alert',
      showCloseButton: showCloseButton && kind !== 'alert',
      tabIndex: -1 // @ts-ignore
      ,
      title: title,
      type: type,
      width: "100%"
    }, typeof children === 'function' ? children({
      initialFocusRef: initialFocusRef
    }) : children);
  });
};
DialogModal.propTypes = __chunk_1._objectSpread({
  a11yDescriptionId: PropTypes.string,
  a11yTitleId: PropTypes.string,
  actionButtonsProps: PropTypes.shape(__chunk_8.actionButtonsPropTypes),
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
  className: PropTypes.string,
  footer: PropTypes.oneOfType([PropTypes.func, PropTypes.string, PropTypes.element]),
  hide: PropTypes.func,
  isVisible: PropTypes.bool,
  kind: PropTypes.oneOf(['alert']),
  showActionButtons: PropTypes.bool,
  showCloseButton: PropTypes.bool,
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  type: PropTypes.string
}, types.animatePropTypes, types.restrictHidePropTypes);
DialogModal.defaultProps = __chunk_1._objectSpread({
  actionButtonsProps: {},
  a11yDescriptionId: uniqueId.getUniqueId('Modal'),
  a11yTitleId: uniqueId.getUniqueId('Modal'),
  className: undefined,
  footer: undefined,
  isVisible: false,
  kind: undefined,
  showActionButtons: false,
  showCloseButton: false,
  title: undefined,
  type: undefined
}, types.animateDefaultProps, types.restrictDefaultProps, {
  hideOnEsc: true,
  hideOnClickOutside: true
}); // @ts-ignore

var C = DialogModal;

exports.default = C;
exports.DialogModal = C;
