'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var Group = _interopDefault(require('reakit/Group'));
var React = require('react');
var React__default = _interopDefault(React);
var _get = _interopDefault(require('lodash/get'));
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
require('reakit/styled');

var _Group = styled.default(Group).withConfig({
  displayName: "styled",
  componentId: "sc-1cm5zaa-0"
})(["& > *{border-radius:4px;}& input:focus,& select:focus{z-index:1;position:relative;}& > *:first-child{& input,& select{", ";}}& > *:last-child{& input,& select{", ";}}& > *:not(:first-child):not(:last-child) > input,& > *:not(:first-child):not(:last-child) > select{border-radius:0;}&{", ";}"], function (props) {
  return props.vertical ? styled.css(["border-bottom-right-radius:0;border-bottom-left-radius:0;"]) : styled.css(["border-bottom-right-radius:0;border-top-right-radius:0;"]);
}, function (props) {
  return props.vertical ? styled.css(["border-top-left-radius:0;border-top-right-radius:0;"]) : styled.css(["border-top-left-radius:0;border-bottom-left-radius:0;"]);
}, styledTools.theme('fannypack.Group.base'));

var getVerticalBreakpoint = function getVerticalBreakpoint(_ref) {
  var breakpoint = _ref.breakpoint,
      theme = _ref.theme;
  return typeof breakpoint === 'number' ? breakpoint : _get(theme, "fannypack.layout[" + breakpoint + "Breakpoint]");
};

var Group$1 = function Group$$1(_ref2) {
  var children = _ref2.children,
      className = _ref2.className,
      isVertical = _ref2.isVertical,
      theme = _ref2.theme,
      _verticalAt = _ref2.verticalAt,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref2, ["children", "className", "isVertical", "theme", "verticalAt"]);

  var verticalAt = getVerticalBreakpoint({
    breakpoint: _verticalAt,
    theme: theme
  });
  return React.createElement(_Group, __chunk_1._extends({
    className: className,
    vertical: isVertical,
    verticalAt: verticalAt
  }, props), children);
};
Group$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isVertical: PropTypes.bool,
  theme: PropTypes.object,
  verticalAt: PropTypes.oneOfType([types.breakpointPropType, PropTypes.number])
};
Group$1.defaultProps = {
  className: undefined,
  isVertical: false,
  theme: {},
  verticalAt: undefined
}; // @ts-ignore

var C = styled.withTheme(Group$1);

exports.Group = C;
exports.default = C;
