'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var Hidden = _interopDefault(require('reakit/Hidden'));
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
require('reakit/styled');
require('lodash/get');
require('styled-tools');

var HiddenContainer = function HiddenContainer(_ref) {
  var children = _ref.children,
      defaultVisible = _ref.defaultVisible,
      initialState = _ref.initialState,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "defaultVisible", "initialState"]);

  return React.createElement(Hidden.Container, __chunk_1._extends({
    initialState: __chunk_1._objectSpread({
      visible: defaultVisible
    }, initialState)
  }, props), function (_ref2) {
    var visible = _ref2.visible,
        rest = __chunk_1._objectWithoutPropertiesLoose(_ref2, ["visible"]);

    return children(__chunk_1._objectSpread({
      isVisible: visible
    }, rest));
  });
};
HiddenContainer.propTypes = {
  children: PropTypes.func.isRequired,
  defaultVisible: PropTypes.bool,
  initialState: PropTypes.object
};
HiddenContainer.defaultProps = {
  defaultVisible: false,
  initialState: {}
};

var HiddenHide = styled.default(Hidden.Hide).withConfig({
  displayName: "styled__HiddenHide",
  componentId: "sc-1iaaa8w-0"
})(["", ";"], styled.theme('fannypack.Hidden.Hide.base'));
var HiddenShow = styled.default(Hidden.Show).withConfig({
  displayName: "styled__HiddenShow",
  componentId: "sc-1iaaa8w-1"
})(["", ";"], styled.theme('fannypack.Hidden.Show.base'));
var HiddenToggle = styled.default(Hidden.Toggle).withConfig({
  displayName: "styled__HiddenToggle",
  componentId: "sc-1iaaa8w-2"
})(["", ";"], styled.theme('fannypack.Hidden.Toggle.base'));
var _Hidden = styled.default(Hidden).withConfig({
  displayName: "styled",
  componentId: "sc-1iaaa8w-3"
})(["&{", ";}"], styled.theme('fannypack.Hidden.base'));

var HiddenShow$1 = function HiddenShow$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(HiddenShow, props, children);
};
HiddenShow$1.propTypes = {
  children: PropTypes.node,
  onClick: PropTypes.func,
  show: PropTypes.func.isRequired
};
HiddenShow$1.defaultProps = {
  children: null,
  onClick: undefined
}; // @ts-ignore

var C = HiddenShow$1;

var HiddenHide$1 = React.forwardRef(function (_ref, ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return (// @ts-ignore
    React.createElement(HiddenHide, __chunk_1._extends({}, props, {
      ref: ref
    }), children)
  );
});
HiddenHide$1.propTypes = {
  children: PropTypes.node,
  hide: PropTypes.func.isRequired,
  onClick: PropTypes.func
};
HiddenHide$1.defaultProps = {
  children: null,
  onClick: undefined
}; // @ts-ignore

var C$1 = HiddenHide$1;

var HiddenToggle$1 = function HiddenToggle$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(HiddenToggle, props, children);
};
HiddenToggle$1.propTypes = {
  children: PropTypes.node,
  onClick: PropTypes.func,
  toggle: PropTypes.func.isRequired
};
HiddenToggle$1.defaultProps = {
  children: null,
  onClick: undefined
};
var C$2 = HiddenToggle$1;

var Hidden$1 = function Hidden$$1(_ref) {
  var children = _ref.children,
      isVisible = _ref.isVisible,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "isVisible"]);

  return React.createElement(_Hidden, __chunk_1._extends({
    visible: isVisible
  }, props), children);
};
Hidden$1.Container = HiddenContainer;
Hidden$1.Show = C;
Hidden$1.Hide = C$1;
Hidden$1.Toggle = C$2;
Hidden$1.propTypes = __chunk_1._objectSpread({}, types.animatePropTypes, types.restrictHidePropTypes, {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isVisible: PropTypes.bool
});
Hidden$1.defaultProps = __chunk_1._objectSpread({}, types.animateDefaultProps, types.restrictDefaultProps, {
  className: undefined,
  isVisible: undefined
}); // @ts-ignore

var C$3 = Hidden$1;

exports.default = C$3;
exports.Hidden = C$3;
exports.HiddenContainer = HiddenContainer;
exports.HiddenHide = C$1;
exports.HiddenShow = C;
exports.HiddenToggle = C$2;
