'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Image = _interopDefault(require('reakit/Image'));
var classNames = _interopDefault(require('classnames'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
require('reakit/styled');
require('lodash/get');

var fitProperties = function fitProperties(props) {
  if (!props.fit) return;

  if (props.fit === 'contain') {
    return styled.css(["object-fit:contain;", ";", ";", ";"], function (props) {
      return props.fitPosition ? styled.css(["object-position:", ";"], props.fitPosition) : '';
    }, styledTools.theme('fannypack.Image.fit.base'), styledTools.theme('fannypack.Image.fit.contain'));
  }

  if (props.fit === 'cover') {
    return styled.css(["object-fit:cover;", ";", ";", ";"], function (props) {
      return props.fitPosition ? styled.css(["object-position:", ";"], props.fitPosition) : '';
    }, styledTools.theme('fannypack.Image.fit.base'), styledTools.theme('fannypack.Image.fit.cover'));
  }

  return null;
};

var fixedProperties = function fixedProperties(props) {
  if (!props.isFixed) return;
  return styled.css(["max-width:unset;", ";"], styledTools.theme('fannypack.Image.fixed'));
};

var _Image = styled.default(Image).withConfig({
  displayName: "styled",
  componentId: "sc-19nzt74-0"
})(["max-width:100%;&{", ";}&{", ";}", ";"], fitProperties, fixedProperties, styledTools.theme('fannypack.Image.base'));

var Image$1 = function Image$$1(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      isFixed = _ref.isFixed,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "className", "isFixed"]);

  return React.createElement(_Image, __chunk_1._extends({
    className: classNames((_classNames = {}, _classNames[className || ''] = Boolean(className), _classNames)),
    isFixed: isFixed
  }, props), children);
};
Image$1.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
  fit: PropTypes.oneOf(['cover', 'contain']),
  fitPosition: PropTypes.string,
  isFixed: PropTypes.bool
};
Image$1.defaultProps = {
  className: undefined,
  fit: undefined,
  fitPosition: undefined,
  isFixed: false
};
var C = Image$1;

exports.Image = C;
exports.default = C;
