'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var __chunk_13 = require('./chunk-fb522222.js');
var Group = require('./Group.js');
var __chunk_17 = require('./chunk-b52ddba6.js');
var ConditionalWrap = _interopDefault(require('conditional-wrap'));
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
require('./styled.js');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./Text.js');
require('./chunk-ab4246ea.js');
require('reakit/Box');
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('./Label.js');
require('reakit/Label');
require('reakit/Field');
require('./types.js');
require('reakit/Group');
require('./chunk-cb567965.js');
require('./parseIcons.js');
require('airbnb-prop-types');
require('./Spinner.js');
require('reakit/Input');

var InputField = function InputField(_ref) {
  var addonBefore = _ref.addonBefore,
      addonAfter = _ref.addonAfter,
      a11yId = _ref.a11yId,
      description = _ref.description,
      hint = _ref.hint,
      isOptional = _ref.isOptional,
      isVertical = _ref.isVertical,
      label = _ref.label,
      validationText = _ref.validationText,
      after = _ref.after,
      a11yLabel = _ref.a11yLabel,
      autoComplete = _ref.autoComplete,
      autoFocus = _ref.autoFocus,
      before = _ref.before,
      children = _ref.children,
      className = _ref.className,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      isLoading = _ref.isLoading,
      isRequired = _ref.isRequired,
      name = _ref.name,
      size = _ref.size,
      max = _ref.max,
      maxLength = _ref.maxLength,
      min = _ref.min,
      minLength = _ref.minLength,
      multiple = _ref.multiple,
      pattern = _ref.pattern,
      placeholder = _ref.placeholder,
      readOnly = _ref.readOnly,
      spellCheck = _ref.spellCheck,
      step = _ref.step,
      state = _ref.state,
      type = _ref.type,
      value = _ref.value,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["addonBefore", "addonAfter", "a11yId", "description", "hint", "isOptional", "isVertical", "label", "validationText", "after", "a11yLabel", "autoComplete", "autoFocus", "before", "children", "className", "defaultValue", "disabled", "isLoading", "isRequired", "name", "size", "max", "maxLength", "min", "minLength", "multiple", "pattern", "placeholder", "readOnly", "spellCheck", "step", "state", "type", "value", "onBlur", "onChange", "onFocus"]);

  return React.createElement(__chunk_13.FieldWrapper, __chunk_1._extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return React.createElement(ConditionalWrap, {
      condition: addonBefore || addonAfter,
      wrap: function wrap(children) {
        return React.createElement(Group.Group, {
          isVertical: isVertical
        }, children);
      }
    }, addonBefore, React.createElement(__chunk_17.Input, __chunk_1._extends({
      after: after,
      a11yId: a11yId,
      a11yLabel: a11yLabel,
      autoComplete: autoComplete,
      autoFocus: autoFocus,
      before: before,
      className: className,
      defaultValue: defaultValue,
      disabled: disabled,
      isLoading: isLoading,
      isRequired: isRequired,
      name: name,
      size: size,
      max: max,
      maxLength: maxLength,
      min: min,
      minLength: minLength,
      multiple: multiple,
      pattern: pattern,
      placeholder: placeholder,
      readOnly: readOnly,
      spellCheck: spellCheck,
      step: step,
      state: state,
      type: type,
      value: value,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus
    }, elementProps), children), addonAfter);
  });
};
var inputFieldPropTypes = __chunk_1._objectSpread({
  addonBefore: PropTypes.element,
  addonAfter: PropTypes.element,
  isVertical: PropTypes.bool
}, __chunk_13.fieldWrapperPropTypes, __chunk_17.inputPropTypes);
InputField.propTypes = inputFieldPropTypes;
var inputFieldDefaultProps = __chunk_1._objectSpread({
  addonBefore: undefined,
  addonAfter: undefined,
  isVertical: false
}, __chunk_13.fieldWrapperDefaultProps, __chunk_17.inputDefaultProps);
InputField.defaultProps = inputFieldDefaultProps; // @ts-ignore

var C = InputField;

exports.default = __chunk_17.Input;
exports.Input = __chunk_17.Input;
exports.InputField = C;
