'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var List = _interopDefault(require('reakit/List'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var orderedProperties = styled.css(["list-style-type:decimal;& &{list-style-type:lower-alpha;}& & &{list-style-type:lower-roman;}&{", ";}"], styledTools.theme('fannypack.List.ordered'));
var horizontalProperties = styled.css(["& li{display:inline-block;margin-right:1rem;margin-bottom:unset;}&{", ";}"], styledTools.theme('fannypack.List.horizontal'));
var ListItem = styled.default(Box).withConfig({
  displayName: "styled__ListItem",
  componentId: "wo6si3-0"
})(["margin-bottom:0.2rem;&{", ";}"], styledTools.theme('fannypack.List.item.base'));
var _List = styled.default(List).withConfig({
  displayName: "styled",
  componentId: "wo6si3-1"
})(["list-style:unset;list-style-type:none;&:not(:last-child){margin-bottom:", "rem;}& &{margin-left:", "rem;}&{", ";}&{", ";}&{", ";}"], styled.space(4), styled.space(4), function (props) {
  return props.isOrdered && orderedProperties;
}, function (props) {
  return props.isHorizontal && horizontalProperties;
}, styledTools.theme('fannypack.List.base'));

var ListItem$1 = function ListItem$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "className"]);

  return React.createElement(ListItem, __chunk_1._extends({
    use: "li",
    className: className
  }, props), children);
};
ListItem$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string
};
ListItem$1.defaultProps = {
  className: undefined
};
var C = ListItem$1;

var List$1 = function List$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isOrdered = _ref.isOrdered,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "className", "isOrdered"]);

  return React.createElement(_List, __chunk_1._extends({
    use: isOrdered ? 'ol' : undefined,
    className: className,
    isOrdered: isOrdered
  }, props), children);
};
List$1.Item = C;
List$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isOrdered: PropTypes.bool,
  isHorizontal: PropTypes.bool
};
List$1.defaultProps = {
  className: undefined,
  isOrdered: false,
  isHorizontal: false
};
var C$1 = List$1;

exports.List = C$1;
exports.ListItem = C;
exports.default = C$1;
