'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var Text = require('./Text.js');
var Heading = require('./Heading.js');
var Blockquote = require('./Blockquote.js');
var List = require('./List.js');
var Link = require('./Link.js');
var Divider = require('./Divider.js');
var Image = require('./Image.js');
var MarkdownRenderer = _interopDefault(require('markdown-react-js'));
var Paragraph = require('./Paragraph.js');
var Table = require('./Table.js');
var React = require('react');
var React__default = _interopDefault(React);
var _get = _interopDefault(require('lodash/get'));
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('./styled.js');
require('reakit/styled');
require('styled-tools');
require('./chunk-ab4246ea.js');
require('reakit/Heading');
require('classnames');
require('reakit/Blockquote');
require('polished');
require('reakit/List');
require('./chunk-36150710.js');
require('reakit/Link');
require('reakit/Divider');
require('reakit/Image');
require('reakit/Paragraph');
require('conditional-wrap');

var tags = function tags(props) {
  return {
    p: {
      Component: Paragraph.Paragraph,
      props: _get(props, 'elementProps.p', {})
    },
    strong: {
      Component: Text.Text,
      props: __chunk_1._objectSpread({
        fontWeight: 'bold'
      }, _get(props, 'elementProps.strong', {}))
    },
    em: {
      Component: Text.Text,
      props: __chunk_1._objectSpread({
        use: 'em'
      }, _get(props, 'elementProps.em', {}))
    },
    a: {
      Component: Link.Link,
      props: _get(props, 'elementProps.a', {})
    },
    blockquote: {
      Component: Blockquote.Blockquote,
      props: _get(props, 'elementProps.blockquote', {})
    },
    h1: {
      Component: Heading.Heading,
      props: __chunk_1._objectSpread({
        use: 'h1'
      }, _get(props, 'elementProps.h1', {}))
    },
    h2: {
      Component: Heading.Heading,
      props: __chunk_1._objectSpread({
        use: 'h2'
      }, _get(props, 'elementProps.h2', {}))
    },
    h3: {
      Component: Heading.Heading,
      props: __chunk_1._objectSpread({
        use: 'h3'
      }, _get(props, 'elementProps.h3', {}))
    },
    h4: {
      Component: Heading.Heading,
      props: __chunk_1._objectSpread({
        use: 'h4'
      }, _get(props, 'elementProps.h4', {}))
    },
    h5: {
      Component: Heading.Heading,
      props: __chunk_1._objectSpread({
        use: 'h5'
      }, _get(props, 'elementProps.h5', {}))
    },
    h6: {
      Component: Heading.Heading,
      props: __chunk_1._objectSpread({
        use: 'h6'
      }, _get(props, 'elementProps.h6', {}))
    },
    hr: __chunk_1._objectSpread({
      Component: Divider.Divider
    }, _get(props, 'elementProps.hr', {})),
    ul: {
      Component: List.List,
      props: __chunk_1._objectSpread({
        listStyleType: 'disc',
        listStylePosition: 'inside'
      }, _get(props, 'elementProps.ul', {}))
    },
    ol: {
      Component: List.List,
      props: __chunk_1._objectSpread({
        isOrdered: true,
        listStylePosition: 'inside'
      }, _get(props, 'elementProps.ol', {}))
    },
    li: {
      Component: List.List.Item,
      props: _get(props, 'elementProps.li', {})
    },
    table: {
      Component: Table.default,
      props: _get(props, 'elementProps.table', {})
    },
    tbody: {
      Component: Table.default.Body,
      props: _get(props, 'elementProps.tbody', {})
    },
    thead: {
      Component: Table.default.Head,
      props: _get(props, 'elementProps.thead', {})
    },
    tfoot: {
      Component: Table.default.Foot,
      props: _get(props, 'elementProps.tfoot', {})
    },
    tr: {
      Component: Table.default.Row,
      props: _get(props, 'elementProps.tr', {})
    },
    td: {
      Component: Table.default.Cell,
      props: _get(props, 'elementProps.td', {})
    },
    th: {
      Component: Table.default.HeadCell,
      props: _get(props, 'elementProps.th', {})
    },
    img: {
      Component: Image.Image,
      props: _get(props, 'elementProps.img', {})
    }
  };
};

var Markdown =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(Markdown, _React$Component);

  function Markdown() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleIterate", function (Tag, props, children) {
      var _ref = tags(_this.props)[Tag] || {
        Component: Tag
      },
          Component = _ref.Component,
          _ref$props = _ref.props,
          overrideProps = _ref$props === void 0 ? {} : _ref$props;

      return (// @ts-ignore
        React.createElement(Component, __chunk_1._extends({}, props, overrideProps || {}), children)
      );
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var _this$props = _this.props,
          content = _this$props.content,
          props = __chunk_1._objectWithoutPropertiesLoose(_this$props, ["content"]);

      return React.createElement(Box, props, React.createElement(MarkdownRenderer, {
        onIterate: _this.handleIterate,
        text: content
      }));
    });

    return _this;
  }

  return Markdown;
}(React.Component);

__chunk_1._defineProperty(Markdown, "propTypes", {
  content: PropTypes.string.isRequired,
  elementProps: PropTypes.object
});

__chunk_1._defineProperty(Markdown, "defaultProps", {
  elementProps: {}
});

var C = Markdown;

exports.default = C;
exports.Markdown = C;
