'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var __chunk_6 = require('./chunk-f77e63ff.js');
var Navigation = require('./Navigation-ddd17e18.js');
var Popover = require('./Popover-fc2eeb99.js');
var __chunk_18 = require('./chunk-55feb281.js');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
require('./styled.js');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./types.js');
require('./chunk-cb567965.js');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('reakit/Box');
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('airbnb-prop-types');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('reakit/Navigation');
require('./VisuallyHidden.js');
require('./chunk-235bc185.js');
require('focus-trap');
require('reakit/Popover');
require('./chunk-d538c3df.js');
require('./chunk-fdbfe348.js');
require('./chunk-1c9fbb5b.js');
require('lodash/omit');
require('./Divider.js');
require('reakit/Divider');

var KEYS = {
  UP: 38,
  DOWN: 40,
  TAB: 9,
  SPACE: 32
};
var MenuButton =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(MenuButton, _React$Component);

  function MenuButton() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleKeyDown", function (e) {
      var _this$props = _this.props,
          context = _this$props.context,
          isVisible = _this$props.isVisible;

      if (!isVisible) {
        if (e.keyCode === KEYS.DOWN || e.keyCode === KEYS.TAB || e.keyCode === KEYS.SPACE || e.keyCode === KEYS.UP) {
          e.preventDefault();
          context && context.handleMenuOpenViaKeyboard({
            startAt: e.keyCode === KEYS.UP ? 'last' : 'first'
          });
        }
      }
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var _this$props2 = _this.props,
          context = _this$props2.context,
          props = __chunk_1._objectWithoutPropertiesLoose(_this$props2, ["context"]);

      return React.createElement(__chunk_18.MenuButton, __chunk_1._extends({
        "aria-haspopup": "menu",
        "aria-expanded": props.isVisible,
        onKeyDown: _this.handleKeyDown
      }, context, props, {
        type: "button"
      }));
    });

    return _this;
  }

  return MenuButton;
}(React.Component); // @ts-ignore

__chunk_1._defineProperty(MenuButton, "propTypes", __chunk_1._objectSpread({}, __chunk_6.buttonPropTypes, {
  onClick: PropTypes.func
}));

__chunk_1._defineProperty(MenuButton, "defaultProps", __chunk_1._objectSpread({}, __chunk_6.buttonDefaultProps));

var C = __chunk_18.withMenuContext(MenuButton);

var MenuDivider = function MenuDivider(_ref) {
  var props = __chunk_1._extends({}, _ref);

  return React.createElement(__chunk_18.MenuDivider, __chunk_1._extends({
    role: "separator"
  }, props));
};
MenuDivider.propTypes = {};
MenuDivider.defaultProps = {};
var C$1 = MenuDivider;

var MenuGroup = function MenuGroup(_ref) {
  var children = _ref.children,
      title = _ref.title,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "title"]);

  return React.createElement(__chunk_18.MenuGroup, props, title && React.createElement(__chunk_18.MenuGroupTitle, null, title), children);
};
MenuGroup.propTypes = {
  children: PropTypes.node.isRequired,
  title: PropTypes.string
};
MenuGroup.defaultProps = {};
var C$2 = MenuGroup;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Component = function (_React$Component) {
  _inherits(Component, _React$Component);

  function Component() {
    var _temp, _this, _ret;

    _classCallCheck(this, Component);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  Component.prototype.getArgs = function getArgs() {
    var state = this.state,
        props = this.props,
        setState = this._setState,
        forceUpdate = this._forceUpdate;

    return {
      state: state,
      props: props,
      setState: setState,
      forceUpdate: forceUpdate
    };
  };

  Component.prototype.componentDidMount = function componentDidMount() {
    if (this.props.didMount) this.props.didMount(this.getArgs());
  };

  Component.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    if (this.props.shouldUpdate) return this.props.shouldUpdate({
      props: this.props,
      state: this.state,
      nextProps: nextProps,
      nextState: nextState
    });else return true;
  };

  Component.prototype.componentWillUnmount = function componentWillUnmount() {
    if (this.props.willUnmount) this.props.willUnmount({
      state: this.state,
      props: this.props
    });
  };

  Component.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (this.props.didUpdate) this.props.didUpdate(Object.assign(this.getArgs(), {
      prevProps: prevProps,
      prevState: prevState
    }));
  };

  Component.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        render = _props.render;

    return children ? typeof children === 'function' ? children(this.getArgs()) : children : render ? render(this.getArgs()) : null;
  };

  return Component;
}(React__default.Component);

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.state = this.props.initialState;

  this._setState = function () {
    return _this2.setState.apply(_this2, arguments);
  };

  this._forceUpdate = function () {
    return _this2.forceUpdate.apply(_this2, arguments);
  };
};

var MenuPopover =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(MenuPopover, _React$Component);

  function MenuPopover() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var _this$props = _this.props,
          children = _this$props.children,
          props = __chunk_1._objectWithoutPropertiesLoose(_this$props, ["children"]);

      return React.createElement(__chunk_18.MenuContext.Provider, null, React.createElement(__chunk_18.MenuPopover, __chunk_1._extends({}, props, {
        gutter: 6,
        placement: "bottom-start"
      }), function (popover) {
        return React.createElement(__chunk_18.MenuContext.Consumer, null, function (_ref) {
          var setPopoverProps = _ref.setPopoverProps;
          return React.createElement(Component, {
            initialState: {
              isVisible: popover.isVisible
            } // @ts-ignore
            ,
            didMount: function didMount(_ref2) {
              var setState = _ref2.setState;
              setState({
                isVisible: popover.isVisible
              });
              setPopoverProps && setPopoverProps(popover);
            } // @ts-ignore
            ,
            didUpdate: function didUpdate(_ref3) {
              var isVisible = _ref3.state.isVisible,
                  setState = _ref3.setState;

              if (popover.isVisible !== isVisible) {
                setState({
                  isVisible: popover.isVisible
                });
                setPopoverProps && setPopoverProps(popover);
              }
            }
          }, function () {
            return children;
          });
        });
      }));
    });

    return _this;
  }

  return MenuPopover;
}(React.Component); // @ts-ignore

__chunk_1._defineProperty(MenuPopover, "propTypes", __chunk_1._objectSpread({}, Popover.popoverPropTypes, {
  children: PropTypes.node.isRequired
}));

__chunk_1._defineProperty(MenuPopover, "defaultProps", __chunk_1._objectSpread({}, Popover.popoverDefaultProps));

var C$3 = MenuPopover;

var KEYS$1 = {
  UP: 38,
  DOWN: 40,
  LEFT: 37,
  RIGHT: 39,
  HOME: 36,
  END: 35,
  FNUP: 33,
  FNDOWN: 34
};
var Menu =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(Menu, _React$Component);

  function Menu() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "menu", React.createRef());

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "state", {
      activeItemIndex: -1
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "componentDidUpdate", function (prevProps) {
      var _this$props = _this.props,
          context = _this$props.context,
          setInitialFocus = _this$props.setInitialFocus;
      var prevContext = prevProps.context;

      if (setInitialFocus && context && prevContext && context.isVisible !== prevContext.isVisible) {
        var menuItems = _this.menu.current && _this.menu.current.querySelectorAll('[role=menuitem]:not(:disabled)') || [];
        var startAtFirst = !context.startAt || context.startAt === 'first';
        requestAnimationFrame(function () {
          var focusedItem = menuItems[startAtFirst ? 0 : menuItems.length - 1];

          if (focusedItem) {
            // @ts-ignore
            focusedItem.focus();
          }
        });
      }
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleKeyDown", function (e) {
      var prevActiveItemIndex = _this.state.activeItemIndex;
      var menuItems = _this.menu.current && _this.menu.current.querySelectorAll('[role=menuitem]:not(:disabled)') || [];

      if (Object.values(KEYS$1).some(function (key) {
        return e.keyCode === key;
      })) {
        var _activeItemIndex = prevActiveItemIndex;
        e.preventDefault();

        if (e.keyCode === KEYS$1.DOWN || e.keyCode === KEYS$1.RIGHT) {
          _activeItemIndex = prevActiveItemIndex + 1;

          if (_activeItemIndex >= menuItems.length) {
            _activeItemIndex = 0;
          }
        } else if (e.keyCode === KEYS$1.UP || e.keyCode === KEYS$1.LEFT) {
          _activeItemIndex = prevActiveItemIndex - 1;

          if (_activeItemIndex < 0) {
            _activeItemIndex = menuItems.length - 1;
          }
        } else if (e.keyCode === KEYS$1.HOME || e.keyCode === KEYS$1.FNUP) {
          _activeItemIndex = 0;
        } else if (e.keyCode === KEYS$1.END || e.keyCode === KEYS$1.FNDOWN) {
          _activeItemIndex = menuItems.length - 1;
        }

        if (_activeItemIndex > -1 && menuItems[_activeItemIndex]) {
          // @ts-ignore
          menuItems[_activeItemIndex].focus();

          _this.setState({
            activeItemIndex: _activeItemIndex
          });
        }
      }
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleFocus", function () {
      var setInitialFocus = _this.props.setInitialFocus;
      var menuItems = _this.menu.current && _this.menu.current.querySelectorAll('[role=menuitem]') || [];
      var activeItemIndex = setInitialFocus ? 0 : -1; // @ts-ignore

      menuItems.forEach(function (item, i) {
        if (document.activeElement && document.activeElement.isEqualNode(item)) {
          activeItemIndex = i;
        }
      });

      _this.setState({
        activeItemIndex: activeItemIndex
      });
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          isHorizontal = _this$props2.isHorizontal,
          props = __chunk_1._objectWithoutPropertiesLoose(_this$props2, ["children", "isHorizontal"]);

      return React.createElement(__chunk_18._Menu, __chunk_1._extends({
        elementRef: _this.menu,
        role: "menu",
        "aria-orientation": isHorizontal ? 'horizontal' : 'vertical',
        isHorizontal: isHorizontal,
        onKeyDown: _this.handleKeyDown,
        onFocus: _this.handleFocus
      }, props), children);
    });

    return _this;
  }

  return Menu;
}(React.Component); // @ts-ignore

__chunk_1._defineProperty(Menu, "propTypes", __chunk_1._objectSpread({}, Navigation.navigationPropTypes, {
  children: PropTypes.node.isRequired,
  isHorizontal: PropTypes.bool
}));

__chunk_1._defineProperty(Menu, "defaultProps", __chunk_1._objectSpread({}, Navigation.navigationDefaultProps, {
  isHorizontal: false,
  setInitialFocus: true
}));

var C$4 = __chunk_18.withMenuContext(Menu);
C$4.Button = C;
C$4.Divider = C$1;
C$4.Group = C$2;
C$4.Item = __chunk_18.MenuItem;
C$4.Popover = C$3;

exports.default = C$4;
exports.Menu = C$4;
exports.MenuDivider = C$1;
exports.MenuGroup = C$2;
exports.MenuItem = __chunk_18.MenuItem;
exports.MenuButton = C;
exports.MenuPopover = C$3;
