'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var VisuallyHidden = require('./VisuallyHidden.js');
var __chunk_15 = require('./chunk-235bc185.js');
var Popover = _interopDefault(require('reakit/Popover'));
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var __chunk_6 = require('./chunk-f77e63ff.js');
var __chunk_3 = require('./chunk-cb567965.js');
var Box = _interopDefault(require('reakit/Box'));
var InlineBlock = _interopDefault(require('reakit/InlineBlock'));
var __chunk_9 = require('./chunk-d538c3df.js');
require('reakit/Block');
require('reakit/Inline');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('airbnb-prop-types');
require('./chunk-fdbfe348.js');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('./chunk-1c9fbb5b.js');
require('lodash/omit');

var PopoverContainer = function PopoverContainer(_ref) {
  var children = _ref.children,
      defaultVisible = _ref.defaultVisible,
      initialState = _ref.initialState,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "defaultVisible", "initialState"]);

  return React.createElement(Popover.Container, __chunk_1._extends({
    initialState: __chunk_1._objectSpread({
      visible: defaultVisible
    }, initialState)
  }, props), function (_ref2) {
    var visible = _ref2.visible,
        rest = __chunk_1._objectWithoutPropertiesLoose(_ref2, ["visible"]);

    return children(__chunk_1._objectSpread({
      isVisible: visible
    }, rest));
  });
};
PopoverContainer.propTypes = {
  children: PropTypes.func.isRequired,
  defaultVisible: PropTypes.bool,
  initialState: PropTypes.object
};
PopoverContainer.defaultProps = {
  defaultVisible: false,
  initialState: {}
};

var PopoverHide = styled.default(Popover.Hide).withConfig({
  displayName: "styled__PopoverHide",
  componentId: "sc-12khuk0-0"
})(["", ";"], styled.theme('fannypack.Popover.Hide.base'));
var PopoverShow = styled.default(Popover.Show).withConfig({
  displayName: "styled__PopoverShow",
  componentId: "sc-12khuk0-1"
})(["", ";"], styled.theme('fannypack.Popover.Show.base'));
var PopoverToggle = styled.default(Popover.Toggle).withConfig({
  displayName: "styled__PopoverToggle",
  componentId: "sc-12khuk0-2"
})(["", ";"], styled.theme('fannypack.Popover.Toggle.base'));
var PopoverClose = styled.default(__chunk_6.Button).withConfig({
  displayName: "styled__PopoverClose",
  componentId: "sc-12khuk0-3"
})(["position:absolute;width:24px;height:24px;right:0;top:0;padding:0px;text-align:right;", ";"], styled.theme('fannypack.Popover.Close.base'));
var _Popover = styled.default(Popover).withConfig({
  displayName: "styled",
  componentId: "sc-12khuk0-4"
})(["display:block;padding:", "rem;", ";"], styled.space(5), styled.theme('fannypack.Popover.base'));

var PopoverHide$1 = React.forwardRef(function (_ref, ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return (// @ts-ignore
    React.createElement(PopoverHide, __chunk_1._extends({}, props, {
      ref: ref
    }), children)
  );
});
PopoverHide$1.propTypes = {
  children: PropTypes.node.isRequired,
  hide: PropTypes.func.isRequired,
  onClick: PropTypes.func
};
PopoverHide$1.defaultProps = {
  onClick: undefined
};
var C = PopoverHide$1;

var PopoverClose$1 = function PopoverClose$$1(props) {
  return React.createElement(PopoverClose, __chunk_1._extends({
    use: C,
    size: "small",
    kind: "link"
  }, props), React.createElement(VisuallyHidden.default, null, "Close"), React.createElement(__chunk_3.Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
PopoverClose$1.propTypes = {
  hide: PropTypes.func.isRequired
};
PopoverClose$1.defaultProps = {}; // @ts-ignore

var C$1 = PopoverClose$1;

var PopoverPopover = function PopoverPopover(_ref) {
  var children = _ref.children,
      isVisible = _ref.isVisible,
      trapFocus = _ref.trapFocus,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "isVisible", "trapFocus"]);

  return React.createElement(_Popover, __chunk_1._extends({
    visible: isVisible
  }, props), trapFocus ? React.createElement(__chunk_15.TrapFocus, {
    isActive: isVisible
  }, function (_ref2) {
    var fallbackFocusRef = _ref2.fallbackFocusRef,
        initialFocusRef = _ref2.initialFocusRef;
    return React.createElement(Box, {
      elementRef: fallbackFocusRef
    }, __chunk_15.isFunction(children) ? children({
      initialFocusRef: initialFocusRef
    }) : children);
  }) : __chunk_15.isFunction(children) ? children({}) : children);
};
var popoverPopoverPropTypes = __chunk_1._objectSpread({
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
  className: PropTypes.string,
  isVisible: PropTypes.bool,
  flip: PropTypes.bool,
  gutter: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  placement: types.placementPropType,
  shift: PropTypes.bool,
  trapFocus: PropTypes.bool
}, types.animatePropTypes, types.restrictHidePropTypes);
PopoverPopover.propTypes = popoverPopoverPropTypes;
var popoverPopoverDefaultProps = __chunk_1._objectSpread({
  className: undefined,
  flip: true,
  gutter: 12,
  isVisible: false,
  placement: 'bottom',
  shift: true,
  trapFocus: false
}, types.animateDefaultProps, types.restrictDefaultProps, {
  hideOnEsc: true,
  hideOnClickOutside: true
});
PopoverPopover.defaultProps = popoverPopoverDefaultProps;
var C$2 = PopoverPopover;

var PopoverShow$1 = function PopoverShow$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(PopoverShow, props, children);
};
PopoverShow$1.propTypes = {
  children: PropTypes.node.isRequired,
  onClick: PropTypes.func,
  show: PropTypes.func.isRequired
};
PopoverShow$1.defaultProps = {
  onClick: undefined
};
var C$3 = PopoverShow$1;

var PopoverToggle$1 = function PopoverToggle$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(PopoverToggle, props, children);
};
PopoverToggle$1.propTypes = {
  children: PropTypes.node.isRequired,
  onClick: PropTypes.func,
  toggle: PropTypes.func.isRequired
};
PopoverToggle$1.defaultProps = {
  onClick: undefined
};
var C$4 = PopoverToggle$1;

var Popover$1 = function Popover$$1(_ref) {
  var children = _ref.children,
      content = _ref.content,
      showCloseButton = _ref.showCloseButton,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "content", "showCloseButton"]);

  return React.createElement(PopoverContainer, null, function (popover) {
    return React.createElement(InlineBlock, {
      relative: true
    }, __chunk_15.isFunction(children) ?
    /*
    // @ts-ignore */
    children(__chunk_1._objectSpread({
      use: C$4
    }, popover)) : children ? React.cloneElement(children, __chunk_1._objectSpread({
      use: C$4
    }, popover)) : null, React.createElement(C$2, __chunk_1._extends({
      elevation: "200"
    }, props, popover, {
      use: __chunk_9.Pane
    }), function (_ref2) {
      var initialFocusRef = _ref2.initialFocusRef;
      return React.createElement(React.Fragment, null, showCloseButton && React.createElement(C$1, __chunk_1._extends({
        elementRef: initialFocusRef
      }, popover)), typeof content === 'function' ? content(__chunk_1._objectSpread({
        initialFocusRef: initialFocusRef
      }, popover)) : content);
    }));
  });
};
Popover$1.Popover = C$2;
Popover$1.Container = PopoverContainer;
Popover$1.Close = C$1;
Popover$1.Hide = C;
Popover$1.Show = C$3;
Popover$1.Toggle = C$4;
var popoverPropTypes = __chunk_1._objectSpread({}, popoverPopoverPropTypes, {
  className: PropTypes.string,
  content: PropTypes.oneOfType([PropTypes.string, PropTypes.element, PropTypes.func]),
  showCloseButton: PropTypes.bool,
  children: PropTypes.oneOfType([PropTypes.element, PropTypes.func]).isRequired
});
Popover$1.propTypes = popoverPropTypes;
var popoverDefaultProps = __chunk_1._objectSpread({}, popoverPopoverDefaultProps, {
  className: undefined,
  showCloseButton: false,
  children: undefined
});
Popover$1.defaultProps = popoverDefaultProps; // @ts-ignore

var C$5 = Popover$1;

exports.Popover = C$5;
exports.popoverPropTypes = popoverPropTypes;
exports.popoverDefaultProps = popoverDefaultProps;
exports.PopoverContainer = PopoverContainer;
exports.PopoverPopover = C$2;
exports.PopoverShow = C$3;
exports.PopoverHide = C;
exports.PopoverToggle = C$4;
exports.PopoverClose = C$1;
