'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Text = require('./Text.js');
var __chunk_12 = require('./chunk-265a0d76.js');
var __chunk_13 = require('./chunk-fb522222.js');
var Label = _interopDefault(require('reakit/Label'));
var _omit = _interopDefault(require('lodash/omit'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./chunk-ab4246ea.js');
require('reakit/Input');
require('./Label.js');
require('reakit/Field');

var RadioIcon = styled.default(Box).withConfig({
  displayName: "styled__RadioIcon",
  componentId: "sc-1viz9if-0"
})(["border:1px solid #bdbdbd;box-shadow:inset 0px 1px 2px #e5e5e5;border-radius:100%;height:1em;position:relative;width:1em;&{", ";}&{", ";}"], function (props) {
  return props.state && styled.css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
    return styledTools.palette("" + props.state)(props);
  }, function (props) {
    return styledTools.palette("" + props.state)(props);
  });
}, styledTools.theme('fannypack.Radio.base'));
var HiddenRadio = __chunk_12.HiddenInput({
  Icon: RadioIcon,
  checkedIconCss: styled.css(["background:", ";border-radius:50%;content:'';height:0.5em;left:50%;position:absolute;top:50%;transform:translate(-50%,-50%);width:0.5em;"], styledTools.palette('primary')),
  disabledCheckedIconCss: styled.css(["background:", ";"], styledTools.palette('gray300')),
  themePrefix: 'Radio'
});
var Radio = styled.default(Label).withConfig({
  displayName: "styled__Radio",
  componentId: "sc-1viz9if-1"
})(["display:flex;align-items:center;&{", ";}"], styledTools.theme('fannypack.Radio.label'));
var horizontalProperties = styled.css(["display:flex;& ", ":not(:last-child){margin-right:1rem;margin-bottom:unset;}&{", ";}"], Radio, styledTools.theme('fannypack.RadioGroup.horizontal'));
var RadioGroup = styled.default(Box).withConfig({
  displayName: "styled__RadioGroup",
  componentId: "sc-1viz9if-2"
})(["& ", ":not(:last-child){margin-bottom:0.5rem;}&{", ";}"], Radio, function (props) {
  return props.isHorizontal && horizontalProperties;
});

var Radio$1 = function Radio$$1(_ref) {
  var a11yId = _ref.a11yId,
      autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      isRequired = _ref.isRequired,
      label = _ref.label,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      state = _ref.state,
      value = _ref.value,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yId", "autoFocus", "checked", "className", "defaultChecked", "disabled", "isRequired", "label", "onBlur", "onChange", "onFocus", "name", "state", "value"]);

  return React.createElement(Radio, __chunk_1._extends({
    "aria-describedby": "label",
    "aria-invalid": state === 'danger',
    "aria-label": label,
    "aria-required": isRequired
  }, props), React.createElement(HiddenRadio, {
    autoFocus: autoFocus,
    checked: checked,
    defaultChecked: defaultChecked,
    disabled: disabled,
    id: a11yId,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    name: name,
    state: state,
    type: "radio",
    value: value
  }), React.createElement(RadioIcon, {
    state: state
  }), React.createElement(Text.Text, {
    id: "label",
    htmlFor: a11yId,
    marginLeft: "minor-2"
  }, label));
};
Radio$1.propTypes = {
  a11yId: PropTypes.string,
  autoFocus: PropTypes.bool,
  checked: PropTypes.oneOfType([PropTypes.bool, PropTypes.string]),
  className: PropTypes.string,
  defaultChecked: PropTypes.bool,
  disabled: PropTypes.bool,
  isRequired: PropTypes.bool,
  label: PropTypes.string.isRequired,
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func,
  name: PropTypes.string,
  state: PropTypes.string,
  value: PropTypes.string
};
Radio$1.defaultProps = {
  a11yId: undefined,
  autoFocus: false,
  checked: undefined,
  className: undefined,
  defaultChecked: undefined,
  disabled: false,
  isRequired: false,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  name: undefined,
  state: undefined,
  value: undefined
}; // @ts-ignore

var C = Radio$1;

var RadioGroup$1 = function RadioGroup$$1(_ref) {
  var a11yId = _ref.a11yId,
      a11yLabel = _ref.a11yLabel,
      className = _ref.className,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      onChange = _ref.onChange,
      options = _ref.options,
      name = _ref.name,
      state = _ref.state,
      value = _ref.value,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yId", "a11yLabel", "className", "defaultValue", "disabled", "onChange", "options", "name", "state", "value"]);

  return React.createElement(RadioGroup, __chunk_1._extends({
    "aria-describedby": "label",
    "aria-invalid": state === 'danger',
    "aria-label": a11yLabel,
    role: "group"
  }, props), options.map(function (option, i) {
    return React.createElement(C, {
      key: i // eslint-disable-line
      ,
      a11yId: a11yId,
      checked: typeof value === 'undefined' ? undefined : option.value === value,
      defaultChecked: typeof defaultValue === 'undefined' ? undefined : option.value === defaultValue,
      disabled: disabled || option.disabled,
      name: name,
      label: option.label,
      onChange: onChange,
      state: state,
      value: option.value
    });
  }));
};
var radioGroupPropTypes = {
  a11yId: PropTypes.string,
  a11yLabel: PropTypes.string,
  className: PropTypes.string,
  defaultValue: PropTypes.string,
  disabled: PropTypes.bool,
  isHorizontal: PropTypes.bool,
  name: PropTypes.string.isRequired,
  options: PropTypes.array.isRequired,
  state: PropTypes.string,
  value: PropTypes.string,
  onChange: PropTypes.func
};
RadioGroup$1.propTypes = radioGroupPropTypes;
var radioGroupDefaultProps = {
  a11yId: undefined,
  a11yLabel: undefined,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  isHorizontal: false,
  onChange: undefined,
  state: undefined,
  value: undefined
};
RadioGroup$1.defaultProps = radioGroupDefaultProps; // @ts-ignore

var C$1 = RadioGroup$1;

var RadioGroupField = function RadioGroupField(_ref) {
  var a11yId = _ref.a11yId,
      a11yLabel = _ref.a11yLabel,
      className = _ref.className,
      defaultValue = _ref.defaultValue,
      description = _ref.description,
      disabled = _ref.disabled,
      hint = _ref.hint,
      isHorizontal = _ref.isHorizontal,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      label = _ref.label,
      name = _ref.name,
      onChange = _ref.onChange,
      options = _ref.options,
      state = _ref.state,
      validationText = _ref.validationText,
      value = _ref.value,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yId", "a11yLabel", "className", "defaultValue", "description", "disabled", "hint", "isHorizontal", "isOptional", "isRequired", "label", "name", "onChange", "options", "state", "validationText", "value"]);

  return React.createElement(__chunk_13.FieldWrapper, __chunk_1._extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return React.createElement(C$1, __chunk_1._extends({
      a11yId: a11yId,
      a11yLabel: a11yLabel,
      className: className,
      defaultValue: defaultValue,
      disabled: disabled,
      isHorizontal: isHorizontal,
      name: name,
      options: options,
      state: state,
      value: value,
      onChange: onChange
    }, elementProps));
  });
};
RadioGroupField.propTypes = __chunk_1._objectSpread({}, _omit(__chunk_13.fieldWrapperPropTypes, 'children'), radioGroupPropTypes);
RadioGroupField.defaultProps = __chunk_1._objectSpread({}, __chunk_13.fieldWrapperDefaultProps, radioGroupDefaultProps); // @ts-ignore

var C$2 = RadioGroupField;

exports.Radio = C;
exports.RadioGroup = C$1;
exports.RadioGroupField = C$2;
exports.default = C;
