'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Spinner = require('./Spinner.js');
var __chunk_4 = require('./chunk-36150710.js');
var __chunk_13 = require('./chunk-fb522222.js');
var Group = require('./Group.js');
var ConditionalWrap = _interopDefault(require('conditional-wrap'));
var Input = _interopDefault(require('reakit/Input'));
var _omit = _interopDefault(require('lodash/omit'));
var polished = require('polished');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
require('reakit/Box');
require('reakit/Block');
require('reakit/Inline');
var InlineBlock = _interopDefault(require('reakit/InlineBlock'));
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./Text.js');
require('./chunk-ab4246ea.js');
require('./Label.js');
require('reakit/Label');
require('reakit/Field');
require('./types.js');
require('reakit/Group');

var defaultPalette = __chunk_4._defaultPalette({});

var Icon = styled.default.svg.withConfig({
  displayName: "styled__Icon",
  componentId: "sc-1acvgnh-0"
})(["position:absolute;width:20px;height:20px;right:2px;z-index:1;fill:", ";transform:translateY(50%);"], styledTools.palette('text'));
var LoadingSpinner = styled.default(Spinner.Spinner).withConfig({
  displayName: "styled__LoadingSpinner",
  componentId: "sc-1acvgnh-1"
})(["position:absolute;width:15px;height:15px;top:12px;right:7px;z-index:1;"]);
var sizeProperties = {
  small: styled.css(["font-size:0.8rem;& + ", "{width:15px;height:15px;}& + ", "{width:10px;height:10px;top:10px;}&{", ";}"], Icon, LoadingSpinner, styledTools.theme('fannypack.Select.sizes.small')),
  medium: styled.css(["font-size:1.25rem;& + ", "{width:25px;height:25px;}& + ", "{width:20px;height:20px;top:15px;right:10px;}&{", ";}"], Icon, LoadingSpinner, styledTools.theme('fannypack.Select.sizes.medium')),
  large: styled.css(["font-size:1.5rem;& + ", "{width:30px;height:30px;}& + ", "{width:25px;height:25px;top:16px;right:12px;}&{", ";}"], Icon, LoadingSpinner, styledTools.theme('fannypack.Select.sizes.large'))
};
var stateProperties = styled.css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
  return styledTools.palette("" + props.state)(props);
}, function (props) {
  return styledTools.palette("" + props.state)(props);
});
var _Select = styled.default(Input).withConfig({
  displayName: "styled",
  componentId: "sc-1acvgnh-2"
})(["appearance:none;background:linear-gradient(rgb(255,255,255),rgb(249,250,251));border:1px solid #bdbdbd;border-radius:0.2em;color:", ";height:2.5em;padding:0.4em 1.4em 0.4em 0.6em;line-height:1.5;width:100%;&[disabled]{background:", ";box-shadow:unset;color:", ";&{", ";}}&[disabled] + ", "{fill:", ";}&:focus{outline:unset;z-index:2;border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;&{", ";}}&{", ";}&{", ";}", ";"], function (props) {
  return props.isPlaceholderSelected ? polished.tint(0.4, styledTools.palette('text', 0, defaultPalette.text)(props)) : styledTools.palette('text')(props);
}, styledTools.palette('white700'), styledTools.palette('gray400'), styledTools.theme('fannypack.Select.disabled'), Icon, styledTools.palette('gray400'), styledTools.palette('primary'), styledTools.palette('primary'), styledTools.theme('fannypack.Select.focus'), function (props) {
  return props.styledSize && sizeProperties[props.styledSize];
}, function (props) {
  return props.state && stateProperties;
}, styledTools.theme('fannypack.Select.base'));

var Icon$1 = (function () {
  return React.createElement(Icon, {
    viewBox: "0 0 20 20",
    focusable: "false",
    "aria-hidden": "true"
  }, React.createElement("path", {
    d: "M13 8l-3-3-3 3h6zm-.1 4L10 14.9 7.1 12h5.8z",
    fillRule: "evenodd"
  }));
});

var selectDefaultProps = {
  a11yId: undefined,
  a11yLabel: undefined,
  autoComplete: undefined,
  autoFocus: false,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  isFullWidth: false,
  isLoading: false,
  isRequired: false,
  name: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  placeholder: undefined,
  size: 'default',
  state: undefined,
  value: undefined
};
var selectPropTypes = {
  a11yId: PropTypes.string,
  a11yLabel: PropTypes.string,
  autoComplete: PropTypes.string,
  autoFocus: PropTypes.bool,
  className: PropTypes.string,
  defaultValue: PropTypes.string,
  disabled: PropTypes.bool,
  isFullWidth: PropTypes.bool,
  isLoading: PropTypes.bool,
  isRequired: PropTypes.bool,
  name: PropTypes.string,
  options: PropTypes.array.isRequired,
  placeholder: PropTypes.string,
  size: PropTypes.string,
  state: PropTypes.string,
  value: PropTypes.string,
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func
};
var Select =
/*#__PURE__*/
function (_React$PureComponent) {
  __chunk_1._inheritsLoose(Select, _React$PureComponent);

  function Select() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "state", {
      isPlaceholderSelected: Boolean(_this.props.placeholder)
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleChange", function (e) {
      var onChange = _this.props.onChange;

      _this.setState({
        isPlaceholderSelected: false
      });

      onChange && onChange(e);
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var _this$props = _this.props,
          a11yId = _this$props.a11yId,
          a11yLabel = _this$props.a11yLabel,
          autoComplete = _this$props.autoComplete,
          className = _this$props.className,
          autoFocus = _this$props.autoFocus,
          defaultValue = _this$props.defaultValue,
          disabled = _this$props.disabled,
          isFullWidth = _this$props.isFullWidth,
          isLoading = _this$props.isLoading,
          isRequired = _this$props.isRequired,
          name = _this$props.name,
          onBlur = _this$props.onBlur,
          onChange = _this$props.onChange,
          onFocus = _this$props.onFocus,
          options = _this$props.options,
          placeholder = _this$props.placeholder,
          size = _this$props.size,
          state = _this$props.state,
          value = _this$props.value,
          props = __chunk_1._objectWithoutPropertiesLoose(_this$props, ["a11yId", "a11yLabel", "autoComplete", "className", "autoFocus", "defaultValue", "disabled", "isFullWidth", "isLoading", "isRequired", "name", "onBlur", "onChange", "onFocus", "options", "placeholder", "size", "state", "value"]);

      var isPlaceholderSelected = _this.state.isPlaceholderSelected;
      return React.createElement(InlineBlock, __chunk_1._extends({
        relative: true,
        minWidth: "50px",
        width: isFullWidth ? '100%' : undefined
      }, props), React.createElement(_Select, {
        "aria-invalid": state === 'danger',
        "aria-label": a11yLabel,
        "aria-required": isRequired,
        use: "select",
        autoComplete: autoComplete,
        autoFocus: autoFocus,
        defaultValue: defaultValue || placeholder,
        disabled: disabled,
        id: a11yId,
        isFullWidth: isFullWidth,
        isPlaceholderSelected: isPlaceholderSelected,
        name: name,
        onBlur: onBlur,
        onChange: _this.handleChange,
        onFocus: onFocus,
        styledSize: size,
        state: state,
        value: value
      }, placeholder && React.createElement("option", {
        disabled: true
      }, placeholder), options.map(function (option, i) {
        return React.createElement("option", {
          key: i // eslint-disable-line
          ,
          disabled: disabled || option.disabled,
          value: option.value
        }, option.label);
      })), isLoading ? React.createElement(LoadingSpinner, {
        color: "text"
      }) : React.createElement(Icon$1, null));
    });

    return _this;
  }

  return Select;
}(React.PureComponent); // @ts-ignore

__chunk_1._defineProperty(Select, "defaultProps", selectDefaultProps);

__chunk_1._defineProperty(Select, "propTypes", selectPropTypes);

var C = Select;

var SelectField = function SelectField(_ref) {
  var a11yLabel = _ref.a11yLabel,
      a11yId = _ref.a11yId,
      addonBefore = _ref.addonBefore,
      addonAfter = _ref.addonAfter,
      autoComplete = _ref.autoComplete,
      autoFocus = _ref.autoFocus,
      className = _ref.className,
      description = _ref.description,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      hint = _ref.hint,
      isLoading = _ref.isLoading,
      isFullWidth = _ref.isFullWidth,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      isVertical = _ref.isVertical,
      label = _ref.label,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      options = _ref.options,
      placeholder = _ref.placeholder,
      size = _ref.size,
      state = _ref.state,
      validationText = _ref.validationText,
      value = _ref.value,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yLabel", "a11yId", "addonBefore", "addonAfter", "autoComplete", "autoFocus", "className", "description", "defaultValue", "disabled", "hint", "isLoading", "isFullWidth", "isOptional", "isRequired", "isVertical", "label", "name", "onBlur", "onChange", "onFocus", "options", "placeholder", "size", "state", "validationText", "value"]);

  return React.createElement(__chunk_13.FieldWrapper, __chunk_1._extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return React.createElement(ConditionalWrap, {
      condition: addonBefore || addonAfter,
      wrap: function wrap(children) {
        return React.createElement(Group.Group, {
          isVertical: isVertical
        }, children);
      }
    }, addonBefore, React.createElement(C, __chunk_1._extends({
      a11yId: a11yId,
      a11yLabel: a11yLabel,
      autoComplete: autoComplete,
      autoFocus: autoFocus,
      className: className,
      defaultValue: defaultValue,
      disabled: disabled,
      isFullWidth: isFullWidth,
      isLoading: isLoading,
      isRequired: isRequired,
      name: name,
      options: options,
      placeholder: placeholder,
      size: size,
      state: state,
      value: value,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus
    }, elementProps)), addonAfter);
  });
};
SelectField.propTypes = __chunk_1._objectSpread({
  addonBefore: PropTypes.element,
  addonAfter: PropTypes.element,
  isVertical: PropTypes.bool
}, _omit(__chunk_13.fieldWrapperPropTypes, 'children'), selectPropTypes);
SelectField.defaultProps = __chunk_1._objectSpread({
  addonBefore: undefined,
  addonAfter: undefined,
  isVertical: false
}, __chunk_13.fieldWrapperDefaultProps, selectDefaultProps); // @ts-ignore

var C$1 = SelectField;

exports.default = C;
exports.Select = C;
exports.SelectField = C$1;
