'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var sizes = {
  small: styled.css(["&{font-size:14px;border-width:2px;}&{", ";}"], styledTools.theme('fannypack.Spinner.sizes.small')),
  medium: styled.css(["&{font-size:28px;}&{", ";}"], styledTools.theme('fannypack.Spinner.sizes.medium')),
  large: styled.css(["&{font-size:36px;}&{", ";}"], styledTools.theme('fannypack.Spinner.sizes.large'))
};
var rotate = styled.keyframes(["from{transform:rotate(0deg);}to{transform:rotate(360deg);}"]);
var spinnerProperties = styled.css(["animation:", " 0.6s infinite linear;border:0.1em solid ", ";border-radius:100%;border-right-color:transparent;border-top-color:transparent;display:inline-block;height:1em;width:1em;position:relative;"], rotate, function (props) {
  return props.color ? styledTools.palette(props.color)(props) : null;
});
var _Spinner = styled.default(Box).withConfig({
  displayName: "styled",
  componentId: "v4xo8u-0"
})(["font-size:20px;", ";&{", ";}", ";"], spinnerProperties, styledTools.theme('fannypack.Spinner.base'), function (props) {
  return props.styledSize && sizes[props.styledSize];
});

var Spinner = function Spinner(_ref) {
  var className = _ref.className,
      color = _ref.color,
      size = _ref.size,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["className", "color", "size"]);

  return React.createElement(_Spinner, __chunk_1._extends({
    className: className,
    color: color,
    styledSize: size
  }, props));
};
Spinner.propTypes = {
  className: PropTypes.string,
  color: PropTypes.string,
  size: PropTypes.string
};
Spinner.defaultProps = {
  className: undefined,
  color: 'primary',
  size: 'default'
}; // @ts-ignore

var C = Spinner;

exports.Spinner = C;
exports.default = C;
