'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var __chunk_4 = require('./chunk-36150710.js');
var Text = require('./Text.js');
var __chunk_12 = require('./chunk-265a0d76.js');
var __chunk_13 = require('./chunk-fb522222.js');
var Label = _interopDefault(require('reakit/Label'));
var _omit = _interopDefault(require('lodash/omit'));
var polished = require('polished');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./chunk-ab4246ea.js');
require('reakit/Input');
require('./Label.js');
require('reakit/Field');

var defaultPalette = __chunk_4._defaultPalette({});

var SwitchIcon = styled.default(Box).withConfig({
  displayName: "styled__SwitchIcon",
  componentId: "ohpvlq-0"
})(["background-color:", ";border:1px solid #bdbdbd;border-radius:1em;height:1.5em;position:relative;width:3em;&{", ";}&{", ";}"], styledTools.palette('white700'), function (props) {
  return props.state && styled.css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
    return styledTools.palette("" + props.state);
  }, function (props) {
    return styledTools.palette("" + props.state);
  });
}, styledTools.theme('fannypack.Switch.base'));
var HiddenSwitch = __chunk_12.HiddenInput({
  Icon: SwitchIcon,
  checkedCss: styled.css(["background-color:", ";transition:all ease 0.2s;"], function (props) {
    return styledTools.palette(props.palette || 'primary');
  }),
  disabledCheckedCss: styled.css(["background-color:", ";border-color:", ";"], function (props) {
    return polished.tint(0.5, styledTools.palette(props.palette || 'primary', 0, defaultPalette.primary)(props));
  }, function (props) {
    return polished.tint(0.5, styledTools.palette(props.palette || 'primary', 0, defaultPalette.primary)(props));
  }),
  disabledUncheckedIconCss: styled.css(["background:", ";"], styledTools.palette('white700')),
  checkedIconCss: styled.css(["border-color:", ";left:1.7em;"], function (props) {
    return styledTools.palette(props.palette || 'primary', 0, defaultPalette.primary);
  }),
  disabledCheckedIconCss: styled.css(["border-color:", ";"], function (props) {
    return polished.tint(0.5, styledTools.palette(props.palette || 'primary', 0, defaultPalette.primary)(props));
  }),
  uncheckedIconCss: styled.css(["background:white;content:'';border-radius:100%;border:1px solid #bdbdbd;height:1em;width:1em;top:0.2em;left:0.2em;transition:all ease 0.2s;position:absolute;"]),
  themePrefix: 'Switch'
});
var _Switch = styled.default(Label).withConfig({
  displayName: "styled",
  componentId: "ohpvlq-1"
})(["align-items:center;cursor:", ";display:flex;&{", ";}"], function (props) {
  return props.disabled ? 'not-allowed' : 'pointer';
}, styledTools.theme('fannypack.Switch.label'));

var Switch = function Switch(_ref) {
  var autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      id = _ref.id,
      isRequired = _ref.isRequired,
      label = _ref.label,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      name = _ref.name,
      palette = _ref.palette,
      state = _ref.state,
      value = _ref.value,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["autoFocus", "checked", "className", "defaultChecked", "disabled", "id", "isRequired", "label", "onBlur", "onChange", "onFocus", "name", "palette", "state", "value"]);

  return React.createElement(_Switch, __chunk_1._extends({
    "aria-describedby": "label",
    "aria-invalid": state === 'danger',
    "aria-label": label,
    "aria-required": isRequired,
    disabled: disabled
  }, props), React.createElement(HiddenSwitch, {
    autoFocus: autoFocus,
    checked: checked,
    defaultChecked: defaultChecked,
    disabled: disabled,
    id: id,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    name: name,
    palette: palette,
    state: state,
    type: "checkbox",
    value: value
  }), React.createElement(SwitchIcon, {
    state: state
  }), label && React.createElement(Text.Text, {
    id: "label",
    htmlFor: id,
    marginLeft: "major-1"
  }, label));
};
var switchPropTypes = {
  autoFocus: PropTypes.bool,
  checked: PropTypes.bool,
  className: PropTypes.string,
  defaultChecked: PropTypes.bool,
  disabled: PropTypes.bool,
  id: PropTypes.string,
  isRequired: PropTypes.bool,
  label: PropTypes.string,
  name: PropTypes.string,
  palette: PropTypes.string,
  state: PropTypes.string,
  value: PropTypes.string,
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func
};
Switch.propTypes = switchPropTypes;
var switchDefaultProps = {
  autoFocus: false,
  checked: undefined,
  className: undefined,
  defaultChecked: undefined,
  disabled: false,
  id: undefined,
  isRequired: false,
  label: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  palette: undefined,
  name: undefined,
  state: undefined,
  value: undefined
};
Switch.defaultProps = switchDefaultProps;
var C = Switch;

var SwitchField = function SwitchField(_ref) {
  var a11yId = _ref.a11yId,
      description = _ref.description,
      hint = _ref.hint,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      label = _ref.label,
      switchLabel = _ref.switchLabel,
      state = _ref.state,
      validationText = _ref.validationText,
      autoFocus = _ref.autoFocus,
      checked = _ref.checked,
      className = _ref.className,
      defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      id = _ref.id,
      name = _ref.name,
      palette = _ref.palette,
      value = _ref.value,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yId", "description", "hint", "isOptional", "isRequired", "label", "switchLabel", "state", "validationText", "autoFocus", "checked", "className", "defaultChecked", "disabled", "id", "name", "palette", "value", "onBlur", "onChange", "onFocus"]);

  return React.createElement(__chunk_13.FieldWrapper, __chunk_1._extends({
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, props), function (_ref2) {
    var elementProps = _ref2.elementProps;
    return React.createElement(C, __chunk_1._extends({
      label: switchLabel,
      autoFocus: autoFocus,
      checked: checked,
      className: className,
      defaultChecked: defaultChecked,
      disabled: disabled,
      id: id,
      isRequired: isRequired,
      name: name,
      palette: palette,
      state: state,
      value: value,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus
    }, elementProps));
  });
};
SwitchField.propTypes = __chunk_1._objectSpread({
  a11yId: PropTypes.string,
  switchLabel: PropTypes.string
}, _omit(__chunk_13.fieldWrapperPropTypes, 'children'), switchPropTypes);
SwitchField.defaultProps = __chunk_1._objectSpread({
  a11yId: undefined,
  switchLabel: undefined
}, __chunk_13.fieldWrapperDefaultProps, switchDefaultProps); // @ts-ignore

var C$1 = SwitchField;

exports.Switch = C;
exports.SwitchField = C$1;
exports.default = C;
