'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var ConditionalWrap = _interopDefault(require('conditional-wrap'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
var InlineBlock = _interopDefault(require('reakit/InlineBlock'));
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var Caption = styled.default(Box).withConfig({
  displayName: "styled__Caption",
  componentId: "y1jyri-0"
})(["caption-side:", ";&{", ";}"], function (props) {
  return props.position;
}, styledTools.theme('fannypack.Table.Caption.base'));
var TableCell = styled.default(Box).withConfig({
  displayName: "styled__TableCell",
  componentId: "y1jyri-1"
})(["padding:", "rem;&{", ";}"], styledTools.theme('fannypack.Table.spacing'), styledTools.theme('fannypack.Table.Cell.base'));
var TableFoot = styled.default(Box).withConfig({
  displayName: "styled__TableFoot",
  componentId: "y1jyri-2"
})(["font-weight:bold;&{", ";}&{", ";}"], function (props) {
  return props.hasBorder && styled.css(["border-top:2px solid ", ";"], styledTools.theme('fannypack.Table.borderColor'));
}, styledTools.theme('fannypack.Table.Foot.base'));
var TableHead = styled.default(Box).withConfig({
  displayName: "styled__TableHead",
  componentId: "y1jyri-3"
})(["border:unset;&{", ";}&{", ";}"], function (props) {
  return props.hasBorder && styled.css(["border-bottom:2px solid ", ";"], styledTools.theme('fannypack.Table.borderColor'));
}, styledTools.theme('fannypack.Table.Head.base'));
var TableHeadCell = styled.default(Box).withConfig({
  displayName: "styled__TableHeadCell",
  componentId: "y1jyri-4"
})(["font-weight:bold;padding:", "rem;&{", ";}"], styledTools.theme('fannypack.Table.spacing'), styledTools.theme('fannypack.Table.HeadCell.base'));
var TableRow = styled.default(Box).withConfig({
  displayName: "styled__TableRow",
  componentId: "y1jyri-5"
})(["&{", ";}"], styledTools.theme('fannypack.Table.Row.base'));
var TableBody = styled.default(Box).withConfig({
  displayName: "styled__TableBody",
  componentId: "y1jyri-6"
})(["", ";&{", ";}"], function (props) {
  return props.hasBorders && styled.css(["& ", "{border-bottom:1px solid ", ";}"], TableRow, styledTools.theme('fannypack.Table.borderColor'));
}, styledTools.theme('fannypack.Table.Body.base'));
var fullWidthProperties = styled.css(["width:100%;"]);
var hoverableProperties = styled.css(["& ", " ", ":hover{background-color:", " !important;}"], TableBody, TableRow, styledTools.theme('fannypack.Table.hover.backgroundColor'));
var stripedProperties = styled.css(["& ", " ", ":nth-child(even){background-color:", ";}"], TableBody, TableRow, styledTools.theme('fannypack.Table.striped.backgroundColor'));
var _Table = styled.default(Box).withConfig({
  displayName: "styled",
  componentId: "y1jyri-7"
})(["border-collapse:collapse;border-spacing:0;text-align:left;&:not(:last-child){margin-bottom:", "rem;}&{", ";}&{", ";}&{", ";}&{", ";}"], styled.space(4), function (props) {
  return props.isFullWidth && fullWidthProperties;
}, function (props) {
  return props.isHoverable && hoverableProperties;
}, function (props) {
  return props.isStriped && stripedProperties;
}, styledTools.theme('fannypack.Table.base'));

var TableBody$1 = function TableBody$$1(_ref) {
  var children = _ref.children,
      hasBorders = _ref.hasBorders,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "hasBorders"]);

  return React.createElement(TableBody, __chunk_1._extends({
    use: "tbody",
    hasBorders: hasBorders
  }, props), children);
};
TableBody$1.propTypes = {
  children: PropTypes.node.isRequired,
  hasBorders: PropTypes.bool
};
TableBody$1.defaultProps = {
  hasBorders: false
};
var C = TableBody$1;

var TableCaption = function TableCaption(_ref) {
  var children = _ref.children,
      position = _ref.position,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "position"]);

  return React.createElement(Caption, __chunk_1._extends({
    use: "caption",
    position: position
  }, props), children);
};
TableCaption.propTypes = {
  children: PropTypes.node.isRequired,
  position: PropTypes.oneOf(['top', 'bottom'])
};
TableCaption.defaultProps = {
  position: 'top'
};
var C$1 = TableCaption;

var TableCell$1 = function TableCell$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(TableCell, __chunk_1._extends({
    use: "td"
  }, props), children);
};
TableCell$1.propTypes = {
  children: PropTypes.node
};
TableCell$1.defaultProps = {};
var C$2 = TableCell$1;

var TableFoot$1 = function TableFoot$$1(_ref) {
  var children = _ref.children,
      hasBorder = _ref.hasBorder,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "hasBorder"]);

  return React.createElement(TableFoot, __chunk_1._extends({
    use: "tfoot",
    hasBorder: hasBorder
  }, props), children);
};
TableFoot$1.propTypes = {
  children: PropTypes.node.isRequired,
  hasBorder: PropTypes.bool
};
TableFoot$1.defaultProps = {
  hasBorder: true
};
var C$3 = TableFoot$1;

var TableHead$1 = function TableHead$$1(_ref) {
  var children = _ref.children,
      hasBorder = _ref.hasBorder,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "hasBorder"]);

  return React.createElement(TableHead, __chunk_1._extends({
    use: "thead",
    hasBorder: hasBorder
  }, props), children);
};
TableHead$1.propTypes = {
  children: PropTypes.node.isRequired,
  hasBorder: PropTypes.bool
};
TableHead$1.defaultProps = {
  hasBorder: true
};
var C$4 = TableHead$1;

var TableHeadCell$1 = function TableHeadCell$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(TableHeadCell, __chunk_1._extends({
    use: "th"
  }, props), children);
};
TableHeadCell$1.propTypes = {
  children: PropTypes.node
};
TableHeadCell$1.defaultProps = {};
var C$5 = TableHeadCell$1;

var TableRow$1 = function TableRow$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(TableRow, __chunk_1._extends({
    use: "tr"
  }, props), children);
};
TableRow$1.propTypes = {
  children: PropTypes.node.isRequired
};
TableRow$1.defaultProps = {};
var C$6 = TableRow$1;

var OuterBorder = styled.default(InlineBlock).withConfig({
  displayName: "Table__OuterBorder",
  componentId: "sc-1as57q1-0"
})(["border:1px solid ", ";border-radius:5px;padding:0.25rem 0.5rem;", ";"], styledTools.theme('fannypack.Table.borderColor'), function (props) {
  return props.isFullWidth && styled.css(["width:100%;"]);
});
var Table = function Table(_ref) {
  var a11yTitle = _ref.a11yTitle,
      children = _ref.children,
      hasBorder = _ref.hasBorder,
      isFullWidth = _ref.isFullWidth,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yTitle", "children", "hasBorder", "isFullWidth"]);

  return React.createElement(ConditionalWrap, {
    condition: hasBorder,
    wrap: function wrap(children) {
      return React.createElement(OuterBorder, {
        isFullWidth: isFullWidth
      }, children);
    }
  }, React.createElement(_Table, __chunk_1._extends({
    use: "table",
    "aria-label": a11yTitle,
    isFullWidth: isFullWidth
  }, props), children));
};
Table.Body = C;
Table.Caption = C$1;
Table.Cell = C$2;
Table.Foot = C$3;
Table.Head = C$4;
Table.HeadCell = C$5;
Table.Row = C$6;
Table.propTypes = {
  a11yTitle: PropTypes.string,
  children: PropTypes.node.isRequired,
  hasBorder: PropTypes.bool,
  isFullWidth: PropTypes.bool,
  isHoverable: PropTypes.bool,
  isStriped: PropTypes.bool
};
Table.defaultProps = {
  a11yTitle: undefined,
  hasBorder: false,
  isFullWidth: false,
  isHoverable: false,
  isStriped: false
};
var C$7 = Table;

exports.default = C$7;
exports.Table = C$7;
exports.TableBody = C;
exports.TableCaption = C$1;
exports.TableCell = C$2;
exports.TableFoot = C$3;
exports.TableHead = C$4;
exports.TableHeadCell = C$5;
exports.TableRow = C$6;
