'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Tabs = _interopDefault(require('reakit/Tabs'));
var classNames = _interopDefault(require('classnames'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
require('reakit/styled');
require('lodash/get');

var TabPanel = styled.default(Tabs.Panel).withConfig({
  displayName: "styled__TabPanel",
  componentId: "sc-1783spc-0"
})(["&{", ";}"], styledTools.theme('fannypack.Tabs.Panel.base'));
var Tab = styled.default(Tabs.Tab).withConfig({
  displayName: "styled__Tab",
  componentId: "sc-1783spc-1"
})(["align-items:center;border-top-left-radius:4px;border-top-right-radius:4px;cursor:pointer;display:flex;height:2.5em;justify-content:center;margin-bottom:-1px;padding:0.5rem;&.active{background-color:white;color:", ";fill:", ";", ";}&:focus{outline:none;", ";}&:not(.active):hover{background-color:", ";border-bottom:1px solid ", ";", ";}&:not(:last-child){margin-right:0.5rem;}&{", ";}"], styledTools.palette('primary'), styledTools.palette('primary'), styledTools.theme('fannypack.Tabs.Tab.active'), styledTools.theme('fannypack.Tabs.Tab.focus'), styledTools.palette('white700'), styledTools.palette('textTint'), styledTools.theme('fannypack.Tabs.Tab.hover'), styledTools.theme('fannypack.Tabs.Tab.base'));
var alignPropeties = {
  center: styled.css(["justify-content:center;"]),
  right: styled.css(["justify-content:flex-end;"])
};
var _Tabs = styled.default(Tabs).withConfig({
  displayName: "styled",
  componentId: "sc-1783spc-2"
})(["align-items:center;border-bottom:1px solid ", ";display:flex;font-weight:", ";list-style:none;", ";& ", "{", ";", ";}& ", ".active{", ";", ";}&{", ";}&{", ";}"], styledTools.palette('textTint'), styledTools.theme('fannypack.fontWeights.semibold'), function (props) {
  return props.isFitted && styled.css(["& ", "{flex:1;}"], Tab);
}, Tab, function (props) {
  return props.type === 'default' && styled.css(["&{", ";}"], styledTools.theme('fannypack.Tabs.Tab.default.base'));
}, function (props) {
  return props.type === 'boxed' && styled.css(["border:1px solid transparent;&{", ";}"], styledTools.theme('fannypack.Tabs.Tab.boxed.base'));
}, Tab, function (props) {
  return props.type === 'default' && styled.css(["box-shadow:inset 0 -2px 0 0 ", ";&{", ";}"], styledTools.palette('primary'), styledTools.theme('fannypack.Tabs.Tab.default.active'));
}, function (props) {
  return props.type === 'boxed' && styled.css(["border:1px solid ", ";border-bottom-color:transparent;&{", ";}"], styledTools.palette('textTint'), styledTools.theme('fannypack.Tabs.Tab.boxed.active'));
}, function (props) {
  return props.align && alignPropeties[props.align || ''];
}, styledTools.theme('fannypack.Tabs.base'));

var noop = function noop() {};

var Tab$1 = function Tab$$1(_ref) {
  var children = _ref.children,
      className = _ref.className,
      isActive = _ref.isActive,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "className", "isActive"]);

  return React.createElement(Tab, __chunk_1._extends({}, props, {
    className: classNames(className, {
      active: isActive
    })
  }), children);
};
Tab$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isActive: PropTypes.bool,
  tab: PropTypes.string.isRequired,
  current: PropTypes.number.isRequired,
  register: PropTypes.func.isRequired,
  update: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  isCurrent: PropTypes.func.isRequired,
  show: PropTypes.func.isRequired,
  next: PropTypes.func.isRequired,
  previous: PropTypes.func.isRequired
};
Tab$1.defaultProps = {
  className: undefined,
  isActive: false,
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: function isCurrent() {
    return false;
  },
  show: noop,
  next: noop,
  previous: noop
}; // @ts-ignore

var C = Tab$1;

var TabPanel$1 = function TabPanel$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(TabPanel, props, children);
};
TabPanel$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  tab: PropTypes.string.isRequired,
  isCurrent: PropTypes.func.isRequired
};
TabPanel$1.defaultProps = {
  className: undefined
}; // @ts-ignore

var C$1 = TabPanel$1;

var Tabs$1 = function Tabs$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(_Tabs, __chunk_1._extends({
    use: Tabs
  }, props), children);
};
Tabs$1.Tab = C;
Tabs$1.Panel = C$1;
Tabs$1.Container = Tabs.Container;
Tabs$1.propTypes = {
  align: PropTypes.oneOf(['left', 'center', 'right']),
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isFitted: PropTypes.bool,
  type: PropTypes.oneOf(['default', 'boxed'])
};
Tabs$1.defaultProps = {
  align: undefined,
  className: undefined,
  isFitted: false,
  type: 'default'
};
var C$2 = Tabs$1;

exports.default = C$2;
exports.Tabs = C$2;
