'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var InlineFlex = _interopDefault(require('reakit/InlineFlex'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
var __chunk_3 = require('./chunk-cb567965.js');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('airbnb-prop-types');
var __chunk_6 = require('./chunk-f77e63ff.js');
require('./types.js');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('./chunk-fdbfe348.js');
require('./chunk-1c9fbb5b.js');
require('lodash/omit');

var sizeAttributes = {
  medium: styled.css(["font-size:1em;height:2rem;&{", ";}"], styledTools.theme('fannypack.Tag.sizes.medium')),
  large: styled.css(["font-size:1.25em;height:2.5rem;&{", ";}"], styledTools.theme('fannypack.Tag.sizes.large'))
};
var outlinedProperties = styled.css(["&{background-color:unset;border:1px solid ", ";color:", ";fill:", ";}&{", ";}"], styledTools.palette(), styledTools.palette(), styledTools.palette(), styledTools.theme('fannypack.Tag.outlined'));
var RemoveButton = styled.default(__chunk_6.Button).withConfig({
  displayName: "styled__RemoveButton",
  componentId: "sc-1g01kou-0"
})(["background:none;padding:0 ", "rem;height:100%;", ";&:focus{box-shadow:inset ", " 0px 0px 0px 2px;}&{", ";}"], styled.space(1), function (props) {
  return props.kind !== 'ghost' && styled.css(["color:", ";"], function (props) {
    return styledTools.palette(props.palette + "Inverted");
  });
}, function (props) {
  return styledTools.palette(props.palette === 'default' ? 'primary' : props.palette + "300")(props);
}, styledTools.theme('fannypack.Tag.RemoveButton.base'));
var TagContent = styled.default(Box).withConfig({
  displayName: "styled__TagContent",
  componentId: "sc-1g01kou-1"
})(["padding:0 ", "em;", ";&{", ";}"], styled.space(2), function (props) {
  return props.isRemovable && styled.css(["padding-right:0rem;"]);
}, styledTools.theme('fannypack.Tag.TagContent.base'));
var Tag = styled.default(InlineFlex).withConfig({
  displayName: "styled__Tag",
  componentId: "sc-1g01kou-2"
})(["align-items:center;background-color:", ";border-radius:4px;color:", ";fill:", ";font-size:", "rem;font-weight:", ";height:1.5rem;justify-content:center;&{", ";", ";}&{", ";}"], styledTools.palette(), function (props) {
  return styledTools.palette(props.palette + "Inverted");
}, function (props) {
  return styledTools.palette(props.palette + "Inverted");
}, styledTools.theme('fannypack.fontSizes.100'), styledTools.theme('fannypack.fontWeights.semibold'), function (props) {
  return props.styledSize && sizeAttributes[props.styledSize];
}, function (props) {
  return props.kind === 'outlined' && outlinedProperties;
}, styledTools.theme('fannypack.Tag.base'));

var Tag$1 = function Tag$$1(_ref) {
  var children = _ref.children,
      onRemove = _ref.onRemove,
      size = _ref.size,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "onRemove", "size"]);

  return React.createElement(Tag, __chunk_1._extends({
    styledSize: size
  }, props), React.createElement(TagContent, {
    isRemovable: Boolean(onRemove)
  }, children), Boolean(onRemove) && React.createElement(RemoveButton, {
    onClick: onRemove,
    kind: props.kind === 'outlined' ? 'ghost' : undefined,
    palette: props.palette
  }, React.createElement(__chunk_3.Icon, {
    a11yLabel: "Close",
    icon: "times"
  })));
};
Tag$1.propTypes = {
  className: PropTypes.string,
  children: PropTypes.node.isRequired,
  kind: PropTypes.oneOf(['outlined']),
  onRemove: PropTypes.func,
  palette: PropTypes.string,
  size: PropTypes.string
};
Tag$1.defaultProps = {
  className: undefined,
  kind: undefined,
  onRemove: undefined,
  palette: 'text',
  size: undefined
}; // @ts-ignore

var C = Tag$1;

exports.Tag = C;
exports.default = C;
