'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Spinner = require('./Spinner.js');
var __chunk_13 = require('./chunk-fb522222.js');
var use = _interopDefault(require('reakit/use'));
var Input$1 = _interopDefault(require('reakit/Input'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./Text.js');
require('./chunk-ab4246ea.js');
require('./Label.js');
require('reakit/Label');
require('reakit/Field');

var LoadingSpinner = styled.default(Spinner.Spinner).withConfig({
  displayName: "styled__LoadingSpinner",
  componentId: "sc-1okmeud-0"
})(["position:absolute;width:15px;height:15px;top:12px;right:10px;z-index:1;"]);
var sizeProperties = {
  small: styled.css(["font-size:0.8rem;& + ", "{width:10px;height:10px;top:10px;}&{", ";}"], LoadingSpinner, styledTools.theme('fannypack.Textarea.sizes.small')),
  medium: styled.css(["font-size:1.25rem;& + ", "{width:20px;height:20px;top:15px;right:10px;}&{", ";}"], LoadingSpinner, styledTools.theme('fannypack.Textarea.sizes.medium')),
  large: styled.css(["font-size:1.5rem;& + ", "{width:25px;height:25px;top:16px;right:12px;}&{", ";}"], LoadingSpinner, styledTools.theme('fannypack.Textarea.sizes.large'))
};
var stateProperties = styled.css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
  return styledTools.palette(props.state + "300")(props);
}, function (props) {
  return styledTools.palette(props.state + "300")(props);
});
var _Textarea = styled.default(use(Input$1, 'textarea')).withConfig({
  displayName: "styled",
  componentId: "sc-1okmeud-1"
})(["border:1px solid #bdbdbd;box-shadow:inset 0px 1px 2px #e5e5e5;border-radius:0.2em;width:100%;padding:0.4em 0.6em;&[disabled]{background-color:", ";box-shadow:unset;color:", ";&{", ";}}&:focus{outline:unset;z-index:2;border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;&{", ";}}&::placeholder{opacity:0.6;&{", ";}}&{", ";}&{", ";}", ";"], styledTools.palette('white700'), styledTools.palette('gray400'), styledTools.theme('fannypack.Textarea.disabled'), styledTools.palette('primary'), styledTools.palette('primary'), styledTools.theme('fannypack.Textarea.focus'), styledTools.theme('fannypack.Textarea.placeholder'), function (props) {
  return props.styledSize && sizeProperties[props.styledSize];
}, function (props) {
  return props.state && stateProperties;
}, styledTools.theme('fannypack.Textarea.base'));

var Textarea = function Textarea(_ref) {
  var a11yId = _ref.a11yId,
      a11yLabel = _ref.a11yLabel,
      isLoading = _ref.isLoading,
      isRequired = _ref.isRequired,
      size = _ref.size,
      state = _ref.state,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yId", "a11yLabel", "isLoading", "isRequired", "size", "state"]);

  return React.createElement(Box, {
    relative: true
  }, React.createElement(_Textarea, __chunk_1._extends({
    "aria-invalid": state === 'danger',
    "aria-label": a11yLabel,
    "aria-required": isRequired,
    id: a11yId,
    styledSize: size,
    state: state
  }, props)), isLoading && React.createElement(LoadingSpinner, {
    color: "text"
  }));
};
var textareaPropTypes = {
  a11yId: PropTypes.string,
  a11yLabel: PropTypes.string,
  autoComplete: PropTypes.string,
  autoFocus: PropTypes.bool,
  children: PropTypes.node,
  className: PropTypes.string,
  defaultValue: PropTypes.string,
  disabled: PropTypes.bool,
  isFullWidth: PropTypes.bool,
  isLoading: PropTypes.bool,
  isRequired: PropTypes.bool,
  name: PropTypes.string,
  size: PropTypes.string,
  maxLength: PropTypes.number,
  minLength: PropTypes.number,
  pattern: PropTypes.string,
  placeholder: PropTypes.string,
  readOnly: PropTypes.bool,
  rows: PropTypes.number,
  spellCheck: PropTypes.bool,
  state: PropTypes.string,
  value: PropTypes.string,
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func
};
Textarea.propTypes = textareaPropTypes;
var textareaDefaultProps = {
  a11yId: undefined,
  a11yLabel: undefined,
  autoComplete: undefined,
  autoFocus: false,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  isFullWidth: false,
  isLoading: false,
  isRequired: false,
  maxLength: undefined,
  minLength: undefined,
  name: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  pattern: undefined,
  placeholder: undefined,
  readOnly: undefined,
  rows: 3,
  spellCheck: undefined,
  size: 'default',
  state: undefined,
  value: undefined
};
Textarea.defaultProps = textareaDefaultProps; // @ts-ignore

var TextareaField = function TextareaField(_ref) {
  var a11yId = _ref.a11yId,
      a11yLabel = _ref.a11yLabel,
      description = _ref.description,
      hint = _ref.hint,
      isLoading = _ref.isLoading,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      label = _ref.label,
      size = _ref.size,
      state = _ref.state,
      validationText = _ref.validationText,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yId", "a11yLabel", "description", "hint", "isLoading", "isOptional", "isRequired", "label", "size", "state", "validationText"]);

  return React.createElement(__chunk_13.FieldWrapper, {
    a11yId: a11yId,
    description: description,
    hint: hint,
    isOptional: isOptional,
    isRequired: isRequired,
    label: label,
    state: state,
    validationText: validationText
  }, function (_ref2) {
    var elementProps = _ref2.elementProps;
    return React.createElement(Textarea, __chunk_1._extends({}, props, elementProps));
  });
};
TextareaField.propTypes = __chunk_1._objectSpread({}, __chunk_13.fieldWrapperPropTypes, textareaPropTypes);
TextareaField.defaultProps = __chunk_1._objectSpread({}, __chunk_13.fieldWrapperDefaultProps, textareaDefaultProps); // @ts-ignore

var C$1 = TextareaField;

exports.Textarea = Textarea;
exports.TextareaField = C$1;
exports.default = Textarea;
