'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Portal = require('./Portal.js');
var ThemeProvider = _interopDefault(require('reakit/Provider'));
var Loads = require('react-loads');
var Loads__default = _interopDefault(Loads);
var _camelCase = _interopDefault(require('lodash/camelCase'));
var __chunk_19 = require('./chunk-954170c2.js');
var __chunk_20 = require('./chunk-8fc73837.js');
var React = require('react');
var React__default = _interopDefault(React);
var _get = _interopDefault(require('lodash/get'));
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
require('reakit/styled');
require('reakit/Portal');
require('reakit/Box');
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('./types.js');
require('./chunk-cb567965.js');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('airbnb-prop-types');
require('./chunk-f77e63ff.js');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('./chunk-fdbfe348.js');
require('./chunk-1c9fbb5b.js');
require('lodash/omit');
require('./Heading.js');
require('reakit/Heading');
require('classnames');
require('./VisuallyHidden.js');
require('./chunk-d538c3df.js');
require('reakit');
require('lodash/uniqueId');
require('@fortawesome/free-solid-svg-icons/faInfoCircle');
require('@fortawesome/free-solid-svg-icons/faExclamationTriangle');
require('@fortawesome/free-solid-svg-icons/faCheckCircle');
require('@fortawesome/free-solid-svg-icons/faExclamationCircle');
require('@fortawesome/free-solid-svg-icons/faTimes');

function _templateObject() {
  var data = __chunk_1._taggedTemplateLiteralLoose(["\n  html, body {\n    box-sizing: border-box;\n    font-family: ", ";\n    font-size: ", "px;\n    font-weight: ", ";\n    line-height: 1.5;\n    margin: 0;\n    padding: 0;\n    overflow-x: hidden;\n    -webkit-font-smoothing: antialiased;\n    text-rendering: optimizeLegibility;\n    color: ", ";\n    fill: ", ";\n  }\n\n  html.wf-active, body {\n    font-family: ", ";\n  }\n\n  *,\n  *::before,\n  *::after {\n    box-sizing: inherit;\n  }\n\n  *:focus {\n    outline: 2px solid ", ";\n    outline-offset: 2px;\n  }\n\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Global = styled.createGlobalStyle(_templateObject(), function (props) {
  return styledTools.theme('fannypack.global.fallbackFontFamily')(props) || styledTools.theme('fannypack.global.fontFamily')(props);
}, styledTools.theme('fannypack.global.fontSize'), styledTools.theme('fannypack.fontWeights.normal'), styledTools.palette('text'), styledTools.palette('text'), styledTools.theme('fannypack.global.fontFamily'), styledTools.palette('primary'), styledTools.theme('fannypack.global.base'));

var buildColorFromPalette = function buildColorFromPalette(property, _ref) {
  var theme = _ref.theme,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["theme"]);

  // @ts-ignore
  var color = theme.palette[props[_camelCase(property)]];

  if (typeof color === 'function') {
    color = color(props);
  }

  if (!color) return;
  return property + ": " + color + " !important;";
};

var buildSpacingFromTheme = function buildSpacingFromTheme(property, props) {
  // @ts-ignore
  var spacing = styled.space(props[_camelCase(property)])(props);
  if (!spacing) return;
  return property + ": " + spacing + "rem !important;";
};

var buildFontSizeFromTheme = function buildFontSizeFromTheme(property, _ref2) {
  var theme = _ref2.theme,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref2, ["theme"]);

  // @ts-ignore
  var size = theme.fannypack.fontSizes[props[_camelCase(property)]];

  if (!size) return;
  return property + ": " + size + "rem !important;";
};

var buildFontWeightFromTheme = function buildFontWeightFromTheme(property, _ref3) {
  var theme = _ref3.theme,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref3, ["theme"]);

  // @ts-ignore
  var weight = theme.fannypack.fontWeights[props[_camelCase(property)]];

  if (!weight) return;
  return property + ": " + weight + " !important;";
};

var reakitTheme = {
  Box: styled.css(["", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";", ";"], function (props) {
    return buildColorFromPalette('color', props);
  }, function (props) {
    return buildColorFromPalette('background-color', props);
  }, function (props) {
    return buildColorFromPalette('border-block-end-color', props);
  }, function (props) {
    return buildColorFromPalette('border-block-start-color', props);
  }, function (props) {
    return buildColorFromPalette('border-bottom-color', props);
  }, function (props) {
    return buildColorFromPalette('border-color', props);
  }, function (props) {
    return buildColorFromPalette('border-inline-end-color', props);
  }, function (props) {
    return buildColorFromPalette('border-inline-start-color', props);
  }, function (props) {
    return buildColorFromPalette('border-left-color', props);
  }, function (props) {
    return buildColorFromPalette('border-right-color', props);
  }, function (props) {
    return buildColorFromPalette('border-top-color', props);
  }, function (props) {
    return buildColorFromPalette('border-bottom-color', props);
  }, function (props) {
    return buildColorFromPalette('caret-color', props);
  }, function (props) {
    return buildColorFromPalette('column-rule-color', props);
  }, function (props) {
    return buildColorFromPalette('outline-color', props);
  }, function (props) {
    return buildColorFromPalette('text-decoration-color', props);
  }, function (props) {
    return buildColorFromPalette('text-emphasis-color', props);
  }, function (props) {
    return buildSpacingFromTheme('margin', props);
  }, function (props) {
    return buildSpacingFromTheme('margin-left', props);
  }, function (props) {
    return buildSpacingFromTheme('margin-right', props);
  }, function (props) {
    return buildSpacingFromTheme('margin-top', props);
  }, function (props) {
    return buildSpacingFromTheme('margin-bottom', props);
  }, function (props) {
    return buildSpacingFromTheme('padding', props);
  }, function (props) {
    return buildSpacingFromTheme('padding-left', props);
  }, function (props) {
    return buildSpacingFromTheme('padding-right', props);
  }, function (props) {
    return buildSpacingFromTheme('padding-top', props);
  }, function (props) {
    return buildSpacingFromTheme('padding-bottom', props);
  }, function (props) {
    return buildFontSizeFromTheme('font-size', props);
  }, function (props) {
    return buildFontWeightFromTheme('font-weight', props);
  })
};

var ToastManager = function ToastManager(_ref) {
  var theme = _ref.theme;

  var ToastComponent = _get(theme, 'fannypack.Toast.component', __chunk_19.Toast);

  var defaultProps = _get(theme, 'fannypack.Toast.defaultProps', {});

  var placement = _get(theme, 'fannypack.Toast.placement', 'top-end');

  var isStacked = _get(theme, 'fannypack.Toast.isStacked', true);

  return React.createElement(Portal.default, null, React.createElement(__chunk_19.Toasts, {
    placement: placement
  }, React.createElement(__chunk_19.ToastContainer, {
    placement: placement
  }, function (state) {
    return [].concat(isStacked ? state.toasts : [state.toasts[0]]).filter(Boolean).map(function (toast) {
      return React.createElement(ToastComponent, __chunk_1._extends({
        key: toast.key,
        onClickClose: function onClickClose() {
          return state.remove({
            key: toast.key
          });
        }
      }, defaultProps, toast), toast.message);
    });
  })));
};
ToastManager.propTypes = {
  theme: PropTypes.object
};
ToastManager.defaultProps = {
  theme: {
    fannypack: {}
  }
};
var ToastManager$1 = styled.withTheme(ToastManager);

var loadTheme = function loadTheme(_ref) {
  var _theme = _ref.theme,
      isStandalone = _ref.isStandalone;
  var theme = __chunk_20.defaultTheme(_theme);

  if (isStandalone && _theme) {
    theme = _theme;
  }

  if (typeof window !== 'undefined') {
    var webFontLoaderConfig = theme.webFontLoader;

    if (webFontLoaderConfig) {
      // @ts-ignore
      Promise.resolve(require('webfontloader')).then(function (webFontLoader) {
        return webFontLoader.load(webFontLoaderConfig);
      });
    }
  }

  var derivedTheme = __chunk_1._objectSpread({
    fannypack: theme
  }, reakitTheme, theme && theme.reakit ? theme.reakit : {}, {
    palette: theme && theme.palette ? theme.palette : {}
  });

  return derivedTheme;
};

var Provider =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(Provider, _React$Component);

  function Provider() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "state", {
      theme: loadTheme({
        theme: _this.props.theme,
        isStandalone: _this.props.isStandalone
      })
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var children = _this.props.children;
      var theme = _this.state.theme;
      return React.createElement(ThemeProvider, {
        theme: theme
      }, React.createElement(Loads.LoadsProvider, null, React.createElement(React.Fragment, null, React.createElement(Global, null), !_get(theme, 'fannypack.Toast.disabled') && React.createElement(ToastManager$1, null), children)));
    });

    return _this;
  }

  return Provider;
}(React.Component);

__chunk_1._defineProperty(Provider, "propTypes", {
  children: PropTypes.node.isRequired,
  isStandalone: PropTypes.bool,
  theme: PropTypes.object
});

__chunk_1._defineProperty(Provider, "defaultProps", {
  isStandalone: false,
  theme: {}
});

exports.ThemeProvider = Provider;
exports.default = Provider;
