'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Paragraph = require('./Paragraph.js');
var _isArrayLikeObject = _interopDefault(require('lodash/isArrayLikeObject'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('./chunk-ab4246ea.js');
require('reakit/Paragraph');

var Timeline = styled.default(Box).withConfig({
  displayName: "styled__Timeline",
  componentId: "yjvza4-0"
})(["&{", ";}"], styledTools.theme('fannypack.Timeline.base'));
var TimelineRow = styled.default(Box).withConfig({
  displayName: "styled__TimelineRow",
  componentId: "yjvza4-1"
})(["display:flex;position:relative;&:last-child{margin-bottom:0;}&::before{content:'';border:1px solid ", ";position:absolute;height:100%;left:", "rem;margin-top:", "rem;}&:last-child::before{border:0;}"], function (props) {
  return styledTools.palette(props.lineColor || 'textTint', props.lineColor);
}, styled.space(1), styled.space(5));
var TimelineStep = styled.default(Box).withConfig({
  displayName: "styled__TimelineStep",
  componentId: "yjvza4-2"
})(["&{", ";}"], styledTools.theme('fannypack.Timeline.Step.base'));
var TimelineBullet = styled.default(Box).withConfig({
  displayName: "styled__TimelineBullet",
  componentId: "yjvza4-3"
})(["border-radius:50%;display:inline-flex;height:0.625rem;width:0.625rem;margin-top:", "rem;margin-right:", "rem;z-index:1;&{", ";}"], styled.space(4), styled.space(2), styledTools.theme('fannypack.Timeline.Bullet.base'));
var TimelineStepHeading = styled.default(Paragraph.Paragraph).withConfig({
  displayName: "styled__TimelineStepHeading",
  componentId: "yjvza4-4"
})(["margin-top:", "rem;margin-bottom:", "rem;line-height:1.5rem;color:", ";&:not(:last-child){margin-top:", "rem;margin-bottom:", "rem;}&{", ";}"], styled.space(2), styled.space(1), function (props) {
  return props.color || styledTools.palette('text');
}, styled.space(2), styled.space(1), styledTools.theme('fannypack.Timeline.StepHeading.base'));
var TimelineStepDetail = styled.default(Box).withConfig({
  displayName: "styled__TimelineStepDetail",
  componentId: "yjvza4-5"
})(["color:", ";&{", ";}"], function (props) {
  return props.color || styledTools.palette('text');
}, styledTools.theme('fannypack.Timeline.StepDetail.base'));

/* eslint react/prop-types: 0 */

var TimelineStep$1 = function TimelineStep$$1(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      lineColor = _ref.lineColor,
      progressColor = _ref.progressColor;
  return React.createElement(TimelineRow, {
    lineColor: lineColor,
    "aria-labelledby": a11yTitleId,
    "aria-describedby": a11yDescriptionId
  }, React.createElement(TimelineBullet, {
    backgroundColor: progressColor
  }), React.createElement(TimelineStep, {
    "aria-labelledby": a11yTitleId,
    "aria-describedby": a11yDescriptionId
  }, children));
};

TimelineStep$1.propTypes = {
  a11yDescriptionId: PropTypes.string,
  a11yTitleId: PropTypes.string,
  children: PropTypes.node.isRequired,
  lineColor: PropTypes.string,
  progressColor: PropTypes.string
};
TimelineStep$1.defaultProps = {
  a11yDescriptionId: undefined,
  a11yTitleId: undefined,
  lineColor: undefined,
  progressColor: 'textTint'
}; // @ts-ignore

var C = TimelineStep$1;

var TimelineStepDetail$1 = function TimelineStepDetail$$1(_ref) {
  var children = _ref.children,
      color = _ref.color,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "color"]);

  return React.createElement(TimelineStepDetail, __chunk_1._extends({
    color: color
  }, props), children);
};

TimelineStepDetail$1.propTypes = {
  children: PropTypes.node.isRequired,
  color: PropTypes.string
};
TimelineStepDetail$1.defaultProps = {
  color: undefined
};
var C$1 = TimelineStepDetail$1;

var TimelineStepHeading$1 = function TimelineStepHeading$$1(_ref) {
  var children = _ref.children,
      color = _ref.color,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "color"]);

  return React.createElement(TimelineStepHeading, __chunk_1._extends({
    color: color,
    fontWeight: "semibold"
  }, props), children);
};

TimelineStepHeading$1.propTypes = {
  children: PropTypes.node.isRequired,
  color: PropTypes.string
};
TimelineStepHeading$1.defaultProps = {
  color: undefined
};
var C$2 = TimelineStepHeading$1;

/* eslint react/prop-types: 0 */
var Timeline$1 = function Timeline$$1(_ref) {
  var activeStep = _ref.activeStep,
      children = _ref.children,
      progressColor = _ref.progressColor;

  if (!_isArrayLikeObject(children)) {
    return null;
  }

  var activeIndexStep = React.Children.toArray(children).findIndex(function (child) {
    return child.props.a11yTitleId === activeStep;
  });
  return React.createElement(Timeline, null, React.Children.map(children, function (child, index) {
    var _child = child;
    var color = progressColor ? progressColor : _child.props.progressColor;
    return index <= activeIndexStep ? React.cloneElement(_child, {
      lineColor: index < activeIndexStep ? color : undefined,
      progressColor: color || undefined
    }) : child;
  }));
};
Timeline$1.Step = C;
Timeline$1.StepHeading = C$2;
Timeline$1.StepDetail = C$1;
Timeline$1.propTypes = {
  activeStep: PropTypes.string,
  children: PropTypes.node.isRequired,
  progressColor: PropTypes.string
};
Timeline$1.defaultProps = {
  activeStep: undefined,
  progressColor: undefined
}; // @ts-ignore

var C$3 = Timeline$1;

exports.default = C$3;
exports.Timeline = C$3;
