'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var Backdrop = require('./Backdrop.js');
var Overlay = require('./Overlay-463c58ea.js');
var __chunk_15 = require('./chunk-235bc185.js');
var Portal = require('./Portal.js');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');

var ModalContainer = function ModalContainer(_ref) {
  var children = _ref.children,
      defaultVisible = _ref.defaultVisible,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "defaultVisible"]);

  return React.createElement(Overlay.OverlayContainer, __chunk_1._extends({
    defaultVisible: defaultVisible
  }, props), children);
};

ModalContainer.propTypes = __chunk_1._objectSpread({}, Overlay.overlayContainerPropTypes);
ModalContainer.defaultProps = __chunk_1._objectSpread({}, Overlay.overlayContainerDefaultProps);

var ModalHide = styled.default(Overlay.Overlay.Hide).withConfig({
  displayName: "styled__ModalHide",
  componentId: "sc-13yjzse-0"
})(["", ";"], styledTools.theme('fannypack.Modal.Hide.base'));
var ModalShow = styled.default(Overlay.Overlay.Show).withConfig({
  displayName: "styled__ModalShow",
  componentId: "sc-13yjzse-1"
})(["", ";"], styledTools.theme('fannypack.Modal.Show.base'));
var _Modal = styled.default(Overlay.Overlay).withConfig({
  displayName: "styled",
  componentId: "sc-13yjzse-2"
})(["padding:0 1rem;max-width:600px;width:100%;", ";"], styledTools.theme('fannypack.Modal.base'));

var ModalHide$1 = React.forwardRef(function (_ref, ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return (// @ts-ignore
    React.createElement(ModalHide, __chunk_1._extends({}, props, {
      ref: ref
    }), children)
  );
});
ModalHide$1.propTypes = __chunk_1._objectSpread({}, Overlay.overlayHidePropTypes);
ModalHide$1.defaultProps = __chunk_1._objectSpread({}, Overlay.overlayHideDefaultProps); // @ts-ignore

var C = ModalHide$1;

var ModalShow$1 = function ModalShow$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(ModalShow, props, children);
};

ModalShow$1.propTypes = __chunk_1._objectSpread({}, Overlay.overlayShowPropTypes);
ModalShow$1.defaultProps = __chunk_1._objectSpread({}, Overlay.overlayShowDefaultProps); // @ts-ignore

var C$1 = ModalShow$1;

var Modal = function Modal(_ref) {
  var children = _ref.children,
      delay = _ref.delay,
      duration = _ref.duration,
      fade = _ref.fade,
      hide = _ref.hide,
      hideOnEsc = _ref.hideOnEsc,
      hideOnClickOutside = _ref.hideOnClickOutside,
      isVisible = _ref.isVisible,
      kind = _ref.kind,
      showActionButtons = _ref.showActionButtons,
      showCloseButton = _ref.showCloseButton,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "delay", "duration", "fade", "hide", "hideOnEsc", "hideOnClickOutside", "isVisible", "kind", "showActionButtons", "showCloseButton"]);

  return React.createElement(Portal.default, null, React.createElement(__chunk_15.TrapFocus, {
    isActive: isVisible,
    usesPortal: true
  }, function (_ref2) {
    var fallbackFocusRef = _ref2.fallbackFocusRef,
        initialFocusRef = _ref2.initialFocusRef;
    return React.createElement(React.Fragment, null, React.createElement(Backdrop.default, {
      delay: delay,
      duration: duration,
      expand: undefined,
      hide: hideOnClickOutside && kind !== 'alert' ? hide : undefined,
      fade: fade,
      hideOnEsc: kind === 'alert' ? false : hideOnEsc,
      isVisible: isVisible,
      slide: undefined,
      use: hideOnClickOutside && kind !== 'alert' ? C : undefined
    }), React.createElement(_Modal, __chunk_1._extends({
      "aria-modal": "true",
      delay: delay,
      duration: duration,
      fade: fade,
      hideOnEsc: kind === 'alert' ? false : hideOnEsc,
      hideOnClickOutside: kind === 'alert' ? false : hideOnClickOutside,
      isVisible: isVisible
    }, props), __chunk_15.isFunction(children) ? children({
      fallbackFocusRef: fallbackFocusRef,
      initialFocusRef: initialFocusRef
    }) : children));
  }));
};
Modal.propTypes = __chunk_1._objectSpread({
  children: PropTypes.func,
  className: PropTypes.string,
  isVisible: PropTypes.bool,
  hide: PropTypes.func,
  kind: PropTypes.oneOf(['alert']),
  showActionButtons: PropTypes.bool,
  showCloseButton: PropTypes.bool
}, types.animatePropTypes, types.restrictHidePropTypes);
Modal.defaultProps = __chunk_1._objectSpread({
  className: undefined,
  isVisible: false,
  kind: undefined,
  showActionButtons: false,
  showCloseButton: false
}, types.animateDefaultProps, types.restrictDefaultProps, {
  hideOnClickOutside: true,
  hideOnEsc: true
});
Modal.Container = ModalContainer;
Modal.Hide = C;
Modal.Show = C$1;
var C$2 = Modal;

exports.Modal = C$2;
exports.ModalContainer = ModalContainer;
exports.ModalHide = C;
exports.ModalShow = C$1;
