'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Heading = require('./Heading.js');
var __chunk_9 = require('./chunk-d538c3df.js');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');

var Card = styled.default(__chunk_9.Pane).withConfig({
  displayName: "styled",
  componentId: "sc-150cbjc-0"
})(["padding:", "rem;&{", ";}"], styled.space(6, 'minor'), styledTools.theme('fannypack.Card.base'));
var CardContent = styled.default(Box).withConfig({
  displayName: "styled__CardContent",
  componentId: "sc-150cbjc-1"
})(["&{", ";}"], styledTools.theme('fannypack.Card.Content.base'));
var CardHeader = styled.default(Box).withConfig({
  displayName: "styled__CardHeader",
  componentId: "sc-150cbjc-2"
})(["align-items:center;display:flex;flex-wrap:wrap;justify-content:space-between;padding-bottom:", "em;position:relative;width:100%;&{", ";}"], styled.space(4), styledTools.theme('fannypack.Card.Header.base'));
var CardFooter = styled.default(Box).withConfig({
  displayName: "styled__CardFooter",
  componentId: "sc-150cbjc-3"
})(["display:flex;padding-top:", "rem;width:100%;&{", ";}"], styled.space(4), styledTools.theme('fannypack.Card.Footer.base'));
var CardTitle = styled.default(Heading.Heading).withConfig({
  displayName: "styled__CardTitle",
  componentId: "sc-150cbjc-4"
})(["margin-bottom:0px;&{", ";}"], styledTools.theme('fannypack.Card.Title.base'));

var CardCard = function CardCard(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "children"]);

  return React.createElement(Card, __chunk_1._extends({
    "aria-describedby": a11yDescriptionId,
    "aria-labelledby": a11yTitleId
  }, props), children);
};

var cardCardPropTypes = __chunk_1._objectSpread({
  a11yDescriptionId: PropTypes.string,
  a11yTitleId: PropTypes.string,
  children: PropTypes.node.isRequired,
  className: PropTypes.string
}, __chunk_9.panePropTypes);
CardCard.propTypes = cardCardPropTypes;
var cardCardDefaultProps = __chunk_1._objectSpread({}, __chunk_9.paneDefaultProps, {
  a11yDescriptionId: undefined,
  a11yTitleId: undefined,
  border: 'shadow',
  children: undefined,
  className: undefined
});
CardCard.defaultProps = cardCardDefaultProps;
var C = CardCard;

var CardHeader$1 = function CardHeader$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(CardHeader, props, children);
};

CardHeader$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string
};
CardHeader$1.defaultProps = {
  className: undefined
};
var C$1 = CardHeader$1;

var CardContent$1 = function CardContent$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(CardContent, props, children);
};

CardContent$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string
};
CardContent$1.defaultProps = {
  className: undefined
};
var C$2 = CardContent$1;

var CardTitle$1 = function CardTitle$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(CardTitle, __chunk_1._extends({
    use: "h5",
    isSubHeading: true
  }, props), children);
};

CardTitle$1.defaultProps = {
  className: undefined
};
var C$3 = CardTitle$1;

var CardFooter$1 = function CardFooter$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(CardFooter, props, children);
};

CardFooter$1.propTypes = {
  children: PropTypes.node.isRequired,
  className: PropTypes.string
};
CardFooter$1.defaultProps = {
  className: undefined
};
var C$4 = CardFooter$1;

exports.CardCard = C;
exports.CardHeader = C$1;
exports.CardContent = C$2;
exports.CardTitle = C$3;
exports.CardFooter = C$4;
exports.cardCardPropTypes = cardCardPropTypes;
exports.cardCardDefaultProps = cardCardDefaultProps;
