'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var __chunk_2 = require('./chunk-ab4246ea.js');
var __chunk_3 = require('./chunk-cb567965.js');
var Navigation = require('./Navigation-ddd17e18.js');
var Divider = require('./Divider.js');
var Popover = require('./Popover-fc2eeb99.js');
var _Button = _interopDefault(require('reakit/Button'));
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
var __chunk_6 = require('./chunk-f77e63ff.js');
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('./chunk-fdbfe348.js');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./types.js');
require('./parseIcons.js');
require('airbnb-prop-types');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('./chunk-1c9fbb5b.js');
require('lodash/omit');

var MenuItem = styled.default(_Button).withConfig({
  displayName: "styled__MenuItem",
  componentId: "l9b8us-0"
})(["background-color:unset;cursor:pointer;display:block;font-weight:", ";padding:", "rem ", "rem;text-align:left;width:100%;a&{color:unset;fill:unset;text-decoration:unset;&:hover{color:unset;fill:unset;}}&[disabled]{cursor:not-allowed;opacity:0.5;&{", ";}}&:not(:disabled):focus{outline:unset;background-color:", ";&{", ";}}&:not(:disabled):hover{background-color:", ";&{", ";}}&:not(:disabled):focus:active,&:not(:disabled):hover:active{background-color:", ";}", " & ", "{top:0.15em;}&{", ";}"], styled.theme('fannypack.fontWeights.semibold'), styled.space(1.5), styled.space(4), styled.theme('fannypack.Menu.Item.disabled'), styled.palette('white600'), styled.theme('fannypack.Menu.Item.focus'), styled.palette('white600'), styled.theme('fannypack.Menu.Item.hover'), styled.palette('white700'), function (props) {
  return props.isActive && styled.css(["background-color:", ";&&:hover,&&:focus{background-color:", ";}&{", ";}"], styled.palette('white700'), styled.palette('white800'), styled.theme('fannypack.Menu.Item.active'));
}, __chunk_2.Icon, styled.theme('fannypack.Menu.Item.base'));
var MenuButton = styled.default(__chunk_6.Button).withConfig({
  displayName: "styled__MenuButton",
  componentId: "l9b8us-1"
})(["&{", ";}"], styled.theme('fannypack.Menu.Button.base'));
var MenuDivider = styled.default(Divider.Divider).withConfig({
  displayName: "styled__MenuDivider",
  componentId: "l9b8us-2"
})(["margin:0;width:100%;&{", ";}"], styled.theme('fannypack.Menu.Divider.base'));
var MenuIcon = styled.default(__chunk_3.Icon).withConfig({
  displayName: "styled__MenuIcon",
  componentId: "l9b8us-3"
})(["margin-right:", "rem;&{", ";}"], styled.space(2), styled.theme('fannypack.Menu.Item.icon'));
var MenuGroup = styled.default(Box).withConfig({
  displayName: "styled__MenuGroup",
  componentId: "l9b8us-4"
})(["margin:", "rem 0;width:100%;&{", ";}"], styled.space(2), styled.theme('fannypack.Menu.Group.base'));
var MenuGroupTitle = styled.default(Box).withConfig({
  displayName: "styled__MenuGroupTitle",
  componentId: "l9b8us-5"
})(["color:", ";font-size:", "rem;font-weight:", ";letter-spacing:1px;padding:", "rem ", "rem;padding-top:", "rem;text-transform:uppercase;&{", ";}"], styled.palette('text200'), styled.theme('fannypack.fontSizes.100'), styled.theme('fannypack.fontWeights.semibold'), styled.space(2), styled.space(4), styled.space(1), styled.theme('fannypack.Menu.Group.title'));
var MenuPopover = styled.default(Popover.Popover).withConfig({
  displayName: "styled__MenuPopover",
  componentId: "l9b8us-6"
})(["padding:0px;width:200px;&{", ";}"], styled.theme('fannypack.Menu.Popover.base'));
var _Menu = styled.default(Navigation.Navigation).withConfig({
  displayName: "styled",
  componentId: "l9b8us-7"
})(["display:flex;align-items:flex-start;", ";&{", ";}"], function (props) {
  return props.isHorizontal ? styled.css(["flex-direction:row;& ", "{display:flex;flex-direction:row;flex-wrap:wrap;}& ", "{width:unset;}&{", ";}"], MenuGroup, MenuItem, styled.theme('fannypack.Menu.horizontal')) : styled.css(["flex-direction:column;&{", ";}"], styled.theme('fannypack.Menu.vertical'));
}, styled.theme('fannypack.Menu.base'));

var initialState = {
  startAt: undefined,
  handleMenuOpenViaKeyboard: function handleMenuOpenViaKeyboard() {},
  setPopoverProps: function setPopoverProps() {},
  hide: function hide() {},
  show: function show() {},
  toggle: function toggle() {},
  isVisible: false
};
var Context = React.createContext(initialState);

var MenuProvider =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(MenuProvider, _React$Component);

  function MenuProvider() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleMenuOpenViaKeyboard", function (_temp) {
      var _ref = _temp === void 0 ? {} : _temp,
          _ref$startAt = _ref.startAt,
          startAt = _ref$startAt === void 0 ? 'first' : _ref$startAt;

      _this.setState({
        startAt: startAt
      }, _this.state.show);
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "setPopoverProps", function (popover) {
      _this.setState(__chunk_1._objectSpread({}, popover));
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "state", __chunk_1._objectSpread({}, initialState, {
      setPopoverProps: _this.setPopoverProps,
      handleMenuOpenViaKeyboard: _this.handleMenuOpenViaKeyboard
    }));

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var children = _this.props.children;
      return React.createElement(Context.Provider, {
        value: _this.state
      }, children);
    });

    return _this;
  }

  return MenuProvider;
}(React.Component);

var MenuContext = __chunk_1._objectSpread({}, Context, {
  Provider: MenuProvider
});
var withMenuContext = function withMenuContext(C) {
  return function (props) {
    return React.createElement(Context.Consumer, null, function (context) {
      return React.createElement(C, __chunk_1._extends({
        context: context
      }, props));
    });
  };
};

var menuItemPropTypes = {
  children: PropTypes.node.isRequired,
  hideOnClick: PropTypes.bool,
  icon: __chunk_3.iconPropTypes['icon'],
  isActive: PropTypes.bool,
  isDisabled: PropTypes.bool,
  onClick: PropTypes.func
};
var menuItemDefaultProps = {
  hideOnClick: true,
  icon: undefined,
  isActive: false,
  isDisabled: false,
  onClick: undefined
};
var MenuItem$1 =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(MenuItem$$1, _React$Component);

  function MenuItem$$1() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "handleClick", function () {
      var _this$props = _this.props,
          context = _this$props.context,
          hideOnClick = _this$props.hideOnClick,
          onClick = _this$props.onClick;
      onClick && onClick();
      hideOnClick && context && context.hide();
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "render", function () {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          icon = _this$props2.icon,
          isDisabled = _this$props2.isDisabled,
          props = __chunk_1._objectWithoutPropertiesLoose(_this$props2, ["children", "icon", "isDisabled"]);

      return React.createElement(MenuItem, __chunk_1._extends({
        role: "menuitem",
        disabled: isDisabled
      }, props, {
        onClick: _this.handleClick,
        type: "button"
      }), icon && // @ts-ignore
      React.createElement(MenuIcon, {
        a11yHidden: true,
        icon: icon
      }), children);
    });

    return _this;
  }

  return MenuItem$$1;
}(React.Component); // @ts-ignore

__chunk_1._defineProperty(MenuItem$1, "propTypes", menuItemPropTypes);

__chunk_1._defineProperty(MenuItem$1, "defaultProps", menuItemDefaultProps);

var C = withMenuContext(MenuItem$1);

exports.MenuButton = MenuButton;
exports.withMenuContext = withMenuContext;
exports.MenuDivider = MenuDivider;
exports.MenuGroup = MenuGroup;
exports.MenuGroupTitle = MenuGroupTitle;
exports.MenuContext = MenuContext;
exports.MenuPopover = MenuPopover;
exports._Menu = _Menu;
exports.MenuItem = C;
exports.menuItemPropTypes = menuItemPropTypes;
