'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var parseIcons = require('./parseIcons.js');
var __chunk_4 = require('./chunk-36150710.js');
var faInfoCircle = require('@fortawesome/free-solid-svg-icons/faInfoCircle');
var faExclamationTriangle = require('@fortawesome/free-solid-svg-icons/faExclamationTriangle');
var faCheckCircle = require('@fortawesome/free-solid-svg-icons/faCheckCircle');
var faExclamationCircle = require('@fortawesome/free-solid-svg-icons/faExclamationCircle');
var faTimes = require('@fortawesome/free-solid-svg-icons/faTimes');
var _get = _interopDefault(require('lodash/get'));

var global = (function (overrides) {
  return __chunk_1._objectSpread({
    fontFamily: "system-ui, -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Fira Sans', 'Droid Sans', 'Helvetica Neue', sans-serif",
    fontSize: 16
  }, _get(overrides, 'global', {}));
});

var layout = (function (overrides) {
  return __chunk_1._objectSpread({
    gapFactor: styled.space(2),
    mobileBreakpoint: 480,
    tabletBreakpoint: 768,
    desktopBreakpoint: 1024,
    widescreenBreakpoint: 1200,
    fullHDBreakpoint: 1440,
    minorUnit: 4,
    majorUnit: 8
  }, _get(overrides, 'layout', {}));
});

var fontSizes = (function (overrides) {
  return __chunk_1._objectSpread({
    100: 0.75,
    150: 0.875,
    200: 1,
    300: 1.25,
    400: 1.5,
    500: 2,
    600: 2.5,
    700: 3,
    800: 3.75,
    900: 4.5
  }, _get(overrides, 'fontSizes', {}));
});

var fontWeights = (function (overrides) {
  return __chunk_1._objectSpread({
    normal: 400,
    semibold: 600,
    bold: 700
  }, _get(overrides, 'fontWeights', {}));
});

var Container = (function (overrides) {
  return __chunk_1._objectSpread({
    fluidMargin: '0 2rem',
    tabletMargin: '0 1rem'
  }, _get(overrides, 'Container', {}));
});

var FieldSet = (function (overrides) {
  return __chunk_1._objectSpread({
    spacing: 'major-3'
  }, _get(overrides, 'FieldSet', {}));
});

var parseOverrideIcons = function parseOverrideIcons(icons) {
  return icons.reduce(function (currentIcons, iconSet) {
    return __chunk_1._objectSpread({}, currentIcons, parseIcons.default(iconSet.icons, {
      type: iconSet.type,
      prefix: iconSet.prefix
    }));
  }, {});
};

var Icon = (function (overrides) {
  return __chunk_1._objectSpread({}, _get(overrides, 'Icon', {}), {
    icons: __chunk_1._objectSpread({}, parseIcons.default([faInfoCircle, faExclamationTriangle, faCheckCircle, faExclamationCircle, faTimes], {
      type: 'font-awesome-standalone'
    }), parseOverrideIcons(_get(overrides, 'Icon.iconSets', [])), _get(overrides, 'Icon.icons', {})),
    iconNames: __chunk_1._objectSpread({
      info: 'info-circle',
      warning: 'exclamation-triangle',
      success: 'check-circle',
      danger: 'exclamation-circle'
    }, _get(overrides, 'Icon.iconNames', {}))
  });
});

var LayoutSet = (function (overrides) {
  return __chunk_1._objectSpread({
    spacing: 'major-4'
  }, _get(overrides, 'LayoutSet', {}));
});

var Pane = (function (overrides) {
  return __chunk_1._objectSpread({}, _get(overrides, 'Pane', {}), {
    elevations: __chunk_1._objectSpread({
      100: 4,
      200: 8,
      300: 12,
      400: 24
    }, _get(overrides, 'Pane.elevations', {}))
  });
});

var Table = (function (overrides) {
  return __chunk_1._objectSpread({
    borderColor: styled.palette('gray100'),
    spacing: styled.space(2)
  }, _get(overrides, 'Table', {}), {
    hover: __chunk_1._objectSpread({
      backgroundColor: styled.palette('white700')
    }, _get(overrides, 'Table.hover', {})),
    striped: __chunk_1._objectSpread({
      backgroundColor: styled.palette('white600')
    }, _get(overrides, 'Table.striped', {}))
  });
});

function theme(overrides) {
  if (overrides === void 0) {
    overrides = {};
  }

  return __chunk_1._objectSpread({}, overrides, {
    global: global(overrides),
    palette: __chunk_4._defaultPalette(overrides),
    layout: layout(overrides),
    fontSizes: fontSizes(overrides),
    fontWeights: fontWeights(overrides),
    Container: Container(overrides),
    FieldSet: FieldSet(overrides),
    Icon: Icon(overrides),
    LayoutSet: LayoutSet(overrides),
    Pane: Pane(overrides),
    Table: Table(overrides)
  });
}

exports.defaultTheme = theme;
