'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var __chunk_3 = require('./chunk-cb567965.js');
var __chunk_6 = require('./chunk-f77e63ff.js');
var Heading = require('./Heading.js');
var VisuallyHidden = require('./VisuallyHidden.js');
var __chunk_9 = require('./chunk-d538c3df.js');
var _omit = _interopDefault(require('lodash/omit'));
var reakit = require('reakit');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var _uniqueId = _interopDefault(require('lodash/uniqueId'));
var Box = _interopDefault(require('reakit/Box'));
var Flex = _interopDefault(require('reakit/Flex'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('airbnb-prop-types');
require('./chunk-fdbfe348.js');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('./chunk-1c9fbb5b.js');

var ToastClose = styled.default(__chunk_6.Button).withConfig({
  displayName: "styled__ToastClose",
  componentId: "cax10c-0"
})(["width:24px;height:24px;padding:0;text-align:right;", ";&:hover{background-color:", ";&{", ";}}&{", ";}"], function (props) {
  return props.isAbsolute ? styled.css(["position:absolute;right:", "rem;top:", "rem;"], styled.space(2), styled.space(2)) : styled.css(["margin:0 ", "rem;"], styled.space(2));
}, styled.palette('white700'), styled.theme('fannypack.Toast.Close.hover'), styled.theme('fannypack.Toast.Close.base'));
var ToastTitle = styled.default(Heading.Heading).withConfig({
  displayName: "styled__ToastTitle",
  componentId: "cax10c-1"
})(["&{", ";}"], styled.theme('fannypack.Toast.Title.base'));
var ToastIconWrapper = styled.default(Flex).withConfig({
  displayName: "styled__ToastIconWrapper",
  componentId: "cax10c-2"
})(["margin-right:", "rem;margin-left:-", "rem;align-items:center;&{", ";}"], styled.space(3), styled.space(1), styled.theme('fannypack.Toast.Icon.wrapper'));
var ToastIcon = styled.default(__chunk_3.Icon).withConfig({
  displayName: "styled__ToastIcon",
  componentId: "cax10c-3"
})(["&{", ";}"], styled.theme('fannypack.Toast.Icon.base'));
var Content = styled.default(Flex).withConfig({
  displayName: "styled__Content",
  componentId: "cax10c-4"
})(["padding:", "rem;padding-left:calc(", "rem + 5px);padding-right:", "rem;&{", ";}"], styled.space(4), styled.space(4), styled.space(8), styled.theme('fannypack.Toast.Content.base'));
var heightCountdown = styled.keyframes(["from{height:calc(100% + 2px);}to{height:0%;}"]);
var widthCountdown = styled.keyframes(["from{width:calc(100% + 2px);}to{width:0%;}"]);
var CountdownBar = styled.default(Box).withConfig({
  displayName: "styled__CountdownBar",
  componentId: "cax10c-5"
})(["position:absolute;", ";", ";", ";", ";&{", ";}"], function (props) {
  return props.isHorizontal ? styled.css(["border-bottom-right-radius:3px;border-bottom-left-radius:3px;bottom:0;height:5px;right:-1px;width:calc(100% + 2px);"]) : styled.css(["border-top-left-radius:3px;border-bottom-left-radius:3px;bottom:-1px;height:calc(100% + 2px);margin-left:-1px;width:5px;"]);
}, function (props) {
  return props.type && styled.css(["background-color:", ";"], props.isBackground ? styled.palette(props.type + "Tint") : styled.palette(props.type));
}, function (props) {
  return props.autoDismissTimeout && styled.css(["", ";&{", ";}"], function (props) {
    return props.isHorizontal ? styled.css(["animation:", " ", "ms linear forwards;border-bottom-left-radius:unset;"], widthCountdown, props.autoDismissTimeout) : styled.css(["animation:", " ", "ms linear forwards;border-top-left-radius:unset;"], heightCountdown, props.autoDismissTimeout);
  }, styled.theme('fannypack.Toast.CountdownBar.autoDismissTimeout'));
}, function (props) {
  return props.isBackground && styled.css(["&{", ";}"], styled.theme('fannypack.Toast.CountdownBar.background'));
}, styled.theme('fannypack.Toast.CountdownBar.base'));
var tintAttributes = styled.css(["background-color:", ";color:", ";fill:", ";", ";"], function (props) {
  return props.type && styled.palette(props.type + "Tint")(props);
}, function (props) {
  return props.type && styled.palette(props.type + "TintInverted")(props);
}, function (props) {
  return props.type && styled.palette(props.type + "TintInverted")(props);
}, styled.theme('fannypack.Toast.tint'));
var Toast = styled.default(__chunk_9.Pane).withConfig({
  displayName: "styled__Toast",
  componentId: "cax10c-6"
})(["align-items:center;display:flex;font-size:", "rem;justify-content:space-between;position:relative;width:350px;&:not(:last-child){margin-bottom:", "rem;}&{", ";}&{", ";}"], styled.theme('fannypack.fontSizes.150'), styled.space(4), function (props) {
  return props.hasTint && tintAttributes;
}, styled.theme('fannypack.Toast.base'));
var fromLeft = styled.keyframes(["from{transform:translateX(-120%);}to{transform:translateX(0);}"]);
var fromRight = styled.keyframes(["from{transform:translateX(120%);}to{transform:translateX(0);}"]);
var fromTop = styled.keyframes(["from{transform:translateY(-120%);}to{transform:translateY(0);}"]);
var fromBottom = styled.keyframes(["from{transform:translateY(120%);}to{transform:translateY(0);}"]);
var placementAttributes = {
  'top-start': styled.css(["top:1rem;left:1rem;& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromLeft),
  top: styled.css(["top:1rem;left:50%;transform:translateX(-50%);& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromTop),
  'top-end': styled.css(["top:1rem;right:1rem;& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromRight),
  left: styled.css(["left:1rem;top:50%;transform:translateY(-50%);& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromLeft),
  right: styled.css(["right:1rem;top:50%;transform:translateY(-50%);& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromRight),
  'bottom-start': styled.css(["bottom:1rem;left:1rem;& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromLeft),
  bottom: styled.css(["bottom:1rem;left:50%;transform:translateX(-50%);& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromBottom),
  'bottom-end': styled.css(["bottom:1rem;right:1rem;& ", "{animation:", " 300ms ease-in-out forwards;}"], Toast, fromRight)
};
var Toasts = styled.default(Box).withConfig({
  displayName: "styled__Toasts",
  componentId: "cax10c-7"
})(["position:fixed;z-index:99999;", ";&{", ";}"], function (props) {
  return placementAttributes[props.placement];
}, styled.theme('fannypack.Toasts.base'));

var initialState = {
  autoDismissTimeout: 5000,
  toasts: []
};

var add = function add(toast) {
  return function (_ref) {
    var setState = _ref.setState,
        state = _ref.state;
    var placement = state.props.placement;

    var key = _uniqueId('toast-');

    var autoDismissTimeout = typeof toast.autoDismissTimeout === 'number' ? toast.autoDismissTimeout : state.autoDismissTimeout;
    setState(function (state) {
      return {
        toasts: [].concat(placement.includes('bottom') ? state.toasts : [], [__chunk_1._objectSpread({
          key: key,
          autoDismissTimeout: autoDismissTimeout
        }, toast)], !placement.includes('bottom') ? state.toasts : [])
      };
    });

    if (autoDismissTimeout > 0) {
      setTimeout(function () {
        return setState(function (state) {
          return {
            toasts: state.toasts.filter(function (toast) {
              return toast.key !== key;
            })
          };
        });
      }, toast.autoDismissTimeout || state.autoDismissTimeout);
    }
  };
};

var effects = {
  add: add,
  info: function info(toast) {
    return add(__chunk_1._objectSpread({}, toast, {
      type: 'info'
    }));
  },
  success: function success(toast) {
    return add(__chunk_1._objectSpread({}, toast, {
      type: 'success'
    }));
  },
  danger: function danger(toast) {
    return add(__chunk_1._objectSpread({}, toast, {
      type: 'danger'
    }));
  },
  warning: function warning(toast) {
    return add(__chunk_1._objectSpread({}, toast, {
      type: 'warning'
    }));
  }
};
var actions = {
  remove: function remove(_ref2) {
    var key = _ref2.key;
    return function (state) {
      return {
        toasts: state.toasts.filter(function (toast) {
          return toast.key !== key;
        })
      };
    };
  }
};
var ToastContainer = function ToastContainer(_ref3) {
  var children = _ref3.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref3, ["children"]);

  return React.createElement(reakit.Container, {
    context: "toasts",
    initialState: __chunk_1._objectSpread({}, initialState, {
      props: props
    }),
    actions: actions,
    effects: effects,
    pure: true
  }, children);
};
ToastContainer.propTypes = {
  children: PropTypes.func.isRequired,
  placement: types.placementPropType
};
ToastContainer.defaultProps = {
  placement: 'top-end'
};

var ToastClose$1 = function ToastClose$$1(_ref) {
  var onClickClose = _ref.onClickClose,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["onClickClose"]);

  return React.createElement(ToastClose, __chunk_1._extends({
    kind: "link",
    onClick: onClickClose
  }, props), React.createElement(VisuallyHidden.default, null, "Close"), React.createElement(__chunk_3.Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
ToastClose$1.propTypes = {
  isAbsolute: PropTypes.bool,
  onClickClose: PropTypes.func
};
ToastClose$1.defaultProps = {
  isAbsolute: false,
  onClickClose: undefined
};
var C = ToastClose$1;

var ToastIcon$1 = function ToastIcon$$1(_ref) {
  var size = _ref.size,
      type = _ref.type,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["size", "type"]);

  return React.createElement(ToastIconWrapper, props, React.createElement(ToastIcon, {
    a11yLabel: type,
    color: type,
    icon: type,
    size: size
  }));
};
ToastIcon$1.propTypes = {
  size: PropTypes.string,
  type: PropTypes.string.isRequired
};
ToastIcon$1.defaultProps = {
  size: undefined
}; // @ts-ignore

var C$1 = ToastIcon$1;

var ToastTitle$1 = function ToastTitle$$1(_ref) {
  var children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children"]);

  return React.createElement(ToastTitle, __chunk_1._extends({
    fontWeight: "semibold",
    use: "h6"
  }, props), children);
};
ToastTitle$1.propTypes = {
  children: PropTypes.node.isRequired
};
var C$2 = ToastTitle$1;

var Toast$1 = function Toast$$1(_ref) {
  var autoDismissTimeout = _ref.autoDismissTimeout,
      children = _ref.children,
      closeButtonProps = _ref.closeButtonProps,
      hasHorizontalBar = _ref.hasHorizontalBar,
      hasIcon = _ref.hasIcon,
      hideCloseButton = _ref.hideCloseButton,
      onClickClose = _ref.onClickClose,
      title = _ref.title,
      type = _ref.type,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["autoDismissTimeout", "children", "closeButtonProps", "hasHorizontalBar", "hasIcon", "hideCloseButton", "onClickClose", "title", "type"]);

  return React.createElement(Toast, __chunk_1._extends({
    type: type
  }, props), React.createElement(CountdownBar, {
    isHorizontal: hasHorizontalBar,
    isBackground: true,
    type: type
  }), React.createElement(CountdownBar, {
    autoDismissTimeout: autoDismissTimeout,
    isHorizontal: hasHorizontalBar,
    type: type
  }), React.createElement(Content, null, hasIcon && type && React.createElement(C$1, {
    type: type,
    size: children ? '300' : undefined
  }), React.createElement(Box, null, title && React.createElement(C$2, {
    marginBottom: children ? 'minor-2' : undefined
  }, title), children)), !hideCloseButton && React.createElement(C, __chunk_1._extends({
    isAbsolute: Boolean(children),
    onClickClose: onClickClose
  }, closeButtonProps)));
};
Toast$1.Container = ToastContainer;
Toast$1.propTypes = __chunk_1._objectSpread({
  autoDismissTimeout: PropTypes.number,
  children: PropTypes.node,
  closeButtonProps: PropTypes.shape(_omit(__chunk_6.buttonPropTypes, 'children')),
  hasHorizontalBar: PropTypes.bool,
  hasIcon: PropTypes.bool,
  hasTint: PropTypes.bool,
  hideCloseButton: PropTypes.bool,
  onClickClose: PropTypes.func,
  type: PropTypes.string,
  title: PropTypes.string
}, __chunk_9.panePropTypes);
Toast$1.defaultProps = __chunk_1._objectSpread({}, __chunk_9.paneDefaultProps, {
  autoDismissTimeout: undefined,
  children: undefined,
  closeButtonProps: {},
  elevation: '300',
  hasHorizontalBar: false,
  hasIcon: true,
  hasTint: false,
  hideCloseButton: false,
  onClickClose: undefined,
  title: undefined,
  type: 'info'
});
var C$3 = Toast$1;

exports.Toasts = Toasts;
exports.ToastContainer = ToastContainer;
exports.Toast = C$3;
