'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var __chunk_3 = require('./chunk-cb567965.js');
var Spinner = require('./Spinner.js');
var Input = _interopDefault(require('reakit/Input'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
var InlineFlex = _interopDefault(require('reakit/InlineFlex'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/Grid');

var LoadingSpinner = styled.default(Spinner.Spinner).withConfig({
  displayName: "styled__LoadingSpinner",
  componentId: "kl4ffb-0"
})(["position:absolute;width:15px;height:15px;top:12px;right:10px;z-index:2;"]);
var sizeProperties = {
  small: styled.css(["& + ", "{width:10px;height:10px;top:10px;}&{", ";}"], LoadingSpinner, styledTools.theme('fannypack.Input.sizes.small')),
  medium: styled.css(["& + ", "{width:20px;height:20px;top:15px;right:10px;}&{", ";}"], LoadingSpinner, styledTools.theme('fannypack.Input.sizes.medium')),
  large: styled.css(["& + ", "{width:25px;height:25px;top:16px;right:12px;}&{", ";}"], LoadingSpinner, styledTools.theme('fannypack.Input.sizes.large'))
};
var wrapperSizeProperties = {
  small: styled.css(["font-size:0.8rem;&{", ";}"], styledTools.theme('fannypack.Input.Wrapper.sizes.small')),
  medium: styled.css(["font-size:1.25rem;&{", ";}"], styledTools.theme('fannypack.Input.Wrapper.sizes.medium')),
  large: styled.css(["font-size:1.5rem;&{", ";}"], styledTools.theme('fannypack.Input.Wrapper.sizes.large'))
};
var stateProperties = styled.css(["border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;"], function (props) {
  return styledTools.palette("" + props.state)(props);
}, function (props) {
  return styledTools.palette("" + props.state)(props);
}); // @ts-ignore

var Icon = styled.default(__chunk_3.Icon).withConfig({
  displayName: "styled__Icon",
  componentId: "kl4ffb-1"
})(["fill:", ";height:2.5em;margin:0 0.75em;top:0;", ";"], styledTools.palette('text100'), styledTools.theme('fannypack.Input.Icon.base'));
var InputWrapper = styled.default(Box).withConfig({
  displayName: "styled__InputWrapper",
  componentId: "kl4ffb-2"
})(["align-items:center;position:relative;width:100%;&{", ";}&{", ";}"], styledTools.theme('fannypack.Input.Wrapper.base'), function (props) {
  return props.styledSize && wrapperSizeProperties[props.styledSize];
});
var _Input = styled.default(Input).withConfig({
  displayName: "styled",
  componentId: "kl4ffb-3"
})(["border:1px solid #bdbdbd;box-shadow:inset 0px 1px 2px #e5e5e5;border-radius:0.2em;height:2.5em;width:100%;padding:0.4em 0.6em;&[disabled]{background-color:", ";box-shadow:unset;color:", ";&{", ";}}&:focus{outline:unset;z-index:2;border-color:", ";box-shadow:", " 0px 0px 0px 1px !important;&{", ";}}&::placeholder{opacity:0.6;&{", ";}}&{", ";}&{", ";}&{", ";}&{", ";}&{", ";}"], styledTools.palette('white700'), styledTools.palette('gray400'), styledTools.theme('fannypack.Input.disabled'), function (props) {
  return styledTools.palette('primary')(props);
}, function (props) {
  return styledTools.palette('primary')(props);
}, styledTools.theme('fannypack.Input.focus'), styledTools.theme('fannypack.Input.placeholder'), function (props) {
  return props.after && styled.css(["padding-right:2.3em;"]);
}, function (props) {
  return props.before && styled.css(["padding-left:2.3em;"]);
}, styledTools.theme('fannypack.Input.base'), function (props) {
  return props.styledSize && sizeProperties[props.styledSize];
}, function (props) {
  return props.state && stateProperties;
});

var Input$1 = function Input$$1(_ref) {
  var a11yLabel = _ref.a11yLabel,
      a11yId = _ref.a11yId,
      after = _ref.after,
      autoComplete = _ref.autoComplete,
      autoFocus = _ref.autoFocus,
      before = _ref.before,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      inputRef = _ref.inputRef,
      isLoading = _ref.isLoading,
      isRequired = _ref.isRequired,
      max = _ref.max,
      maxLength = _ref.maxLength,
      min = _ref.min,
      minLength = _ref.minLength,
      multiple = _ref.multiple,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      pattern = _ref.pattern,
      placeholder = _ref.placeholder,
      readOnly = _ref.readOnly,
      spellCheck = _ref.spellCheck,
      step = _ref.step,
      type = _ref.type,
      size = _ref.size,
      state = _ref.state,
      value = _ref.value,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yLabel", "a11yId", "after", "autoComplete", "autoFocus", "before", "defaultValue", "disabled", "inputRef", "isLoading", "isRequired", "max", "maxLength", "min", "minLength", "multiple", "name", "onBlur", "onChange", "onFocus", "pattern", "placeholder", "readOnly", "spellCheck", "step", "type", "size", "state", "value"]);

  return React.createElement(InputWrapper, __chunk_1._extends({
    styledSize: size
  }, props), before && React.createElement(InlineFlex, {
    absolute: true,
    zIndex: "3"
  }, before), after && React.createElement(InlineFlex, {
    absolute: true,
    right: "0",
    zIndex: "3"
  }, after), React.createElement(_Input, {
    after: after,
    "aria-invalid": state === 'danger',
    "aria-label": a11yLabel,
    "aria-required": isRequired,
    autoComplete: autoComplete,
    autoFocus: autoFocus,
    before: before,
    defaultValue: defaultValue,
    disabled: disabled,
    elementRef: inputRef,
    id: a11yId,
    max: max,
    maxLength: maxLength,
    min: min,
    minLength: minLength,
    multiple: multiple,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    pattern: pattern,
    placeholder: placeholder,
    readOnly: readOnly,
    spellCheck: spellCheck,
    state: state,
    step: step,
    styledSize: size,
    type: type,
    value: value
  }), isLoading && React.createElement(LoadingSpinner, {
    color: "text"
  }));
};
Input$1.Icon = Icon;
var inputPropTypes = {
  after: PropTypes.element,
  a11yId: PropTypes.string,
  a11yLabel: PropTypes.string,
  autoComplete: PropTypes.string,
  autoFocus: PropTypes.bool,
  before: PropTypes.element,
  children: PropTypes.node,
  className: PropTypes.string,
  defaultValue: PropTypes.string,
  disabled: PropTypes.bool,
  inputRef: PropTypes.object,
  isLoading: PropTypes.bool,
  isRequired: PropTypes.bool,
  name: PropTypes.string,
  size: types.sizePropType,
  max: PropTypes.number,
  maxLength: PropTypes.number,
  min: PropTypes.number,
  minLength: PropTypes.number,
  multiple: PropTypes.bool,
  pattern: PropTypes.string,
  placeholder: PropTypes.string,
  readOnly: PropTypes.bool,
  spellCheck: PropTypes.bool,
  step: PropTypes.number,
  state: PropTypes.string,
  type: PropTypes.string,
  value: PropTypes.string,
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func
};
Input$1.propTypes = inputPropTypes;
var inputDefaultProps = {
  a11yId: undefined,
  a11yLabel: undefined,
  autoComplete: undefined,
  autoFocus: false,
  children: null,
  className: undefined,
  defaultValue: undefined,
  disabled: false,
  after: undefined,
  before: undefined,
  inputRef: undefined,
  isLoading: false,
  isRequired: false,
  max: undefined,
  maxLength: undefined,
  min: undefined,
  minLength: undefined,
  multiple: false,
  name: undefined,
  onBlur: undefined,
  onChange: undefined,
  onFocus: undefined,
  pattern: undefined,
  placeholder: undefined,
  readOnly: undefined,
  spellCheck: undefined,
  size: 'default',
  state: undefined,
  step: undefined,
  type: 'text',
  value: undefined
};
Input$1.defaultProps = inputDefaultProps; // @ts-ignore

var C = Input$1;

exports.Input = C;
exports.inputDefaultProps = inputDefaultProps;
exports.inputPropTypes = inputPropTypes;
