'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('./styled.js');
var __chunk_3 = require('./chunk-cb567965.js');
var __chunk_4 = require('./chunk-36150710.js');
var polished = require('polished');
var _Button = _interopDefault(require('reakit/Button'));
var styledTools = require('styled-tools');

var defaultPalette = __chunk_4._defaultPalette({});

var isInteractive = function isInteractive(props) {
  return !props.isStatic && !props.isLoading && !props.disabled && props.kind !== 'link';
};
var sizeProperties = {
  small: styled.css(["&{font-size:", "em;min-height:", "em;padding:0 ", "rem;}&{", ";}"], styledTools.theme('fannypack.fontSizes.100'), styled.space(8), styled.space(2), styledTools.theme('fannypack.Button.sizes.small')),
  medium: styled.css(["&{min-height:", "em;padding:0 ", "rem;}&{", ";}"], styled.space(12), styled.space(5), styledTools.theme('fannypack.Button.sizes.medium')),
  large: styled.css(["&{font-size:", "em;min-height:", "em;padding:0 ", "rem;}&{", ";}"], styledTools.theme('fannypack.fontSizes.300'), styled.space(12), styled.space(6), styledTools.theme('fannypack.Button.sizes.large'))
};
var linkProperties = styled.css(["&{border:0;background:unset;color:", ";fill:", ";text-decoration:underline;&:hover{color:", ";fill:", ";}}&{", ";}"], function (props // @ts-ignore
) {
  return props.palette === 'default' ? styledTools.palette('text', 0, defaultPalette.text)(props) : styledTools.palette()(props);
}, function (props // @ts-ignore
) {
  return props.palette === 'default' ? styledTools.palette('text', 0, defaultPalette.text)(props) : styledTools.palette()(props);
}, function (props) {
  return props.palette === 'default' ? // @ts-ignore
  polished.darken(0.5, styledTools.palette('text', 0, defaultPalette.text)(props)) : polished.darken(0.5, styledTools.palette()(props));
}, function (props) {
  return props.palette === 'default' ? // @ts-ignore
  polished.darken(0.5, styledTools.palette('text', 0, defaultPalette.text)(props)) : polished.darken(0.5, styledTools.palette()(props));
}, styledTools.theme('fannypack.Button.link'));
var outlinedProperties = styled.css(["&{background-color:unset;border:1px solid ", ";color:", ";fill:", ";", ";}&{", ";}"], styledTools.palette(), styledTools.palette(), styledTools.palette(), function (props) {
  return isInteractive(props) && styled.css(["&:hover{background-color:", ";color:", ";fill:", ";}"], styledTools.palette(), function (props) {
    return styledTools.palette(props.palette + "Inverted")(props);
  }, function (props) {
    return styledTools.palette(props.palette + "Inverted")(props);
  });
}, styledTools.theme('fannypack.Button.outlined'));
var ghostProperties = styled.css(["&{background-color:unset;border:unset;color:", ";fill:", ";&:hover{background-color:", ";}&:hover:active{background-color:", ";}}&{", ";}"], function (props) {
  return props.palette === 'default' ? styledTools.palette('defaultInverted') : styledTools.palette();
}, function (props) {
  return props.palette === 'default' ? styledTools.palette('defaultInverted') : styledTools.palette();
}, function (props) {
  return polished.darken(0.05, styledTools.palette('default')(props));
}, function (props) {
  return polished.darken(0.1, styledTools.palette('default')(props));
}, styledTools.theme('fannypack.Button.ghost'));
var disabledProperties = styled.css(["&{cursor:not-allowed;opacity:0.7;outline:unset;pointer-events:unset;}&{", ";}"], styledTools.theme('fannypack.Button.disabled'));
var staticProperties = styled.css(["&{cursor:default;outline:unset;&:focus{box-shadow:unset !important;outline:unset !important;}}&{", ";}"], styledTools.theme('fannypack.Button.static'));
var interactiveProperties = styled.css(["&:hover{background-color:", ";}&:hover:active{background-color:", ";}&{", ";}"], function (props) {
  return polished.darken(0.05, styledTools.palette()(props));
}, function (props) {
  return polished.darken(0.1, styledTools.palette()(props));
}, styledTools.theme('fannypack.Button.interactive'));
var loadingProperties = styled.css(["&{cursor:not-allowed;&:focus{box-shadow:unset !important;outline:unset !important;}}&{", ";}"], styledTools.theme('fannypack.Button.loading'));
var ButtonIcon = styled.default(__chunk_3.Icon).withConfig({
  displayName: "styled__ButtonIcon",
  componentId: "sc-1syi5vl-0"
})(["", ";", ";&{", ";}"], function (props) {
  return props.isBefore && styled.css(["margin-left:-", "em;margin-right:", "em;"], styled.space(1), styled.space(2));
}, function (props) {
  return props.isAfter && styled.css(["margin-left:", "em;margin-right:-", "em;"], styled.space(2), styled.space(1));
}, styledTools.theme('fannypack.Button.Icon.base'));
var Button = styled.default(_Button).withConfig({
  displayName: "styled__Button",
  componentId: "sc-1syi5vl-1"
})(["align-items:center;background-color:", ";border-radius:4px;color:", ";fill:", ";cursor:pointer;display:inline-flex;font-weight:", ";min-height:2.5em;justify-content:center;padding:0 0.8rem;text-decoration:none;&:focus{outline:unset;z-index:2;box-shadow:", " 0px 0px 0px 2px;}&[disabled]{", ";}&{", ";}", ";&{", ";}", ";", ";", ";", ";", ";", ";", ";"], styledTools.palette(), function (props) {
  return styledTools.palette(props.palette + "Inverted")(props);
}, function (props) {
  return styledTools.palette(props.palette + "Inverted")(props);
}, styledTools.theme('fannypack.fontWeights.semibold'), function (props) {
  return styledTools.palette(props.palette === 'default' ? 'primary' : props.palette + "300")(props);
}, disabledProperties, styledTools.theme('fannypack.Button.base'), function (props) {
  return props.palette === 'default' && styled.css(["border:1px solid ", ";"], styledTools.palette('gray100'));
}, styledTools.theme('fannypack.Button.base'), function (props) {
  return props.styledSize && sizeProperties[props.styledSize || ''];
}, function (props) {
  return props.isLoading && loadingProperties;
}, function (props) {
  return props.isStatic && staticProperties;
}, function (props) {
  return isInteractive(props) ? interactiveProperties : '';
}, function (props) {
  return props.kind === 'outlined' && outlinedProperties;
}, function (props) {
  return props.kind === 'link' && linkProperties;
}, function (props) {
  return props.kind === 'ghost' && ghostProperties;
});

exports._Button = Button;
exports.ButtonIcon = ButtonIcon;
exports.isInteractive = isInteractive;
