'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var __chunk_3 = require('./chunk-cb567965.js');
var VisuallyHidden = require('./VisuallyHidden.js');
var __chunk_10 = require('./chunk-36dd93f1.js');
var uniqueId = require('./uniqueId.js');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var __chunk_6 = require('./chunk-f77e63ff.js');
var Box = _interopDefault(require('reakit/Box'));
var Flex = _interopDefault(require('reakit/Flex'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/InlineFlex');
require('reakit/Grid');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('airbnb-prop-types');
require('./chunk-fdbfe348.js');
require('./types.js');
require('./Spinner.js');
require('./chunk-c084df69.js');
require('./chunk-36150710.js');
require('polished');
require('reakit/Button');
require('./chunk-1c9fbb5b.js');
require('lodash/omit');

var getTintAttributes = function getTintAttributes(props) {
  var type = props.type,
      hasTint = props.hasTint;

  if (!hasTint || !type) {
    return;
  }

  return styled.css(["background-color:", ";box-shadow:none;color:", ";fill:", ";", ";"], type && styled.palette(type + "Tint")(props), type && styled.palette(type + "TintInverted")(props), type && styled.palette(type + "TintInverted")(props), styled.theme('fannypack.Callout.tint'));
};

var _Callout = styled.default(__chunk_10.CardCard).withConfig({
  displayName: "styled",
  componentId: "sc-578c22-0"
})(["position:relative;", ";&{", ";}"], getTintAttributes, styled.theme('fannypack.Callout.base'));
var CalloutClose = styled.default(__chunk_6.Button).withConfig({
  displayName: "styled__CalloutClose",
  componentId: "sc-578c22-1"
})(["position:absolute;right:0.8rem;top:0.8rem;width:30px;height:30px;padding:0;text-align:right;&:hover{background-color:", ";&{", ";}}", ";"], styled.palette('white700'), styled.theme('fannypack.Callout.Close.hover'), styled.theme('fannypack.Callout.Close.base'));
var CalloutHeader = styled.default(__chunk_10.CardHeader).withConfig({
  displayName: "styled__CalloutHeader",
  componentId: "sc-578c22-2"
})(["display:flex;justify-content:flex-start;&{", ";}"], styled.theme('fannypack.Callout.Header.base'));
var CalloutContent = styled.default(__chunk_10.CardContent).withConfig({
  displayName: "styled__CalloutContent",
  componentId: "sc-578c22-3"
})(["&{", ";}"], styled.theme('fannypack.Callout.Content.base'));
var CalloutTitle = styled.default(__chunk_10.CardTitle).withConfig({
  displayName: "styled__CalloutTitle",
  componentId: "sc-578c22-4"
})(["&{", ";}"], styled.theme('fannypack.Callout.Title.base'));
var CalloutFooter = styled.default(__chunk_10.CardFooter).withConfig({
  displayName: "styled__CalloutFooter",
  componentId: "sc-578c22-5"
})(["&{", ";}"], styled.theme('fannypack.Callout.Footer.base'));
var CalloutIcon = styled.default(__chunk_3.Icon).withConfig({
  displayName: "styled__CalloutIcon",
  componentId: "sc-578c22-6"
})(["margin-right:", "rem;&{", ";}"], styled.space(4), styled.theme('fannypack.Callout.Icon.base'));

var CalloutClose$1 = function CalloutClose$$1(_ref) {
  var onClickClose = _ref.onClickClose,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["onClickClose"]);

  return React.createElement(CalloutClose, __chunk_1._extends({
    kind: "link",
    onClick: onClickClose
  }, props), React.createElement(VisuallyHidden.default, null, "Close"), React.createElement(__chunk_3.Icon, {
    a11yHidden: true,
    icon: "times"
  }));
};
var calloutClosePropTypes = {
  onClickClose: PropTypes.func
};
CalloutClose$1.propTypes = calloutClosePropTypes;
CalloutClose$1.defaultProps = {
  onClickClose: undefined
}; // @ts-ignore

var C = CalloutClose$1;

var Callout = function Callout(_ref) {
  var a11yDescriptionId = _ref.a11yDescriptionId,
      a11yTitleId = _ref.a11yTitleId,
      children = _ref.children,
      closeButtonProps = _ref.closeButtonProps,
      footer = _ref.footer,
      hasTint = _ref.hasTint,
      icon = _ref.icon,
      onClickClose = _ref.onClickClose,
      showCloseButton = _ref.showCloseButton,
      title = _ref.title,
      type = _ref.type,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yDescriptionId", "a11yTitleId", "children", "closeButtonProps", "footer", "hasTint", "icon", "onClickClose", "showCloseButton", "title", "type"]);

  return React.createElement(_Callout, __chunk_1._extends({
    a11yDescriptionId: a11yDescriptionId,
    a11yTitleId: a11yTitleId,
    hasTint: hasTint,
    type: type
  }, props), React.createElement(Flex, null, (type || icon) && React.createElement(CalloutTitle, null, React.createElement(CalloutIcon, {
    icon: type || icon,
    color: type
  })), React.createElement(Box, null, title && React.createElement(CalloutHeader, null, typeof title === 'string' ? React.createElement(CalloutTitle, {
    id: a11yTitleId
  }, title) : title), React.createElement(CalloutContent, {
    id: a11yDescriptionId
  }, children), footer && React.createElement(CalloutFooter, null, footer))), showCloseButton && React.createElement(C, __chunk_1._extends({
    onClickClose: onClickClose
  }, closeButtonProps)));
};
var calloutPropTypes = __chunk_1._objectSpread({
  a11yDescriptionId: PropTypes.string,
  a11yTitleId: PropTypes.string,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  closeButtonProps: PropTypes.shape(calloutClosePropTypes),
  footer: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  hasTint: PropTypes.bool,
  icon: PropTypes.string,
  onClickClose: PropTypes.func,
  showCloseButton: PropTypes.bool,
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  type: PropTypes.string
}, __chunk_10.cardCardPropTypes);
Callout.propTypes = calloutPropTypes;
var calloutDefaultProps = __chunk_1._objectSpread({}, __chunk_10.cardCardDefaultProps, {
  a11yDescriptionId: uniqueId.getUniqueId('Callout'),
  a11yTitleId: uniqueId.getUniqueId('Callout'),
  children: undefined,
  className: undefined,
  closeButtonProps: {},
  footer: undefined,
  hasTint: false,
  icon: undefined,
  onClickClose: undefined,
  showCloseButton: false,
  title: undefined,
  type: undefined
});
Callout.defaultProps = calloutDefaultProps; // @ts-ignore

var C$1 = Callout;

exports._Callout = C$1;
exports.calloutPropTypes = calloutPropTypes;
exports.calloutDefaultProps = calloutDefaultProps;
