'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');

var Pane = styled.default(Box).withConfig({
  displayName: "styled__Pane",
  componentId: "sc-16zc95q-0"
})(["background-color:white;border-radius:3px;", ";", ";", ";", ";", ";&{", ";}"], function (props) {
  return props.styledBorder !== 'shadow' && typeof props.styledBorder !== 'boolean' ? "border: " + props.styledBorder : null;
}, function (props) {
  return props.styledBorder === 'shadow' && styled.css(["box-shadow:0px 2px 4px 0px rgba(0,0,0,0.1),0px 0px 0px 1px rgba(0,0,0,0.1);&{", ";}"], styledTools.theme('fannypack.Pane.border.shadow'));
}, function (props) {
  return props.elevation && styled.css(["box-shadow:0px ", "px ", "px 0px rgba(0,0,0,0.1),0px 0px 0px 1px rgba(0,0,0,0.1);"], function (props // @ts-ignore
  ) {
    return styledTools.theme("fannypack.Pane.elevations." + props.elevation)(props) / 2;
  }, styledTools.theme("fannypack.Pane.elevations." + props.elevation));
}, function (props) {
  return props.styledBorder === true && styled.css(["border:1px solid ", ";&{", ";}"], styledTools.palette('white800'), styledTools.theme('fannypack.Pane.border.default'));
}, function (props) {
  return props.isFullWidth && styled.css(["width:100%;"]);
}, styledTools.theme('fannypack.Pane.base'));

var Pane$1 = function Pane$$1(_ref) {
  var border = _ref.border,
      children = _ref.children,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["border", "children"]);

  return React.createElement(Pane, __chunk_1._extends({
    styledBorder: border
  }, props), children);
};
var panePropTypes = {
  border: PropTypes.oneOfType([PropTypes.bool, PropTypes.oneOf(['shadow'])]),
  className: PropTypes.string,
  children: PropTypes.node,
  isFullWidth: PropTypes.bool,
  elevation: PropTypes.string
};
Pane$1.propTypes = panePropTypes;
var paneDefaultProps = {
  border: false,
  className: undefined,
  children: undefined,
  isFullWidth: false
};
Pane$1.defaultProps = paneDefaultProps;
var C = Pane$1;

exports.Pane = C;
exports.panePropTypes = panePropTypes;
exports.paneDefaultProps = paneDefaultProps;
