'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var types = require('./types.js');
var __chunk_3 = require('./chunk-cb567965.js');
var Spinner = require('./Spinner.js');
var __chunk_5 = require('./chunk-c084df69.js');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');

var Text = styled.default.span.withConfig({
  displayName: "Button__Text",
  componentId: "sc-9gxgrv-0"
})(["align-items:center;display:inline-flex;"]);
var SpinnerWrapper = styled.default(Box).withConfig({
  displayName: "Button__SpinnerWrapper",
  componentId: "sc-9gxgrv-1"
})(["position:absolute;display:flex;align-items:center;justify-content:center;& + ", "{opacity:0;}"], Text);
var Button = function Button(_ref) {
  var children = _ref.children,
      className = _ref.className,
      disabled = _ref.disabled,
      iconAfter = _ref.iconAfter,
      iconBefore = _ref.iconBefore,
      isLoading = _ref.isLoading,
      isStatic = _ref.isStatic,
      kind = _ref.kind,
      palette = _ref.palette,
      size = _ref.size,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["children", "className", "disabled", "iconAfter", "iconBefore", "isLoading", "isStatic", "kind", "palette", "size"]);

  var child = React.createElement(React.Fragment, null, iconBefore && React.createElement(__chunk_5.ButtonIcon, {
    a11yHidden: true,
    icon: iconBefore,
    isBefore: true
  }), children, iconAfter && React.createElement(__chunk_5.ButtonIcon, {
    a11yHidden: true,
    icon: iconAfter,
    isAfter: true
  }));
  return React.createElement(__chunk_5._Button, __chunk_1._extends({
    className: className,
    disabled: disabled,
    isLoading: isLoading,
    isStatic: isStatic,
    kind: kind,
    palette: palette,
    styledSize: size
  }, props), isLoading ? React.createElement(React.Fragment, null, React.createElement(SpinnerWrapper, null, React.createElement(Spinner.Spinner, {
    color: kind === 'default' ? (palette || '') + "Inverted" : palette
  })), React.createElement(Text, null, child)) : child);
};
var buttonPropTypes = {
  autoFocus: PropTypes.bool,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  disabled: PropTypes.bool,
  id: PropTypes.string,
  iconAfter: __chunk_3.iconPropTypes['icon'],
  iconBefore: __chunk_3.iconPropTypes['icon'],
  isLoading: PropTypes.bool,
  isStatic: PropTypes.bool,
  kind: types.buttonTypePropType,
  palette: PropTypes.string,
  size: types.sizePropType,
  type: PropTypes.string
};
Button.propTypes = buttonPropTypes;
var buttonDefaultProps = {
  autoFocus: false,
  className: undefined,
  disabled: false,
  id: undefined,
  iconAfter: undefined,
  iconBefore: undefined,
  isLoading: false,
  isStatic: false,
  kind: 'default',
  palette: 'default',
  size: 'default',
  type: 'button'
};
Button.defaultProps = buttonDefaultProps; // @ts-ignore

var C = Button;

exports.Button = C;
exports.buttonPropTypes = buttonPropTypes;
exports.buttonDefaultProps = buttonDefaultProps;
