'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-3b74065f.js');
var styled = require('./styled.js');
var Text = require('./Text.js');
var Label$1 = require('./Label.js');
var Field = _interopDefault(require('reakit/Field'));
var React = require('react');
var React__default = _interopDefault(React);
var styledTools = require('styled-tools');
var PropTypes = require('prop-types');
var Box = _interopDefault(require('reakit/Box'));
var Flex = _interopDefault(require('reakit/Flex'));
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/InlineFlex');
require('reakit/Grid');

var Label = styled.default(Label$1.default).withConfig({
  displayName: "styled__Label",
  componentId: "ixmo9v-0"
})(["margin-bottom:0 !important;&{", ";}"], styledTools.theme('fannypack.FieldWrapper.label'));
var DescriptionText = styled.default(Text.Text).withConfig({
  displayName: "styled__DescriptionText",
  componentId: "ixmo9v-1"
})(["display:block;font-size:0.8rem;&{", ";}"], styledTools.theme('fannypack.FieldWrapper.description'));
var HintText = styled.default(Text.Text).withConfig({
  displayName: "styled__HintText",
  componentId: "ixmo9v-2"
})(["display:block;font-size:0.8rem;margin-top:", "rem;&{", ";}"], styled.space(1), styledTools.theme('fannypack.FieldWrapper.hint'));
var OptionalText = styled.default(Text.Text).withConfig({
  displayName: "styled__OptionalText",
  componentId: "ixmo9v-3"
})(["font-size:0.8rem;color:", ";margin-left:", "rem;line-height:1;&{", ";}"], styledTools.palette('text100'), styled.space(2), styledTools.theme('fannypack.FieldWrapper.optional'));
var ValidationText = styled.default(Text.Text).withConfig({
  displayName: "styled__ValidationText",
  componentId: "ixmo9v-4"
})(["display:block;font-size:0.8rem;margin-top:", "rem;&{", ";}"], styled.space(1), styledTools.theme('fannypack.FieldWrapper.validation'));
var _FieldWrapper = styled.default(Field).withConfig({
  displayName: "styled",
  componentId: "ixmo9v-5"
})(["&{", ";}"], styledTools.theme('fannypack.FieldWrapper.base'));

var FieldWrapper = function FieldWrapper(_ref) {
  var a11yId = _ref.a11yId,
      children = _ref.children,
      description = _ref.description,
      hint = _ref.hint,
      isOptional = _ref.isOptional,
      isRequired = _ref.isRequired,
      label = _ref.label,
      state = _ref.state,
      validationText = _ref.validationText,
      props = __chunk_1._objectWithoutPropertiesLoose(_ref, ["a11yId", "children", "description", "hint", "isOptional", "isRequired", "label", "state", "validationText"]);

  var elementProps = {
    isRequired: isRequired,
    a11yId: a11yId,
    state: state
  };
  return React.createElement(_FieldWrapper, props, label && React.createElement(Box, {
    marginBottom: "minor-2"
  }, React.createElement(Flex, {
    alignItems: "center"
  }, typeof label === 'string' ? React.createElement(Label, {
    htmlFor: a11yId
  }, label) : label, isOptional && React.createElement(OptionalText, null, "OPTIONAL")), typeof description === 'string' ? React.createElement(DescriptionText, null, description) : React.createElement("div", null, description)), typeof children === 'function' ? children({
    elementProps: elementProps
  }) : React.cloneElement(children, elementProps), typeof hint === 'string' ? React.createElement(HintText, null, hint) : React.createElement("div", null, hint), validationText && React.createElement(ValidationText, {
    color: state
  }, validationText));
};
var fieldWrapperPropTypes = {
  a11yId: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.element, PropTypes.func]).isRequired,
  className: PropTypes.string,
  description: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  hint: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  isOptional: PropTypes.bool,
  isRequired: PropTypes.bool,
  label: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  state: PropTypes.string,
  validationText: PropTypes.string
};
FieldWrapper.propTypes = fieldWrapperPropTypes;
var fieldWrapperDefaultProps = {
  a11yId: undefined,
  className: undefined,
  description: undefined,
  hint: undefined,
  isOptional: undefined,
  isRequired: undefined,
  label: undefined,
  state: undefined,
  validationText: undefined
};
FieldWrapper.defaultProps = fieldWrapperDefaultProps; // @ts-ignore

var C = FieldWrapper;

exports.FieldWrapper = C;
exports.fieldWrapperDefaultProps = fieldWrapperDefaultProps;
exports.fieldWrapperPropTypes = fieldWrapperPropTypes;
