'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('reakit/styled');
var styled__default = _interopDefault(styled);
var _get = _interopDefault(require('lodash/get'));
var styledTools = require('styled-tools');

// @ts-ignore
var space = (function (_scalar, _scaleType) {
  if (_scaleType === void 0) {
    _scaleType = 'minor';
  }

  return function (props) {
    var scalar = _scalar;
    var scaleType = _scaleType;
    if (!scalar) return 0;

    if (typeof scalar === 'string' && (scalar.includes('minor') || scalar.includes('major'))) {
      // @ts-ignore
      var _scalar$split = scalar.split('-');

      scaleType = _scalar$split[0];
      scalar = _scalar$split[1];
      scalar = parseFloat(scalar);
      if (isNaN(scalar)) return 0;
    }

    var unit = _get(props, "theme.fannypack.layout." + scaleType + "Unit");

    var fontSize = _get(props, 'theme.fannypack.global.fontSize');

    return scalar * (unit / fontSize);
  };
});

exports.ThemeProvider = styled.ThemeProvider;
exports.css = styled.css;
exports.keyframes = styled.keyframes;
exports.createGlobalStyle = styled.createGlobalStyle;
exports.isStyledComponent = styled.isStyledComponent;
exports.ThemeConsumer = styled.ThemeConsumer;
exports.withTheme = styled.withTheme;
exports.ServerStyleSheet = styled.ServerStyleSheet;
exports.StyleSheetManager = styled.StyleSheetManager;
exports.prop = styledTools.prop;
exports.theme = styledTools.theme;
exports.palette = styledTools.palette;
exports.ifProp = styledTools.ifProp;
exports.ifNotProp = styledTools.ifNotProp;
exports.switchProp = styledTools.switchProp;
exports.withProp = styledTools.withProp;
exports.space = space;
exports.default = styled__default;
