'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var styled = require('./styled.js');
var __chunk_4 = require('./chunk-36150710.js');
var __chunk_5 = require('./chunk-c084df69.js');
var __chunk_20 = require('./chunk-8fc73837.js');
var polished = require('polished');
require('reakit/styled');
require('lodash/get');
require('styled-tools');
require('./chunk-3b74065f.js');
require('./chunk-cb567965.js');
require('./parseIcons.js');
require('./chunk-ab4246ea.js');
require('reakit/Box');
require('reakit/Block');
require('reakit/Inline');
require('reakit/InlineBlock');
require('reakit/Flex');
require('reakit/InlineFlex');
require('reakit/Grid');
require('react');
require('airbnb-prop-types');
require('prop-types');
require('reakit/Button');
require('@fortawesome/free-solid-svg-icons/faInfoCircle');
require('@fortawesome/free-solid-svg-icons/faExclamationTriangle');
require('@fortawesome/free-solid-svg-icons/faCheckCircle');
require('@fortawesome/free-solid-svg-icons/faExclamationCircle');
require('@fortawesome/free-solid-svg-icons/faTimes');

var global = {
  fontFamily: "'Lato', system-ui, -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Fira Sans', 'Droid Sans', 'Helvetica Neue', sans-serif",
  fallbackFontFamily: "system-ui, -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Fira Sans', 'Droid Sans', 'Helvetica Neue', sans-serif"
};

var webFontLoader = {
  google: {
    families: ['Lato:400,700,900']
  }
};

var layout = {
  mobileBreakpoint: 600
};

var fontWeights = {
  normal: 400,
  semibold: 700,
  bold: 900
};

var _palette = {
  default: 'white',
  text: '#333231',
  primary200: '#d2f1fa',
  primary300: '#a4dbeb',
  primary400: '#51afc9',
  primary: '#007fa3',
  primary500: '#007fa3',
  primary600: '#0e6d8c',
  primary700: '#16556e',
  primary800: '#173c4c',
  secondary200: '#f5cee1',
  secondary300: '#f7a6cf',
  secondary400: '#ed4c9d',
  secondary: '#e70073',
  secondaryInverted: 'white',
  secondary500: '#e70073',
  secondary600: '#d10069',
  secondary700: '#b7005c',
  secondary800: '#98004c',
  success200: '#e8fad7',
  success300: '#caf2a2',
  success400: '#a1ed55',
  success: '#5cb700',
  successInverted: 'white',
  success500: '#5cb700',
  success600: '#4d9801',
  success700: '#376e02',
  success800: '#234701',
  danger200: '#fad4d7',
  danger300: '#ed8893',
  danger400: '#f25a66',
  danger: '#e41625',
  danger500: '#e41625',
  danger600: '#ce1323',
  danger700: '#b4111e',
  danger800: '#850c16'
};

var defaultPalette = __chunk_4._defaultPalette({});

var Button = {
  base: styled.css(["border-radius:0px;border:2px solid ", ";color:", ";height:", "rem;padding:0 ", "rem;font-size:15px;text-transform:uppercase;", ";"], function (props) {
    return props.palette === 'default' ? styled.palette('gray700') : 'transparent';
  }, function (props) {
    return props.palette === 'default' ? styled.palette('gray700') : styled.palette(props.palette + "Inverted");
  }, styled.space(11), styled.space(4), function (props) {
    return __chunk_5.isInteractive(props) && styled.css(["&:focus{outline:2px solid ", ";outline-offset:0;box-shadow:none;background-color:", ";}"], function (props) {
      return props.palette === 'default' ? styled.palette('gray800') : styled.palette();
    }, styled.palette());
  }),
  outlined: styled.css(["border-width:2px;"]),
  ghost: styled.css(["border:2px solid transparent;", ";"], function (props) {
    return __chunk_5.isInteractive(props) && styled.css(["&:hover{background-color:", ";color:", ";fill:", ";}&:hover:active{background-color:", ";}"], function (props) {
      return props.palette === 'default' ? styled.palette('gray700') : styled.palette();
    }, function (props) {
      return props.palette === 'default' ? styled.palette('default') : styled.palette(props.palette + "Inverted");
    }, function (props) {
      return props.palette === 'default' ? styled.palette('default') : styled.palette(props.palette + "Inverted");
    }, function (props) {
      return props.palette === 'default' ? polished.darken(0.1, styled.palette('gray700', 0, defaultPalette.gray700)(props)) : polished.darken(0.1, styled.palette()(props));
    });
  }),
  interactive: styled.css(["&:focus{border:2px solid white;background-color:", ";color:", ";}", ";"], function (props) {
    return props.palette === 'default' ? styled.palette('gray800') : styled.palette(props.palette + "600");
  }, function (props) {
    return props.palette === 'default' ? 'white' : styled.palette(props.palette + "Inverted");
  }, function (props) {
    return props.palette === 'default' && styled.css(["&:hover{background-color:", ";color:white;}&:hover:active{background-color:", ";}"], styled.palette('gray700'), styled.palette('gray800'));
  }),
  link: styled.css(["border:2px solid transparent;background:unset;"]),
  sizes: {
    small: styled.css(["height:", "rem;font-size:15px;padding:0 ", "rem;"], styled.space(8), styled.space(4))
  }
};

var Checkbox = {
  base: styled.css(["border-radius:0px;box-shadow:none;"])
};

var Container = {
  base: styled.css(["", ";"], function (props) {
    return props.isFluid && styled.css(["margin:0px;"]);
  })
};

var Heading = {
  base: styled.css(["font-weight:", ";"], styled.theme('fannypack.fontWeights.semibold')),
  h6: styled.css(["font-size:1.125rem;"])
};

var Input = {
  base: styled.css(["border-radius:0px;box-shadow:none;height:", "em;"], styled.space(11))
};

var Label = {
  base: styled.css(["font-size:14px;"])
};

var Select = {
  base: styled.css(["border-radius:0px;box-shadow:none;height:", "em;"], styled.space(10))
};

var SelectMenu = {
  ActionButton: {
    base: styled.css(["height:", "rem;"], styled.space(2))
  },
  Button: {
    base: styled.css(["border:1px solid #bdbdbd;color:", ";height:", "rem;padding:0.4em 1.4em 0.4em 0.6em;text-transform:unset;", ";"], styled.palette('text'), styled.space(10), function (props) {
      return __chunk_5.isInteractive(props) && styled.css(["&:hover{background-color:unset;color:unset;}&:focus{background-color:unset;color:unset;border:1px solid ", ";outline:unset;box-shadow:", " 0px 0px 0px 1px !important;}"], styled.palette('primary'), styled.palette('primary'));
    })
  }
};

var medipass = {
  // Foundation
  global: global,
  webFontLoader: webFontLoader,
  layout: layout,
  fontWeights: fontWeights,
  palette: _palette,
  // Components
  Button: Button,
  Checkbox: Checkbox,
  Container: Container,
  Heading: Heading,
  Input: Input,
  Label: Label,
  Select: Select,
  SelectMenu: SelectMenu
};

var index = {
  default: __chunk_20.defaultTheme,
  medipass: medipass
};

exports.default = index;
