import * as React from 'react';
import { CardCardProps } from './CardCard';
import { CardContentProps } from './CardContent';
import { CardHeaderProps } from './CardHeader';
import { CardFooterProps } from './CardFooter';
import { CardTitleProps } from './CardTitle';
export declare type LocalCardProps = {
    a11yDescriptionId?: string;
    a11yTitleId?: string;
    children: React.ReactNode;
    className?: string;
    footer?: string | React.ReactElement<any>;
    headerActions?: React.ReactElement<any>;
    isFullWidth?: boolean;
    title?: string | React.ReactElement<any>;
};
export declare type CardProps = CardCardProps & LocalCardProps;
export declare type CardComponents = {
    Card: React.FunctionComponent<CardCardProps>;
    Header: React.FunctionComponent<CardHeaderProps>;
    Content: React.FunctionComponent<CardContentProps>;
    Footer: React.FunctionComponent<CardFooterProps>;
    Title: React.FunctionComponent<CardTitleProps>;
};
export declare const Card: React.FunctionComponent<LocalCardProps> & CardComponents;
declare const C: React.FunctionComponent<CardProps> & CardComponents;
export default C;
