import * as React from 'react';
import * as PropTypes from 'prop-types';
import { LocalPaneProps, PaneProps } from '../Pane/Pane';
export declare type LocalCardCardProps = LocalPaneProps & {
    a11yDescriptionId?: string;
    a11yTitleId?: string;
    children: React.ReactNode;
    className?: string;
};
export declare type CardCardProps = LocalCardCardProps & PaneProps;
export declare const cardCardPropTypes: {
    border: PropTypes.Validator<boolean | "shadow" | undefined>;
    className: PropTypes.Requireable<string>;
    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    isFullWidth: PropTypes.Requireable<boolean>;
    elevation: PropTypes.Requireable<string>;
    a11yDescriptionId: PropTypes.Requireable<string>;
    a11yTitleId: PropTypes.Requireable<string>;
};
export declare const cardCardDefaultProps: {
    a11yDescriptionId: undefined;
    a11yTitleId: undefined;
    border: "shadow";
    children: undefined;
    className: undefined;
    isFullWidth: boolean;
};
declare const C: React.FunctionComponent<CardCardProps>;
export default C;
