import * as React from 'react';
import * as PropTypes from 'prop-types';
import { LabelProps as ReakitLabelProps } from 'reakit/ts';
export declare type LocalCheckboxProps = {
    /** Automatically focus on the checkbox */
    autoFocus?: boolean;
    checked?: boolean;
    className?: string;
    /** Is the checkbox checked by default? */
    defaultChecked?: boolean;
    /** Disables the checkbox */
    disabled?: boolean;
    /** ID for the checkbox */
    id?: string;
    indeterminate?: boolean;
    /** Makes the checkbox required and sets aria-invalid to true */
    isRequired?: boolean;
    /** Checkbox label */
    label?: string;
    name?: string;
    /** State of the checkbox. Can be any color in the palette. */
    state?: string;
    /** Initial value of the checkbox */
    value?: boolean | string;
    /** Function to invoke when focus is lost */
    onBlur?: React.FocusEventHandler<HTMLInputElement>;
    /** Function to invoke when checkbox has changed */
    onChange?: React.FormEventHandler<HTMLInputElement>;
    /** Function to invoke when checkbox is focused */
    onFocus?: React.FocusEventHandler<HTMLInputElement>;
};
export declare type CheckboxProps = LocalCheckboxProps & ReakitLabelProps;
export declare const Checkbox: React.FunctionComponent<LocalCheckboxProps>;
export declare const checkboxPropTypes: {
    autoFocus: PropTypes.Requireable<boolean>;
    checked: PropTypes.Requireable<boolean>;
    className: PropTypes.Requireable<string>;
    defaultChecked: PropTypes.Requireable<boolean>;
    disabled: PropTypes.Requireable<boolean>;
    id: PropTypes.Requireable<string>;
    indeterminate: PropTypes.Requireable<boolean>;
    isRequired: PropTypes.Requireable<boolean>;
    label: PropTypes.Requireable<string>;
    name: PropTypes.Requireable<string>;
    state: PropTypes.Requireable<string>;
    value: PropTypes.Requireable<string | boolean>;
    onBlur: PropTypes.Requireable<(...args: any[]) => any>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    onFocus: PropTypes.Requireable<(...args: any[]) => any>;
};
export declare const checkboxDefaultProps: {
    autoFocus: boolean;
    checked: undefined;
    className: undefined;
    defaultChecked: undefined;
    disabled: boolean;
    id: undefined;
    indeterminate: boolean;
    isRequired: boolean;
    label: undefined;
    onBlur: undefined;
    onChange: undefined;
    onFocus: undefined;
    name: undefined;
    state: undefined;
    value: undefined;
};
declare const C: React.FunctionComponent<CheckboxProps>;
export default C;
