import * as React from 'react';
import * as PropTypes from 'prop-types';
import { BoxProps as ReakitBoxProps } from 'reakit/ts';
export declare type LocalHighlightedCodeProps = {
    children: React.ReactNode;
    className?: string;
    codeClassName?: string;
    isBlock?: boolean;
    lang: string;
    showLabel?: boolean;
    showLineNumbers?: boolean;
};
export declare type HighlightedCodeProps = LocalHighlightedCodeProps & ReakitBoxProps;
export declare class HighlightedCode extends React.PureComponent<LocalHighlightedCodeProps> {
    static propTypes: {
        children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
        className: PropTypes.Requireable<string>;
        codeClassName: PropTypes.Requireable<string>;
        isBlock: PropTypes.Requireable<boolean>;
        lang: PropTypes.Validator<string>;
        showLabel: PropTypes.Requireable<boolean>;
        showLineNumbers: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        className: undefined;
        codeClassName: undefined;
        isBlock: boolean;
        showLabel: boolean;
        showLineNumbers: boolean;
    };
    componentDidMount: () => void;
    render: () => JSX.Element;
}
declare const C: React.FunctionComponent<HighlightedCodeProps>;
export default C;
