import * as React from 'react';
import { Omit } from '../types';
import { ActionButtonsProps } from '../Button/ActionButtons';
import { ButtonProps } from '../Button/Button';
import { DialogDialogProps, LocalDialogDialogProps } from './DialogDialog';
import { DialogContentProps } from './DialogContent';
import { DialogHeaderProps } from './DialogHeader';
import { DialogFooterProps } from './DialogFooter';
import { DialogTitleProps } from './DialogTitle';
import { DialogCloseProps } from './DialogClose';
import { DialogIconProps } from './DialogIcon';
export declare type LocalDialogProps = LocalDialogDialogProps & {
    actionButtonsProps?: ActionButtonsProps;
    a11yDescriptionId?: string;
    a11yTitleId?: string;
    children: React.ReactNode;
    className?: string;
    closeButtonProps?: Omit<ButtonProps, 'children'>;
    footer?: string | React.ReactElement<any>;
    onClickClose?: () => void;
    showActionButtons?: boolean;
    showCloseButton?: boolean;
    title?: string | React.ReactElement<any>;
    type?: string;
};
export declare type DialogProps = LocalDialogProps & DialogDialogProps;
export declare type DialogComponents = {
    Dialog: React.FunctionComponent<DialogDialogProps>;
    Content: React.FunctionComponent<DialogContentProps>;
    Header: React.FunctionComponent<DialogHeaderProps>;
    Footer: React.FunctionComponent<DialogFooterProps>;
    Title: React.FunctionComponent<DialogTitleProps>;
    Close: React.FunctionComponent<DialogCloseProps>;
    Icon: React.FunctionComponent<DialogIconProps>;
};
export declare const Dialog: React.FunctionComponent<LocalDialogProps> & DialogComponents;
declare const C: React.FunctionComponent<DialogProps> & DialogComponents;
export default C;
