import * as React from 'react';
import * as PropTypes from 'prop-types';
import { LocalPaneProps, PaneProps } from '../Pane/Pane';
export declare type LocalDialogDialogProps = LocalPaneProps & {
    a11yDescriptionId?: string;
    a11yTitleId?: string;
    children: React.ReactNode;
    className?: string;
    kind?: 'alert' | undefined;
};
export declare type DialogDialogProps = LocalDialogDialogProps & PaneProps;
export declare const DialogDialog: React.FunctionComponent<LocalDialogDialogProps>;
export declare const dialogDialogPropTypes: {
    children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
    border: PropTypes.Validator<boolean | "shadow" | undefined>;
    className: PropTypes.Requireable<string>;
    isFullWidth: PropTypes.Requireable<boolean>;
    elevation: PropTypes.Requireable<string>;
    a11yDescriptionId: PropTypes.Requireable<string>;
    a11yTitleId: PropTypes.Requireable<string>;
    kind: PropTypes.Validator<"alert" | undefined>;
};
export declare const dialogDialogDefaultProps: {
    a11yDescriptionId: undefined;
    a11yTitleId: undefined;
    border: boolean;
    className: undefined;
    kind: undefined;
    children: undefined;
    isFullWidth: boolean;
};
declare const C: React.FunctionComponent<DialogDialogProps>;
export default C;
