import * as React from 'react';
import { ActionButtonsProps } from '../Button/ActionButtons';
import { ModalProps, LocalModalProps } from '../Modal/Modal';
import { Omit, AnimateProps, RestrictHideProps } from '../types';
export declare type LocalDialogModalProps = AnimateProps & RestrictHideProps & Omit<LocalModalProps, 'children'> & {
    a11yDescriptionId?: string;
    a11yTitleId?: string;
    actionButtonsProps?: ActionButtonsProps;
    children: (({ initialFocusRef }: {
        initialFocusRef: React.RefObject<HTMLElement>;
    }) => React.ReactNode) | React.ReactNode;
    className?: string;
    footer?: (({ initialFocusRef }: {
        initialFocusRef: React.RefObject<HTMLElement>;
    }) => React.ReactNode) | string | React.ReactElement<any>;
    hide?(): void;
    /** Whether or not to show the modal component */
    isVisible?: boolean;
    kind?: 'alert';
    showActionButtons?: boolean;
    showCloseButton?: boolean;
    title?: string | React.ReactElement<any>;
    type?: string;
};
export declare type DialogModalProps = Omit<ModalProps, 'children'> & LocalDialogModalProps;
export declare const DialogModal: React.FunctionComponent<LocalDialogModalProps>;
declare const C: React.FunctionComponent<DialogModalProps>;
export default C;
