import * as React from 'react';
import { HiddenProps as ReakitHiddenProps } from 'reakit/ts/Hidden/Hidden';
import { AnimateProps, RestrictHideProps } from '../types';
import { HiddenContainerProps } from './HiddenContainer';
import { HiddenShowProps } from './HiddenShow';
import { HiddenHideProps } from './HiddenHide';
import { HiddenToggleProps } from './HiddenToggle';
export declare type LocalHiddenProps = AnimateProps & RestrictHideProps & {
    children: React.ReactNode;
    className?: string;
    isVisible?: boolean;
};
export declare type HiddenProps = ReakitHiddenProps & LocalHiddenProps;
export declare type HiddenComponents = {
    Container: React.FunctionComponent<HiddenContainerProps>;
    Show: React.FunctionComponent<HiddenShowProps>;
    Hide: React.FunctionComponent<HiddenHideProps>;
    Toggle: React.FunctionComponent<HiddenToggleProps>;
};
export declare const Hidden: React.FunctionComponent<LocalHiddenProps> & HiddenComponents;
declare const C: React.FunctionComponent<HiddenProps> & HiddenComponents;
export default C;
