import * as React from 'react';
import { ImageProps as ReakitImageProps } from 'reakit/ts';
export declare type LocalImageProps = {
    children?: React.ReactNode;
    className?: string;
    /** How the image fits its bounds */
    fit?: 'cover' | 'contain';
    /** Positioning of the fitted image. Value can be "top", "left", "center", "right", "bottom" or an "x y" coordinate */
    fitPosition?: string;
    /** Fix the width of the image. It will not be responsive. */
    isFixed?: boolean;
};
export declare type ImageProps = LocalImageProps & ReakitImageProps;
export declare const Image: React.FunctionComponent<LocalImageProps>;
declare const C: React.FunctionComponent<ImageProps>;
export default C;
