import * as React from 'react';
import * as PropTypes from 'prop-types';
import { LocalNavigationProps, NavigationProps } from '../Navigation/Navigation';
import { MenuButtonProps } from './MenuButton';
import { MenuDividerProps } from './MenuDivider';
import { MenuGroupProps } from './MenuGroup';
import { MenuItemProps } from './MenuItem';
import { MenuPopoverProps } from './MenuPopover';
import { MenuContextState } from './MenuContext';
export declare type LocalMenuProps = LocalNavigationProps & {
    children: React.ReactNode;
    context?: MenuContextState;
    isHorizontal?: boolean;
    setInitialFocus?: boolean;
};
export declare type MenuProps = NavigationProps & LocalMenuProps;
export declare type MenuComponents = {
    Button: React.FunctionComponent<MenuButtonProps>;
    Divider: React.FunctionComponent<MenuDividerProps>;
    Group: React.FunctionComponent<MenuGroupProps>;
    Item: React.FunctionComponent<MenuItemProps>;
    Popover: React.FunctionComponent<MenuPopoverProps>;
};
declare type State = {
    activeItemIndex: number;
};
export declare class Menu extends React.Component<LocalMenuProps, State> {
    static propTypes: {
        children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
        isHorizontal: PropTypes.Requireable<boolean>;
        a11yTitle: PropTypes.Requireable<string>;
        className: PropTypes.Requireable<string>;
        use: PropTypes.Requireable<any>;
    };
    static defaultProps: {
        isHorizontal: boolean;
        setInitialFocus: boolean;
        a11yTitle: undefined;
        className: undefined;
        use: undefined;
    };
    menu: React.RefObject<HTMLElement>;
    state: {
        activeItemIndex: number;
    };
    componentDidUpdate: (prevProps: import("reakit/ts/Navigation/Navigation").NavigationProps & LocalNavigationProps & {
        children: React.ReactNode;
        context?: MenuContextState | undefined;
        isHorizontal?: boolean | undefined;
        setInitialFocus?: boolean | undefined;
    }) => void;
    handleKeyDown: (e: React.KeyboardEvent<any>) => void;
    handleFocus: () => void;
    render: () => JSX.Element;
}
declare const C: React.FunctionComponent<MenuProps> & MenuComponents;
export default C;
