import * as React from 'react';
import * as PropTypes from 'prop-types';
import { LocalButtonProps, ButtonProps } from '../Button/Button';
import { Omit } from '../types';
import { MenuContextState } from './MenuContext';
export declare type LocalMenuButtonProps = LocalButtonProps & {
    context?: MenuContextState;
    isVisible?: boolean;
    onClick?(e: React.MouseEvent<any>): void;
};
export declare type MenuButtonProps = Omit<ButtonProps, 'as'> & LocalMenuButtonProps;
export declare class MenuButton extends React.Component<LocalMenuButtonProps> {
    static propTypes: {
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        autoFocus: PropTypes.Requireable<boolean>;
        children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
        className: PropTypes.Requireable<string>;
        disabled: PropTypes.Requireable<boolean>;
        id: PropTypes.Requireable<string>;
        iconAfter: PropTypes.Validator<string | import("../parseIcons").ParsedIcon>;
        iconBefore: PropTypes.Validator<string | import("../parseIcons").ParsedIcon>;
        isLoading: PropTypes.Requireable<boolean>;
        isStatic: PropTypes.Requireable<boolean>;
        kind: PropTypes.Validator<import("../types/props").ButtonType>;
        palette: PropTypes.Requireable<string>;
        size: PropTypes.Validator<import("../types/props").Size>;
        type: PropTypes.Requireable<string>;
    };
    static defaultProps: {
        autoFocus?: boolean | undefined;
        children?: React.ReactNode;
        className?: string | undefined;
        disabled?: boolean | undefined;
        id?: string | undefined;
        iconAfter?: string | import("../parseIcons").ParsedIcon | undefined;
        iconBefore?: string | import("../parseIcons").ParsedIcon | undefined;
        isLoading?: boolean | undefined;
        isStatic?: boolean | undefined;
        kind?: "default" | "link" | "outlined" | "ghost" | undefined;
        palette?: string | undefined;
        size?: "medium" | "default" | "small" | "large" | "xlarge" | "xxlarge" | "xxxlarge" | undefined;
        type?: string | undefined;
    };
    handleKeyDown: (e: React.KeyboardEvent<any>) => void;
    render: () => JSX.Element;
}
declare const C: React.FunctionComponent<MenuButtonProps>;
export default C;
