import * as React from 'react';
import * as PropTypes from 'prop-types';
import { ButtonProps as ReakitButtonProps } from 'reakit/ts/Button/Button';
import { Omit } from '../types';
import { IconProps } from '../Icon/Icon';
import { MenuContextState } from './MenuContext';
export declare type LocalMenuItemProps = {
    children: React.ReactNode;
    context?: MenuContextState;
    hideOnClick?: boolean;
    icon?: IconProps['icon'];
    isActive?: boolean;
    isDisabled?: boolean;
    onClick?(): void;
};
export declare type MenuItemProps = Omit<Omit<ReakitButtonProps, 'as'>, 'elementRef'> & LocalMenuItemProps;
export declare const menuItemPropTypes: {
    children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
    hideOnClick: PropTypes.Requireable<boolean>;
    icon: PropTypes.Validator<string | import("../parseIcons").ParsedIcon>;
    isActive: PropTypes.Requireable<boolean>;
    isDisabled: PropTypes.Requireable<boolean>;
    onClick: PropTypes.Requireable<(...args: any[]) => any>;
};
export declare const menuItemDefaultProps: {
    hideOnClick: boolean;
    icon: undefined;
    isActive: boolean;
    isDisabled: boolean;
    onClick: undefined;
};
export declare class MenuItem extends React.Component<LocalMenuItemProps> {
    static propTypes: {
        children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
        hideOnClick: PropTypes.Requireable<boolean>;
        icon: PropTypes.Validator<string | import("../parseIcons").ParsedIcon>;
        isActive: PropTypes.Requireable<boolean>;
        isDisabled: PropTypes.Requireable<boolean>;
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
    };
    static defaultProps: {
        hideOnClick: boolean;
        icon: undefined;
        isActive: boolean;
        isDisabled: boolean;
        onClick: undefined;
    };
    handleClick: () => void;
    render: () => JSX.Element;
}
declare const C: React.FunctionComponent<MenuItemProps>;
export default C;
