import * as React from 'react';
import * as PropTypes from 'prop-types';
import { LocalPopoverProps, PopoverProps } from '../Popover/Popover';
export declare type LocalMenuPopoverProps = LocalPopoverProps & {
    children: React.ReactNode;
};
export declare type MenuPopoverProps = PopoverProps & LocalMenuPopoverProps;
export declare class MenuPopover extends React.Component<LocalMenuPopoverProps> {
    static propTypes: {
        children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
        className: PropTypes.Requireable<string>;
        content: PropTypes.Validator<string | React.ReactElement<any> | (({ initialFocusRef, ...args }: {
            initialFocusRef?: React.RefObject<any> | undefined;
        } & import("../Popover/PopoverContainer").PopoverContainerRenderProps) => React.ReactNode)>;
        showCloseButton: PropTypes.Requireable<boolean>;
        hideOnEsc: PropTypes.Requireable<boolean>;
        hideOnClickOutside: PropTypes.Requireable<boolean>;
        delay: PropTypes.Requireable<string>;
        duration: PropTypes.Requireable<string>;
        expand: PropTypes.Validator<boolean | "bottom" | "left" | "right" | "top" | "center" | undefined>;
        fade: PropTypes.Requireable<boolean>;
        slide: PropTypes.Validator<boolean | "bottom" | "left" | "right" | "top" | undefined>;
        timing: PropTypes.Requireable<string>;
        isVisible: PropTypes.Requireable<boolean>;
        flip: PropTypes.Requireable<boolean>;
        gutter: PropTypes.Requireable<string | number>;
        placement: PropTypes.Validator<import("../types/props").Placement>;
        shift: PropTypes.Requireable<boolean>;
        trapFocus: PropTypes.Requireable<boolean>;
    };
    static defaultProps: {
        className: undefined;
        showCloseButton: boolean;
        children: undefined;
        isVisible?: boolean | undefined;
        flip?: boolean | undefined;
        gutter?: string | number | undefined;
        placement?: "bottom" | "left" | "right" | "top" | "auto" | "top-start" | "right-start" | "bottom-start" | "left-start" | "top-end" | "right-end" | "bottom-end" | "left-end" | undefined;
        shift?: boolean | undefined;
        trapFocus?: boolean | undefined;
        delay?: string | undefined;
        duration?: string | undefined;
        expand?: boolean | "bottom" | "left" | "right" | "top" | "center" | undefined;
        fade?: boolean | undefined;
        slide?: boolean | "bottom" | "left" | "right" | "top" | undefined;
        timing?: string | undefined;
        hideOnEsc?: boolean | undefined;
        hideOnClickOutside?: boolean | undefined;
    };
    render: () => JSX.Element;
}
declare const C: React.FunctionComponent<MenuPopoverProps>;
export default C;
