import * as React from 'react';
import { OverlayProps } from '../Overlay/Overlay';
import { ModalContainerProps } from './ModalContainer';
import { ModalHideProps } from './ModalHide';
import { ModalShowProps } from './ModalShow';
import { AnimateProps, RestrictHideProps } from '../types';
export declare type LocalModalProps = {
    children: React.ReactNode | (({ fallbackFocusRef, initialFocusRef }: {
        fallbackFocusRef: React.RefObject<HTMLElement>;
        initialFocusRef: React.RefObject<HTMLElement>;
    }) => React.ReactNode);
    className?: string;
    /** Whether or not to show the modal component */
    isVisible?: boolean;
    hide?(): void;
    kind?: 'alert' | void;
    showActionButtons?: boolean;
    showCloseButton?: boolean;
} & RestrictHideProps & AnimateProps;
export declare type ModalProps = OverlayProps & LocalModalProps;
export declare type ModalComponents = {
    Container: React.FunctionComponent<ModalContainerProps>;
    Hide: React.FunctionComponent<ModalHideProps>;
    Show: React.FunctionComponent<ModalShowProps>;
};
export declare const Modal: React.FunctionComponent<LocalModalProps> & ModalComponents;
declare const C: React.FunctionComponent<ModalProps> & ModalComponents;
export default C;
