import * as React from 'react';
import * as PropTypes from 'prop-types';
import { NavigationProps as ReakitNavigationProps } from 'reakit/ts';
export declare type LocalNavigationProps = {
    a11yTitle?: string;
    children: React.ReactNode;
    className?: string;
    use?: any;
};
export declare type NavigationProps = ReakitNavigationProps & LocalNavigationProps;
export declare const Navigation: React.FunctionComponent<LocalNavigationProps>;
export declare const navigationPropTypes: {
    a11yTitle: PropTypes.Requireable<string>;
    children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
    className: PropTypes.Requireable<string>;
    use: PropTypes.Requireable<any>;
};
export declare const navigationDefaultProps: {
    a11yTitle: undefined;
    className: undefined;
    use: undefined;
};
declare const C: React.FunctionComponent<NavigationProps>;
export default C;
