import * as React from 'react';
import * as PropTypes from 'prop-types';
import { PopoverProps as ReakitPopoverProps } from 'reakit/ts/Popover/Popover';
import { Omit } from '../types';
import { PopoverContainerProps, PopoverContainerRenderProps } from './PopoverContainer';
import { PopoverCloseProps } from './PopoverClose';
import { LocalPopoverPopoverProps, PopoverPopoverProps } from './PopoverPopover';
import { PopoverShowProps } from './PopoverShow';
import { PopoverHideProps } from './PopoverHide';
import { PopoverToggleProps } from './PopoverToggle';
export declare type LocalPopoverProps = LocalPopoverPopoverProps & {
    children: React.ReactNode | (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode);
    className?: string;
    content: string | React.ReactElement<any> | (({ initialFocusRef, ...args }: {
        initialFocusRef?: React.RefObject<any>;
    } & PopoverContainerRenderProps) => React.ReactNode);
    /** Displays a cross button in the top right corner of the popover content. */
    showCloseButton?: boolean;
};
export declare type PopoverProps = Omit<ReakitPopoverProps, 'content'> & LocalPopoverProps;
export declare type PopoverComponents = {
    Popover: React.FunctionComponent<PopoverPopoverProps>;
    Container: React.FunctionComponent<PopoverContainerProps>;
    Close: React.FunctionComponent<PopoverCloseProps>;
    Hide: React.FunctionComponent<PopoverHideProps>;
    Show: React.FunctionComponent<PopoverShowProps>;
    Toggle: React.FunctionComponent<PopoverToggleProps>;
};
export declare const Popover: React.FunctionComponent<LocalPopoverProps> & PopoverComponents;
export declare const popoverPropTypes: {
    className: PropTypes.Requireable<string>;
    content: PropTypes.Validator<string | React.ReactElement<any> | (({ initialFocusRef, ...args }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    } & PopoverContainerRenderProps) => React.ReactNode)>;
    showCloseButton: PropTypes.Requireable<boolean>;
    children: PropTypes.Validator<string | number | boolean | {} | React.ReactElement<any> | React.ReactNodeArray | React.ReactPortal | (string & React.ReactElement<any>) | (string & {}) | (string & React.ReactNodeArray) | (string & React.ReactPortal) | (number & {}) | (number & React.ReactElement<any>) | (number & React.ReactNodeArray) | (number & React.ReactPortal) | (false & {}) | (false & React.ReactElement<any>) | (false & React.ReactNodeArray) | (false & React.ReactPortal) | (true & {}) | (true & React.ReactElement<any>) | (true & React.ReactNodeArray) | (true & React.ReactPortal) | (React.ReactElement<any> & string) | (React.ReactElement<any> & number) | (React.ReactElement<any> & false) | (React.ReactElement<any> & true) | (React.ReactElement<any> & React.ReactNodeArray) | (React.ReactElement<any> & React.ReactPortal) | (React.ReactNodeArray & string) | (React.ReactNodeArray & number) | (React.ReactNodeArray & false) | (React.ReactNodeArray & true) | (React.ReactNodeArray & React.ReactElement<any>) | (React.ReactNodeArray & React.ReactPortal) | (React.ReactPortal & string) | (React.ReactPortal & number) | (React.ReactPortal & false) | (React.ReactPortal & true) | (React.ReactPortal & React.ReactElement<any>) | (React.ReactPortal & React.ReactNodeArray) | (({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) | ((({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) & string) | ((({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) & number) | ((({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) & false) | ((({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) & true) | ((({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) & React.ReactElement<any>) | ((({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) & React.ReactNodeArray) | ((({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) & React.ReactPortal) | (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode) | (string & (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode)) | (number & (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode)) | (false & (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode)) | (true & (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode)) | (React.ReactElement<any> & (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode)) | (React.ReactNodeArray & (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode)) | (React.ReactPortal & (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode)) | ((({ initialFocusRef }: {
        initialFocusRef?: React.RefObject<any> | undefined;
    }) => React.ReactNode) & (({ use, ...args }: PopoverContainerRenderProps & {
        use: React.ReactElement<any>;
    }) => React.ReactNode)) | null | undefined>;
    hideOnEsc: PropTypes.Requireable<boolean>;
    hideOnClickOutside: PropTypes.Requireable<boolean>;
    delay: PropTypes.Requireable<string>;
    duration: PropTypes.Requireable<string>;
    expand: PropTypes.Validator<boolean | "bottom" | "left" | "right" | "top" | "center" | undefined>;
    fade: PropTypes.Requireable<boolean>;
    slide: PropTypes.Validator<boolean | "bottom" | "left" | "right" | "top" | undefined>;
    timing: PropTypes.Requireable<string>;
    isVisible: PropTypes.Requireable<boolean>;
    flip: PropTypes.Requireable<boolean>;
    gutter: PropTypes.Requireable<string | number>;
    placement: PropTypes.Validator<import("../types/props").Placement>;
    shift: PropTypes.Requireable<boolean>;
    trapFocus: PropTypes.Requireable<boolean>;
};
export declare const popoverDefaultProps: {
    className: undefined;
    showCloseButton: boolean;
    children: undefined;
    isVisible?: boolean | undefined;
    flip?: boolean | undefined;
    gutter?: string | number | undefined;
    placement?: "bottom" | "left" | "right" | "top" | "auto" | "top-start" | "right-start" | "bottom-start" | "left-start" | "top-end" | "right-end" | "bottom-end" | "left-end" | undefined;
    shift?: boolean | undefined;
    trapFocus?: boolean | undefined;
    delay?: string | undefined;
    duration?: string | undefined;
    expand?: boolean | "bottom" | "left" | "right" | "top" | "center" | undefined;
    fade?: boolean | undefined;
    slide?: boolean | "bottom" | "left" | "right" | "top" | undefined;
    timing?: string | undefined;
    hideOnEsc?: boolean | undefined;
    hideOnClickOutside?: boolean | undefined;
};
declare const C: React.FunctionComponent<PopoverProps> & PopoverComponents;
export default C;
