import * as React from 'react';
import { LabelProps as ReakitLabelProps } from 'reakit/ts';
export declare type LocalRadioProps = {
    /** An accessible id for the radio */
    a11yId?: string;
    /** Automatically focus on the radio */
    autoFocus?: boolean;
    checked?: boolean;
    className?: string;
    /** Is the radio checked by default */
    defaultChecked?: boolean;
    /** Disables the radio */
    disabled?: boolean;
    /** Makes the radio required and sets aria-invalid to true */
    isRequired?: boolean;
    /** radio label */
    label: string;
    name?: string;
    /** State of the radio. Can be any color in the palette. */
    state?: string;
    /** Controlled value of the radio */
    value?: string;
    /** Function to invoke when focus is lost */
    onBlur?: React.FocusEventHandler<HTMLInputElement>;
    /** Function to invoke when input has changed */
    onChange?: React.FormEventHandler<HTMLInputElement>;
    /** Function to invoke when input is focused */
    onFocus?: React.FocusEventHandler<HTMLInputElement>;
};
export declare type RadioProps = ReakitLabelProps & LocalRadioProps;
export declare const Radio: React.FunctionComponent<LocalRadioProps>;
declare const C: React.FunctionComponent<RadioProps>;
export default C;
