import * as React from 'react';
import * as PropTypes from 'prop-types';
import { BoxProps as ReakitBoxProps } from 'reakit/ts';
export declare type LocalRadioGroupProps = {
    /** An accessible ID for the radio group */
    a11yId?: string;
    /** An accessible label for the radio group */
    a11yLabel?: string;
    className?: string;
    /** Default value of the radio group */
    defaultValue?: string;
    /** Disables the radio group */
    disabled?: boolean;
    isHorizontal?: boolean;
    name: string;
    /** Radio group options */
    options: Array<{
        disabled?: boolean;
        label: string;
        value: string;
    }>;
    /** State of the radio group. Can be any color in the palette. */
    state?: string;
    /** Controlled value of the radio group */
    value?: string;
    /** Function to invoke when radio group has changed */
    onChange?: React.FormEventHandler<HTMLInputElement>;
};
export declare type RadioGroupProps = ReakitBoxProps & LocalRadioGroupProps;
export declare const RadioGroup: React.FunctionComponent<LocalRadioGroupProps>;
export declare const radioGroupPropTypes: {
    a11yId: PropTypes.Requireable<string>;
    a11yLabel: PropTypes.Requireable<string>;
    className: PropTypes.Requireable<string>;
    defaultValue: PropTypes.Requireable<string>;
    disabled: PropTypes.Requireable<boolean>;
    isHorizontal: PropTypes.Requireable<boolean>;
    name: PropTypes.Validator<string>;
    options: PropTypes.Validator<any[]>;
    state: PropTypes.Requireable<string>;
    value: PropTypes.Requireable<string>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
};
export declare const radioGroupDefaultProps: {
    a11yId: undefined;
    a11yLabel: undefined;
    className: undefined;
    defaultValue: undefined;
    disabled: boolean;
    isHorizontal: boolean;
    onChange: undefined;
    state: undefined;
    value: undefined;
};
declare const C: React.FunctionComponent<RadioGroupProps>;
export default C;
