import * as React from 'react';
import { BoxProps as ReakitBoxProps } from 'reakit/ts';
import { Omit, Size } from '../types';
export declare type LocalRatingProps = {
    className?: string;
    size?: Size;
    defaultRating?: number;
    maxRating?: number;
    onRate?: ({ rating, maxRating }: {
        rating: number;
        maxRating?: number;
    }) => void;
    disabled?: boolean;
};
export declare type RatingProps = LocalRatingProps & Omit<ReakitBoxProps, 'size'>;
export declare type RatingState = {
    rating: number | undefined;
    isSelecting: boolean;
    selectedIndex: number | undefined;
};
export declare class Rating extends React.Component<LocalRatingProps, RatingState> {
    static defaultProps: {
        className: undefined;
        size: string;
        defaultRating: number;
        maxRating: number;
        onRate: undefined;
        disabled: boolean;
    };
    state: {
        rating: number;
        isSelecting: boolean;
        selectedIndex: number;
    };
    handleStarClick: (index: number) => void;
    handleStarMouseOver: (index: number) => void;
    handleMouseLeave: () => void;
    render(): JSX.Element;
}
declare const C: React.FunctionComponent<RatingProps>;
export default C;
