import * as React from 'react';
import { LocalSelectProps, SelectProps } from './Select';
import { LocalFieldWrapperProps } from '../FieldWrapper/FieldWrapper';
import { Omit } from '../types';
export declare type LocalSelectFieldProps = Omit<LocalFieldWrapperProps, 'children'> & LocalSelectProps & {
    /** Addon component to the input (before). Similar to the addon components in Input. */
    addonBefore?: React.ReactElement<any>;
    /** Addon component to the input (after). Similar to the addon components in Input. */
    addonAfter?: React.ReactElement<any>;
    /** If addonBefore or addonAfter exists, then the addons will render vertically. */
    isVertical?: boolean;
};
export declare type SelectFieldProps = LocalSelectFieldProps & SelectProps;
export declare const SelectField: React.FunctionComponent<LocalSelectFieldProps>;
declare const C: React.FunctionComponent<SelectFieldProps>;
export default C;
