import * as React from 'react';
import { LocalSelectMenuProps, SelectMenuProps } from './SelectMenu';
import { LocalFieldWrapperProps } from '../FieldWrapper/FieldWrapper';
import { Omit } from '../types';
export declare type LocalSelectMenuFieldProps = Omit<LocalFieldWrapperProps, 'children'> & LocalSelectMenuProps & {
    /** Addon component to the input (before). Similar to the addon components in Input. */
    addonBefore?: React.ReactElement<any>;
    /** Addon component to the input (after). Similar to the addon components in Input. */
    addonAfter?: React.ReactElement<any>;
    /** If addonBefore or addonAfter exists, then the addons will render vertically. */
    isVertical?: boolean;
};
export declare type SelectMenuFieldProps = SelectMenuProps & LocalSelectMenuFieldProps;
export declare const SelectMenuField: React.FunctionComponent<LocalSelectMenuFieldProps>;
declare const C: React.FunctionComponent<SelectMenuFieldProps>;
export default C;
