import * as React from 'react';
import * as PropTypes from 'prop-types';
import { LocalInputProps, InputProps } from '../Input/Input';
export declare type LocalSelectMenuSearchInputProps = LocalInputProps & {
    isDropdownActive?: boolean;
};
export declare type SelectMenuSearchInputProps = InputProps & LocalSelectMenuSearchInputProps;
export declare const selectMenuSearchInputPropTypes: {
    after: PropTypes.Requireable<PropTypes.ReactElementLike>;
    a11yId: PropTypes.Requireable<string>;
    a11yLabel: PropTypes.Requireable<string>;
    autoComplete: PropTypes.Requireable<string>;
    autoFocus: PropTypes.Requireable<boolean>;
    before: PropTypes.Requireable<PropTypes.ReactElementLike>;
    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    className: PropTypes.Requireable<string>;
    defaultValue: PropTypes.Requireable<string>;
    disabled: PropTypes.Requireable<boolean>;
    inputRef: PropTypes.Validator<React.RefObject<any> | undefined>;
    isLoading: PropTypes.Requireable<boolean>;
    isRequired: PropTypes.Requireable<boolean>;
    name: PropTypes.Requireable<string>;
    size: PropTypes.Validator<import("../types/props").Size>;
    max: PropTypes.Requireable<number>;
    maxLength: PropTypes.Requireable<number>;
    min: PropTypes.Requireable<number>;
    minLength: PropTypes.Requireable<number>;
    multiple: PropTypes.Requireable<boolean>;
    pattern: PropTypes.Requireable<string>;
    placeholder: PropTypes.Requireable<string>;
    readOnly: PropTypes.Requireable<boolean>;
    spellCheck: PropTypes.Requireable<boolean>;
    step: PropTypes.Requireable<number>;
    state: PropTypes.Requireable<string>;
    type: PropTypes.Requireable<string>;
    value: PropTypes.Requireable<string>;
    onBlur: PropTypes.Requireable<(...args: any[]) => any>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    onFocus: PropTypes.Requireable<(...args: any[]) => any>;
};
export declare const selectMenuSearchInputDefaultProps: {
    autoComplete: string;
    before: JSX.Element;
    isDropdownActive: boolean;
    isFullWidth: boolean;
    placeholder: string;
    after?: React.ReactElement<any> | undefined;
    a11yId?: string | undefined;
    a11yLabel?: string | undefined;
    autoFocus?: boolean | undefined;
    children?: React.ReactNode;
    className?: string | undefined;
    defaultValue?: string | undefined;
    disabled?: boolean | undefined;
    inputRef?: React.RefObject<any> | undefined;
    isLoading?: boolean | undefined;
    isRequired?: boolean | undefined;
    name?: string | undefined;
    size?: "medium" | "default" | "small" | "large" | "xlarge" | "xxlarge" | "xxxlarge" | undefined;
    max?: number | undefined;
    maxLength?: number | undefined;
    min?: number | undefined;
    minLength?: number | undefined;
    multiple?: boolean | undefined;
    pattern?: string | undefined;
    readOnly?: boolean | undefined;
    spellCheck?: boolean | undefined;
    step?: number | undefined;
    state?: string | undefined;
    type?: string | undefined;
    value?: string | undefined;
    onBlur?: ((event: React.FocusEvent<HTMLInputElement>) => void) | undefined;
    onChange?: ((event: React.FormEvent<HTMLInputElement>) => void) | undefined;
    onFocus?: ((event: React.FocusEvent<HTMLInputElement>) => void) | undefined;
};
export declare class SelectMenuSearchInput extends React.Component<LocalSelectMenuSearchInputProps> {
    static propTypes: {
        after: PropTypes.Requireable<PropTypes.ReactElementLike>;
        a11yId: PropTypes.Requireable<string>;
        a11yLabel: PropTypes.Requireable<string>;
        autoComplete: PropTypes.Requireable<string>;
        autoFocus: PropTypes.Requireable<boolean>;
        before: PropTypes.Requireable<PropTypes.ReactElementLike>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        className: PropTypes.Requireable<string>;
        defaultValue: PropTypes.Requireable<string>;
        disabled: PropTypes.Requireable<boolean>;
        inputRef: PropTypes.Validator<React.RefObject<any> | undefined>;
        isLoading: PropTypes.Requireable<boolean>;
        isRequired: PropTypes.Requireable<boolean>;
        name: PropTypes.Requireable<string>;
        size: PropTypes.Validator<import("../types/props").Size>;
        max: PropTypes.Requireable<number>;
        maxLength: PropTypes.Requireable<number>;
        min: PropTypes.Requireable<number>;
        minLength: PropTypes.Requireable<number>;
        multiple: PropTypes.Requireable<boolean>;
        pattern: PropTypes.Requireable<string>;
        placeholder: PropTypes.Requireable<string>;
        readOnly: PropTypes.Requireable<boolean>;
        spellCheck: PropTypes.Requireable<boolean>;
        step: PropTypes.Requireable<number>;
        state: PropTypes.Requireable<string>;
        type: PropTypes.Requireable<string>;
        value: PropTypes.Requireable<string>;
        onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        onFocus: PropTypes.Requireable<(...args: any[]) => any>;
    };
    static defaultProps: {
        autoComplete: string;
        before: JSX.Element;
        isDropdownActive: boolean;
        isFullWidth: boolean;
        placeholder: string;
        after?: React.ReactElement<any> | undefined;
        a11yId?: string | undefined;
        a11yLabel?: string | undefined;
        autoFocus?: boolean | undefined;
        children?: React.ReactNode;
        className?: string | undefined;
        defaultValue?: string | undefined;
        disabled?: boolean | undefined;
        inputRef?: React.RefObject<any> | undefined;
        isLoading?: boolean | undefined;
        isRequired?: boolean | undefined;
        name?: string | undefined;
        size?: "medium" | "default" | "small" | "large" | "xlarge" | "xxlarge" | "xxxlarge" | undefined;
        max?: number | undefined;
        maxLength?: number | undefined;
        min?: number | undefined;
        minLength?: number | undefined;
        multiple?: boolean | undefined;
        pattern?: string | undefined;
        readOnly?: boolean | undefined;
        spellCheck?: boolean | undefined;
        step?: number | undefined;
        state?: string | undefined;
        type?: string | undefined;
        value?: string | undefined;
        onBlur?: ((event: React.FocusEvent<HTMLInputElement>) => void) | undefined;
        onChange?: ((event: React.FormEvent<HTMLInputElement>) => void) | undefined;
        onFocus?: ((event: React.FocusEvent<HTMLInputElement>) => void) | undefined;
    };
    search: React.RefObject<HTMLInputElement>;
    componentDidUpdate: (prevProps: LocalSelectMenuSearchInputProps) => void;
    render: () => JSX.Element;
}
export default SelectMenuSearchInput;
