import * as React from 'react';
import { TabsTabProps as ReakitTabProps } from 'reakit/ts/Tabs/TabsTab';
import { StepContainerActions, StepContainerSelectors } from 'reakit/ts/Step/StepContainer';
export declare type LocalTabProps = {
    children: React.ReactNode;
    className?: string;
    /** Makes the tab in an active state */
    isActive?: boolean;
    /** A unique identifier for the tab */
    tab: string;
    current: number;
    register: StepContainerActions['register'];
    update: StepContainerActions['update'];
    unregister: StepContainerActions['unregister'];
    show: StepContainerActions['show'];
    next: StepContainerActions['next'];
    previous: StepContainerActions['previous'];
    isCurrent: StepContainerSelectors['isCurrent'];
};
export declare type TabProps = ReakitTabProps & LocalTabProps;
export declare const Tab: React.FunctionComponent<LocalTabProps>;
declare const C: React.FunctionComponent<TabProps>;
export default C;
