import * as React from 'react';
import * as PropTypes from 'prop-types';
import { ThemeConfig } from '../types';
declare type DerivedTheme = {
    fannypack: ThemeConfig;
    palette: ThemeConfig['palette'];
};
export declare type LocalThemeProviderProps = {
    children: React.ReactNode;
    isStandalone?: boolean;
    theme?: ThemeConfig;
};
export declare type State = {
    theme: DerivedTheme;
};
declare class Provider extends React.Component<LocalThemeProviderProps, State> {
    static propTypes: {
        children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
        isStandalone: PropTypes.Requireable<boolean>;
        theme: PropTypes.Requireable<object>;
    };
    static defaultProps: {
        isStandalone: boolean;
        theme: {};
    };
    state: {
        theme: DerivedTheme;
    };
    render: () => JSX.Element;
}
export default Provider;
