import * as React from 'react';
import { ButtonProps } from '../Button/Button';
import { LocalPaneProps, PaneProps } from '../Pane/Pane';
import { Omit } from '../types';
import { ToastCloseProps } from './ToastClose';
import { ToastContainerProps } from './ToastContainer';
export declare type LocalToastProps = LocalPaneProps & {
    autoDismissTimeout?: number;
    children?: React.ReactNode;
    closeButtonProps?: Omit<ButtonProps, 'children'>;
    hasHorizontalBar?: boolean;
    hasIcon?: boolean;
    hasTint?: boolean;
    hideCloseButton?: boolean;
    onClickClose?: ToastCloseProps['onClickClose'];
    title?: string;
    type?: string;
};
export declare type ToastProps = PaneProps & LocalToastProps;
export declare type ToastComponents = {
    Container: React.FunctionComponent<ToastContainerProps>;
};
export declare const Toast: React.FunctionComponent<LocalToastProps> & ToastComponents;
declare const C: React.FunctionComponent<ToastProps> & ToastComponents;
export default C;
