import defaultTheme from './default';
declare const _default: {
    default: typeof defaultTheme;
    medipass: {
        global: {
            fontFamily: string;
            fallbackFontFamily: string;
        };
        webFontLoader: {
            google: {
                families: string[];
            };
        };
        layout: {
            mobileBreakpoint: number;
        };
        fontWeights: {
            normal: number;
            semibold: number;
            bold: number;
        };
        palette: {
            default: string;
            text: string;
            primary200: string;
            primary300: string;
            primary400: string;
            primary: string;
            primary500: string;
            primary600: string;
            primary700: string;
            primary800: string;
            secondary200: string;
            secondary300: string;
            secondary400: string;
            secondary: string;
            secondaryInverted: string;
            secondary500: string;
            secondary600: string;
            secondary700: string;
            secondary800: string;
            success200: string;
            success300: string;
            success400: string;
            success: string;
            successInverted: string;
            success500: string;
            success600: string;
            success700: string;
            success800: string;
            danger200: string;
            danger300: string;
            danger400: string;
            danger: string;
            danger500: string;
            danger600: string;
            danger700: string;
            danger800: string;
        };
        Button: {
            base: import("styled-components").FlattenInterpolation<import("styled-components").ThemedStyledProps<{
                theme: {
                    fannypack: import("../types/theme").ThemeConfig;
                };
            }, any>>[];
            outlined: import("styled-components").InterpolationValue[];
            ghost: import("styled-components").FlattenInterpolation<import("styled-components").ThemeProps<any>>[];
            interactive: import("styled-components").FlattenInterpolation<import("styled-components").ThemedStyledProps<{
                theme: import("styled-tools").ThemeWithPalette;
                tone?: number | undefined;
            }, any>>[];
            link: import("styled-components").InterpolationValue[];
            sizes: {
                small: import("styled-components").FlattenInterpolation<import("styled-components").ThemedStyledProps<{
                    theme: {
                        fannypack: import("../types/theme").ThemeConfig;
                    };
                }, any>>[];
            };
        };
        Checkbox: {
            base: import("styled-components").InterpolationValue[];
        };
        Container: {
            base: import("styled-components").FlattenInterpolation<any>[];
        };
        Heading: {
            base: import("styled-components").FlattenInterpolation<import("styled-components").ThemedStyledProps<{
                theme: {
                    [key: string]: any;
                };
            }, any>>[];
            h6: import("styled-components").InterpolationValue[];
        };
        Input: {
            base: import("styled-components").FlattenInterpolation<import("styled-components").ThemedStyledProps<{
                theme: {
                    fannypack: import("../types/theme").ThemeConfig;
                };
            }, any>>[];
        };
        Label: {
            base: import("styled-components").InterpolationValue[];
        };
        Select: {
            base: import("styled-components").FlattenInterpolation<import("styled-components").ThemedStyledProps<{
                theme: {
                    fannypack: import("../types/theme").ThemeConfig;
                };
            }, any>>[];
        };
        SelectMenu: {
            ActionButton: {
                base: import("styled-components").FlattenInterpolation<import("styled-components").ThemedStyledProps<{
                    theme: {
                        fannypack: import("../types/theme").ThemeConfig;
                    };
                }, any>>[];
            };
            Button: {
                base: import("styled-components").FlattenInterpolation<import("styled-components").ThemedStyledProps<{
                    theme: import("styled-tools").ThemeWithPalette;
                    tone?: number | undefined;
                }, any>>[];
            };
        };
    };
};
export default _default;
